#pragma once

////////////////////////////////////////////////////////////////////////////////
// The MIT License (MIT)
//
// Copyright (c) 2019 Nicholas Frechette & Animation Compression Library contributors
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
////////////////////////////////////////////////////////////////////////////////

#include "acl/version.h"
#include "acl/core/impl/compiler_utils.h"

#include <cstdint>

ACL_IMPL_FILE_PRAGMA_PUSH

// This file is generated with the python script located at: ./tools/calc_local_bit_rates.py

namespace acl
{
	ACL_IMPL_VERSION_NAMESPACE_BEGIN

	namespace acl_impl
	{
		constexpr uint8_t k_local_bit_rate_permutations_no_scale[361][2] =
		{
			{ 0, 0 },		// 0 bits per transform
			{ 0, 1 },		// 9 bits per transform
			{ 1, 0 },		// 9 bits per transform
			{ 0, 2 },		// 12 bits per transform
			{ 2, 0 },		// 12 bits per transform
			{ 0, 3 },		// 15 bits per transform
			{ 3, 0 },		// 15 bits per transform
			{ 0, 4 },		// 18 bits per transform
			{ 1, 1 },		// 18 bits per transform
			{ 4, 0 },		// 18 bits per transform
			{ 0, 5 },		// 21 bits per transform
			{ 1, 2 },		// 21 bits per transform
			{ 2, 1 },		// 21 bits per transform
			{ 5, 0 },		// 21 bits per transform
			{ 0, 6 },		// 24 bits per transform
			{ 1, 3 },		// 24 bits per transform
			{ 2, 2 },		// 24 bits per transform
			{ 3, 1 },		// 24 bits per transform
			{ 6, 0 },		// 24 bits per transform
			{ 0, 7 },		// 27 bits per transform
			{ 1, 4 },		// 27 bits per transform
			{ 2, 3 },		// 27 bits per transform
			{ 3, 2 },		// 27 bits per transform
			{ 4, 1 },		// 27 bits per transform
			{ 7, 0 },		// 27 bits per transform
			{ 0, 8 },		// 30 bits per transform
			{ 1, 5 },		// 30 bits per transform
			{ 2, 4 },		// 30 bits per transform
			{ 3, 3 },		// 30 bits per transform
			{ 4, 2 },		// 30 bits per transform
			{ 5, 1 },		// 30 bits per transform
			{ 8, 0 },		// 30 bits per transform
			{ 0, 9 },		// 33 bits per transform
			{ 1, 6 },		// 33 bits per transform
			{ 2, 5 },		// 33 bits per transform
			{ 3, 4 },		// 33 bits per transform
			{ 4, 3 },		// 33 bits per transform
			{ 5, 2 },		// 33 bits per transform
			{ 6, 1 },		// 33 bits per transform
			{ 9, 0 },		// 33 bits per transform
			{ 0, 10 },		// 36 bits per transform
			{ 1, 7 },		// 36 bits per transform
			{ 2, 6 },		// 36 bits per transform
			{ 3, 5 },		// 36 bits per transform
			{ 4, 4 },		// 36 bits per transform
			{ 5, 3 },		// 36 bits per transform
			{ 6, 2 },		// 36 bits per transform
			{ 7, 1 },		// 36 bits per transform
			{ 10, 0 },		// 36 bits per transform
			{ 0, 11 },		// 39 bits per transform
			{ 1, 8 },		// 39 bits per transform
			{ 2, 7 },		// 39 bits per transform
			{ 3, 6 },		// 39 bits per transform
			{ 4, 5 },		// 39 bits per transform
			{ 5, 4 },		// 39 bits per transform
			{ 6, 3 },		// 39 bits per transform
			{ 7, 2 },		// 39 bits per transform
			{ 8, 1 },		// 39 bits per transform
			{ 11, 0 },		// 39 bits per transform
			{ 0, 12 },		// 42 bits per transform
			{ 1, 9 },		// 42 bits per transform
			{ 2, 8 },		// 42 bits per transform
			{ 3, 7 },		// 42 bits per transform
			{ 4, 6 },		// 42 bits per transform
			{ 5, 5 },		// 42 bits per transform
			{ 6, 4 },		// 42 bits per transform
			{ 7, 3 },		// 42 bits per transform
			{ 8, 2 },		// 42 bits per transform
			{ 9, 1 },		// 42 bits per transform
			{ 12, 0 },		// 42 bits per transform
			{ 0, 13 },		// 45 bits per transform
			{ 1, 10 },		// 45 bits per transform
			{ 2, 9 },		// 45 bits per transform
			{ 3, 8 },		// 45 bits per transform
			{ 4, 7 },		// 45 bits per transform
			{ 5, 6 },		// 45 bits per transform
			{ 6, 5 },		// 45 bits per transform
			{ 7, 4 },		// 45 bits per transform
			{ 8, 3 },		// 45 bits per transform
			{ 9, 2 },		// 45 bits per transform
			{ 10, 1 },		// 45 bits per transform
			{ 13, 0 },		// 45 bits per transform
			{ 0, 14 },		// 48 bits per transform
			{ 1, 11 },		// 48 bits per transform
			{ 2, 10 },		// 48 bits per transform
			{ 3, 9 },		// 48 bits per transform
			{ 4, 8 },		// 48 bits per transform
			{ 5, 7 },		// 48 bits per transform
			{ 6, 6 },		// 48 bits per transform
			{ 7, 5 },		// 48 bits per transform
			{ 8, 4 },		// 48 bits per transform
			{ 9, 3 },		// 48 bits per transform
			{ 10, 2 },		// 48 bits per transform
			{ 11, 1 },		// 48 bits per transform
			{ 14, 0 },		// 48 bits per transform
			{ 0, 15 },		// 51 bits per transform
			{ 1, 12 },		// 51 bits per transform
			{ 2, 11 },		// 51 bits per transform
			{ 3, 10 },		// 51 bits per transform
			{ 4, 9 },		// 51 bits per transform
			{ 5, 8 },		// 51 bits per transform
			{ 6, 7 },		// 51 bits per transform
			{ 7, 6 },		// 51 bits per transform
			{ 8, 5 },		// 51 bits per transform
			{ 9, 4 },		// 51 bits per transform
			{ 10, 3 },		// 51 bits per transform
			{ 11, 2 },		// 51 bits per transform
			{ 12, 1 },		// 51 bits per transform
			{ 15, 0 },		// 51 bits per transform
			{ 0, 16 },		// 54 bits per transform
			{ 1, 13 },		// 54 bits per transform
			{ 2, 12 },		// 54 bits per transform
			{ 3, 11 },		// 54 bits per transform
			{ 4, 10 },		// 54 bits per transform
			{ 5, 9 },		// 54 bits per transform
			{ 6, 8 },		// 54 bits per transform
			{ 7, 7 },		// 54 bits per transform
			{ 8, 6 },		// 54 bits per transform
			{ 9, 5 },		// 54 bits per transform
			{ 10, 4 },		// 54 bits per transform
			{ 11, 3 },		// 54 bits per transform
			{ 12, 2 },		// 54 bits per transform
			{ 13, 1 },		// 54 bits per transform
			{ 16, 0 },		// 54 bits per transform
			{ 0, 17 },		// 57 bits per transform
			{ 1, 14 },		// 57 bits per transform
			{ 2, 13 },		// 57 bits per transform
			{ 3, 12 },		// 57 bits per transform
			{ 4, 11 },		// 57 bits per transform
			{ 5, 10 },		// 57 bits per transform
			{ 6, 9 },		// 57 bits per transform
			{ 7, 8 },		// 57 bits per transform
			{ 8, 7 },		// 57 bits per transform
			{ 9, 6 },		// 57 bits per transform
			{ 10, 5 },		// 57 bits per transform
			{ 11, 4 },		// 57 bits per transform
			{ 12, 3 },		// 57 bits per transform
			{ 13, 2 },		// 57 bits per transform
			{ 14, 1 },		// 57 bits per transform
			{ 17, 0 },		// 57 bits per transform
			{ 1, 15 },		// 60 bits per transform
			{ 2, 14 },		// 60 bits per transform
			{ 3, 13 },		// 60 bits per transform
			{ 4, 12 },		// 60 bits per transform
			{ 5, 11 },		// 60 bits per transform
			{ 6, 10 },		// 60 bits per transform
			{ 7, 9 },		// 60 bits per transform
			{ 8, 8 },		// 60 bits per transform
			{ 9, 7 },		// 60 bits per transform
			{ 10, 6 },		// 60 bits per transform
			{ 11, 5 },		// 60 bits per transform
			{ 12, 4 },		// 60 bits per transform
			{ 13, 3 },		// 60 bits per transform
			{ 14, 2 },		// 60 bits per transform
			{ 15, 1 },		// 60 bits per transform
			{ 1, 16 },		// 63 bits per transform
			{ 2, 15 },		// 63 bits per transform
			{ 3, 14 },		// 63 bits per transform
			{ 4, 13 },		// 63 bits per transform
			{ 5, 12 },		// 63 bits per transform
			{ 6, 11 },		// 63 bits per transform
			{ 7, 10 },		// 63 bits per transform
			{ 8, 9 },		// 63 bits per transform
			{ 9, 8 },		// 63 bits per transform
			{ 10, 7 },		// 63 bits per transform
			{ 11, 6 },		// 63 bits per transform
			{ 12, 5 },		// 63 bits per transform
			{ 13, 4 },		// 63 bits per transform
			{ 14, 3 },		// 63 bits per transform
			{ 15, 2 },		// 63 bits per transform
			{ 16, 1 },		// 63 bits per transform
			{ 1, 17 },		// 66 bits per transform
			{ 2, 16 },		// 66 bits per transform
			{ 3, 15 },		// 66 bits per transform
			{ 4, 14 },		// 66 bits per transform
			{ 5, 13 },		// 66 bits per transform
			{ 6, 12 },		// 66 bits per transform
			{ 7, 11 },		// 66 bits per transform
			{ 8, 10 },		// 66 bits per transform
			{ 9, 9 },		// 66 bits per transform
			{ 10, 8 },		// 66 bits per transform
			{ 11, 7 },		// 66 bits per transform
			{ 12, 6 },		// 66 bits per transform
			{ 13, 5 },		// 66 bits per transform
			{ 14, 4 },		// 66 bits per transform
			{ 15, 3 },		// 66 bits per transform
			{ 16, 2 },		// 66 bits per transform
			{ 17, 1 },		// 66 bits per transform
			{ 2, 17 },		// 69 bits per transform
			{ 3, 16 },		// 69 bits per transform
			{ 4, 15 },		// 69 bits per transform
			{ 5, 14 },		// 69 bits per transform
			{ 6, 13 },		// 69 bits per transform
			{ 7, 12 },		// 69 bits per transform
			{ 8, 11 },		// 69 bits per transform
			{ 9, 10 },		// 69 bits per transform
			{ 10, 9 },		// 69 bits per transform
			{ 11, 8 },		// 69 bits per transform
			{ 12, 7 },		// 69 bits per transform
			{ 13, 6 },		// 69 bits per transform
			{ 14, 5 },		// 69 bits per transform
			{ 15, 4 },		// 69 bits per transform
			{ 16, 3 },		// 69 bits per transform
			{ 17, 2 },		// 69 bits per transform
			{ 3, 17 },		// 72 bits per transform
			{ 4, 16 },		// 72 bits per transform
			{ 5, 15 },		// 72 bits per transform
			{ 6, 14 },		// 72 bits per transform
			{ 7, 13 },		// 72 bits per transform
			{ 8, 12 },		// 72 bits per transform
			{ 9, 11 },		// 72 bits per transform
			{ 10, 10 },		// 72 bits per transform
			{ 11, 9 },		// 72 bits per transform
			{ 12, 8 },		// 72 bits per transform
			{ 13, 7 },		// 72 bits per transform
			{ 14, 6 },		// 72 bits per transform
			{ 15, 5 },		// 72 bits per transform
			{ 16, 4 },		// 72 bits per transform
			{ 17, 3 },		// 72 bits per transform
			{ 4, 17 },		// 75 bits per transform
			{ 5, 16 },		// 75 bits per transform
			{ 6, 15 },		// 75 bits per transform
			{ 7, 14 },		// 75 bits per transform
			{ 8, 13 },		// 75 bits per transform
			{ 9, 12 },		// 75 bits per transform
			{ 10, 11 },		// 75 bits per transform
			{ 11, 10 },		// 75 bits per transform
			{ 12, 9 },		// 75 bits per transform
			{ 13, 8 },		// 75 bits per transform
			{ 14, 7 },		// 75 bits per transform
			{ 15, 6 },		// 75 bits per transform
			{ 16, 5 },		// 75 bits per transform
			{ 17, 4 },		// 75 bits per transform
			{ 5, 17 },		// 78 bits per transform
			{ 6, 16 },		// 78 bits per transform
			{ 7, 15 },		// 78 bits per transform
			{ 8, 14 },		// 78 bits per transform
			{ 9, 13 },		// 78 bits per transform
			{ 10, 12 },		// 78 bits per transform
			{ 11, 11 },		// 78 bits per transform
			{ 12, 10 },		// 78 bits per transform
			{ 13, 9 },		// 78 bits per transform
			{ 14, 8 },		// 78 bits per transform
			{ 15, 7 },		// 78 bits per transform
			{ 16, 6 },		// 78 bits per transform
			{ 17, 5 },		// 78 bits per transform
			{ 6, 17 },		// 81 bits per transform
			{ 7, 16 },		// 81 bits per transform
			{ 8, 15 },		// 81 bits per transform
			{ 9, 14 },		// 81 bits per transform
			{ 10, 13 },		// 81 bits per transform
			{ 11, 12 },		// 81 bits per transform
			{ 12, 11 },		// 81 bits per transform
			{ 13, 10 },		// 81 bits per transform
			{ 14, 9 },		// 81 bits per transform
			{ 15, 8 },		// 81 bits per transform
			{ 16, 7 },		// 81 bits per transform
			{ 17, 6 },		// 81 bits per transform
			{ 7, 17 },		// 84 bits per transform
			{ 8, 16 },		// 84 bits per transform
			{ 9, 15 },		// 84 bits per transform
			{ 10, 14 },		// 84 bits per transform
			{ 11, 13 },		// 84 bits per transform
			{ 12, 12 },		// 84 bits per transform
			{ 13, 11 },		// 84 bits per transform
			{ 14, 10 },		// 84 bits per transform
			{ 15, 9 },		// 84 bits per transform
			{ 16, 8 },		// 84 bits per transform
			{ 17, 7 },		// 84 bits per transform
			{ 8, 17 },		// 87 bits per transform
			{ 9, 16 },		// 87 bits per transform
			{ 10, 15 },		// 87 bits per transform
			{ 11, 14 },		// 87 bits per transform
			{ 12, 13 },		// 87 bits per transform
			{ 13, 12 },		// 87 bits per transform
			{ 14, 11 },		// 87 bits per transform
			{ 15, 10 },		// 87 bits per transform
			{ 16, 9 },		// 87 bits per transform
			{ 17, 8 },		// 87 bits per transform
			{ 9, 17 },		// 90 bits per transform
			{ 10, 16 },		// 90 bits per transform
			{ 11, 15 },		// 90 bits per transform
			{ 12, 14 },		// 90 bits per transform
			{ 13, 13 },		// 90 bits per transform
			{ 14, 12 },		// 90 bits per transform
			{ 15, 11 },		// 90 bits per transform
			{ 16, 10 },		// 90 bits per transform
			{ 17, 9 },		// 90 bits per transform
			{ 10, 17 },		// 93 bits per transform
			{ 11, 16 },		// 93 bits per transform
			{ 12, 15 },		// 93 bits per transform
			{ 13, 14 },		// 93 bits per transform
			{ 14, 13 },		// 93 bits per transform
			{ 15, 12 },		// 93 bits per transform
			{ 16, 11 },		// 93 bits per transform
			{ 17, 10 },		// 93 bits per transform
			{ 0, 18 },		// 96 bits per transform
			{ 11, 17 },		// 96 bits per transform
			{ 12, 16 },		// 96 bits per transform
			{ 13, 15 },		// 96 bits per transform
			{ 14, 14 },		// 96 bits per transform
			{ 15, 13 },		// 96 bits per transform
			{ 16, 12 },		// 96 bits per transform
			{ 17, 11 },		// 96 bits per transform
			{ 18, 0 },		// 96 bits per transform
			{ 12, 17 },		// 99 bits per transform
			{ 13, 16 },		// 99 bits per transform
			{ 14, 15 },		// 99 bits per transform
			{ 15, 14 },		// 99 bits per transform
			{ 16, 13 },		// 99 bits per transform
			{ 17, 12 },		// 99 bits per transform
			{ 13, 17 },		// 102 bits per transform
			{ 14, 16 },		// 102 bits per transform
			{ 15, 15 },		// 102 bits per transform
			{ 16, 14 },		// 102 bits per transform
			{ 17, 13 },		// 102 bits per transform
			{ 1, 18 },		// 105 bits per transform
			{ 14, 17 },		// 105 bits per transform
			{ 15, 16 },		// 105 bits per transform
			{ 16, 15 },		// 105 bits per transform
			{ 17, 14 },		// 105 bits per transform
			{ 18, 1 },		// 105 bits per transform
			{ 2, 18 },		// 108 bits per transform
			{ 15, 17 },		// 108 bits per transform
			{ 16, 16 },		// 108 bits per transform
			{ 17, 15 },		// 108 bits per transform
			{ 18, 2 },		// 108 bits per transform
			{ 3, 18 },		// 111 bits per transform
			{ 16, 17 },		// 111 bits per transform
			{ 17, 16 },		// 111 bits per transform
			{ 18, 3 },		// 111 bits per transform
			{ 4, 18 },		// 114 bits per transform
			{ 17, 17 },		// 114 bits per transform
			{ 18, 4 },		// 114 bits per transform
			{ 5, 18 },		// 117 bits per transform
			{ 18, 5 },		// 117 bits per transform
			{ 6, 18 },		// 120 bits per transform
			{ 18, 6 },		// 120 bits per transform
			{ 7, 18 },		// 123 bits per transform
			{ 18, 7 },		// 123 bits per transform
			{ 8, 18 },		// 126 bits per transform
			{ 18, 8 },		// 126 bits per transform
			{ 9, 18 },		// 129 bits per transform
			{ 18, 9 },		// 129 bits per transform
			{ 10, 18 },		// 132 bits per transform
			{ 18, 10 },		// 132 bits per transform
			{ 11, 18 },		// 135 bits per transform
			{ 18, 11 },		// 135 bits per transform
			{ 12, 18 },		// 138 bits per transform
			{ 18, 12 },		// 138 bits per transform
			{ 13, 18 },		// 141 bits per transform
			{ 18, 13 },		// 141 bits per transform
			{ 14, 18 },		// 144 bits per transform
			{ 18, 14 },		// 144 bits per transform
			{ 15, 18 },		// 147 bits per transform
			{ 18, 15 },		// 147 bits per transform
			{ 16, 18 },		// 150 bits per transform
			{ 18, 16 },		// 150 bits per transform
			{ 17, 18 },		// 153 bits per transform
			{ 18, 17 },		// 153 bits per transform
			{ 18, 18 },		// 192 bits per transform
		};

		constexpr uint8_t k_local_bit_rate_permutations[6859][3] =
		{
			{ 0, 0, 0 },		// 0 bits per transform
			{ 0, 0, 1 },		// 9 bits per transform
			{ 0, 1, 0 },		// 9 bits per transform
			{ 1, 0, 0 },		// 9 bits per transform
			{ 0, 0, 2 },		// 12 bits per transform
			{ 0, 2, 0 },		// 12 bits per transform
			{ 2, 0, 0 },		// 12 bits per transform
			{ 0, 0, 3 },		// 15 bits per transform
			{ 0, 3, 0 },		// 15 bits per transform
			{ 3, 0, 0 },		// 15 bits per transform
			{ 0, 0, 4 },		// 18 bits per transform
			{ 0, 1, 1 },		// 18 bits per transform
			{ 0, 4, 0 },		// 18 bits per transform
			{ 1, 0, 1 },		// 18 bits per transform
			{ 1, 1, 0 },		// 18 bits per transform
			{ 4, 0, 0 },		// 18 bits per transform
			{ 0, 0, 5 },		// 21 bits per transform
			{ 0, 1, 2 },		// 21 bits per transform
			{ 0, 2, 1 },		// 21 bits per transform
			{ 0, 5, 0 },		// 21 bits per transform
			{ 1, 0, 2 },		// 21 bits per transform
			{ 1, 2, 0 },		// 21 bits per transform
			{ 2, 0, 1 },		// 21 bits per transform
			{ 2, 1, 0 },		// 21 bits per transform
			{ 5, 0, 0 },		// 21 bits per transform
			{ 0, 0, 6 },		// 24 bits per transform
			{ 0, 1, 3 },		// 24 bits per transform
			{ 0, 2, 2 },		// 24 bits per transform
			{ 0, 3, 1 },		// 24 bits per transform
			{ 0, 6, 0 },		// 24 bits per transform
			{ 1, 0, 3 },		// 24 bits per transform
			{ 1, 3, 0 },		// 24 bits per transform
			{ 2, 0, 2 },		// 24 bits per transform
			{ 2, 2, 0 },		// 24 bits per transform
			{ 3, 0, 1 },		// 24 bits per transform
			{ 3, 1, 0 },		// 24 bits per transform
			{ 6, 0, 0 },		// 24 bits per transform
			{ 0, 0, 7 },		// 27 bits per transform
			{ 0, 1, 4 },		// 27 bits per transform
			{ 0, 2, 3 },		// 27 bits per transform
			{ 0, 3, 2 },		// 27 bits per transform
			{ 0, 4, 1 },		// 27 bits per transform
			{ 0, 7, 0 },		// 27 bits per transform
			{ 1, 0, 4 },		// 27 bits per transform
			{ 1, 1, 1 },		// 27 bits per transform
			{ 1, 4, 0 },		// 27 bits per transform
			{ 2, 0, 3 },		// 27 bits per transform
			{ 2, 3, 0 },		// 27 bits per transform
			{ 3, 0, 2 },		// 27 bits per transform
			{ 3, 2, 0 },		// 27 bits per transform
			{ 4, 0, 1 },		// 27 bits per transform
			{ 4, 1, 0 },		// 27 bits per transform
			{ 7, 0, 0 },		// 27 bits per transform
			{ 0, 0, 8 },		// 30 bits per transform
			{ 0, 1, 5 },		// 30 bits per transform
			{ 0, 2, 4 },		// 30 bits per transform
			{ 0, 3, 3 },		// 30 bits per transform
			{ 0, 4, 2 },		// 30 bits per transform
			{ 0, 5, 1 },		// 30 bits per transform
			{ 0, 8, 0 },		// 30 bits per transform
			{ 1, 0, 5 },		// 30 bits per transform
			{ 1, 1, 2 },		// 30 bits per transform
			{ 1, 2, 1 },		// 30 bits per transform
			{ 1, 5, 0 },		// 30 bits per transform
			{ 2, 0, 4 },		// 30 bits per transform
			{ 2, 1, 1 },		// 30 bits per transform
			{ 2, 4, 0 },		// 30 bits per transform
			{ 3, 0, 3 },		// 30 bits per transform
			{ 3, 3, 0 },		// 30 bits per transform
			{ 4, 0, 2 },		// 30 bits per transform
			{ 4, 2, 0 },		// 30 bits per transform
			{ 5, 0, 1 },		// 30 bits per transform
			{ 5, 1, 0 },		// 30 bits per transform
			{ 8, 0, 0 },		// 30 bits per transform
			{ 0, 0, 9 },		// 33 bits per transform
			{ 0, 1, 6 },		// 33 bits per transform
			{ 0, 2, 5 },		// 33 bits per transform
			{ 0, 3, 4 },		// 33 bits per transform
			{ 0, 4, 3 },		// 33 bits per transform
			{ 0, 5, 2 },		// 33 bits per transform
			{ 0, 6, 1 },		// 33 bits per transform
			{ 0, 9, 0 },		// 33 bits per transform
			{ 1, 0, 6 },		// 33 bits per transform
			{ 1, 1, 3 },		// 33 bits per transform
			{ 1, 2, 2 },		// 33 bits per transform
			{ 1, 3, 1 },		// 33 bits per transform
			{ 1, 6, 0 },		// 33 bits per transform
			{ 2, 0, 5 },		// 33 bits per transform
			{ 2, 1, 2 },		// 33 bits per transform
			{ 2, 2, 1 },		// 33 bits per transform
			{ 2, 5, 0 },		// 33 bits per transform
			{ 3, 0, 4 },		// 33 bits per transform
			{ 3, 1, 1 },		// 33 bits per transform
			{ 3, 4, 0 },		// 33 bits per transform
			{ 4, 0, 3 },		// 33 bits per transform
			{ 4, 3, 0 },		// 33 bits per transform
			{ 5, 0, 2 },		// 33 bits per transform
			{ 5, 2, 0 },		// 33 bits per transform
			{ 6, 0, 1 },		// 33 bits per transform
			{ 6, 1, 0 },		// 33 bits per transform
			{ 9, 0, 0 },		// 33 bits per transform
			{ 0, 0, 10 },		// 36 bits per transform
			{ 0, 1, 7 },		// 36 bits per transform
			{ 0, 2, 6 },		// 36 bits per transform
			{ 0, 3, 5 },		// 36 bits per transform
			{ 0, 4, 4 },		// 36 bits per transform
			{ 0, 5, 3 },		// 36 bits per transform
			{ 0, 6, 2 },		// 36 bits per transform
			{ 0, 7, 1 },		// 36 bits per transform
			{ 0, 10, 0 },		// 36 bits per transform
			{ 1, 0, 7 },		// 36 bits per transform
			{ 1, 1, 4 },		// 36 bits per transform
			{ 1, 2, 3 },		// 36 bits per transform
			{ 1, 3, 2 },		// 36 bits per transform
			{ 1, 4, 1 },		// 36 bits per transform
			{ 1, 7, 0 },		// 36 bits per transform
			{ 2, 0, 6 },		// 36 bits per transform
			{ 2, 1, 3 },		// 36 bits per transform
			{ 2, 2, 2 },		// 36 bits per transform
			{ 2, 3, 1 },		// 36 bits per transform
			{ 2, 6, 0 },		// 36 bits per transform
			{ 3, 0, 5 },		// 36 bits per transform
			{ 3, 1, 2 },		// 36 bits per transform
			{ 3, 2, 1 },		// 36 bits per transform
			{ 3, 5, 0 },		// 36 bits per transform
			{ 4, 0, 4 },		// 36 bits per transform
			{ 4, 1, 1 },		// 36 bits per transform
			{ 4, 4, 0 },		// 36 bits per transform
			{ 5, 0, 3 },		// 36 bits per transform
			{ 5, 3, 0 },		// 36 bits per transform
			{ 6, 0, 2 },		// 36 bits per transform
			{ 6, 2, 0 },		// 36 bits per transform
			{ 7, 0, 1 },		// 36 bits per transform
			{ 7, 1, 0 },		// 36 bits per transform
			{ 10, 0, 0 },		// 36 bits per transform
			{ 0, 0, 11 },		// 39 bits per transform
			{ 0, 1, 8 },		// 39 bits per transform
			{ 0, 2, 7 },		// 39 bits per transform
			{ 0, 3, 6 },		// 39 bits per transform
			{ 0, 4, 5 },		// 39 bits per transform
			{ 0, 5, 4 },		// 39 bits per transform
			{ 0, 6, 3 },		// 39 bits per transform
			{ 0, 7, 2 },		// 39 bits per transform
			{ 0, 8, 1 },		// 39 bits per transform
			{ 0, 11, 0 },		// 39 bits per transform
			{ 1, 0, 8 },		// 39 bits per transform
			{ 1, 1, 5 },		// 39 bits per transform
			{ 1, 2, 4 },		// 39 bits per transform
			{ 1, 3, 3 },		// 39 bits per transform
			{ 1, 4, 2 },		// 39 bits per transform
			{ 1, 5, 1 },		// 39 bits per transform
			{ 1, 8, 0 },		// 39 bits per transform
			{ 2, 0, 7 },		// 39 bits per transform
			{ 2, 1, 4 },		// 39 bits per transform
			{ 2, 2, 3 },		// 39 bits per transform
			{ 2, 3, 2 },		// 39 bits per transform
			{ 2, 4, 1 },		// 39 bits per transform
			{ 2, 7, 0 },		// 39 bits per transform
			{ 3, 0, 6 },		// 39 bits per transform
			{ 3, 1, 3 },		// 39 bits per transform
			{ 3, 2, 2 },		// 39 bits per transform
			{ 3, 3, 1 },		// 39 bits per transform
			{ 3, 6, 0 },		// 39 bits per transform
			{ 4, 0, 5 },		// 39 bits per transform
			{ 4, 1, 2 },		// 39 bits per transform
			{ 4, 2, 1 },		// 39 bits per transform
			{ 4, 5, 0 },		// 39 bits per transform
			{ 5, 0, 4 },		// 39 bits per transform
			{ 5, 1, 1 },		// 39 bits per transform
			{ 5, 4, 0 },		// 39 bits per transform
			{ 6, 0, 3 },		// 39 bits per transform
			{ 6, 3, 0 },		// 39 bits per transform
			{ 7, 0, 2 },		// 39 bits per transform
			{ 7, 2, 0 },		// 39 bits per transform
			{ 8, 0, 1 },		// 39 bits per transform
			{ 8, 1, 0 },		// 39 bits per transform
			{ 11, 0, 0 },		// 39 bits per transform
			{ 0, 0, 12 },		// 42 bits per transform
			{ 0, 1, 9 },		// 42 bits per transform
			{ 0, 2, 8 },		// 42 bits per transform
			{ 0, 3, 7 },		// 42 bits per transform
			{ 0, 4, 6 },		// 42 bits per transform
			{ 0, 5, 5 },		// 42 bits per transform
			{ 0, 6, 4 },		// 42 bits per transform
			{ 0, 7, 3 },		// 42 bits per transform
			{ 0, 8, 2 },		// 42 bits per transform
			{ 0, 9, 1 },		// 42 bits per transform
			{ 0, 12, 0 },		// 42 bits per transform
			{ 1, 0, 9 },		// 42 bits per transform
			{ 1, 1, 6 },		// 42 bits per transform
			{ 1, 2, 5 },		// 42 bits per transform
			{ 1, 3, 4 },		// 42 bits per transform
			{ 1, 4, 3 },		// 42 bits per transform
			{ 1, 5, 2 },		// 42 bits per transform
			{ 1, 6, 1 },		// 42 bits per transform
			{ 1, 9, 0 },		// 42 bits per transform
			{ 2, 0, 8 },		// 42 bits per transform
			{ 2, 1, 5 },		// 42 bits per transform
			{ 2, 2, 4 },		// 42 bits per transform
			{ 2, 3, 3 },		// 42 bits per transform
			{ 2, 4, 2 },		// 42 bits per transform
			{ 2, 5, 1 },		// 42 bits per transform
			{ 2, 8, 0 },		// 42 bits per transform
			{ 3, 0, 7 },		// 42 bits per transform
			{ 3, 1, 4 },		// 42 bits per transform
			{ 3, 2, 3 },		// 42 bits per transform
			{ 3, 3, 2 },		// 42 bits per transform
			{ 3, 4, 1 },		// 42 bits per transform
			{ 3, 7, 0 },		// 42 bits per transform
			{ 4, 0, 6 },		// 42 bits per transform
			{ 4, 1, 3 },		// 42 bits per transform
			{ 4, 2, 2 },		// 42 bits per transform
			{ 4, 3, 1 },		// 42 bits per transform
			{ 4, 6, 0 },		// 42 bits per transform
			{ 5, 0, 5 },		// 42 bits per transform
			{ 5, 1, 2 },		// 42 bits per transform
			{ 5, 2, 1 },		// 42 bits per transform
			{ 5, 5, 0 },		// 42 bits per transform
			{ 6, 0, 4 },		// 42 bits per transform
			{ 6, 1, 1 },		// 42 bits per transform
			{ 6, 4, 0 },		// 42 bits per transform
			{ 7, 0, 3 },		// 42 bits per transform
			{ 7, 3, 0 },		// 42 bits per transform
			{ 8, 0, 2 },		// 42 bits per transform
			{ 8, 2, 0 },		// 42 bits per transform
			{ 9, 0, 1 },		// 42 bits per transform
			{ 9, 1, 0 },		// 42 bits per transform
			{ 12, 0, 0 },		// 42 bits per transform
			{ 0, 0, 13 },		// 45 bits per transform
			{ 0, 1, 10 },		// 45 bits per transform
			{ 0, 2, 9 },		// 45 bits per transform
			{ 0, 3, 8 },		// 45 bits per transform
			{ 0, 4, 7 },		// 45 bits per transform
			{ 0, 5, 6 },		// 45 bits per transform
			{ 0, 6, 5 },		// 45 bits per transform
			{ 0, 7, 4 },		// 45 bits per transform
			{ 0, 8, 3 },		// 45 bits per transform
			{ 0, 9, 2 },		// 45 bits per transform
			{ 0, 10, 1 },		// 45 bits per transform
			{ 0, 13, 0 },		// 45 bits per transform
			{ 1, 0, 10 },		// 45 bits per transform
			{ 1, 1, 7 },		// 45 bits per transform
			{ 1, 2, 6 },		// 45 bits per transform
			{ 1, 3, 5 },		// 45 bits per transform
			{ 1, 4, 4 },		// 45 bits per transform
			{ 1, 5, 3 },		// 45 bits per transform
			{ 1, 6, 2 },		// 45 bits per transform
			{ 1, 7, 1 },		// 45 bits per transform
			{ 1, 10, 0 },		// 45 bits per transform
			{ 2, 0, 9 },		// 45 bits per transform
			{ 2, 1, 6 },		// 45 bits per transform
			{ 2, 2, 5 },		// 45 bits per transform
			{ 2, 3, 4 },		// 45 bits per transform
			{ 2, 4, 3 },		// 45 bits per transform
			{ 2, 5, 2 },		// 45 bits per transform
			{ 2, 6, 1 },		// 45 bits per transform
			{ 2, 9, 0 },		// 45 bits per transform
			{ 3, 0, 8 },		// 45 bits per transform
			{ 3, 1, 5 },		// 45 bits per transform
			{ 3, 2, 4 },		// 45 bits per transform
			{ 3, 3, 3 },		// 45 bits per transform
			{ 3, 4, 2 },		// 45 bits per transform
			{ 3, 5, 1 },		// 45 bits per transform
			{ 3, 8, 0 },		// 45 bits per transform
			{ 4, 0, 7 },		// 45 bits per transform
			{ 4, 1, 4 },		// 45 bits per transform
			{ 4, 2, 3 },		// 45 bits per transform
			{ 4, 3, 2 },		// 45 bits per transform
			{ 4, 4, 1 },		// 45 bits per transform
			{ 4, 7, 0 },		// 45 bits per transform
			{ 5, 0, 6 },		// 45 bits per transform
			{ 5, 1, 3 },		// 45 bits per transform
			{ 5, 2, 2 },		// 45 bits per transform
			{ 5, 3, 1 },		// 45 bits per transform
			{ 5, 6, 0 },		// 45 bits per transform
			{ 6, 0, 5 },		// 45 bits per transform
			{ 6, 1, 2 },		// 45 bits per transform
			{ 6, 2, 1 },		// 45 bits per transform
			{ 6, 5, 0 },		// 45 bits per transform
			{ 7, 0, 4 },		// 45 bits per transform
			{ 7, 1, 1 },		// 45 bits per transform
			{ 7, 4, 0 },		// 45 bits per transform
			{ 8, 0, 3 },		// 45 bits per transform
			{ 8, 3, 0 },		// 45 bits per transform
			{ 9, 0, 2 },		// 45 bits per transform
			{ 9, 2, 0 },		// 45 bits per transform
			{ 10, 0, 1 },		// 45 bits per transform
			{ 10, 1, 0 },		// 45 bits per transform
			{ 13, 0, 0 },		// 45 bits per transform
			{ 0, 0, 14 },		// 48 bits per transform
			{ 0, 1, 11 },		// 48 bits per transform
			{ 0, 2, 10 },		// 48 bits per transform
			{ 0, 3, 9 },		// 48 bits per transform
			{ 0, 4, 8 },		// 48 bits per transform
			{ 0, 5, 7 },		// 48 bits per transform
			{ 0, 6, 6 },		// 48 bits per transform
			{ 0, 7, 5 },		// 48 bits per transform
			{ 0, 8, 4 },		// 48 bits per transform
			{ 0, 9, 3 },		// 48 bits per transform
			{ 0, 10, 2 },		// 48 bits per transform
			{ 0, 11, 1 },		// 48 bits per transform
			{ 0, 14, 0 },		// 48 bits per transform
			{ 1, 0, 11 },		// 48 bits per transform
			{ 1, 1, 8 },		// 48 bits per transform
			{ 1, 2, 7 },		// 48 bits per transform
			{ 1, 3, 6 },		// 48 bits per transform
			{ 1, 4, 5 },		// 48 bits per transform
			{ 1, 5, 4 },		// 48 bits per transform
			{ 1, 6, 3 },		// 48 bits per transform
			{ 1, 7, 2 },		// 48 bits per transform
			{ 1, 8, 1 },		// 48 bits per transform
			{ 1, 11, 0 },		// 48 bits per transform
			{ 2, 0, 10 },		// 48 bits per transform
			{ 2, 1, 7 },		// 48 bits per transform
			{ 2, 2, 6 },		// 48 bits per transform
			{ 2, 3, 5 },		// 48 bits per transform
			{ 2, 4, 4 },		// 48 bits per transform
			{ 2, 5, 3 },		// 48 bits per transform
			{ 2, 6, 2 },		// 48 bits per transform
			{ 2, 7, 1 },		// 48 bits per transform
			{ 2, 10, 0 },		// 48 bits per transform
			{ 3, 0, 9 },		// 48 bits per transform
			{ 3, 1, 6 },		// 48 bits per transform
			{ 3, 2, 5 },		// 48 bits per transform
			{ 3, 3, 4 },		// 48 bits per transform
			{ 3, 4, 3 },		// 48 bits per transform
			{ 3, 5, 2 },		// 48 bits per transform
			{ 3, 6, 1 },		// 48 bits per transform
			{ 3, 9, 0 },		// 48 bits per transform
			{ 4, 0, 8 },		// 48 bits per transform
			{ 4, 1, 5 },		// 48 bits per transform
			{ 4, 2, 4 },		// 48 bits per transform
			{ 4, 3, 3 },		// 48 bits per transform
			{ 4, 4, 2 },		// 48 bits per transform
			{ 4, 5, 1 },		// 48 bits per transform
			{ 4, 8, 0 },		// 48 bits per transform
			{ 5, 0, 7 },		// 48 bits per transform
			{ 5, 1, 4 },		// 48 bits per transform
			{ 5, 2, 3 },		// 48 bits per transform
			{ 5, 3, 2 },		// 48 bits per transform
			{ 5, 4, 1 },		// 48 bits per transform
			{ 5, 7, 0 },		// 48 bits per transform
			{ 6, 0, 6 },		// 48 bits per transform
			{ 6, 1, 3 },		// 48 bits per transform
			{ 6, 2, 2 },		// 48 bits per transform
			{ 6, 3, 1 },		// 48 bits per transform
			{ 6, 6, 0 },		// 48 bits per transform
			{ 7, 0, 5 },		// 48 bits per transform
			{ 7, 1, 2 },		// 48 bits per transform
			{ 7, 2, 1 },		// 48 bits per transform
			{ 7, 5, 0 },		// 48 bits per transform
			{ 8, 0, 4 },		// 48 bits per transform
			{ 8, 1, 1 },		// 48 bits per transform
			{ 8, 4, 0 },		// 48 bits per transform
			{ 9, 0, 3 },		// 48 bits per transform
			{ 9, 3, 0 },		// 48 bits per transform
			{ 10, 0, 2 },		// 48 bits per transform
			{ 10, 2, 0 },		// 48 bits per transform
			{ 11, 0, 1 },		// 48 bits per transform
			{ 11, 1, 0 },		// 48 bits per transform
			{ 14, 0, 0 },		// 48 bits per transform
			{ 0, 0, 15 },		// 51 bits per transform
			{ 0, 1, 12 },		// 51 bits per transform
			{ 0, 2, 11 },		// 51 bits per transform
			{ 0, 3, 10 },		// 51 bits per transform
			{ 0, 4, 9 },		// 51 bits per transform
			{ 0, 5, 8 },		// 51 bits per transform
			{ 0, 6, 7 },		// 51 bits per transform
			{ 0, 7, 6 },		// 51 bits per transform
			{ 0, 8, 5 },		// 51 bits per transform
			{ 0, 9, 4 },		// 51 bits per transform
			{ 0, 10, 3 },		// 51 bits per transform
			{ 0, 11, 2 },		// 51 bits per transform
			{ 0, 12, 1 },		// 51 bits per transform
			{ 0, 15, 0 },		// 51 bits per transform
			{ 1, 0, 12 },		// 51 bits per transform
			{ 1, 1, 9 },		// 51 bits per transform
			{ 1, 2, 8 },		// 51 bits per transform
			{ 1, 3, 7 },		// 51 bits per transform
			{ 1, 4, 6 },		// 51 bits per transform
			{ 1, 5, 5 },		// 51 bits per transform
			{ 1, 6, 4 },		// 51 bits per transform
			{ 1, 7, 3 },		// 51 bits per transform
			{ 1, 8, 2 },		// 51 bits per transform
			{ 1, 9, 1 },		// 51 bits per transform
			{ 1, 12, 0 },		// 51 bits per transform
			{ 2, 0, 11 },		// 51 bits per transform
			{ 2, 1, 8 },		// 51 bits per transform
			{ 2, 2, 7 },		// 51 bits per transform
			{ 2, 3, 6 },		// 51 bits per transform
			{ 2, 4, 5 },		// 51 bits per transform
			{ 2, 5, 4 },		// 51 bits per transform
			{ 2, 6, 3 },		// 51 bits per transform
			{ 2, 7, 2 },		// 51 bits per transform
			{ 2, 8, 1 },		// 51 bits per transform
			{ 2, 11, 0 },		// 51 bits per transform
			{ 3, 0, 10 },		// 51 bits per transform
			{ 3, 1, 7 },		// 51 bits per transform
			{ 3, 2, 6 },		// 51 bits per transform
			{ 3, 3, 5 },		// 51 bits per transform
			{ 3, 4, 4 },		// 51 bits per transform
			{ 3, 5, 3 },		// 51 bits per transform
			{ 3, 6, 2 },		// 51 bits per transform
			{ 3, 7, 1 },		// 51 bits per transform
			{ 3, 10, 0 },		// 51 bits per transform
			{ 4, 0, 9 },		// 51 bits per transform
			{ 4, 1, 6 },		// 51 bits per transform
			{ 4, 2, 5 },		// 51 bits per transform
			{ 4, 3, 4 },		// 51 bits per transform
			{ 4, 4, 3 },		// 51 bits per transform
			{ 4, 5, 2 },		// 51 bits per transform
			{ 4, 6, 1 },		// 51 bits per transform
			{ 4, 9, 0 },		// 51 bits per transform
			{ 5, 0, 8 },		// 51 bits per transform
			{ 5, 1, 5 },		// 51 bits per transform
			{ 5, 2, 4 },		// 51 bits per transform
			{ 5, 3, 3 },		// 51 bits per transform
			{ 5, 4, 2 },		// 51 bits per transform
			{ 5, 5, 1 },		// 51 bits per transform
			{ 5, 8, 0 },		// 51 bits per transform
			{ 6, 0, 7 },		// 51 bits per transform
			{ 6, 1, 4 },		// 51 bits per transform
			{ 6, 2, 3 },		// 51 bits per transform
			{ 6, 3, 2 },		// 51 bits per transform
			{ 6, 4, 1 },		// 51 bits per transform
			{ 6, 7, 0 },		// 51 bits per transform
			{ 7, 0, 6 },		// 51 bits per transform
			{ 7, 1, 3 },		// 51 bits per transform
			{ 7, 2, 2 },		// 51 bits per transform
			{ 7, 3, 1 },		// 51 bits per transform
			{ 7, 6, 0 },		// 51 bits per transform
			{ 8, 0, 5 },		// 51 bits per transform
			{ 8, 1, 2 },		// 51 bits per transform
			{ 8, 2, 1 },		// 51 bits per transform
			{ 8, 5, 0 },		// 51 bits per transform
			{ 9, 0, 4 },		// 51 bits per transform
			{ 9, 1, 1 },		// 51 bits per transform
			{ 9, 4, 0 },		// 51 bits per transform
			{ 10, 0, 3 },		// 51 bits per transform
			{ 10, 3, 0 },		// 51 bits per transform
			{ 11, 0, 2 },		// 51 bits per transform
			{ 11, 2, 0 },		// 51 bits per transform
			{ 12, 0, 1 },		// 51 bits per transform
			{ 12, 1, 0 },		// 51 bits per transform
			{ 15, 0, 0 },		// 51 bits per transform
			{ 0, 0, 16 },		// 54 bits per transform
			{ 0, 1, 13 },		// 54 bits per transform
			{ 0, 2, 12 },		// 54 bits per transform
			{ 0, 3, 11 },		// 54 bits per transform
			{ 0, 4, 10 },		// 54 bits per transform
			{ 0, 5, 9 },		// 54 bits per transform
			{ 0, 6, 8 },		// 54 bits per transform
			{ 0, 7, 7 },		// 54 bits per transform
			{ 0, 8, 6 },		// 54 bits per transform
			{ 0, 9, 5 },		// 54 bits per transform
			{ 0, 10, 4 },		// 54 bits per transform
			{ 0, 11, 3 },		// 54 bits per transform
			{ 0, 12, 2 },		// 54 bits per transform
			{ 0, 13, 1 },		// 54 bits per transform
			{ 0, 16, 0 },		// 54 bits per transform
			{ 1, 0, 13 },		// 54 bits per transform
			{ 1, 1, 10 },		// 54 bits per transform
			{ 1, 2, 9 },		// 54 bits per transform
			{ 1, 3, 8 },		// 54 bits per transform
			{ 1, 4, 7 },		// 54 bits per transform
			{ 1, 5, 6 },		// 54 bits per transform
			{ 1, 6, 5 },		// 54 bits per transform
			{ 1, 7, 4 },		// 54 bits per transform
			{ 1, 8, 3 },		// 54 bits per transform
			{ 1, 9, 2 },		// 54 bits per transform
			{ 1, 10, 1 },		// 54 bits per transform
			{ 1, 13, 0 },		// 54 bits per transform
			{ 2, 0, 12 },		// 54 bits per transform
			{ 2, 1, 9 },		// 54 bits per transform
			{ 2, 2, 8 },		// 54 bits per transform
			{ 2, 3, 7 },		// 54 bits per transform
			{ 2, 4, 6 },		// 54 bits per transform
			{ 2, 5, 5 },		// 54 bits per transform
			{ 2, 6, 4 },		// 54 bits per transform
			{ 2, 7, 3 },		// 54 bits per transform
			{ 2, 8, 2 },		// 54 bits per transform
			{ 2, 9, 1 },		// 54 bits per transform
			{ 2, 12, 0 },		// 54 bits per transform
			{ 3, 0, 11 },		// 54 bits per transform
			{ 3, 1, 8 },		// 54 bits per transform
			{ 3, 2, 7 },		// 54 bits per transform
			{ 3, 3, 6 },		// 54 bits per transform
			{ 3, 4, 5 },		// 54 bits per transform
			{ 3, 5, 4 },		// 54 bits per transform
			{ 3, 6, 3 },		// 54 bits per transform
			{ 3, 7, 2 },		// 54 bits per transform
			{ 3, 8, 1 },		// 54 bits per transform
			{ 3, 11, 0 },		// 54 bits per transform
			{ 4, 0, 10 },		// 54 bits per transform
			{ 4, 1, 7 },		// 54 bits per transform
			{ 4, 2, 6 },		// 54 bits per transform
			{ 4, 3, 5 },		// 54 bits per transform
			{ 4, 4, 4 },		// 54 bits per transform
			{ 4, 5, 3 },		// 54 bits per transform
			{ 4, 6, 2 },		// 54 bits per transform
			{ 4, 7, 1 },		// 54 bits per transform
			{ 4, 10, 0 },		// 54 bits per transform
			{ 5, 0, 9 },		// 54 bits per transform
			{ 5, 1, 6 },		// 54 bits per transform
			{ 5, 2, 5 },		// 54 bits per transform
			{ 5, 3, 4 },		// 54 bits per transform
			{ 5, 4, 3 },		// 54 bits per transform
			{ 5, 5, 2 },		// 54 bits per transform
			{ 5, 6, 1 },		// 54 bits per transform
			{ 5, 9, 0 },		// 54 bits per transform
			{ 6, 0, 8 },		// 54 bits per transform
			{ 6, 1, 5 },		// 54 bits per transform
			{ 6, 2, 4 },		// 54 bits per transform
			{ 6, 3, 3 },		// 54 bits per transform
			{ 6, 4, 2 },		// 54 bits per transform
			{ 6, 5, 1 },		// 54 bits per transform
			{ 6, 8, 0 },		// 54 bits per transform
			{ 7, 0, 7 },		// 54 bits per transform
			{ 7, 1, 4 },		// 54 bits per transform
			{ 7, 2, 3 },		// 54 bits per transform
			{ 7, 3, 2 },		// 54 bits per transform
			{ 7, 4, 1 },		// 54 bits per transform
			{ 7, 7, 0 },		// 54 bits per transform
			{ 8, 0, 6 },		// 54 bits per transform
			{ 8, 1, 3 },		// 54 bits per transform
			{ 8, 2, 2 },		// 54 bits per transform
			{ 8, 3, 1 },		// 54 bits per transform
			{ 8, 6, 0 },		// 54 bits per transform
			{ 9, 0, 5 },		// 54 bits per transform
			{ 9, 1, 2 },		// 54 bits per transform
			{ 9, 2, 1 },		// 54 bits per transform
			{ 9, 5, 0 },		// 54 bits per transform
			{ 10, 0, 4 },		// 54 bits per transform
			{ 10, 1, 1 },		// 54 bits per transform
			{ 10, 4, 0 },		// 54 bits per transform
			{ 11, 0, 3 },		// 54 bits per transform
			{ 11, 3, 0 },		// 54 bits per transform
			{ 12, 0, 2 },		// 54 bits per transform
			{ 12, 2, 0 },		// 54 bits per transform
			{ 13, 0, 1 },		// 54 bits per transform
			{ 13, 1, 0 },		// 54 bits per transform
			{ 16, 0, 0 },		// 54 bits per transform
			{ 0, 0, 17 },		// 57 bits per transform
			{ 0, 1, 14 },		// 57 bits per transform
			{ 0, 2, 13 },		// 57 bits per transform
			{ 0, 3, 12 },		// 57 bits per transform
			{ 0, 4, 11 },		// 57 bits per transform
			{ 0, 5, 10 },		// 57 bits per transform
			{ 0, 6, 9 },		// 57 bits per transform
			{ 0, 7, 8 },		// 57 bits per transform
			{ 0, 8, 7 },		// 57 bits per transform
			{ 0, 9, 6 },		// 57 bits per transform
			{ 0, 10, 5 },		// 57 bits per transform
			{ 0, 11, 4 },		// 57 bits per transform
			{ 0, 12, 3 },		// 57 bits per transform
			{ 0, 13, 2 },		// 57 bits per transform
			{ 0, 14, 1 },		// 57 bits per transform
			{ 0, 17, 0 },		// 57 bits per transform
			{ 1, 0, 14 },		// 57 bits per transform
			{ 1, 1, 11 },		// 57 bits per transform
			{ 1, 2, 10 },		// 57 bits per transform
			{ 1, 3, 9 },		// 57 bits per transform
			{ 1, 4, 8 },		// 57 bits per transform
			{ 1, 5, 7 },		// 57 bits per transform
			{ 1, 6, 6 },		// 57 bits per transform
			{ 1, 7, 5 },		// 57 bits per transform
			{ 1, 8, 4 },		// 57 bits per transform
			{ 1, 9, 3 },		// 57 bits per transform
			{ 1, 10, 2 },		// 57 bits per transform
			{ 1, 11, 1 },		// 57 bits per transform
			{ 1, 14, 0 },		// 57 bits per transform
			{ 2, 0, 13 },		// 57 bits per transform
			{ 2, 1, 10 },		// 57 bits per transform
			{ 2, 2, 9 },		// 57 bits per transform
			{ 2, 3, 8 },		// 57 bits per transform
			{ 2, 4, 7 },		// 57 bits per transform
			{ 2, 5, 6 },		// 57 bits per transform
			{ 2, 6, 5 },		// 57 bits per transform
			{ 2, 7, 4 },		// 57 bits per transform
			{ 2, 8, 3 },		// 57 bits per transform
			{ 2, 9, 2 },		// 57 bits per transform
			{ 2, 10, 1 },		// 57 bits per transform
			{ 2, 13, 0 },		// 57 bits per transform
			{ 3, 0, 12 },		// 57 bits per transform
			{ 3, 1, 9 },		// 57 bits per transform
			{ 3, 2, 8 },		// 57 bits per transform
			{ 3, 3, 7 },		// 57 bits per transform
			{ 3, 4, 6 },		// 57 bits per transform
			{ 3, 5, 5 },		// 57 bits per transform
			{ 3, 6, 4 },		// 57 bits per transform
			{ 3, 7, 3 },		// 57 bits per transform
			{ 3, 8, 2 },		// 57 bits per transform
			{ 3, 9, 1 },		// 57 bits per transform
			{ 3, 12, 0 },		// 57 bits per transform
			{ 4, 0, 11 },		// 57 bits per transform
			{ 4, 1, 8 },		// 57 bits per transform
			{ 4, 2, 7 },		// 57 bits per transform
			{ 4, 3, 6 },		// 57 bits per transform
			{ 4, 4, 5 },		// 57 bits per transform
			{ 4, 5, 4 },		// 57 bits per transform
			{ 4, 6, 3 },		// 57 bits per transform
			{ 4, 7, 2 },		// 57 bits per transform
			{ 4, 8, 1 },		// 57 bits per transform
			{ 4, 11, 0 },		// 57 bits per transform
			{ 5, 0, 10 },		// 57 bits per transform
			{ 5, 1, 7 },		// 57 bits per transform
			{ 5, 2, 6 },		// 57 bits per transform
			{ 5, 3, 5 },		// 57 bits per transform
			{ 5, 4, 4 },		// 57 bits per transform
			{ 5, 5, 3 },		// 57 bits per transform
			{ 5, 6, 2 },		// 57 bits per transform
			{ 5, 7, 1 },		// 57 bits per transform
			{ 5, 10, 0 },		// 57 bits per transform
			{ 6, 0, 9 },		// 57 bits per transform
			{ 6, 1, 6 },		// 57 bits per transform
			{ 6, 2, 5 },		// 57 bits per transform
			{ 6, 3, 4 },		// 57 bits per transform
			{ 6, 4, 3 },		// 57 bits per transform
			{ 6, 5, 2 },		// 57 bits per transform
			{ 6, 6, 1 },		// 57 bits per transform
			{ 6, 9, 0 },		// 57 bits per transform
			{ 7, 0, 8 },		// 57 bits per transform
			{ 7, 1, 5 },		// 57 bits per transform
			{ 7, 2, 4 },		// 57 bits per transform
			{ 7, 3, 3 },		// 57 bits per transform
			{ 7, 4, 2 },		// 57 bits per transform
			{ 7, 5, 1 },		// 57 bits per transform
			{ 7, 8, 0 },		// 57 bits per transform
			{ 8, 0, 7 },		// 57 bits per transform
			{ 8, 1, 4 },		// 57 bits per transform
			{ 8, 2, 3 },		// 57 bits per transform
			{ 8, 3, 2 },		// 57 bits per transform
			{ 8, 4, 1 },		// 57 bits per transform
			{ 8, 7, 0 },		// 57 bits per transform
			{ 9, 0, 6 },		// 57 bits per transform
			{ 9, 1, 3 },		// 57 bits per transform
			{ 9, 2, 2 },		// 57 bits per transform
			{ 9, 3, 1 },		// 57 bits per transform
			{ 9, 6, 0 },		// 57 bits per transform
			{ 10, 0, 5 },		// 57 bits per transform
			{ 10, 1, 2 },		// 57 bits per transform
			{ 10, 2, 1 },		// 57 bits per transform
			{ 10, 5, 0 },		// 57 bits per transform
			{ 11, 0, 4 },		// 57 bits per transform
			{ 11, 1, 1 },		// 57 bits per transform
			{ 11, 4, 0 },		// 57 bits per transform
			{ 12, 0, 3 },		// 57 bits per transform
			{ 12, 3, 0 },		// 57 bits per transform
			{ 13, 0, 2 },		// 57 bits per transform
			{ 13, 2, 0 },		// 57 bits per transform
			{ 14, 0, 1 },		// 57 bits per transform
			{ 14, 1, 0 },		// 57 bits per transform
			{ 17, 0, 0 },		// 57 bits per transform
			{ 0, 1, 15 },		// 60 bits per transform
			{ 0, 2, 14 },		// 60 bits per transform
			{ 0, 3, 13 },		// 60 bits per transform
			{ 0, 4, 12 },		// 60 bits per transform
			{ 0, 5, 11 },		// 60 bits per transform
			{ 0, 6, 10 },		// 60 bits per transform
			{ 0, 7, 9 },		// 60 bits per transform
			{ 0, 8, 8 },		// 60 bits per transform
			{ 0, 9, 7 },		// 60 bits per transform
			{ 0, 10, 6 },		// 60 bits per transform
			{ 0, 11, 5 },		// 60 bits per transform
			{ 0, 12, 4 },		// 60 bits per transform
			{ 0, 13, 3 },		// 60 bits per transform
			{ 0, 14, 2 },		// 60 bits per transform
			{ 0, 15, 1 },		// 60 bits per transform
			{ 1, 0, 15 },		// 60 bits per transform
			{ 1, 1, 12 },		// 60 bits per transform
			{ 1, 2, 11 },		// 60 bits per transform
			{ 1, 3, 10 },		// 60 bits per transform
			{ 1, 4, 9 },		// 60 bits per transform
			{ 1, 5, 8 },		// 60 bits per transform
			{ 1, 6, 7 },		// 60 bits per transform
			{ 1, 7, 6 },		// 60 bits per transform
			{ 1, 8, 5 },		// 60 bits per transform
			{ 1, 9, 4 },		// 60 bits per transform
			{ 1, 10, 3 },		// 60 bits per transform
			{ 1, 11, 2 },		// 60 bits per transform
			{ 1, 12, 1 },		// 60 bits per transform
			{ 1, 15, 0 },		// 60 bits per transform
			{ 2, 0, 14 },		// 60 bits per transform
			{ 2, 1, 11 },		// 60 bits per transform
			{ 2, 2, 10 },		// 60 bits per transform
			{ 2, 3, 9 },		// 60 bits per transform
			{ 2, 4, 8 },		// 60 bits per transform
			{ 2, 5, 7 },		// 60 bits per transform
			{ 2, 6, 6 },		// 60 bits per transform
			{ 2, 7, 5 },		// 60 bits per transform
			{ 2, 8, 4 },		// 60 bits per transform
			{ 2, 9, 3 },		// 60 bits per transform
			{ 2, 10, 2 },		// 60 bits per transform
			{ 2, 11, 1 },		// 60 bits per transform
			{ 2, 14, 0 },		// 60 bits per transform
			{ 3, 0, 13 },		// 60 bits per transform
			{ 3, 1, 10 },		// 60 bits per transform
			{ 3, 2, 9 },		// 60 bits per transform
			{ 3, 3, 8 },		// 60 bits per transform
			{ 3, 4, 7 },		// 60 bits per transform
			{ 3, 5, 6 },		// 60 bits per transform
			{ 3, 6, 5 },		// 60 bits per transform
			{ 3, 7, 4 },		// 60 bits per transform
			{ 3, 8, 3 },		// 60 bits per transform
			{ 3, 9, 2 },		// 60 bits per transform
			{ 3, 10, 1 },		// 60 bits per transform
			{ 3, 13, 0 },		// 60 bits per transform
			{ 4, 0, 12 },		// 60 bits per transform
			{ 4, 1, 9 },		// 60 bits per transform
			{ 4, 2, 8 },		// 60 bits per transform
			{ 4, 3, 7 },		// 60 bits per transform
			{ 4, 4, 6 },		// 60 bits per transform
			{ 4, 5, 5 },		// 60 bits per transform
			{ 4, 6, 4 },		// 60 bits per transform
			{ 4, 7, 3 },		// 60 bits per transform
			{ 4, 8, 2 },		// 60 bits per transform
			{ 4, 9, 1 },		// 60 bits per transform
			{ 4, 12, 0 },		// 60 bits per transform
			{ 5, 0, 11 },		// 60 bits per transform
			{ 5, 1, 8 },		// 60 bits per transform
			{ 5, 2, 7 },		// 60 bits per transform
			{ 5, 3, 6 },		// 60 bits per transform
			{ 5, 4, 5 },		// 60 bits per transform
			{ 5, 5, 4 },		// 60 bits per transform
			{ 5, 6, 3 },		// 60 bits per transform
			{ 5, 7, 2 },		// 60 bits per transform
			{ 5, 8, 1 },		// 60 bits per transform
			{ 5, 11, 0 },		// 60 bits per transform
			{ 6, 0, 10 },		// 60 bits per transform
			{ 6, 1, 7 },		// 60 bits per transform
			{ 6, 2, 6 },		// 60 bits per transform
			{ 6, 3, 5 },		// 60 bits per transform
			{ 6, 4, 4 },		// 60 bits per transform
			{ 6, 5, 3 },		// 60 bits per transform
			{ 6, 6, 2 },		// 60 bits per transform
			{ 6, 7, 1 },		// 60 bits per transform
			{ 6, 10, 0 },		// 60 bits per transform
			{ 7, 0, 9 },		// 60 bits per transform
			{ 7, 1, 6 },		// 60 bits per transform
			{ 7, 2, 5 },		// 60 bits per transform
			{ 7, 3, 4 },		// 60 bits per transform
			{ 7, 4, 3 },		// 60 bits per transform
			{ 7, 5, 2 },		// 60 bits per transform
			{ 7, 6, 1 },		// 60 bits per transform
			{ 7, 9, 0 },		// 60 bits per transform
			{ 8, 0, 8 },		// 60 bits per transform
			{ 8, 1, 5 },		// 60 bits per transform
			{ 8, 2, 4 },		// 60 bits per transform
			{ 8, 3, 3 },		// 60 bits per transform
			{ 8, 4, 2 },		// 60 bits per transform
			{ 8, 5, 1 },		// 60 bits per transform
			{ 8, 8, 0 },		// 60 bits per transform
			{ 9, 0, 7 },		// 60 bits per transform
			{ 9, 1, 4 },		// 60 bits per transform
			{ 9, 2, 3 },		// 60 bits per transform
			{ 9, 3, 2 },		// 60 bits per transform
			{ 9, 4, 1 },		// 60 bits per transform
			{ 9, 7, 0 },		// 60 bits per transform
			{ 10, 0, 6 },		// 60 bits per transform
			{ 10, 1, 3 },		// 60 bits per transform
			{ 10, 2, 2 },		// 60 bits per transform
			{ 10, 3, 1 },		// 60 bits per transform
			{ 10, 6, 0 },		// 60 bits per transform
			{ 11, 0, 5 },		// 60 bits per transform
			{ 11, 1, 2 },		// 60 bits per transform
			{ 11, 2, 1 },		// 60 bits per transform
			{ 11, 5, 0 },		// 60 bits per transform
			{ 12, 0, 4 },		// 60 bits per transform
			{ 12, 1, 1 },		// 60 bits per transform
			{ 12, 4, 0 },		// 60 bits per transform
			{ 13, 0, 3 },		// 60 bits per transform
			{ 13, 3, 0 },		// 60 bits per transform
			{ 14, 0, 2 },		// 60 bits per transform
			{ 14, 2, 0 },		// 60 bits per transform
			{ 15, 0, 1 },		// 60 bits per transform
			{ 15, 1, 0 },		// 60 bits per transform
			{ 0, 1, 16 },		// 63 bits per transform
			{ 0, 2, 15 },		// 63 bits per transform
			{ 0, 3, 14 },		// 63 bits per transform
			{ 0, 4, 13 },		// 63 bits per transform
			{ 0, 5, 12 },		// 63 bits per transform
			{ 0, 6, 11 },		// 63 bits per transform
			{ 0, 7, 10 },		// 63 bits per transform
			{ 0, 8, 9 },		// 63 bits per transform
			{ 0, 9, 8 },		// 63 bits per transform
			{ 0, 10, 7 },		// 63 bits per transform
			{ 0, 11, 6 },		// 63 bits per transform
			{ 0, 12, 5 },		// 63 bits per transform
			{ 0, 13, 4 },		// 63 bits per transform
			{ 0, 14, 3 },		// 63 bits per transform
			{ 0, 15, 2 },		// 63 bits per transform
			{ 0, 16, 1 },		// 63 bits per transform
			{ 1, 0, 16 },		// 63 bits per transform
			{ 1, 1, 13 },		// 63 bits per transform
			{ 1, 2, 12 },		// 63 bits per transform
			{ 1, 3, 11 },		// 63 bits per transform
			{ 1, 4, 10 },		// 63 bits per transform
			{ 1, 5, 9 },		// 63 bits per transform
			{ 1, 6, 8 },		// 63 bits per transform
			{ 1, 7, 7 },		// 63 bits per transform
			{ 1, 8, 6 },		// 63 bits per transform
			{ 1, 9, 5 },		// 63 bits per transform
			{ 1, 10, 4 },		// 63 bits per transform
			{ 1, 11, 3 },		// 63 bits per transform
			{ 1, 12, 2 },		// 63 bits per transform
			{ 1, 13, 1 },		// 63 bits per transform
			{ 1, 16, 0 },		// 63 bits per transform
			{ 2, 0, 15 },		// 63 bits per transform
			{ 2, 1, 12 },		// 63 bits per transform
			{ 2, 2, 11 },		// 63 bits per transform
			{ 2, 3, 10 },		// 63 bits per transform
			{ 2, 4, 9 },		// 63 bits per transform
			{ 2, 5, 8 },		// 63 bits per transform
			{ 2, 6, 7 },		// 63 bits per transform
			{ 2, 7, 6 },		// 63 bits per transform
			{ 2, 8, 5 },		// 63 bits per transform
			{ 2, 9, 4 },		// 63 bits per transform
			{ 2, 10, 3 },		// 63 bits per transform
			{ 2, 11, 2 },		// 63 bits per transform
			{ 2, 12, 1 },		// 63 bits per transform
			{ 2, 15, 0 },		// 63 bits per transform
			{ 3, 0, 14 },		// 63 bits per transform
			{ 3, 1, 11 },		// 63 bits per transform
			{ 3, 2, 10 },		// 63 bits per transform
			{ 3, 3, 9 },		// 63 bits per transform
			{ 3, 4, 8 },		// 63 bits per transform
			{ 3, 5, 7 },		// 63 bits per transform
			{ 3, 6, 6 },		// 63 bits per transform
			{ 3, 7, 5 },		// 63 bits per transform
			{ 3, 8, 4 },		// 63 bits per transform
			{ 3, 9, 3 },		// 63 bits per transform
			{ 3, 10, 2 },		// 63 bits per transform
			{ 3, 11, 1 },		// 63 bits per transform
			{ 3, 14, 0 },		// 63 bits per transform
			{ 4, 0, 13 },		// 63 bits per transform
			{ 4, 1, 10 },		// 63 bits per transform
			{ 4, 2, 9 },		// 63 bits per transform
			{ 4, 3, 8 },		// 63 bits per transform
			{ 4, 4, 7 },		// 63 bits per transform
			{ 4, 5, 6 },		// 63 bits per transform
			{ 4, 6, 5 },		// 63 bits per transform
			{ 4, 7, 4 },		// 63 bits per transform
			{ 4, 8, 3 },		// 63 bits per transform
			{ 4, 9, 2 },		// 63 bits per transform
			{ 4, 10, 1 },		// 63 bits per transform
			{ 4, 13, 0 },		// 63 bits per transform
			{ 5, 0, 12 },		// 63 bits per transform
			{ 5, 1, 9 },		// 63 bits per transform
			{ 5, 2, 8 },		// 63 bits per transform
			{ 5, 3, 7 },		// 63 bits per transform
			{ 5, 4, 6 },		// 63 bits per transform
			{ 5, 5, 5 },		// 63 bits per transform
			{ 5, 6, 4 },		// 63 bits per transform
			{ 5, 7, 3 },		// 63 bits per transform
			{ 5, 8, 2 },		// 63 bits per transform
			{ 5, 9, 1 },		// 63 bits per transform
			{ 5, 12, 0 },		// 63 bits per transform
			{ 6, 0, 11 },		// 63 bits per transform
			{ 6, 1, 8 },		// 63 bits per transform
			{ 6, 2, 7 },		// 63 bits per transform
			{ 6, 3, 6 },		// 63 bits per transform
			{ 6, 4, 5 },		// 63 bits per transform
			{ 6, 5, 4 },		// 63 bits per transform
			{ 6, 6, 3 },		// 63 bits per transform
			{ 6, 7, 2 },		// 63 bits per transform
			{ 6, 8, 1 },		// 63 bits per transform
			{ 6, 11, 0 },		// 63 bits per transform
			{ 7, 0, 10 },		// 63 bits per transform
			{ 7, 1, 7 },		// 63 bits per transform
			{ 7, 2, 6 },		// 63 bits per transform
			{ 7, 3, 5 },		// 63 bits per transform
			{ 7, 4, 4 },		// 63 bits per transform
			{ 7, 5, 3 },		// 63 bits per transform
			{ 7, 6, 2 },		// 63 bits per transform
			{ 7, 7, 1 },		// 63 bits per transform
			{ 7, 10, 0 },		// 63 bits per transform
			{ 8, 0, 9 },		// 63 bits per transform
			{ 8, 1, 6 },		// 63 bits per transform
			{ 8, 2, 5 },		// 63 bits per transform
			{ 8, 3, 4 },		// 63 bits per transform
			{ 8, 4, 3 },		// 63 bits per transform
			{ 8, 5, 2 },		// 63 bits per transform
			{ 8, 6, 1 },		// 63 bits per transform
			{ 8, 9, 0 },		// 63 bits per transform
			{ 9, 0, 8 },		// 63 bits per transform
			{ 9, 1, 5 },		// 63 bits per transform
			{ 9, 2, 4 },		// 63 bits per transform
			{ 9, 3, 3 },		// 63 bits per transform
			{ 9, 4, 2 },		// 63 bits per transform
			{ 9, 5, 1 },		// 63 bits per transform
			{ 9, 8, 0 },		// 63 bits per transform
			{ 10, 0, 7 },		// 63 bits per transform
			{ 10, 1, 4 },		// 63 bits per transform
			{ 10, 2, 3 },		// 63 bits per transform
			{ 10, 3, 2 },		// 63 bits per transform
			{ 10, 4, 1 },		// 63 bits per transform
			{ 10, 7, 0 },		// 63 bits per transform
			{ 11, 0, 6 },		// 63 bits per transform
			{ 11, 1, 3 },		// 63 bits per transform
			{ 11, 2, 2 },		// 63 bits per transform
			{ 11, 3, 1 },		// 63 bits per transform
			{ 11, 6, 0 },		// 63 bits per transform
			{ 12, 0, 5 },		// 63 bits per transform
			{ 12, 1, 2 },		// 63 bits per transform
			{ 12, 2, 1 },		// 63 bits per transform
			{ 12, 5, 0 },		// 63 bits per transform
			{ 13, 0, 4 },		// 63 bits per transform
			{ 13, 1, 1 },		// 63 bits per transform
			{ 13, 4, 0 },		// 63 bits per transform
			{ 14, 0, 3 },		// 63 bits per transform
			{ 14, 3, 0 },		// 63 bits per transform
			{ 15, 0, 2 },		// 63 bits per transform
			{ 15, 2, 0 },		// 63 bits per transform
			{ 16, 0, 1 },		// 63 bits per transform
			{ 16, 1, 0 },		// 63 bits per transform
			{ 0, 1, 17 },		// 66 bits per transform
			{ 0, 2, 16 },		// 66 bits per transform
			{ 0, 3, 15 },		// 66 bits per transform
			{ 0, 4, 14 },		// 66 bits per transform
			{ 0, 5, 13 },		// 66 bits per transform
			{ 0, 6, 12 },		// 66 bits per transform
			{ 0, 7, 11 },		// 66 bits per transform
			{ 0, 8, 10 },		// 66 bits per transform
			{ 0, 9, 9 },		// 66 bits per transform
			{ 0, 10, 8 },		// 66 bits per transform
			{ 0, 11, 7 },		// 66 bits per transform
			{ 0, 12, 6 },		// 66 bits per transform
			{ 0, 13, 5 },		// 66 bits per transform
			{ 0, 14, 4 },		// 66 bits per transform
			{ 0, 15, 3 },		// 66 bits per transform
			{ 0, 16, 2 },		// 66 bits per transform
			{ 0, 17, 1 },		// 66 bits per transform
			{ 1, 0, 17 },		// 66 bits per transform
			{ 1, 1, 14 },		// 66 bits per transform
			{ 1, 2, 13 },		// 66 bits per transform
			{ 1, 3, 12 },		// 66 bits per transform
			{ 1, 4, 11 },		// 66 bits per transform
			{ 1, 5, 10 },		// 66 bits per transform
			{ 1, 6, 9 },		// 66 bits per transform
			{ 1, 7, 8 },		// 66 bits per transform
			{ 1, 8, 7 },		// 66 bits per transform
			{ 1, 9, 6 },		// 66 bits per transform
			{ 1, 10, 5 },		// 66 bits per transform
			{ 1, 11, 4 },		// 66 bits per transform
			{ 1, 12, 3 },		// 66 bits per transform
			{ 1, 13, 2 },		// 66 bits per transform
			{ 1, 14, 1 },		// 66 bits per transform
			{ 1, 17, 0 },		// 66 bits per transform
			{ 2, 0, 16 },		// 66 bits per transform
			{ 2, 1, 13 },		// 66 bits per transform
			{ 2, 2, 12 },		// 66 bits per transform
			{ 2, 3, 11 },		// 66 bits per transform
			{ 2, 4, 10 },		// 66 bits per transform
			{ 2, 5, 9 },		// 66 bits per transform
			{ 2, 6, 8 },		// 66 bits per transform
			{ 2, 7, 7 },		// 66 bits per transform
			{ 2, 8, 6 },		// 66 bits per transform
			{ 2, 9, 5 },		// 66 bits per transform
			{ 2, 10, 4 },		// 66 bits per transform
			{ 2, 11, 3 },		// 66 bits per transform
			{ 2, 12, 2 },		// 66 bits per transform
			{ 2, 13, 1 },		// 66 bits per transform
			{ 2, 16, 0 },		// 66 bits per transform
			{ 3, 0, 15 },		// 66 bits per transform
			{ 3, 1, 12 },		// 66 bits per transform
			{ 3, 2, 11 },		// 66 bits per transform
			{ 3, 3, 10 },		// 66 bits per transform
			{ 3, 4, 9 },		// 66 bits per transform
			{ 3, 5, 8 },		// 66 bits per transform
			{ 3, 6, 7 },		// 66 bits per transform
			{ 3, 7, 6 },		// 66 bits per transform
			{ 3, 8, 5 },		// 66 bits per transform
			{ 3, 9, 4 },		// 66 bits per transform
			{ 3, 10, 3 },		// 66 bits per transform
			{ 3, 11, 2 },		// 66 bits per transform
			{ 3, 12, 1 },		// 66 bits per transform
			{ 3, 15, 0 },		// 66 bits per transform
			{ 4, 0, 14 },		// 66 bits per transform
			{ 4, 1, 11 },		// 66 bits per transform
			{ 4, 2, 10 },		// 66 bits per transform
			{ 4, 3, 9 },		// 66 bits per transform
			{ 4, 4, 8 },		// 66 bits per transform
			{ 4, 5, 7 },		// 66 bits per transform
			{ 4, 6, 6 },		// 66 bits per transform
			{ 4, 7, 5 },		// 66 bits per transform
			{ 4, 8, 4 },		// 66 bits per transform
			{ 4, 9, 3 },		// 66 bits per transform
			{ 4, 10, 2 },		// 66 bits per transform
			{ 4, 11, 1 },		// 66 bits per transform
			{ 4, 14, 0 },		// 66 bits per transform
			{ 5, 0, 13 },		// 66 bits per transform
			{ 5, 1, 10 },		// 66 bits per transform
			{ 5, 2, 9 },		// 66 bits per transform
			{ 5, 3, 8 },		// 66 bits per transform
			{ 5, 4, 7 },		// 66 bits per transform
			{ 5, 5, 6 },		// 66 bits per transform
			{ 5, 6, 5 },		// 66 bits per transform
			{ 5, 7, 4 },		// 66 bits per transform
			{ 5, 8, 3 },		// 66 bits per transform
			{ 5, 9, 2 },		// 66 bits per transform
			{ 5, 10, 1 },		// 66 bits per transform
			{ 5, 13, 0 },		// 66 bits per transform
			{ 6, 0, 12 },		// 66 bits per transform
			{ 6, 1, 9 },		// 66 bits per transform
			{ 6, 2, 8 },		// 66 bits per transform
			{ 6, 3, 7 },		// 66 bits per transform
			{ 6, 4, 6 },		// 66 bits per transform
			{ 6, 5, 5 },		// 66 bits per transform
			{ 6, 6, 4 },		// 66 bits per transform
			{ 6, 7, 3 },		// 66 bits per transform
			{ 6, 8, 2 },		// 66 bits per transform
			{ 6, 9, 1 },		// 66 bits per transform
			{ 6, 12, 0 },		// 66 bits per transform
			{ 7, 0, 11 },		// 66 bits per transform
			{ 7, 1, 8 },		// 66 bits per transform
			{ 7, 2, 7 },		// 66 bits per transform
			{ 7, 3, 6 },		// 66 bits per transform
			{ 7, 4, 5 },		// 66 bits per transform
			{ 7, 5, 4 },		// 66 bits per transform
			{ 7, 6, 3 },		// 66 bits per transform
			{ 7, 7, 2 },		// 66 bits per transform
			{ 7, 8, 1 },		// 66 bits per transform
			{ 7, 11, 0 },		// 66 bits per transform
			{ 8, 0, 10 },		// 66 bits per transform
			{ 8, 1, 7 },		// 66 bits per transform
			{ 8, 2, 6 },		// 66 bits per transform
			{ 8, 3, 5 },		// 66 bits per transform
			{ 8, 4, 4 },		// 66 bits per transform
			{ 8, 5, 3 },		// 66 bits per transform
			{ 8, 6, 2 },		// 66 bits per transform
			{ 8, 7, 1 },		// 66 bits per transform
			{ 8, 10, 0 },		// 66 bits per transform
			{ 9, 0, 9 },		// 66 bits per transform
			{ 9, 1, 6 },		// 66 bits per transform
			{ 9, 2, 5 },		// 66 bits per transform
			{ 9, 3, 4 },		// 66 bits per transform
			{ 9, 4, 3 },		// 66 bits per transform
			{ 9, 5, 2 },		// 66 bits per transform
			{ 9, 6, 1 },		// 66 bits per transform
			{ 9, 9, 0 },		// 66 bits per transform
			{ 10, 0, 8 },		// 66 bits per transform
			{ 10, 1, 5 },		// 66 bits per transform
			{ 10, 2, 4 },		// 66 bits per transform
			{ 10, 3, 3 },		// 66 bits per transform
			{ 10, 4, 2 },		// 66 bits per transform
			{ 10, 5, 1 },		// 66 bits per transform
			{ 10, 8, 0 },		// 66 bits per transform
			{ 11, 0, 7 },		// 66 bits per transform
			{ 11, 1, 4 },		// 66 bits per transform
			{ 11, 2, 3 },		// 66 bits per transform
			{ 11, 3, 2 },		// 66 bits per transform
			{ 11, 4, 1 },		// 66 bits per transform
			{ 11, 7, 0 },		// 66 bits per transform
			{ 12, 0, 6 },		// 66 bits per transform
			{ 12, 1, 3 },		// 66 bits per transform
			{ 12, 2, 2 },		// 66 bits per transform
			{ 12, 3, 1 },		// 66 bits per transform
			{ 12, 6, 0 },		// 66 bits per transform
			{ 13, 0, 5 },		// 66 bits per transform
			{ 13, 1, 2 },		// 66 bits per transform
			{ 13, 2, 1 },		// 66 bits per transform
			{ 13, 5, 0 },		// 66 bits per transform
			{ 14, 0, 4 },		// 66 bits per transform
			{ 14, 1, 1 },		// 66 bits per transform
			{ 14, 4, 0 },		// 66 bits per transform
			{ 15, 0, 3 },		// 66 bits per transform
			{ 15, 3, 0 },		// 66 bits per transform
			{ 16, 0, 2 },		// 66 bits per transform
			{ 16, 2, 0 },		// 66 bits per transform
			{ 17, 0, 1 },		// 66 bits per transform
			{ 17, 1, 0 },		// 66 bits per transform
			{ 0, 2, 17 },		// 69 bits per transform
			{ 0, 3, 16 },		// 69 bits per transform
			{ 0, 4, 15 },		// 69 bits per transform
			{ 0, 5, 14 },		// 69 bits per transform
			{ 0, 6, 13 },		// 69 bits per transform
			{ 0, 7, 12 },		// 69 bits per transform
			{ 0, 8, 11 },		// 69 bits per transform
			{ 0, 9, 10 },		// 69 bits per transform
			{ 0, 10, 9 },		// 69 bits per transform
			{ 0, 11, 8 },		// 69 bits per transform
			{ 0, 12, 7 },		// 69 bits per transform
			{ 0, 13, 6 },		// 69 bits per transform
			{ 0, 14, 5 },		// 69 bits per transform
			{ 0, 15, 4 },		// 69 bits per transform
			{ 0, 16, 3 },		// 69 bits per transform
			{ 0, 17, 2 },		// 69 bits per transform
			{ 1, 1, 15 },		// 69 bits per transform
			{ 1, 2, 14 },		// 69 bits per transform
			{ 1, 3, 13 },		// 69 bits per transform
			{ 1, 4, 12 },		// 69 bits per transform
			{ 1, 5, 11 },		// 69 bits per transform
			{ 1, 6, 10 },		// 69 bits per transform
			{ 1, 7, 9 },		// 69 bits per transform
			{ 1, 8, 8 },		// 69 bits per transform
			{ 1, 9, 7 },		// 69 bits per transform
			{ 1, 10, 6 },		// 69 bits per transform
			{ 1, 11, 5 },		// 69 bits per transform
			{ 1, 12, 4 },		// 69 bits per transform
			{ 1, 13, 3 },		// 69 bits per transform
			{ 1, 14, 2 },		// 69 bits per transform
			{ 1, 15, 1 },		// 69 bits per transform
			{ 2, 0, 17 },		// 69 bits per transform
			{ 2, 1, 14 },		// 69 bits per transform
			{ 2, 2, 13 },		// 69 bits per transform
			{ 2, 3, 12 },		// 69 bits per transform
			{ 2, 4, 11 },		// 69 bits per transform
			{ 2, 5, 10 },		// 69 bits per transform
			{ 2, 6, 9 },		// 69 bits per transform
			{ 2, 7, 8 },		// 69 bits per transform
			{ 2, 8, 7 },		// 69 bits per transform
			{ 2, 9, 6 },		// 69 bits per transform
			{ 2, 10, 5 },		// 69 bits per transform
			{ 2, 11, 4 },		// 69 bits per transform
			{ 2, 12, 3 },		// 69 bits per transform
			{ 2, 13, 2 },		// 69 bits per transform
			{ 2, 14, 1 },		// 69 bits per transform
			{ 2, 17, 0 },		// 69 bits per transform
			{ 3, 0, 16 },		// 69 bits per transform
			{ 3, 1, 13 },		// 69 bits per transform
			{ 3, 2, 12 },		// 69 bits per transform
			{ 3, 3, 11 },		// 69 bits per transform
			{ 3, 4, 10 },		// 69 bits per transform
			{ 3, 5, 9 },		// 69 bits per transform
			{ 3, 6, 8 },		// 69 bits per transform
			{ 3, 7, 7 },		// 69 bits per transform
			{ 3, 8, 6 },		// 69 bits per transform
			{ 3, 9, 5 },		// 69 bits per transform
			{ 3, 10, 4 },		// 69 bits per transform
			{ 3, 11, 3 },		// 69 bits per transform
			{ 3, 12, 2 },		// 69 bits per transform
			{ 3, 13, 1 },		// 69 bits per transform
			{ 3, 16, 0 },		// 69 bits per transform
			{ 4, 0, 15 },		// 69 bits per transform
			{ 4, 1, 12 },		// 69 bits per transform
			{ 4, 2, 11 },		// 69 bits per transform
			{ 4, 3, 10 },		// 69 bits per transform
			{ 4, 4, 9 },		// 69 bits per transform
			{ 4, 5, 8 },		// 69 bits per transform
			{ 4, 6, 7 },		// 69 bits per transform
			{ 4, 7, 6 },		// 69 bits per transform
			{ 4, 8, 5 },		// 69 bits per transform
			{ 4, 9, 4 },		// 69 bits per transform
			{ 4, 10, 3 },		// 69 bits per transform
			{ 4, 11, 2 },		// 69 bits per transform
			{ 4, 12, 1 },		// 69 bits per transform
			{ 4, 15, 0 },		// 69 bits per transform
			{ 5, 0, 14 },		// 69 bits per transform
			{ 5, 1, 11 },		// 69 bits per transform
			{ 5, 2, 10 },		// 69 bits per transform
			{ 5, 3, 9 },		// 69 bits per transform
			{ 5, 4, 8 },		// 69 bits per transform
			{ 5, 5, 7 },		// 69 bits per transform
			{ 5, 6, 6 },		// 69 bits per transform
			{ 5, 7, 5 },		// 69 bits per transform
			{ 5, 8, 4 },		// 69 bits per transform
			{ 5, 9, 3 },		// 69 bits per transform
			{ 5, 10, 2 },		// 69 bits per transform
			{ 5, 11, 1 },		// 69 bits per transform
			{ 5, 14, 0 },		// 69 bits per transform
			{ 6, 0, 13 },		// 69 bits per transform
			{ 6, 1, 10 },		// 69 bits per transform
			{ 6, 2, 9 },		// 69 bits per transform
			{ 6, 3, 8 },		// 69 bits per transform
			{ 6, 4, 7 },		// 69 bits per transform
			{ 6, 5, 6 },		// 69 bits per transform
			{ 6, 6, 5 },		// 69 bits per transform
			{ 6, 7, 4 },		// 69 bits per transform
			{ 6, 8, 3 },		// 69 bits per transform
			{ 6, 9, 2 },		// 69 bits per transform
			{ 6, 10, 1 },		// 69 bits per transform
			{ 6, 13, 0 },		// 69 bits per transform
			{ 7, 0, 12 },		// 69 bits per transform
			{ 7, 1, 9 },		// 69 bits per transform
			{ 7, 2, 8 },		// 69 bits per transform
			{ 7, 3, 7 },		// 69 bits per transform
			{ 7, 4, 6 },		// 69 bits per transform
			{ 7, 5, 5 },		// 69 bits per transform
			{ 7, 6, 4 },		// 69 bits per transform
			{ 7, 7, 3 },		// 69 bits per transform
			{ 7, 8, 2 },		// 69 bits per transform
			{ 7, 9, 1 },		// 69 bits per transform
			{ 7, 12, 0 },		// 69 bits per transform
			{ 8, 0, 11 },		// 69 bits per transform
			{ 8, 1, 8 },		// 69 bits per transform
			{ 8, 2, 7 },		// 69 bits per transform
			{ 8, 3, 6 },		// 69 bits per transform
			{ 8, 4, 5 },		// 69 bits per transform
			{ 8, 5, 4 },		// 69 bits per transform
			{ 8, 6, 3 },		// 69 bits per transform
			{ 8, 7, 2 },		// 69 bits per transform
			{ 8, 8, 1 },		// 69 bits per transform
			{ 8, 11, 0 },		// 69 bits per transform
			{ 9, 0, 10 },		// 69 bits per transform
			{ 9, 1, 7 },		// 69 bits per transform
			{ 9, 2, 6 },		// 69 bits per transform
			{ 9, 3, 5 },		// 69 bits per transform
			{ 9, 4, 4 },		// 69 bits per transform
			{ 9, 5, 3 },		// 69 bits per transform
			{ 9, 6, 2 },		// 69 bits per transform
			{ 9, 7, 1 },		// 69 bits per transform
			{ 9, 10, 0 },		// 69 bits per transform
			{ 10, 0, 9 },		// 69 bits per transform
			{ 10, 1, 6 },		// 69 bits per transform
			{ 10, 2, 5 },		// 69 bits per transform
			{ 10, 3, 4 },		// 69 bits per transform
			{ 10, 4, 3 },		// 69 bits per transform
			{ 10, 5, 2 },		// 69 bits per transform
			{ 10, 6, 1 },		// 69 bits per transform
			{ 10, 9, 0 },		// 69 bits per transform
			{ 11, 0, 8 },		// 69 bits per transform
			{ 11, 1, 5 },		// 69 bits per transform
			{ 11, 2, 4 },		// 69 bits per transform
			{ 11, 3, 3 },		// 69 bits per transform
			{ 11, 4, 2 },		// 69 bits per transform
			{ 11, 5, 1 },		// 69 bits per transform
			{ 11, 8, 0 },		// 69 bits per transform
			{ 12, 0, 7 },		// 69 bits per transform
			{ 12, 1, 4 },		// 69 bits per transform
			{ 12, 2, 3 },		// 69 bits per transform
			{ 12, 3, 2 },		// 69 bits per transform
			{ 12, 4, 1 },		// 69 bits per transform
			{ 12, 7, 0 },		// 69 bits per transform
			{ 13, 0, 6 },		// 69 bits per transform
			{ 13, 1, 3 },		// 69 bits per transform
			{ 13, 2, 2 },		// 69 bits per transform
			{ 13, 3, 1 },		// 69 bits per transform
			{ 13, 6, 0 },		// 69 bits per transform
			{ 14, 0, 5 },		// 69 bits per transform
			{ 14, 1, 2 },		// 69 bits per transform
			{ 14, 2, 1 },		// 69 bits per transform
			{ 14, 5, 0 },		// 69 bits per transform
			{ 15, 0, 4 },		// 69 bits per transform
			{ 15, 1, 1 },		// 69 bits per transform
			{ 15, 4, 0 },		// 69 bits per transform
			{ 16, 0, 3 },		// 69 bits per transform
			{ 16, 3, 0 },		// 69 bits per transform
			{ 17, 0, 2 },		// 69 bits per transform
			{ 17, 2, 0 },		// 69 bits per transform
			{ 0, 3, 17 },		// 72 bits per transform
			{ 0, 4, 16 },		// 72 bits per transform
			{ 0, 5, 15 },		// 72 bits per transform
			{ 0, 6, 14 },		// 72 bits per transform
			{ 0, 7, 13 },		// 72 bits per transform
			{ 0, 8, 12 },		// 72 bits per transform
			{ 0, 9, 11 },		// 72 bits per transform
			{ 0, 10, 10 },		// 72 bits per transform
			{ 0, 11, 9 },		// 72 bits per transform
			{ 0, 12, 8 },		// 72 bits per transform
			{ 0, 13, 7 },		// 72 bits per transform
			{ 0, 14, 6 },		// 72 bits per transform
			{ 0, 15, 5 },		// 72 bits per transform
			{ 0, 16, 4 },		// 72 bits per transform
			{ 0, 17, 3 },		// 72 bits per transform
			{ 1, 1, 16 },		// 72 bits per transform
			{ 1, 2, 15 },		// 72 bits per transform
			{ 1, 3, 14 },		// 72 bits per transform
			{ 1, 4, 13 },		// 72 bits per transform
			{ 1, 5, 12 },		// 72 bits per transform
			{ 1, 6, 11 },		// 72 bits per transform
			{ 1, 7, 10 },		// 72 bits per transform
			{ 1, 8, 9 },		// 72 bits per transform
			{ 1, 9, 8 },		// 72 bits per transform
			{ 1, 10, 7 },		// 72 bits per transform
			{ 1, 11, 6 },		// 72 bits per transform
			{ 1, 12, 5 },		// 72 bits per transform
			{ 1, 13, 4 },		// 72 bits per transform
			{ 1, 14, 3 },		// 72 bits per transform
			{ 1, 15, 2 },		// 72 bits per transform
			{ 1, 16, 1 },		// 72 bits per transform
			{ 2, 1, 15 },		// 72 bits per transform
			{ 2, 2, 14 },		// 72 bits per transform
			{ 2, 3, 13 },		// 72 bits per transform
			{ 2, 4, 12 },		// 72 bits per transform
			{ 2, 5, 11 },		// 72 bits per transform
			{ 2, 6, 10 },		// 72 bits per transform
			{ 2, 7, 9 },		// 72 bits per transform
			{ 2, 8, 8 },		// 72 bits per transform
			{ 2, 9, 7 },		// 72 bits per transform
			{ 2, 10, 6 },		// 72 bits per transform
			{ 2, 11, 5 },		// 72 bits per transform
			{ 2, 12, 4 },		// 72 bits per transform
			{ 2, 13, 3 },		// 72 bits per transform
			{ 2, 14, 2 },		// 72 bits per transform
			{ 2, 15, 1 },		// 72 bits per transform
			{ 3, 0, 17 },		// 72 bits per transform
			{ 3, 1, 14 },		// 72 bits per transform
			{ 3, 2, 13 },		// 72 bits per transform
			{ 3, 3, 12 },		// 72 bits per transform
			{ 3, 4, 11 },		// 72 bits per transform
			{ 3, 5, 10 },		// 72 bits per transform
			{ 3, 6, 9 },		// 72 bits per transform
			{ 3, 7, 8 },		// 72 bits per transform
			{ 3, 8, 7 },		// 72 bits per transform
			{ 3, 9, 6 },		// 72 bits per transform
			{ 3, 10, 5 },		// 72 bits per transform
			{ 3, 11, 4 },		// 72 bits per transform
			{ 3, 12, 3 },		// 72 bits per transform
			{ 3, 13, 2 },		// 72 bits per transform
			{ 3, 14, 1 },		// 72 bits per transform
			{ 3, 17, 0 },		// 72 bits per transform
			{ 4, 0, 16 },		// 72 bits per transform
			{ 4, 1, 13 },		// 72 bits per transform
			{ 4, 2, 12 },		// 72 bits per transform
			{ 4, 3, 11 },		// 72 bits per transform
			{ 4, 4, 10 },		// 72 bits per transform
			{ 4, 5, 9 },		// 72 bits per transform
			{ 4, 6, 8 },		// 72 bits per transform
			{ 4, 7, 7 },		// 72 bits per transform
			{ 4, 8, 6 },		// 72 bits per transform
			{ 4, 9, 5 },		// 72 bits per transform
			{ 4, 10, 4 },		// 72 bits per transform
			{ 4, 11, 3 },		// 72 bits per transform
			{ 4, 12, 2 },		// 72 bits per transform
			{ 4, 13, 1 },		// 72 bits per transform
			{ 4, 16, 0 },		// 72 bits per transform
			{ 5, 0, 15 },		// 72 bits per transform
			{ 5, 1, 12 },		// 72 bits per transform
			{ 5, 2, 11 },		// 72 bits per transform
			{ 5, 3, 10 },		// 72 bits per transform
			{ 5, 4, 9 },		// 72 bits per transform
			{ 5, 5, 8 },		// 72 bits per transform
			{ 5, 6, 7 },		// 72 bits per transform
			{ 5, 7, 6 },		// 72 bits per transform
			{ 5, 8, 5 },		// 72 bits per transform
			{ 5, 9, 4 },		// 72 bits per transform
			{ 5, 10, 3 },		// 72 bits per transform
			{ 5, 11, 2 },		// 72 bits per transform
			{ 5, 12, 1 },		// 72 bits per transform
			{ 5, 15, 0 },		// 72 bits per transform
			{ 6, 0, 14 },		// 72 bits per transform
			{ 6, 1, 11 },		// 72 bits per transform
			{ 6, 2, 10 },		// 72 bits per transform
			{ 6, 3, 9 },		// 72 bits per transform
			{ 6, 4, 8 },		// 72 bits per transform
			{ 6, 5, 7 },		// 72 bits per transform
			{ 6, 6, 6 },		// 72 bits per transform
			{ 6, 7, 5 },		// 72 bits per transform
			{ 6, 8, 4 },		// 72 bits per transform
			{ 6, 9, 3 },		// 72 bits per transform
			{ 6, 10, 2 },		// 72 bits per transform
			{ 6, 11, 1 },		// 72 bits per transform
			{ 6, 14, 0 },		// 72 bits per transform
			{ 7, 0, 13 },		// 72 bits per transform
			{ 7, 1, 10 },		// 72 bits per transform
			{ 7, 2, 9 },		// 72 bits per transform
			{ 7, 3, 8 },		// 72 bits per transform
			{ 7, 4, 7 },		// 72 bits per transform
			{ 7, 5, 6 },		// 72 bits per transform
			{ 7, 6, 5 },		// 72 bits per transform
			{ 7, 7, 4 },		// 72 bits per transform
			{ 7, 8, 3 },		// 72 bits per transform
			{ 7, 9, 2 },		// 72 bits per transform
			{ 7, 10, 1 },		// 72 bits per transform
			{ 7, 13, 0 },		// 72 bits per transform
			{ 8, 0, 12 },		// 72 bits per transform
			{ 8, 1, 9 },		// 72 bits per transform
			{ 8, 2, 8 },		// 72 bits per transform
			{ 8, 3, 7 },		// 72 bits per transform
			{ 8, 4, 6 },		// 72 bits per transform
			{ 8, 5, 5 },		// 72 bits per transform
			{ 8, 6, 4 },		// 72 bits per transform
			{ 8, 7, 3 },		// 72 bits per transform
			{ 8, 8, 2 },		// 72 bits per transform
			{ 8, 9, 1 },		// 72 bits per transform
			{ 8, 12, 0 },		// 72 bits per transform
			{ 9, 0, 11 },		// 72 bits per transform
			{ 9, 1, 8 },		// 72 bits per transform
			{ 9, 2, 7 },		// 72 bits per transform
			{ 9, 3, 6 },		// 72 bits per transform
			{ 9, 4, 5 },		// 72 bits per transform
			{ 9, 5, 4 },		// 72 bits per transform
			{ 9, 6, 3 },		// 72 bits per transform
			{ 9, 7, 2 },		// 72 bits per transform
			{ 9, 8, 1 },		// 72 bits per transform
			{ 9, 11, 0 },		// 72 bits per transform
			{ 10, 0, 10 },		// 72 bits per transform
			{ 10, 1, 7 },		// 72 bits per transform
			{ 10, 2, 6 },		// 72 bits per transform
			{ 10, 3, 5 },		// 72 bits per transform
			{ 10, 4, 4 },		// 72 bits per transform
			{ 10, 5, 3 },		// 72 bits per transform
			{ 10, 6, 2 },		// 72 bits per transform
			{ 10, 7, 1 },		// 72 bits per transform
			{ 10, 10, 0 },		// 72 bits per transform
			{ 11, 0, 9 },		// 72 bits per transform
			{ 11, 1, 6 },		// 72 bits per transform
			{ 11, 2, 5 },		// 72 bits per transform
			{ 11, 3, 4 },		// 72 bits per transform
			{ 11, 4, 3 },		// 72 bits per transform
			{ 11, 5, 2 },		// 72 bits per transform
			{ 11, 6, 1 },		// 72 bits per transform
			{ 11, 9, 0 },		// 72 bits per transform
			{ 12, 0, 8 },		// 72 bits per transform
			{ 12, 1, 5 },		// 72 bits per transform
			{ 12, 2, 4 },		// 72 bits per transform
			{ 12, 3, 3 },		// 72 bits per transform
			{ 12, 4, 2 },		// 72 bits per transform
			{ 12, 5, 1 },		// 72 bits per transform
			{ 12, 8, 0 },		// 72 bits per transform
			{ 13, 0, 7 },		// 72 bits per transform
			{ 13, 1, 4 },		// 72 bits per transform
			{ 13, 2, 3 },		// 72 bits per transform
			{ 13, 3, 2 },		// 72 bits per transform
			{ 13, 4, 1 },		// 72 bits per transform
			{ 13, 7, 0 },		// 72 bits per transform
			{ 14, 0, 6 },		// 72 bits per transform
			{ 14, 1, 3 },		// 72 bits per transform
			{ 14, 2, 2 },		// 72 bits per transform
			{ 14, 3, 1 },		// 72 bits per transform
			{ 14, 6, 0 },		// 72 bits per transform
			{ 15, 0, 5 },		// 72 bits per transform
			{ 15, 1, 2 },		// 72 bits per transform
			{ 15, 2, 1 },		// 72 bits per transform
			{ 15, 5, 0 },		// 72 bits per transform
			{ 16, 0, 4 },		// 72 bits per transform
			{ 16, 1, 1 },		// 72 bits per transform
			{ 16, 4, 0 },		// 72 bits per transform
			{ 17, 0, 3 },		// 72 bits per transform
			{ 17, 3, 0 },		// 72 bits per transform
			{ 0, 4, 17 },		// 75 bits per transform
			{ 0, 5, 16 },		// 75 bits per transform
			{ 0, 6, 15 },		// 75 bits per transform
			{ 0, 7, 14 },		// 75 bits per transform
			{ 0, 8, 13 },		// 75 bits per transform
			{ 0, 9, 12 },		// 75 bits per transform
			{ 0, 10, 11 },		// 75 bits per transform
			{ 0, 11, 10 },		// 75 bits per transform
			{ 0, 12, 9 },		// 75 bits per transform
			{ 0, 13, 8 },		// 75 bits per transform
			{ 0, 14, 7 },		// 75 bits per transform
			{ 0, 15, 6 },		// 75 bits per transform
			{ 0, 16, 5 },		// 75 bits per transform
			{ 0, 17, 4 },		// 75 bits per transform
			{ 1, 1, 17 },		// 75 bits per transform
			{ 1, 2, 16 },		// 75 bits per transform
			{ 1, 3, 15 },		// 75 bits per transform
			{ 1, 4, 14 },		// 75 bits per transform
			{ 1, 5, 13 },		// 75 bits per transform
			{ 1, 6, 12 },		// 75 bits per transform
			{ 1, 7, 11 },		// 75 bits per transform
			{ 1, 8, 10 },		// 75 bits per transform
			{ 1, 9, 9 },		// 75 bits per transform
			{ 1, 10, 8 },		// 75 bits per transform
			{ 1, 11, 7 },		// 75 bits per transform
			{ 1, 12, 6 },		// 75 bits per transform
			{ 1, 13, 5 },		// 75 bits per transform
			{ 1, 14, 4 },		// 75 bits per transform
			{ 1, 15, 3 },		// 75 bits per transform
			{ 1, 16, 2 },		// 75 bits per transform
			{ 1, 17, 1 },		// 75 bits per transform
			{ 2, 1, 16 },		// 75 bits per transform
			{ 2, 2, 15 },		// 75 bits per transform
			{ 2, 3, 14 },		// 75 bits per transform
			{ 2, 4, 13 },		// 75 bits per transform
			{ 2, 5, 12 },		// 75 bits per transform
			{ 2, 6, 11 },		// 75 bits per transform
			{ 2, 7, 10 },		// 75 bits per transform
			{ 2, 8, 9 },		// 75 bits per transform
			{ 2, 9, 8 },		// 75 bits per transform
			{ 2, 10, 7 },		// 75 bits per transform
			{ 2, 11, 6 },		// 75 bits per transform
			{ 2, 12, 5 },		// 75 bits per transform
			{ 2, 13, 4 },		// 75 bits per transform
			{ 2, 14, 3 },		// 75 bits per transform
			{ 2, 15, 2 },		// 75 bits per transform
			{ 2, 16, 1 },		// 75 bits per transform
			{ 3, 1, 15 },		// 75 bits per transform
			{ 3, 2, 14 },		// 75 bits per transform
			{ 3, 3, 13 },		// 75 bits per transform
			{ 3, 4, 12 },		// 75 bits per transform
			{ 3, 5, 11 },		// 75 bits per transform
			{ 3, 6, 10 },		// 75 bits per transform
			{ 3, 7, 9 },		// 75 bits per transform
			{ 3, 8, 8 },		// 75 bits per transform
			{ 3, 9, 7 },		// 75 bits per transform
			{ 3, 10, 6 },		// 75 bits per transform
			{ 3, 11, 5 },		// 75 bits per transform
			{ 3, 12, 4 },		// 75 bits per transform
			{ 3, 13, 3 },		// 75 bits per transform
			{ 3, 14, 2 },		// 75 bits per transform
			{ 3, 15, 1 },		// 75 bits per transform
			{ 4, 0, 17 },		// 75 bits per transform
			{ 4, 1, 14 },		// 75 bits per transform
			{ 4, 2, 13 },		// 75 bits per transform
			{ 4, 3, 12 },		// 75 bits per transform
			{ 4, 4, 11 },		// 75 bits per transform
			{ 4, 5, 10 },		// 75 bits per transform
			{ 4, 6, 9 },		// 75 bits per transform
			{ 4, 7, 8 },		// 75 bits per transform
			{ 4, 8, 7 },		// 75 bits per transform
			{ 4, 9, 6 },		// 75 bits per transform
			{ 4, 10, 5 },		// 75 bits per transform
			{ 4, 11, 4 },		// 75 bits per transform
			{ 4, 12, 3 },		// 75 bits per transform
			{ 4, 13, 2 },		// 75 bits per transform
			{ 4, 14, 1 },		// 75 bits per transform
			{ 4, 17, 0 },		// 75 bits per transform
			{ 5, 0, 16 },		// 75 bits per transform
			{ 5, 1, 13 },		// 75 bits per transform
			{ 5, 2, 12 },		// 75 bits per transform
			{ 5, 3, 11 },		// 75 bits per transform
			{ 5, 4, 10 },		// 75 bits per transform
			{ 5, 5, 9 },		// 75 bits per transform
			{ 5, 6, 8 },		// 75 bits per transform
			{ 5, 7, 7 },		// 75 bits per transform
			{ 5, 8, 6 },		// 75 bits per transform
			{ 5, 9, 5 },		// 75 bits per transform
			{ 5, 10, 4 },		// 75 bits per transform
			{ 5, 11, 3 },		// 75 bits per transform
			{ 5, 12, 2 },		// 75 bits per transform
			{ 5, 13, 1 },		// 75 bits per transform
			{ 5, 16, 0 },		// 75 bits per transform
			{ 6, 0, 15 },		// 75 bits per transform
			{ 6, 1, 12 },		// 75 bits per transform
			{ 6, 2, 11 },		// 75 bits per transform
			{ 6, 3, 10 },		// 75 bits per transform
			{ 6, 4, 9 },		// 75 bits per transform
			{ 6, 5, 8 },		// 75 bits per transform
			{ 6, 6, 7 },		// 75 bits per transform
			{ 6, 7, 6 },		// 75 bits per transform
			{ 6, 8, 5 },		// 75 bits per transform
			{ 6, 9, 4 },		// 75 bits per transform
			{ 6, 10, 3 },		// 75 bits per transform
			{ 6, 11, 2 },		// 75 bits per transform
			{ 6, 12, 1 },		// 75 bits per transform
			{ 6, 15, 0 },		// 75 bits per transform
			{ 7, 0, 14 },		// 75 bits per transform
			{ 7, 1, 11 },		// 75 bits per transform
			{ 7, 2, 10 },		// 75 bits per transform
			{ 7, 3, 9 },		// 75 bits per transform
			{ 7, 4, 8 },		// 75 bits per transform
			{ 7, 5, 7 },		// 75 bits per transform
			{ 7, 6, 6 },		// 75 bits per transform
			{ 7, 7, 5 },		// 75 bits per transform
			{ 7, 8, 4 },		// 75 bits per transform
			{ 7, 9, 3 },		// 75 bits per transform
			{ 7, 10, 2 },		// 75 bits per transform
			{ 7, 11, 1 },		// 75 bits per transform
			{ 7, 14, 0 },		// 75 bits per transform
			{ 8, 0, 13 },		// 75 bits per transform
			{ 8, 1, 10 },		// 75 bits per transform
			{ 8, 2, 9 },		// 75 bits per transform
			{ 8, 3, 8 },		// 75 bits per transform
			{ 8, 4, 7 },		// 75 bits per transform
			{ 8, 5, 6 },		// 75 bits per transform
			{ 8, 6, 5 },		// 75 bits per transform
			{ 8, 7, 4 },		// 75 bits per transform
			{ 8, 8, 3 },		// 75 bits per transform
			{ 8, 9, 2 },		// 75 bits per transform
			{ 8, 10, 1 },		// 75 bits per transform
			{ 8, 13, 0 },		// 75 bits per transform
			{ 9, 0, 12 },		// 75 bits per transform
			{ 9, 1, 9 },		// 75 bits per transform
			{ 9, 2, 8 },		// 75 bits per transform
			{ 9, 3, 7 },		// 75 bits per transform
			{ 9, 4, 6 },		// 75 bits per transform
			{ 9, 5, 5 },		// 75 bits per transform
			{ 9, 6, 4 },		// 75 bits per transform
			{ 9, 7, 3 },		// 75 bits per transform
			{ 9, 8, 2 },		// 75 bits per transform
			{ 9, 9, 1 },		// 75 bits per transform
			{ 9, 12, 0 },		// 75 bits per transform
			{ 10, 0, 11 },		// 75 bits per transform
			{ 10, 1, 8 },		// 75 bits per transform
			{ 10, 2, 7 },		// 75 bits per transform
			{ 10, 3, 6 },		// 75 bits per transform
			{ 10, 4, 5 },		// 75 bits per transform
			{ 10, 5, 4 },		// 75 bits per transform
			{ 10, 6, 3 },		// 75 bits per transform
			{ 10, 7, 2 },		// 75 bits per transform
			{ 10, 8, 1 },		// 75 bits per transform
			{ 10, 11, 0 },		// 75 bits per transform
			{ 11, 0, 10 },		// 75 bits per transform
			{ 11, 1, 7 },		// 75 bits per transform
			{ 11, 2, 6 },		// 75 bits per transform
			{ 11, 3, 5 },		// 75 bits per transform
			{ 11, 4, 4 },		// 75 bits per transform
			{ 11, 5, 3 },		// 75 bits per transform
			{ 11, 6, 2 },		// 75 bits per transform
			{ 11, 7, 1 },		// 75 bits per transform
			{ 11, 10, 0 },		// 75 bits per transform
			{ 12, 0, 9 },		// 75 bits per transform
			{ 12, 1, 6 },		// 75 bits per transform
			{ 12, 2, 5 },		// 75 bits per transform
			{ 12, 3, 4 },		// 75 bits per transform
			{ 12, 4, 3 },		// 75 bits per transform
			{ 12, 5, 2 },		// 75 bits per transform
			{ 12, 6, 1 },		// 75 bits per transform
			{ 12, 9, 0 },		// 75 bits per transform
			{ 13, 0, 8 },		// 75 bits per transform
			{ 13, 1, 5 },		// 75 bits per transform
			{ 13, 2, 4 },		// 75 bits per transform
			{ 13, 3, 3 },		// 75 bits per transform
			{ 13, 4, 2 },		// 75 bits per transform
			{ 13, 5, 1 },		// 75 bits per transform
			{ 13, 8, 0 },		// 75 bits per transform
			{ 14, 0, 7 },		// 75 bits per transform
			{ 14, 1, 4 },		// 75 bits per transform
			{ 14, 2, 3 },		// 75 bits per transform
			{ 14, 3, 2 },		// 75 bits per transform
			{ 14, 4, 1 },		// 75 bits per transform
			{ 14, 7, 0 },		// 75 bits per transform
			{ 15, 0, 6 },		// 75 bits per transform
			{ 15, 1, 3 },		// 75 bits per transform
			{ 15, 2, 2 },		// 75 bits per transform
			{ 15, 3, 1 },		// 75 bits per transform
			{ 15, 6, 0 },		// 75 bits per transform
			{ 16, 0, 5 },		// 75 bits per transform
			{ 16, 1, 2 },		// 75 bits per transform
			{ 16, 2, 1 },		// 75 bits per transform
			{ 16, 5, 0 },		// 75 bits per transform
			{ 17, 0, 4 },		// 75 bits per transform
			{ 17, 1, 1 },		// 75 bits per transform
			{ 17, 4, 0 },		// 75 bits per transform
			{ 0, 5, 17 },		// 78 bits per transform
			{ 0, 6, 16 },		// 78 bits per transform
			{ 0, 7, 15 },		// 78 bits per transform
			{ 0, 8, 14 },		// 78 bits per transform
			{ 0, 9, 13 },		// 78 bits per transform
			{ 0, 10, 12 },		// 78 bits per transform
			{ 0, 11, 11 },		// 78 bits per transform
			{ 0, 12, 10 },		// 78 bits per transform
			{ 0, 13, 9 },		// 78 bits per transform
			{ 0, 14, 8 },		// 78 bits per transform
			{ 0, 15, 7 },		// 78 bits per transform
			{ 0, 16, 6 },		// 78 bits per transform
			{ 0, 17, 5 },		// 78 bits per transform
			{ 1, 2, 17 },		// 78 bits per transform
			{ 1, 3, 16 },		// 78 bits per transform
			{ 1, 4, 15 },		// 78 bits per transform
			{ 1, 5, 14 },		// 78 bits per transform
			{ 1, 6, 13 },		// 78 bits per transform
			{ 1, 7, 12 },		// 78 bits per transform
			{ 1, 8, 11 },		// 78 bits per transform
			{ 1, 9, 10 },		// 78 bits per transform
			{ 1, 10, 9 },		// 78 bits per transform
			{ 1, 11, 8 },		// 78 bits per transform
			{ 1, 12, 7 },		// 78 bits per transform
			{ 1, 13, 6 },		// 78 bits per transform
			{ 1, 14, 5 },		// 78 bits per transform
			{ 1, 15, 4 },		// 78 bits per transform
			{ 1, 16, 3 },		// 78 bits per transform
			{ 1, 17, 2 },		// 78 bits per transform
			{ 2, 1, 17 },		// 78 bits per transform
			{ 2, 2, 16 },		// 78 bits per transform
			{ 2, 3, 15 },		// 78 bits per transform
			{ 2, 4, 14 },		// 78 bits per transform
			{ 2, 5, 13 },		// 78 bits per transform
			{ 2, 6, 12 },		// 78 bits per transform
			{ 2, 7, 11 },		// 78 bits per transform
			{ 2, 8, 10 },		// 78 bits per transform
			{ 2, 9, 9 },		// 78 bits per transform
			{ 2, 10, 8 },		// 78 bits per transform
			{ 2, 11, 7 },		// 78 bits per transform
			{ 2, 12, 6 },		// 78 bits per transform
			{ 2, 13, 5 },		// 78 bits per transform
			{ 2, 14, 4 },		// 78 bits per transform
			{ 2, 15, 3 },		// 78 bits per transform
			{ 2, 16, 2 },		// 78 bits per transform
			{ 2, 17, 1 },		// 78 bits per transform
			{ 3, 1, 16 },		// 78 bits per transform
			{ 3, 2, 15 },		// 78 bits per transform
			{ 3, 3, 14 },		// 78 bits per transform
			{ 3, 4, 13 },		// 78 bits per transform
			{ 3, 5, 12 },		// 78 bits per transform
			{ 3, 6, 11 },		// 78 bits per transform
			{ 3, 7, 10 },		// 78 bits per transform
			{ 3, 8, 9 },		// 78 bits per transform
			{ 3, 9, 8 },		// 78 bits per transform
			{ 3, 10, 7 },		// 78 bits per transform
			{ 3, 11, 6 },		// 78 bits per transform
			{ 3, 12, 5 },		// 78 bits per transform
			{ 3, 13, 4 },		// 78 bits per transform
			{ 3, 14, 3 },		// 78 bits per transform
			{ 3, 15, 2 },		// 78 bits per transform
			{ 3, 16, 1 },		// 78 bits per transform
			{ 4, 1, 15 },		// 78 bits per transform
			{ 4, 2, 14 },		// 78 bits per transform
			{ 4, 3, 13 },		// 78 bits per transform
			{ 4, 4, 12 },		// 78 bits per transform
			{ 4, 5, 11 },		// 78 bits per transform
			{ 4, 6, 10 },		// 78 bits per transform
			{ 4, 7, 9 },		// 78 bits per transform
			{ 4, 8, 8 },		// 78 bits per transform
			{ 4, 9, 7 },		// 78 bits per transform
			{ 4, 10, 6 },		// 78 bits per transform
			{ 4, 11, 5 },		// 78 bits per transform
			{ 4, 12, 4 },		// 78 bits per transform
			{ 4, 13, 3 },		// 78 bits per transform
			{ 4, 14, 2 },		// 78 bits per transform
			{ 4, 15, 1 },		// 78 bits per transform
			{ 5, 0, 17 },		// 78 bits per transform
			{ 5, 1, 14 },		// 78 bits per transform
			{ 5, 2, 13 },		// 78 bits per transform
			{ 5, 3, 12 },		// 78 bits per transform
			{ 5, 4, 11 },		// 78 bits per transform
			{ 5, 5, 10 },		// 78 bits per transform
			{ 5, 6, 9 },		// 78 bits per transform
			{ 5, 7, 8 },		// 78 bits per transform
			{ 5, 8, 7 },		// 78 bits per transform
			{ 5, 9, 6 },		// 78 bits per transform
			{ 5, 10, 5 },		// 78 bits per transform
			{ 5, 11, 4 },		// 78 bits per transform
			{ 5, 12, 3 },		// 78 bits per transform
			{ 5, 13, 2 },		// 78 bits per transform
			{ 5, 14, 1 },		// 78 bits per transform
			{ 5, 17, 0 },		// 78 bits per transform
			{ 6, 0, 16 },		// 78 bits per transform
			{ 6, 1, 13 },		// 78 bits per transform
			{ 6, 2, 12 },		// 78 bits per transform
			{ 6, 3, 11 },		// 78 bits per transform
			{ 6, 4, 10 },		// 78 bits per transform
			{ 6, 5, 9 },		// 78 bits per transform
			{ 6, 6, 8 },		// 78 bits per transform
			{ 6, 7, 7 },		// 78 bits per transform
			{ 6, 8, 6 },		// 78 bits per transform
			{ 6, 9, 5 },		// 78 bits per transform
			{ 6, 10, 4 },		// 78 bits per transform
			{ 6, 11, 3 },		// 78 bits per transform
			{ 6, 12, 2 },		// 78 bits per transform
			{ 6, 13, 1 },		// 78 bits per transform
			{ 6, 16, 0 },		// 78 bits per transform
			{ 7, 0, 15 },		// 78 bits per transform
			{ 7, 1, 12 },		// 78 bits per transform
			{ 7, 2, 11 },		// 78 bits per transform
			{ 7, 3, 10 },		// 78 bits per transform
			{ 7, 4, 9 },		// 78 bits per transform
			{ 7, 5, 8 },		// 78 bits per transform
			{ 7, 6, 7 },		// 78 bits per transform
			{ 7, 7, 6 },		// 78 bits per transform
			{ 7, 8, 5 },		// 78 bits per transform
			{ 7, 9, 4 },		// 78 bits per transform
			{ 7, 10, 3 },		// 78 bits per transform
			{ 7, 11, 2 },		// 78 bits per transform
			{ 7, 12, 1 },		// 78 bits per transform
			{ 7, 15, 0 },		// 78 bits per transform
			{ 8, 0, 14 },		// 78 bits per transform
			{ 8, 1, 11 },		// 78 bits per transform
			{ 8, 2, 10 },		// 78 bits per transform
			{ 8, 3, 9 },		// 78 bits per transform
			{ 8, 4, 8 },		// 78 bits per transform
			{ 8, 5, 7 },		// 78 bits per transform
			{ 8, 6, 6 },		// 78 bits per transform
			{ 8, 7, 5 },		// 78 bits per transform
			{ 8, 8, 4 },		// 78 bits per transform
			{ 8, 9, 3 },		// 78 bits per transform
			{ 8, 10, 2 },		// 78 bits per transform
			{ 8, 11, 1 },		// 78 bits per transform
			{ 8, 14, 0 },		// 78 bits per transform
			{ 9, 0, 13 },		// 78 bits per transform
			{ 9, 1, 10 },		// 78 bits per transform
			{ 9, 2, 9 },		// 78 bits per transform
			{ 9, 3, 8 },		// 78 bits per transform
			{ 9, 4, 7 },		// 78 bits per transform
			{ 9, 5, 6 },		// 78 bits per transform
			{ 9, 6, 5 },		// 78 bits per transform
			{ 9, 7, 4 },		// 78 bits per transform
			{ 9, 8, 3 },		// 78 bits per transform
			{ 9, 9, 2 },		// 78 bits per transform
			{ 9, 10, 1 },		// 78 bits per transform
			{ 9, 13, 0 },		// 78 bits per transform
			{ 10, 0, 12 },		// 78 bits per transform
			{ 10, 1, 9 },		// 78 bits per transform
			{ 10, 2, 8 },		// 78 bits per transform
			{ 10, 3, 7 },		// 78 bits per transform
			{ 10, 4, 6 },		// 78 bits per transform
			{ 10, 5, 5 },		// 78 bits per transform
			{ 10, 6, 4 },		// 78 bits per transform
			{ 10, 7, 3 },		// 78 bits per transform
			{ 10, 8, 2 },		// 78 bits per transform
			{ 10, 9, 1 },		// 78 bits per transform
			{ 10, 12, 0 },		// 78 bits per transform
			{ 11, 0, 11 },		// 78 bits per transform
			{ 11, 1, 8 },		// 78 bits per transform
			{ 11, 2, 7 },		// 78 bits per transform
			{ 11, 3, 6 },		// 78 bits per transform
			{ 11, 4, 5 },		// 78 bits per transform
			{ 11, 5, 4 },		// 78 bits per transform
			{ 11, 6, 3 },		// 78 bits per transform
			{ 11, 7, 2 },		// 78 bits per transform
			{ 11, 8, 1 },		// 78 bits per transform
			{ 11, 11, 0 },		// 78 bits per transform
			{ 12, 0, 10 },		// 78 bits per transform
			{ 12, 1, 7 },		// 78 bits per transform
			{ 12, 2, 6 },		// 78 bits per transform
			{ 12, 3, 5 },		// 78 bits per transform
			{ 12, 4, 4 },		// 78 bits per transform
			{ 12, 5, 3 },		// 78 bits per transform
			{ 12, 6, 2 },		// 78 bits per transform
			{ 12, 7, 1 },		// 78 bits per transform
			{ 12, 10, 0 },		// 78 bits per transform
			{ 13, 0, 9 },		// 78 bits per transform
			{ 13, 1, 6 },		// 78 bits per transform
			{ 13, 2, 5 },		// 78 bits per transform
			{ 13, 3, 4 },		// 78 bits per transform
			{ 13, 4, 3 },		// 78 bits per transform
			{ 13, 5, 2 },		// 78 bits per transform
			{ 13, 6, 1 },		// 78 bits per transform
			{ 13, 9, 0 },		// 78 bits per transform
			{ 14, 0, 8 },		// 78 bits per transform
			{ 14, 1, 5 },		// 78 bits per transform
			{ 14, 2, 4 },		// 78 bits per transform
			{ 14, 3, 3 },		// 78 bits per transform
			{ 14, 4, 2 },		// 78 bits per transform
			{ 14, 5, 1 },		// 78 bits per transform
			{ 14, 8, 0 },		// 78 bits per transform
			{ 15, 0, 7 },		// 78 bits per transform
			{ 15, 1, 4 },		// 78 bits per transform
			{ 15, 2, 3 },		// 78 bits per transform
			{ 15, 3, 2 },		// 78 bits per transform
			{ 15, 4, 1 },		// 78 bits per transform
			{ 15, 7, 0 },		// 78 bits per transform
			{ 16, 0, 6 },		// 78 bits per transform
			{ 16, 1, 3 },		// 78 bits per transform
			{ 16, 2, 2 },		// 78 bits per transform
			{ 16, 3, 1 },		// 78 bits per transform
			{ 16, 6, 0 },		// 78 bits per transform
			{ 17, 0, 5 },		// 78 bits per transform
			{ 17, 1, 2 },		// 78 bits per transform
			{ 17, 2, 1 },		// 78 bits per transform
			{ 17, 5, 0 },		// 78 bits per transform
			{ 0, 6, 17 },		// 81 bits per transform
			{ 0, 7, 16 },		// 81 bits per transform
			{ 0, 8, 15 },		// 81 bits per transform
			{ 0, 9, 14 },		// 81 bits per transform
			{ 0, 10, 13 },		// 81 bits per transform
			{ 0, 11, 12 },		// 81 bits per transform
			{ 0, 12, 11 },		// 81 bits per transform
			{ 0, 13, 10 },		// 81 bits per transform
			{ 0, 14, 9 },		// 81 bits per transform
			{ 0, 15, 8 },		// 81 bits per transform
			{ 0, 16, 7 },		// 81 bits per transform
			{ 0, 17, 6 },		// 81 bits per transform
			{ 1, 3, 17 },		// 81 bits per transform
			{ 1, 4, 16 },		// 81 bits per transform
			{ 1, 5, 15 },		// 81 bits per transform
			{ 1, 6, 14 },		// 81 bits per transform
			{ 1, 7, 13 },		// 81 bits per transform
			{ 1, 8, 12 },		// 81 bits per transform
			{ 1, 9, 11 },		// 81 bits per transform
			{ 1, 10, 10 },		// 81 bits per transform
			{ 1, 11, 9 },		// 81 bits per transform
			{ 1, 12, 8 },		// 81 bits per transform
			{ 1, 13, 7 },		// 81 bits per transform
			{ 1, 14, 6 },		// 81 bits per transform
			{ 1, 15, 5 },		// 81 bits per transform
			{ 1, 16, 4 },		// 81 bits per transform
			{ 1, 17, 3 },		// 81 bits per transform
			{ 2, 2, 17 },		// 81 bits per transform
			{ 2, 3, 16 },		// 81 bits per transform
			{ 2, 4, 15 },		// 81 bits per transform
			{ 2, 5, 14 },		// 81 bits per transform
			{ 2, 6, 13 },		// 81 bits per transform
			{ 2, 7, 12 },		// 81 bits per transform
			{ 2, 8, 11 },		// 81 bits per transform
			{ 2, 9, 10 },		// 81 bits per transform
			{ 2, 10, 9 },		// 81 bits per transform
			{ 2, 11, 8 },		// 81 bits per transform
			{ 2, 12, 7 },		// 81 bits per transform
			{ 2, 13, 6 },		// 81 bits per transform
			{ 2, 14, 5 },		// 81 bits per transform
			{ 2, 15, 4 },		// 81 bits per transform
			{ 2, 16, 3 },		// 81 bits per transform
			{ 2, 17, 2 },		// 81 bits per transform
			{ 3, 1, 17 },		// 81 bits per transform
			{ 3, 2, 16 },		// 81 bits per transform
			{ 3, 3, 15 },		// 81 bits per transform
			{ 3, 4, 14 },		// 81 bits per transform
			{ 3, 5, 13 },		// 81 bits per transform
			{ 3, 6, 12 },		// 81 bits per transform
			{ 3, 7, 11 },		// 81 bits per transform
			{ 3, 8, 10 },		// 81 bits per transform
			{ 3, 9, 9 },		// 81 bits per transform
			{ 3, 10, 8 },		// 81 bits per transform
			{ 3, 11, 7 },		// 81 bits per transform
			{ 3, 12, 6 },		// 81 bits per transform
			{ 3, 13, 5 },		// 81 bits per transform
			{ 3, 14, 4 },		// 81 bits per transform
			{ 3, 15, 3 },		// 81 bits per transform
			{ 3, 16, 2 },		// 81 bits per transform
			{ 3, 17, 1 },		// 81 bits per transform
			{ 4, 1, 16 },		// 81 bits per transform
			{ 4, 2, 15 },		// 81 bits per transform
			{ 4, 3, 14 },		// 81 bits per transform
			{ 4, 4, 13 },		// 81 bits per transform
			{ 4, 5, 12 },		// 81 bits per transform
			{ 4, 6, 11 },		// 81 bits per transform
			{ 4, 7, 10 },		// 81 bits per transform
			{ 4, 8, 9 },		// 81 bits per transform
			{ 4, 9, 8 },		// 81 bits per transform
			{ 4, 10, 7 },		// 81 bits per transform
			{ 4, 11, 6 },		// 81 bits per transform
			{ 4, 12, 5 },		// 81 bits per transform
			{ 4, 13, 4 },		// 81 bits per transform
			{ 4, 14, 3 },		// 81 bits per transform
			{ 4, 15, 2 },		// 81 bits per transform
			{ 4, 16, 1 },		// 81 bits per transform
			{ 5, 1, 15 },		// 81 bits per transform
			{ 5, 2, 14 },		// 81 bits per transform
			{ 5, 3, 13 },		// 81 bits per transform
			{ 5, 4, 12 },		// 81 bits per transform
			{ 5, 5, 11 },		// 81 bits per transform
			{ 5, 6, 10 },		// 81 bits per transform
			{ 5, 7, 9 },		// 81 bits per transform
			{ 5, 8, 8 },		// 81 bits per transform
			{ 5, 9, 7 },		// 81 bits per transform
			{ 5, 10, 6 },		// 81 bits per transform
			{ 5, 11, 5 },		// 81 bits per transform
			{ 5, 12, 4 },		// 81 bits per transform
			{ 5, 13, 3 },		// 81 bits per transform
			{ 5, 14, 2 },		// 81 bits per transform
			{ 5, 15, 1 },		// 81 bits per transform
			{ 6, 0, 17 },		// 81 bits per transform
			{ 6, 1, 14 },		// 81 bits per transform
			{ 6, 2, 13 },		// 81 bits per transform
			{ 6, 3, 12 },		// 81 bits per transform
			{ 6, 4, 11 },		// 81 bits per transform
			{ 6, 5, 10 },		// 81 bits per transform
			{ 6, 6, 9 },		// 81 bits per transform
			{ 6, 7, 8 },		// 81 bits per transform
			{ 6, 8, 7 },		// 81 bits per transform
			{ 6, 9, 6 },		// 81 bits per transform
			{ 6, 10, 5 },		// 81 bits per transform
			{ 6, 11, 4 },		// 81 bits per transform
			{ 6, 12, 3 },		// 81 bits per transform
			{ 6, 13, 2 },		// 81 bits per transform
			{ 6, 14, 1 },		// 81 bits per transform
			{ 6, 17, 0 },		// 81 bits per transform
			{ 7, 0, 16 },		// 81 bits per transform
			{ 7, 1, 13 },		// 81 bits per transform
			{ 7, 2, 12 },		// 81 bits per transform
			{ 7, 3, 11 },		// 81 bits per transform
			{ 7, 4, 10 },		// 81 bits per transform
			{ 7, 5, 9 },		// 81 bits per transform
			{ 7, 6, 8 },		// 81 bits per transform
			{ 7, 7, 7 },		// 81 bits per transform
			{ 7, 8, 6 },		// 81 bits per transform
			{ 7, 9, 5 },		// 81 bits per transform
			{ 7, 10, 4 },		// 81 bits per transform
			{ 7, 11, 3 },		// 81 bits per transform
			{ 7, 12, 2 },		// 81 bits per transform
			{ 7, 13, 1 },		// 81 bits per transform
			{ 7, 16, 0 },		// 81 bits per transform
			{ 8, 0, 15 },		// 81 bits per transform
			{ 8, 1, 12 },		// 81 bits per transform
			{ 8, 2, 11 },		// 81 bits per transform
			{ 8, 3, 10 },		// 81 bits per transform
			{ 8, 4, 9 },		// 81 bits per transform
			{ 8, 5, 8 },		// 81 bits per transform
			{ 8, 6, 7 },		// 81 bits per transform
			{ 8, 7, 6 },		// 81 bits per transform
			{ 8, 8, 5 },		// 81 bits per transform
			{ 8, 9, 4 },		// 81 bits per transform
			{ 8, 10, 3 },		// 81 bits per transform
			{ 8, 11, 2 },		// 81 bits per transform
			{ 8, 12, 1 },		// 81 bits per transform
			{ 8, 15, 0 },		// 81 bits per transform
			{ 9, 0, 14 },		// 81 bits per transform
			{ 9, 1, 11 },		// 81 bits per transform
			{ 9, 2, 10 },		// 81 bits per transform
			{ 9, 3, 9 },		// 81 bits per transform
			{ 9, 4, 8 },		// 81 bits per transform
			{ 9, 5, 7 },		// 81 bits per transform
			{ 9, 6, 6 },		// 81 bits per transform
			{ 9, 7, 5 },		// 81 bits per transform
			{ 9, 8, 4 },		// 81 bits per transform
			{ 9, 9, 3 },		// 81 bits per transform
			{ 9, 10, 2 },		// 81 bits per transform
			{ 9, 11, 1 },		// 81 bits per transform
			{ 9, 14, 0 },		// 81 bits per transform
			{ 10, 0, 13 },		// 81 bits per transform
			{ 10, 1, 10 },		// 81 bits per transform
			{ 10, 2, 9 },		// 81 bits per transform
			{ 10, 3, 8 },		// 81 bits per transform
			{ 10, 4, 7 },		// 81 bits per transform
			{ 10, 5, 6 },		// 81 bits per transform
			{ 10, 6, 5 },		// 81 bits per transform
			{ 10, 7, 4 },		// 81 bits per transform
			{ 10, 8, 3 },		// 81 bits per transform
			{ 10, 9, 2 },		// 81 bits per transform
			{ 10, 10, 1 },		// 81 bits per transform
			{ 10, 13, 0 },		// 81 bits per transform
			{ 11, 0, 12 },		// 81 bits per transform
			{ 11, 1, 9 },		// 81 bits per transform
			{ 11, 2, 8 },		// 81 bits per transform
			{ 11, 3, 7 },		// 81 bits per transform
			{ 11, 4, 6 },		// 81 bits per transform
			{ 11, 5, 5 },		// 81 bits per transform
			{ 11, 6, 4 },		// 81 bits per transform
			{ 11, 7, 3 },		// 81 bits per transform
			{ 11, 8, 2 },		// 81 bits per transform
			{ 11, 9, 1 },		// 81 bits per transform
			{ 11, 12, 0 },		// 81 bits per transform
			{ 12, 0, 11 },		// 81 bits per transform
			{ 12, 1, 8 },		// 81 bits per transform
			{ 12, 2, 7 },		// 81 bits per transform
			{ 12, 3, 6 },		// 81 bits per transform
			{ 12, 4, 5 },		// 81 bits per transform
			{ 12, 5, 4 },		// 81 bits per transform
			{ 12, 6, 3 },		// 81 bits per transform
			{ 12, 7, 2 },		// 81 bits per transform
			{ 12, 8, 1 },		// 81 bits per transform
			{ 12, 11, 0 },		// 81 bits per transform
			{ 13, 0, 10 },		// 81 bits per transform
			{ 13, 1, 7 },		// 81 bits per transform
			{ 13, 2, 6 },		// 81 bits per transform
			{ 13, 3, 5 },		// 81 bits per transform
			{ 13, 4, 4 },		// 81 bits per transform
			{ 13, 5, 3 },		// 81 bits per transform
			{ 13, 6, 2 },		// 81 bits per transform
			{ 13, 7, 1 },		// 81 bits per transform
			{ 13, 10, 0 },		// 81 bits per transform
			{ 14, 0, 9 },		// 81 bits per transform
			{ 14, 1, 6 },		// 81 bits per transform
			{ 14, 2, 5 },		// 81 bits per transform
			{ 14, 3, 4 },		// 81 bits per transform
			{ 14, 4, 3 },		// 81 bits per transform
			{ 14, 5, 2 },		// 81 bits per transform
			{ 14, 6, 1 },		// 81 bits per transform
			{ 14, 9, 0 },		// 81 bits per transform
			{ 15, 0, 8 },		// 81 bits per transform
			{ 15, 1, 5 },		// 81 bits per transform
			{ 15, 2, 4 },		// 81 bits per transform
			{ 15, 3, 3 },		// 81 bits per transform
			{ 15, 4, 2 },		// 81 bits per transform
			{ 15, 5, 1 },		// 81 bits per transform
			{ 15, 8, 0 },		// 81 bits per transform
			{ 16, 0, 7 },		// 81 bits per transform
			{ 16, 1, 4 },		// 81 bits per transform
			{ 16, 2, 3 },		// 81 bits per transform
			{ 16, 3, 2 },		// 81 bits per transform
			{ 16, 4, 1 },		// 81 bits per transform
			{ 16, 7, 0 },		// 81 bits per transform
			{ 17, 0, 6 },		// 81 bits per transform
			{ 17, 1, 3 },		// 81 bits per transform
			{ 17, 2, 2 },		// 81 bits per transform
			{ 17, 3, 1 },		// 81 bits per transform
			{ 17, 6, 0 },		// 81 bits per transform
			{ 0, 7, 17 },		// 84 bits per transform
			{ 0, 8, 16 },		// 84 bits per transform
			{ 0, 9, 15 },		// 84 bits per transform
			{ 0, 10, 14 },		// 84 bits per transform
			{ 0, 11, 13 },		// 84 bits per transform
			{ 0, 12, 12 },		// 84 bits per transform
			{ 0, 13, 11 },		// 84 bits per transform
			{ 0, 14, 10 },		// 84 bits per transform
			{ 0, 15, 9 },		// 84 bits per transform
			{ 0, 16, 8 },		// 84 bits per transform
			{ 0, 17, 7 },		// 84 bits per transform
			{ 1, 4, 17 },		// 84 bits per transform
			{ 1, 5, 16 },		// 84 bits per transform
			{ 1, 6, 15 },		// 84 bits per transform
			{ 1, 7, 14 },		// 84 bits per transform
			{ 1, 8, 13 },		// 84 bits per transform
			{ 1, 9, 12 },		// 84 bits per transform
			{ 1, 10, 11 },		// 84 bits per transform
			{ 1, 11, 10 },		// 84 bits per transform
			{ 1, 12, 9 },		// 84 bits per transform
			{ 1, 13, 8 },		// 84 bits per transform
			{ 1, 14, 7 },		// 84 bits per transform
			{ 1, 15, 6 },		// 84 bits per transform
			{ 1, 16, 5 },		// 84 bits per transform
			{ 1, 17, 4 },		// 84 bits per transform
			{ 2, 3, 17 },		// 84 bits per transform
			{ 2, 4, 16 },		// 84 bits per transform
			{ 2, 5, 15 },		// 84 bits per transform
			{ 2, 6, 14 },		// 84 bits per transform
			{ 2, 7, 13 },		// 84 bits per transform
			{ 2, 8, 12 },		// 84 bits per transform
			{ 2, 9, 11 },		// 84 bits per transform
			{ 2, 10, 10 },		// 84 bits per transform
			{ 2, 11, 9 },		// 84 bits per transform
			{ 2, 12, 8 },		// 84 bits per transform
			{ 2, 13, 7 },		// 84 bits per transform
			{ 2, 14, 6 },		// 84 bits per transform
			{ 2, 15, 5 },		// 84 bits per transform
			{ 2, 16, 4 },		// 84 bits per transform
			{ 2, 17, 3 },		// 84 bits per transform
			{ 3, 2, 17 },		// 84 bits per transform
			{ 3, 3, 16 },		// 84 bits per transform
			{ 3, 4, 15 },		// 84 bits per transform
			{ 3, 5, 14 },		// 84 bits per transform
			{ 3, 6, 13 },		// 84 bits per transform
			{ 3, 7, 12 },		// 84 bits per transform
			{ 3, 8, 11 },		// 84 bits per transform
			{ 3, 9, 10 },		// 84 bits per transform
			{ 3, 10, 9 },		// 84 bits per transform
			{ 3, 11, 8 },		// 84 bits per transform
			{ 3, 12, 7 },		// 84 bits per transform
			{ 3, 13, 6 },		// 84 bits per transform
			{ 3, 14, 5 },		// 84 bits per transform
			{ 3, 15, 4 },		// 84 bits per transform
			{ 3, 16, 3 },		// 84 bits per transform
			{ 3, 17, 2 },		// 84 bits per transform
			{ 4, 1, 17 },		// 84 bits per transform
			{ 4, 2, 16 },		// 84 bits per transform
			{ 4, 3, 15 },		// 84 bits per transform
			{ 4, 4, 14 },		// 84 bits per transform
			{ 4, 5, 13 },		// 84 bits per transform
			{ 4, 6, 12 },		// 84 bits per transform
			{ 4, 7, 11 },		// 84 bits per transform
			{ 4, 8, 10 },		// 84 bits per transform
			{ 4, 9, 9 },		// 84 bits per transform
			{ 4, 10, 8 },		// 84 bits per transform
			{ 4, 11, 7 },		// 84 bits per transform
			{ 4, 12, 6 },		// 84 bits per transform
			{ 4, 13, 5 },		// 84 bits per transform
			{ 4, 14, 4 },		// 84 bits per transform
			{ 4, 15, 3 },		// 84 bits per transform
			{ 4, 16, 2 },		// 84 bits per transform
			{ 4, 17, 1 },		// 84 bits per transform
			{ 5, 1, 16 },		// 84 bits per transform
			{ 5, 2, 15 },		// 84 bits per transform
			{ 5, 3, 14 },		// 84 bits per transform
			{ 5, 4, 13 },		// 84 bits per transform
			{ 5, 5, 12 },		// 84 bits per transform
			{ 5, 6, 11 },		// 84 bits per transform
			{ 5, 7, 10 },		// 84 bits per transform
			{ 5, 8, 9 },		// 84 bits per transform
			{ 5, 9, 8 },		// 84 bits per transform
			{ 5, 10, 7 },		// 84 bits per transform
			{ 5, 11, 6 },		// 84 bits per transform
			{ 5, 12, 5 },		// 84 bits per transform
			{ 5, 13, 4 },		// 84 bits per transform
			{ 5, 14, 3 },		// 84 bits per transform
			{ 5, 15, 2 },		// 84 bits per transform
			{ 5, 16, 1 },		// 84 bits per transform
			{ 6, 1, 15 },		// 84 bits per transform
			{ 6, 2, 14 },		// 84 bits per transform
			{ 6, 3, 13 },		// 84 bits per transform
			{ 6, 4, 12 },		// 84 bits per transform
			{ 6, 5, 11 },		// 84 bits per transform
			{ 6, 6, 10 },		// 84 bits per transform
			{ 6, 7, 9 },		// 84 bits per transform
			{ 6, 8, 8 },		// 84 bits per transform
			{ 6, 9, 7 },		// 84 bits per transform
			{ 6, 10, 6 },		// 84 bits per transform
			{ 6, 11, 5 },		// 84 bits per transform
			{ 6, 12, 4 },		// 84 bits per transform
			{ 6, 13, 3 },		// 84 bits per transform
			{ 6, 14, 2 },		// 84 bits per transform
			{ 6, 15, 1 },		// 84 bits per transform
			{ 7, 0, 17 },		// 84 bits per transform
			{ 7, 1, 14 },		// 84 bits per transform
			{ 7, 2, 13 },		// 84 bits per transform
			{ 7, 3, 12 },		// 84 bits per transform
			{ 7, 4, 11 },		// 84 bits per transform
			{ 7, 5, 10 },		// 84 bits per transform
			{ 7, 6, 9 },		// 84 bits per transform
			{ 7, 7, 8 },		// 84 bits per transform
			{ 7, 8, 7 },		// 84 bits per transform
			{ 7, 9, 6 },		// 84 bits per transform
			{ 7, 10, 5 },		// 84 bits per transform
			{ 7, 11, 4 },		// 84 bits per transform
			{ 7, 12, 3 },		// 84 bits per transform
			{ 7, 13, 2 },		// 84 bits per transform
			{ 7, 14, 1 },		// 84 bits per transform
			{ 7, 17, 0 },		// 84 bits per transform
			{ 8, 0, 16 },		// 84 bits per transform
			{ 8, 1, 13 },		// 84 bits per transform
			{ 8, 2, 12 },		// 84 bits per transform
			{ 8, 3, 11 },		// 84 bits per transform
			{ 8, 4, 10 },		// 84 bits per transform
			{ 8, 5, 9 },		// 84 bits per transform
			{ 8, 6, 8 },		// 84 bits per transform
			{ 8, 7, 7 },		// 84 bits per transform
			{ 8, 8, 6 },		// 84 bits per transform
			{ 8, 9, 5 },		// 84 bits per transform
			{ 8, 10, 4 },		// 84 bits per transform
			{ 8, 11, 3 },		// 84 bits per transform
			{ 8, 12, 2 },		// 84 bits per transform
			{ 8, 13, 1 },		// 84 bits per transform
			{ 8, 16, 0 },		// 84 bits per transform
			{ 9, 0, 15 },		// 84 bits per transform
			{ 9, 1, 12 },		// 84 bits per transform
			{ 9, 2, 11 },		// 84 bits per transform
			{ 9, 3, 10 },		// 84 bits per transform
			{ 9, 4, 9 },		// 84 bits per transform
			{ 9, 5, 8 },		// 84 bits per transform
			{ 9, 6, 7 },		// 84 bits per transform
			{ 9, 7, 6 },		// 84 bits per transform
			{ 9, 8, 5 },		// 84 bits per transform
			{ 9, 9, 4 },		// 84 bits per transform
			{ 9, 10, 3 },		// 84 bits per transform
			{ 9, 11, 2 },		// 84 bits per transform
			{ 9, 12, 1 },		// 84 bits per transform
			{ 9, 15, 0 },		// 84 bits per transform
			{ 10, 0, 14 },		// 84 bits per transform
			{ 10, 1, 11 },		// 84 bits per transform
			{ 10, 2, 10 },		// 84 bits per transform
			{ 10, 3, 9 },		// 84 bits per transform
			{ 10, 4, 8 },		// 84 bits per transform
			{ 10, 5, 7 },		// 84 bits per transform
			{ 10, 6, 6 },		// 84 bits per transform
			{ 10, 7, 5 },		// 84 bits per transform
			{ 10, 8, 4 },		// 84 bits per transform
			{ 10, 9, 3 },		// 84 bits per transform
			{ 10, 10, 2 },		// 84 bits per transform
			{ 10, 11, 1 },		// 84 bits per transform
			{ 10, 14, 0 },		// 84 bits per transform
			{ 11, 0, 13 },		// 84 bits per transform
			{ 11, 1, 10 },		// 84 bits per transform
			{ 11, 2, 9 },		// 84 bits per transform
			{ 11, 3, 8 },		// 84 bits per transform
			{ 11, 4, 7 },		// 84 bits per transform
			{ 11, 5, 6 },		// 84 bits per transform
			{ 11, 6, 5 },		// 84 bits per transform
			{ 11, 7, 4 },		// 84 bits per transform
			{ 11, 8, 3 },		// 84 bits per transform
			{ 11, 9, 2 },		// 84 bits per transform
			{ 11, 10, 1 },		// 84 bits per transform
			{ 11, 13, 0 },		// 84 bits per transform
			{ 12, 0, 12 },		// 84 bits per transform
			{ 12, 1, 9 },		// 84 bits per transform
			{ 12, 2, 8 },		// 84 bits per transform
			{ 12, 3, 7 },		// 84 bits per transform
			{ 12, 4, 6 },		// 84 bits per transform
			{ 12, 5, 5 },		// 84 bits per transform
			{ 12, 6, 4 },		// 84 bits per transform
			{ 12, 7, 3 },		// 84 bits per transform
			{ 12, 8, 2 },		// 84 bits per transform
			{ 12, 9, 1 },		// 84 bits per transform
			{ 12, 12, 0 },		// 84 bits per transform
			{ 13, 0, 11 },		// 84 bits per transform
			{ 13, 1, 8 },		// 84 bits per transform
			{ 13, 2, 7 },		// 84 bits per transform
			{ 13, 3, 6 },		// 84 bits per transform
			{ 13, 4, 5 },		// 84 bits per transform
			{ 13, 5, 4 },		// 84 bits per transform
			{ 13, 6, 3 },		// 84 bits per transform
			{ 13, 7, 2 },		// 84 bits per transform
			{ 13, 8, 1 },		// 84 bits per transform
			{ 13, 11, 0 },		// 84 bits per transform
			{ 14, 0, 10 },		// 84 bits per transform
			{ 14, 1, 7 },		// 84 bits per transform
			{ 14, 2, 6 },		// 84 bits per transform
			{ 14, 3, 5 },		// 84 bits per transform
			{ 14, 4, 4 },		// 84 bits per transform
			{ 14, 5, 3 },		// 84 bits per transform
			{ 14, 6, 2 },		// 84 bits per transform
			{ 14, 7, 1 },		// 84 bits per transform
			{ 14, 10, 0 },		// 84 bits per transform
			{ 15, 0, 9 },		// 84 bits per transform
			{ 15, 1, 6 },		// 84 bits per transform
			{ 15, 2, 5 },		// 84 bits per transform
			{ 15, 3, 4 },		// 84 bits per transform
			{ 15, 4, 3 },		// 84 bits per transform
			{ 15, 5, 2 },		// 84 bits per transform
			{ 15, 6, 1 },		// 84 bits per transform
			{ 15, 9, 0 },		// 84 bits per transform
			{ 16, 0, 8 },		// 84 bits per transform
			{ 16, 1, 5 },		// 84 bits per transform
			{ 16, 2, 4 },		// 84 bits per transform
			{ 16, 3, 3 },		// 84 bits per transform
			{ 16, 4, 2 },		// 84 bits per transform
			{ 16, 5, 1 },		// 84 bits per transform
			{ 16, 8, 0 },		// 84 bits per transform
			{ 17, 0, 7 },		// 84 bits per transform
			{ 17, 1, 4 },		// 84 bits per transform
			{ 17, 2, 3 },		// 84 bits per transform
			{ 17, 3, 2 },		// 84 bits per transform
			{ 17, 4, 1 },		// 84 bits per transform
			{ 17, 7, 0 },		// 84 bits per transform
			{ 0, 8, 17 },		// 87 bits per transform
			{ 0, 9, 16 },		// 87 bits per transform
			{ 0, 10, 15 },		// 87 bits per transform
			{ 0, 11, 14 },		// 87 bits per transform
			{ 0, 12, 13 },		// 87 bits per transform
			{ 0, 13, 12 },		// 87 bits per transform
			{ 0, 14, 11 },		// 87 bits per transform
			{ 0, 15, 10 },		// 87 bits per transform
			{ 0, 16, 9 },		// 87 bits per transform
			{ 0, 17, 8 },		// 87 bits per transform
			{ 1, 5, 17 },		// 87 bits per transform
			{ 1, 6, 16 },		// 87 bits per transform
			{ 1, 7, 15 },		// 87 bits per transform
			{ 1, 8, 14 },		// 87 bits per transform
			{ 1, 9, 13 },		// 87 bits per transform
			{ 1, 10, 12 },		// 87 bits per transform
			{ 1, 11, 11 },		// 87 bits per transform
			{ 1, 12, 10 },		// 87 bits per transform
			{ 1, 13, 9 },		// 87 bits per transform
			{ 1, 14, 8 },		// 87 bits per transform
			{ 1, 15, 7 },		// 87 bits per transform
			{ 1, 16, 6 },		// 87 bits per transform
			{ 1, 17, 5 },		// 87 bits per transform
			{ 2, 4, 17 },		// 87 bits per transform
			{ 2, 5, 16 },		// 87 bits per transform
			{ 2, 6, 15 },		// 87 bits per transform
			{ 2, 7, 14 },		// 87 bits per transform
			{ 2, 8, 13 },		// 87 bits per transform
			{ 2, 9, 12 },		// 87 bits per transform
			{ 2, 10, 11 },		// 87 bits per transform
			{ 2, 11, 10 },		// 87 bits per transform
			{ 2, 12, 9 },		// 87 bits per transform
			{ 2, 13, 8 },		// 87 bits per transform
			{ 2, 14, 7 },		// 87 bits per transform
			{ 2, 15, 6 },		// 87 bits per transform
			{ 2, 16, 5 },		// 87 bits per transform
			{ 2, 17, 4 },		// 87 bits per transform
			{ 3, 3, 17 },		// 87 bits per transform
			{ 3, 4, 16 },		// 87 bits per transform
			{ 3, 5, 15 },		// 87 bits per transform
			{ 3, 6, 14 },		// 87 bits per transform
			{ 3, 7, 13 },		// 87 bits per transform
			{ 3, 8, 12 },		// 87 bits per transform
			{ 3, 9, 11 },		// 87 bits per transform
			{ 3, 10, 10 },		// 87 bits per transform
			{ 3, 11, 9 },		// 87 bits per transform
			{ 3, 12, 8 },		// 87 bits per transform
			{ 3, 13, 7 },		// 87 bits per transform
			{ 3, 14, 6 },		// 87 bits per transform
			{ 3, 15, 5 },		// 87 bits per transform
			{ 3, 16, 4 },		// 87 bits per transform
			{ 3, 17, 3 },		// 87 bits per transform
			{ 4, 2, 17 },		// 87 bits per transform
			{ 4, 3, 16 },		// 87 bits per transform
			{ 4, 4, 15 },		// 87 bits per transform
			{ 4, 5, 14 },		// 87 bits per transform
			{ 4, 6, 13 },		// 87 bits per transform
			{ 4, 7, 12 },		// 87 bits per transform
			{ 4, 8, 11 },		// 87 bits per transform
			{ 4, 9, 10 },		// 87 bits per transform
			{ 4, 10, 9 },		// 87 bits per transform
			{ 4, 11, 8 },		// 87 bits per transform
			{ 4, 12, 7 },		// 87 bits per transform
			{ 4, 13, 6 },		// 87 bits per transform
			{ 4, 14, 5 },		// 87 bits per transform
			{ 4, 15, 4 },		// 87 bits per transform
			{ 4, 16, 3 },		// 87 bits per transform
			{ 4, 17, 2 },		// 87 bits per transform
			{ 5, 1, 17 },		// 87 bits per transform
			{ 5, 2, 16 },		// 87 bits per transform
			{ 5, 3, 15 },		// 87 bits per transform
			{ 5, 4, 14 },		// 87 bits per transform
			{ 5, 5, 13 },		// 87 bits per transform
			{ 5, 6, 12 },		// 87 bits per transform
			{ 5, 7, 11 },		// 87 bits per transform
			{ 5, 8, 10 },		// 87 bits per transform
			{ 5, 9, 9 },		// 87 bits per transform
			{ 5, 10, 8 },		// 87 bits per transform
			{ 5, 11, 7 },		// 87 bits per transform
			{ 5, 12, 6 },		// 87 bits per transform
			{ 5, 13, 5 },		// 87 bits per transform
			{ 5, 14, 4 },		// 87 bits per transform
			{ 5, 15, 3 },		// 87 bits per transform
			{ 5, 16, 2 },		// 87 bits per transform
			{ 5, 17, 1 },		// 87 bits per transform
			{ 6, 1, 16 },		// 87 bits per transform
			{ 6, 2, 15 },		// 87 bits per transform
			{ 6, 3, 14 },		// 87 bits per transform
			{ 6, 4, 13 },		// 87 bits per transform
			{ 6, 5, 12 },		// 87 bits per transform
			{ 6, 6, 11 },		// 87 bits per transform
			{ 6, 7, 10 },		// 87 bits per transform
			{ 6, 8, 9 },		// 87 bits per transform
			{ 6, 9, 8 },		// 87 bits per transform
			{ 6, 10, 7 },		// 87 bits per transform
			{ 6, 11, 6 },		// 87 bits per transform
			{ 6, 12, 5 },		// 87 bits per transform
			{ 6, 13, 4 },		// 87 bits per transform
			{ 6, 14, 3 },		// 87 bits per transform
			{ 6, 15, 2 },		// 87 bits per transform
			{ 6, 16, 1 },		// 87 bits per transform
			{ 7, 1, 15 },		// 87 bits per transform
			{ 7, 2, 14 },		// 87 bits per transform
			{ 7, 3, 13 },		// 87 bits per transform
			{ 7, 4, 12 },		// 87 bits per transform
			{ 7, 5, 11 },		// 87 bits per transform
			{ 7, 6, 10 },		// 87 bits per transform
			{ 7, 7, 9 },		// 87 bits per transform
			{ 7, 8, 8 },		// 87 bits per transform
			{ 7, 9, 7 },		// 87 bits per transform
			{ 7, 10, 6 },		// 87 bits per transform
			{ 7, 11, 5 },		// 87 bits per transform
			{ 7, 12, 4 },		// 87 bits per transform
			{ 7, 13, 3 },		// 87 bits per transform
			{ 7, 14, 2 },		// 87 bits per transform
			{ 7, 15, 1 },		// 87 bits per transform
			{ 8, 0, 17 },		// 87 bits per transform
			{ 8, 1, 14 },		// 87 bits per transform
			{ 8, 2, 13 },		// 87 bits per transform
			{ 8, 3, 12 },		// 87 bits per transform
			{ 8, 4, 11 },		// 87 bits per transform
			{ 8, 5, 10 },		// 87 bits per transform
			{ 8, 6, 9 },		// 87 bits per transform
			{ 8, 7, 8 },		// 87 bits per transform
			{ 8, 8, 7 },		// 87 bits per transform
			{ 8, 9, 6 },		// 87 bits per transform
			{ 8, 10, 5 },		// 87 bits per transform
			{ 8, 11, 4 },		// 87 bits per transform
			{ 8, 12, 3 },		// 87 bits per transform
			{ 8, 13, 2 },		// 87 bits per transform
			{ 8, 14, 1 },		// 87 bits per transform
			{ 8, 17, 0 },		// 87 bits per transform
			{ 9, 0, 16 },		// 87 bits per transform
			{ 9, 1, 13 },		// 87 bits per transform
			{ 9, 2, 12 },		// 87 bits per transform
			{ 9, 3, 11 },		// 87 bits per transform
			{ 9, 4, 10 },		// 87 bits per transform
			{ 9, 5, 9 },		// 87 bits per transform
			{ 9, 6, 8 },		// 87 bits per transform
			{ 9, 7, 7 },		// 87 bits per transform
			{ 9, 8, 6 },		// 87 bits per transform
			{ 9, 9, 5 },		// 87 bits per transform
			{ 9, 10, 4 },		// 87 bits per transform
			{ 9, 11, 3 },		// 87 bits per transform
			{ 9, 12, 2 },		// 87 bits per transform
			{ 9, 13, 1 },		// 87 bits per transform
			{ 9, 16, 0 },		// 87 bits per transform
			{ 10, 0, 15 },		// 87 bits per transform
			{ 10, 1, 12 },		// 87 bits per transform
			{ 10, 2, 11 },		// 87 bits per transform
			{ 10, 3, 10 },		// 87 bits per transform
			{ 10, 4, 9 },		// 87 bits per transform
			{ 10, 5, 8 },		// 87 bits per transform
			{ 10, 6, 7 },		// 87 bits per transform
			{ 10, 7, 6 },		// 87 bits per transform
			{ 10, 8, 5 },		// 87 bits per transform
			{ 10, 9, 4 },		// 87 bits per transform
			{ 10, 10, 3 },		// 87 bits per transform
			{ 10, 11, 2 },		// 87 bits per transform
			{ 10, 12, 1 },		// 87 bits per transform
			{ 10, 15, 0 },		// 87 bits per transform
			{ 11, 0, 14 },		// 87 bits per transform
			{ 11, 1, 11 },		// 87 bits per transform
			{ 11, 2, 10 },		// 87 bits per transform
			{ 11, 3, 9 },		// 87 bits per transform
			{ 11, 4, 8 },		// 87 bits per transform
			{ 11, 5, 7 },		// 87 bits per transform
			{ 11, 6, 6 },		// 87 bits per transform
			{ 11, 7, 5 },		// 87 bits per transform
			{ 11, 8, 4 },		// 87 bits per transform
			{ 11, 9, 3 },		// 87 bits per transform
			{ 11, 10, 2 },		// 87 bits per transform
			{ 11, 11, 1 },		// 87 bits per transform
			{ 11, 14, 0 },		// 87 bits per transform
			{ 12, 0, 13 },		// 87 bits per transform
			{ 12, 1, 10 },		// 87 bits per transform
			{ 12, 2, 9 },		// 87 bits per transform
			{ 12, 3, 8 },		// 87 bits per transform
			{ 12, 4, 7 },		// 87 bits per transform
			{ 12, 5, 6 },		// 87 bits per transform
			{ 12, 6, 5 },		// 87 bits per transform
			{ 12, 7, 4 },		// 87 bits per transform
			{ 12, 8, 3 },		// 87 bits per transform
			{ 12, 9, 2 },		// 87 bits per transform
			{ 12, 10, 1 },		// 87 bits per transform
			{ 12, 13, 0 },		// 87 bits per transform
			{ 13, 0, 12 },		// 87 bits per transform
			{ 13, 1, 9 },		// 87 bits per transform
			{ 13, 2, 8 },		// 87 bits per transform
			{ 13, 3, 7 },		// 87 bits per transform
			{ 13, 4, 6 },		// 87 bits per transform
			{ 13, 5, 5 },		// 87 bits per transform
			{ 13, 6, 4 },		// 87 bits per transform
			{ 13, 7, 3 },		// 87 bits per transform
			{ 13, 8, 2 },		// 87 bits per transform
			{ 13, 9, 1 },		// 87 bits per transform
			{ 13, 12, 0 },		// 87 bits per transform
			{ 14, 0, 11 },		// 87 bits per transform
			{ 14, 1, 8 },		// 87 bits per transform
			{ 14, 2, 7 },		// 87 bits per transform
			{ 14, 3, 6 },		// 87 bits per transform
			{ 14, 4, 5 },		// 87 bits per transform
			{ 14, 5, 4 },		// 87 bits per transform
			{ 14, 6, 3 },		// 87 bits per transform
			{ 14, 7, 2 },		// 87 bits per transform
			{ 14, 8, 1 },		// 87 bits per transform
			{ 14, 11, 0 },		// 87 bits per transform
			{ 15, 0, 10 },		// 87 bits per transform
			{ 15, 1, 7 },		// 87 bits per transform
			{ 15, 2, 6 },		// 87 bits per transform
			{ 15, 3, 5 },		// 87 bits per transform
			{ 15, 4, 4 },		// 87 bits per transform
			{ 15, 5, 3 },		// 87 bits per transform
			{ 15, 6, 2 },		// 87 bits per transform
			{ 15, 7, 1 },		// 87 bits per transform
			{ 15, 10, 0 },		// 87 bits per transform
			{ 16, 0, 9 },		// 87 bits per transform
			{ 16, 1, 6 },		// 87 bits per transform
			{ 16, 2, 5 },		// 87 bits per transform
			{ 16, 3, 4 },		// 87 bits per transform
			{ 16, 4, 3 },		// 87 bits per transform
			{ 16, 5, 2 },		// 87 bits per transform
			{ 16, 6, 1 },		// 87 bits per transform
			{ 16, 9, 0 },		// 87 bits per transform
			{ 17, 0, 8 },		// 87 bits per transform
			{ 17, 1, 5 },		// 87 bits per transform
			{ 17, 2, 4 },		// 87 bits per transform
			{ 17, 3, 3 },		// 87 bits per transform
			{ 17, 4, 2 },		// 87 bits per transform
			{ 17, 5, 1 },		// 87 bits per transform
			{ 17, 8, 0 },		// 87 bits per transform
			{ 0, 9, 17 },		// 90 bits per transform
			{ 0, 10, 16 },		// 90 bits per transform
			{ 0, 11, 15 },		// 90 bits per transform
			{ 0, 12, 14 },		// 90 bits per transform
			{ 0, 13, 13 },		// 90 bits per transform
			{ 0, 14, 12 },		// 90 bits per transform
			{ 0, 15, 11 },		// 90 bits per transform
			{ 0, 16, 10 },		// 90 bits per transform
			{ 0, 17, 9 },		// 90 bits per transform
			{ 1, 6, 17 },		// 90 bits per transform
			{ 1, 7, 16 },		// 90 bits per transform
			{ 1, 8, 15 },		// 90 bits per transform
			{ 1, 9, 14 },		// 90 bits per transform
			{ 1, 10, 13 },		// 90 bits per transform
			{ 1, 11, 12 },		// 90 bits per transform
			{ 1, 12, 11 },		// 90 bits per transform
			{ 1, 13, 10 },		// 90 bits per transform
			{ 1, 14, 9 },		// 90 bits per transform
			{ 1, 15, 8 },		// 90 bits per transform
			{ 1, 16, 7 },		// 90 bits per transform
			{ 1, 17, 6 },		// 90 bits per transform
			{ 2, 5, 17 },		// 90 bits per transform
			{ 2, 6, 16 },		// 90 bits per transform
			{ 2, 7, 15 },		// 90 bits per transform
			{ 2, 8, 14 },		// 90 bits per transform
			{ 2, 9, 13 },		// 90 bits per transform
			{ 2, 10, 12 },		// 90 bits per transform
			{ 2, 11, 11 },		// 90 bits per transform
			{ 2, 12, 10 },		// 90 bits per transform
			{ 2, 13, 9 },		// 90 bits per transform
			{ 2, 14, 8 },		// 90 bits per transform
			{ 2, 15, 7 },		// 90 bits per transform
			{ 2, 16, 6 },		// 90 bits per transform
			{ 2, 17, 5 },		// 90 bits per transform
			{ 3, 4, 17 },		// 90 bits per transform
			{ 3, 5, 16 },		// 90 bits per transform
			{ 3, 6, 15 },		// 90 bits per transform
			{ 3, 7, 14 },		// 90 bits per transform
			{ 3, 8, 13 },		// 90 bits per transform
			{ 3, 9, 12 },		// 90 bits per transform
			{ 3, 10, 11 },		// 90 bits per transform
			{ 3, 11, 10 },		// 90 bits per transform
			{ 3, 12, 9 },		// 90 bits per transform
			{ 3, 13, 8 },		// 90 bits per transform
			{ 3, 14, 7 },		// 90 bits per transform
			{ 3, 15, 6 },		// 90 bits per transform
			{ 3, 16, 5 },		// 90 bits per transform
			{ 3, 17, 4 },		// 90 bits per transform
			{ 4, 3, 17 },		// 90 bits per transform
			{ 4, 4, 16 },		// 90 bits per transform
			{ 4, 5, 15 },		// 90 bits per transform
			{ 4, 6, 14 },		// 90 bits per transform
			{ 4, 7, 13 },		// 90 bits per transform
			{ 4, 8, 12 },		// 90 bits per transform
			{ 4, 9, 11 },		// 90 bits per transform
			{ 4, 10, 10 },		// 90 bits per transform
			{ 4, 11, 9 },		// 90 bits per transform
			{ 4, 12, 8 },		// 90 bits per transform
			{ 4, 13, 7 },		// 90 bits per transform
			{ 4, 14, 6 },		// 90 bits per transform
			{ 4, 15, 5 },		// 90 bits per transform
			{ 4, 16, 4 },		// 90 bits per transform
			{ 4, 17, 3 },		// 90 bits per transform
			{ 5, 2, 17 },		// 90 bits per transform
			{ 5, 3, 16 },		// 90 bits per transform
			{ 5, 4, 15 },		// 90 bits per transform
			{ 5, 5, 14 },		// 90 bits per transform
			{ 5, 6, 13 },		// 90 bits per transform
			{ 5, 7, 12 },		// 90 bits per transform
			{ 5, 8, 11 },		// 90 bits per transform
			{ 5, 9, 10 },		// 90 bits per transform
			{ 5, 10, 9 },		// 90 bits per transform
			{ 5, 11, 8 },		// 90 bits per transform
			{ 5, 12, 7 },		// 90 bits per transform
			{ 5, 13, 6 },		// 90 bits per transform
			{ 5, 14, 5 },		// 90 bits per transform
			{ 5, 15, 4 },		// 90 bits per transform
			{ 5, 16, 3 },		// 90 bits per transform
			{ 5, 17, 2 },		// 90 bits per transform
			{ 6, 1, 17 },		// 90 bits per transform
			{ 6, 2, 16 },		// 90 bits per transform
			{ 6, 3, 15 },		// 90 bits per transform
			{ 6, 4, 14 },		// 90 bits per transform
			{ 6, 5, 13 },		// 90 bits per transform
			{ 6, 6, 12 },		// 90 bits per transform
			{ 6, 7, 11 },		// 90 bits per transform
			{ 6, 8, 10 },		// 90 bits per transform
			{ 6, 9, 9 },		// 90 bits per transform
			{ 6, 10, 8 },		// 90 bits per transform
			{ 6, 11, 7 },		// 90 bits per transform
			{ 6, 12, 6 },		// 90 bits per transform
			{ 6, 13, 5 },		// 90 bits per transform
			{ 6, 14, 4 },		// 90 bits per transform
			{ 6, 15, 3 },		// 90 bits per transform
			{ 6, 16, 2 },		// 90 bits per transform
			{ 6, 17, 1 },		// 90 bits per transform
			{ 7, 1, 16 },		// 90 bits per transform
			{ 7, 2, 15 },		// 90 bits per transform
			{ 7, 3, 14 },		// 90 bits per transform
			{ 7, 4, 13 },		// 90 bits per transform
			{ 7, 5, 12 },		// 90 bits per transform
			{ 7, 6, 11 },		// 90 bits per transform
			{ 7, 7, 10 },		// 90 bits per transform
			{ 7, 8, 9 },		// 90 bits per transform
			{ 7, 9, 8 },		// 90 bits per transform
			{ 7, 10, 7 },		// 90 bits per transform
			{ 7, 11, 6 },		// 90 bits per transform
			{ 7, 12, 5 },		// 90 bits per transform
			{ 7, 13, 4 },		// 90 bits per transform
			{ 7, 14, 3 },		// 90 bits per transform
			{ 7, 15, 2 },		// 90 bits per transform
			{ 7, 16, 1 },		// 90 bits per transform
			{ 8, 1, 15 },		// 90 bits per transform
			{ 8, 2, 14 },		// 90 bits per transform
			{ 8, 3, 13 },		// 90 bits per transform
			{ 8, 4, 12 },		// 90 bits per transform
			{ 8, 5, 11 },		// 90 bits per transform
			{ 8, 6, 10 },		// 90 bits per transform
			{ 8, 7, 9 },		// 90 bits per transform
			{ 8, 8, 8 },		// 90 bits per transform
			{ 8, 9, 7 },		// 90 bits per transform
			{ 8, 10, 6 },		// 90 bits per transform
			{ 8, 11, 5 },		// 90 bits per transform
			{ 8, 12, 4 },		// 90 bits per transform
			{ 8, 13, 3 },		// 90 bits per transform
			{ 8, 14, 2 },		// 90 bits per transform
			{ 8, 15, 1 },		// 90 bits per transform
			{ 9, 0, 17 },		// 90 bits per transform
			{ 9, 1, 14 },		// 90 bits per transform
			{ 9, 2, 13 },		// 90 bits per transform
			{ 9, 3, 12 },		// 90 bits per transform
			{ 9, 4, 11 },		// 90 bits per transform
			{ 9, 5, 10 },		// 90 bits per transform
			{ 9, 6, 9 },		// 90 bits per transform
			{ 9, 7, 8 },		// 90 bits per transform
			{ 9, 8, 7 },		// 90 bits per transform
			{ 9, 9, 6 },		// 90 bits per transform
			{ 9, 10, 5 },		// 90 bits per transform
			{ 9, 11, 4 },		// 90 bits per transform
			{ 9, 12, 3 },		// 90 bits per transform
			{ 9, 13, 2 },		// 90 bits per transform
			{ 9, 14, 1 },		// 90 bits per transform
			{ 9, 17, 0 },		// 90 bits per transform
			{ 10, 0, 16 },		// 90 bits per transform
			{ 10, 1, 13 },		// 90 bits per transform
			{ 10, 2, 12 },		// 90 bits per transform
			{ 10, 3, 11 },		// 90 bits per transform
			{ 10, 4, 10 },		// 90 bits per transform
			{ 10, 5, 9 },		// 90 bits per transform
			{ 10, 6, 8 },		// 90 bits per transform
			{ 10, 7, 7 },		// 90 bits per transform
			{ 10, 8, 6 },		// 90 bits per transform
			{ 10, 9, 5 },		// 90 bits per transform
			{ 10, 10, 4 },		// 90 bits per transform
			{ 10, 11, 3 },		// 90 bits per transform
			{ 10, 12, 2 },		// 90 bits per transform
			{ 10, 13, 1 },		// 90 bits per transform
			{ 10, 16, 0 },		// 90 bits per transform
			{ 11, 0, 15 },		// 90 bits per transform
			{ 11, 1, 12 },		// 90 bits per transform
			{ 11, 2, 11 },		// 90 bits per transform
			{ 11, 3, 10 },		// 90 bits per transform
			{ 11, 4, 9 },		// 90 bits per transform
			{ 11, 5, 8 },		// 90 bits per transform
			{ 11, 6, 7 },		// 90 bits per transform
			{ 11, 7, 6 },		// 90 bits per transform
			{ 11, 8, 5 },		// 90 bits per transform
			{ 11, 9, 4 },		// 90 bits per transform
			{ 11, 10, 3 },		// 90 bits per transform
			{ 11, 11, 2 },		// 90 bits per transform
			{ 11, 12, 1 },		// 90 bits per transform
			{ 11, 15, 0 },		// 90 bits per transform
			{ 12, 0, 14 },		// 90 bits per transform
			{ 12, 1, 11 },		// 90 bits per transform
			{ 12, 2, 10 },		// 90 bits per transform
			{ 12, 3, 9 },		// 90 bits per transform
			{ 12, 4, 8 },		// 90 bits per transform
			{ 12, 5, 7 },		// 90 bits per transform
			{ 12, 6, 6 },		// 90 bits per transform
			{ 12, 7, 5 },		// 90 bits per transform
			{ 12, 8, 4 },		// 90 bits per transform
			{ 12, 9, 3 },		// 90 bits per transform
			{ 12, 10, 2 },		// 90 bits per transform
			{ 12, 11, 1 },		// 90 bits per transform
			{ 12, 14, 0 },		// 90 bits per transform
			{ 13, 0, 13 },		// 90 bits per transform
			{ 13, 1, 10 },		// 90 bits per transform
			{ 13, 2, 9 },		// 90 bits per transform
			{ 13, 3, 8 },		// 90 bits per transform
			{ 13, 4, 7 },		// 90 bits per transform
			{ 13, 5, 6 },		// 90 bits per transform
			{ 13, 6, 5 },		// 90 bits per transform
			{ 13, 7, 4 },		// 90 bits per transform
			{ 13, 8, 3 },		// 90 bits per transform
			{ 13, 9, 2 },		// 90 bits per transform
			{ 13, 10, 1 },		// 90 bits per transform
			{ 13, 13, 0 },		// 90 bits per transform
			{ 14, 0, 12 },		// 90 bits per transform
			{ 14, 1, 9 },		// 90 bits per transform
			{ 14, 2, 8 },		// 90 bits per transform
			{ 14, 3, 7 },		// 90 bits per transform
			{ 14, 4, 6 },		// 90 bits per transform
			{ 14, 5, 5 },		// 90 bits per transform
			{ 14, 6, 4 },		// 90 bits per transform
			{ 14, 7, 3 },		// 90 bits per transform
			{ 14, 8, 2 },		// 90 bits per transform
			{ 14, 9, 1 },		// 90 bits per transform
			{ 14, 12, 0 },		// 90 bits per transform
			{ 15, 0, 11 },		// 90 bits per transform
			{ 15, 1, 8 },		// 90 bits per transform
			{ 15, 2, 7 },		// 90 bits per transform
			{ 15, 3, 6 },		// 90 bits per transform
			{ 15, 4, 5 },		// 90 bits per transform
			{ 15, 5, 4 },		// 90 bits per transform
			{ 15, 6, 3 },		// 90 bits per transform
			{ 15, 7, 2 },		// 90 bits per transform
			{ 15, 8, 1 },		// 90 bits per transform
			{ 15, 11, 0 },		// 90 bits per transform
			{ 16, 0, 10 },		// 90 bits per transform
			{ 16, 1, 7 },		// 90 bits per transform
			{ 16, 2, 6 },		// 90 bits per transform
			{ 16, 3, 5 },		// 90 bits per transform
			{ 16, 4, 4 },		// 90 bits per transform
			{ 16, 5, 3 },		// 90 bits per transform
			{ 16, 6, 2 },		// 90 bits per transform
			{ 16, 7, 1 },		// 90 bits per transform
			{ 16, 10, 0 },		// 90 bits per transform
			{ 17, 0, 9 },		// 90 bits per transform
			{ 17, 1, 6 },		// 90 bits per transform
			{ 17, 2, 5 },		// 90 bits per transform
			{ 17, 3, 4 },		// 90 bits per transform
			{ 17, 4, 3 },		// 90 bits per transform
			{ 17, 5, 2 },		// 90 bits per transform
			{ 17, 6, 1 },		// 90 bits per transform
			{ 17, 9, 0 },		// 90 bits per transform
			{ 0, 10, 17 },		// 93 bits per transform
			{ 0, 11, 16 },		// 93 bits per transform
			{ 0, 12, 15 },		// 93 bits per transform
			{ 0, 13, 14 },		// 93 bits per transform
			{ 0, 14, 13 },		// 93 bits per transform
			{ 0, 15, 12 },		// 93 bits per transform
			{ 0, 16, 11 },		// 93 bits per transform
			{ 0, 17, 10 },		// 93 bits per transform
			{ 1, 7, 17 },		// 93 bits per transform
			{ 1, 8, 16 },		// 93 bits per transform
			{ 1, 9, 15 },		// 93 bits per transform
			{ 1, 10, 14 },		// 93 bits per transform
			{ 1, 11, 13 },		// 93 bits per transform
			{ 1, 12, 12 },		// 93 bits per transform
			{ 1, 13, 11 },		// 93 bits per transform
			{ 1, 14, 10 },		// 93 bits per transform
			{ 1, 15, 9 },		// 93 bits per transform
			{ 1, 16, 8 },		// 93 bits per transform
			{ 1, 17, 7 },		// 93 bits per transform
			{ 2, 6, 17 },		// 93 bits per transform
			{ 2, 7, 16 },		// 93 bits per transform
			{ 2, 8, 15 },		// 93 bits per transform
			{ 2, 9, 14 },		// 93 bits per transform
			{ 2, 10, 13 },		// 93 bits per transform
			{ 2, 11, 12 },		// 93 bits per transform
			{ 2, 12, 11 },		// 93 bits per transform
			{ 2, 13, 10 },		// 93 bits per transform
			{ 2, 14, 9 },		// 93 bits per transform
			{ 2, 15, 8 },		// 93 bits per transform
			{ 2, 16, 7 },		// 93 bits per transform
			{ 2, 17, 6 },		// 93 bits per transform
			{ 3, 5, 17 },		// 93 bits per transform
			{ 3, 6, 16 },		// 93 bits per transform
			{ 3, 7, 15 },		// 93 bits per transform
			{ 3, 8, 14 },		// 93 bits per transform
			{ 3, 9, 13 },		// 93 bits per transform
			{ 3, 10, 12 },		// 93 bits per transform
			{ 3, 11, 11 },		// 93 bits per transform
			{ 3, 12, 10 },		// 93 bits per transform
			{ 3, 13, 9 },		// 93 bits per transform
			{ 3, 14, 8 },		// 93 bits per transform
			{ 3, 15, 7 },		// 93 bits per transform
			{ 3, 16, 6 },		// 93 bits per transform
			{ 3, 17, 5 },		// 93 bits per transform
			{ 4, 4, 17 },		// 93 bits per transform
			{ 4, 5, 16 },		// 93 bits per transform
			{ 4, 6, 15 },		// 93 bits per transform
			{ 4, 7, 14 },		// 93 bits per transform
			{ 4, 8, 13 },		// 93 bits per transform
			{ 4, 9, 12 },		// 93 bits per transform
			{ 4, 10, 11 },		// 93 bits per transform
			{ 4, 11, 10 },		// 93 bits per transform
			{ 4, 12, 9 },		// 93 bits per transform
			{ 4, 13, 8 },		// 93 bits per transform
			{ 4, 14, 7 },		// 93 bits per transform
			{ 4, 15, 6 },		// 93 bits per transform
			{ 4, 16, 5 },		// 93 bits per transform
			{ 4, 17, 4 },		// 93 bits per transform
			{ 5, 3, 17 },		// 93 bits per transform
			{ 5, 4, 16 },		// 93 bits per transform
			{ 5, 5, 15 },		// 93 bits per transform
			{ 5, 6, 14 },		// 93 bits per transform
			{ 5, 7, 13 },		// 93 bits per transform
			{ 5, 8, 12 },		// 93 bits per transform
			{ 5, 9, 11 },		// 93 bits per transform
			{ 5, 10, 10 },		// 93 bits per transform
			{ 5, 11, 9 },		// 93 bits per transform
			{ 5, 12, 8 },		// 93 bits per transform
			{ 5, 13, 7 },		// 93 bits per transform
			{ 5, 14, 6 },		// 93 bits per transform
			{ 5, 15, 5 },		// 93 bits per transform
			{ 5, 16, 4 },		// 93 bits per transform
			{ 5, 17, 3 },		// 93 bits per transform
			{ 6, 2, 17 },		// 93 bits per transform
			{ 6, 3, 16 },		// 93 bits per transform
			{ 6, 4, 15 },		// 93 bits per transform
			{ 6, 5, 14 },		// 93 bits per transform
			{ 6, 6, 13 },		// 93 bits per transform
			{ 6, 7, 12 },		// 93 bits per transform
			{ 6, 8, 11 },		// 93 bits per transform
			{ 6, 9, 10 },		// 93 bits per transform
			{ 6, 10, 9 },		// 93 bits per transform
			{ 6, 11, 8 },		// 93 bits per transform
			{ 6, 12, 7 },		// 93 bits per transform
			{ 6, 13, 6 },		// 93 bits per transform
			{ 6, 14, 5 },		// 93 bits per transform
			{ 6, 15, 4 },		// 93 bits per transform
			{ 6, 16, 3 },		// 93 bits per transform
			{ 6, 17, 2 },		// 93 bits per transform
			{ 7, 1, 17 },		// 93 bits per transform
			{ 7, 2, 16 },		// 93 bits per transform
			{ 7, 3, 15 },		// 93 bits per transform
			{ 7, 4, 14 },		// 93 bits per transform
			{ 7, 5, 13 },		// 93 bits per transform
			{ 7, 6, 12 },		// 93 bits per transform
			{ 7, 7, 11 },		// 93 bits per transform
			{ 7, 8, 10 },		// 93 bits per transform
			{ 7, 9, 9 },		// 93 bits per transform
			{ 7, 10, 8 },		// 93 bits per transform
			{ 7, 11, 7 },		// 93 bits per transform
			{ 7, 12, 6 },		// 93 bits per transform
			{ 7, 13, 5 },		// 93 bits per transform
			{ 7, 14, 4 },		// 93 bits per transform
			{ 7, 15, 3 },		// 93 bits per transform
			{ 7, 16, 2 },		// 93 bits per transform
			{ 7, 17, 1 },		// 93 bits per transform
			{ 8, 1, 16 },		// 93 bits per transform
			{ 8, 2, 15 },		// 93 bits per transform
			{ 8, 3, 14 },		// 93 bits per transform
			{ 8, 4, 13 },		// 93 bits per transform
			{ 8, 5, 12 },		// 93 bits per transform
			{ 8, 6, 11 },		// 93 bits per transform
			{ 8, 7, 10 },		// 93 bits per transform
			{ 8, 8, 9 },		// 93 bits per transform
			{ 8, 9, 8 },		// 93 bits per transform
			{ 8, 10, 7 },		// 93 bits per transform
			{ 8, 11, 6 },		// 93 bits per transform
			{ 8, 12, 5 },		// 93 bits per transform
			{ 8, 13, 4 },		// 93 bits per transform
			{ 8, 14, 3 },		// 93 bits per transform
			{ 8, 15, 2 },		// 93 bits per transform
			{ 8, 16, 1 },		// 93 bits per transform
			{ 9, 1, 15 },		// 93 bits per transform
			{ 9, 2, 14 },		// 93 bits per transform
			{ 9, 3, 13 },		// 93 bits per transform
			{ 9, 4, 12 },		// 93 bits per transform
			{ 9, 5, 11 },		// 93 bits per transform
			{ 9, 6, 10 },		// 93 bits per transform
			{ 9, 7, 9 },		// 93 bits per transform
			{ 9, 8, 8 },		// 93 bits per transform
			{ 9, 9, 7 },		// 93 bits per transform
			{ 9, 10, 6 },		// 93 bits per transform
			{ 9, 11, 5 },		// 93 bits per transform
			{ 9, 12, 4 },		// 93 bits per transform
			{ 9, 13, 3 },		// 93 bits per transform
			{ 9, 14, 2 },		// 93 bits per transform
			{ 9, 15, 1 },		// 93 bits per transform
			{ 10, 0, 17 },		// 93 bits per transform
			{ 10, 1, 14 },		// 93 bits per transform
			{ 10, 2, 13 },		// 93 bits per transform
			{ 10, 3, 12 },		// 93 bits per transform
			{ 10, 4, 11 },		// 93 bits per transform
			{ 10, 5, 10 },		// 93 bits per transform
			{ 10, 6, 9 },		// 93 bits per transform
			{ 10, 7, 8 },		// 93 bits per transform
			{ 10, 8, 7 },		// 93 bits per transform
			{ 10, 9, 6 },		// 93 bits per transform
			{ 10, 10, 5 },		// 93 bits per transform
			{ 10, 11, 4 },		// 93 bits per transform
			{ 10, 12, 3 },		// 93 bits per transform
			{ 10, 13, 2 },		// 93 bits per transform
			{ 10, 14, 1 },		// 93 bits per transform
			{ 10, 17, 0 },		// 93 bits per transform
			{ 11, 0, 16 },		// 93 bits per transform
			{ 11, 1, 13 },		// 93 bits per transform
			{ 11, 2, 12 },		// 93 bits per transform
			{ 11, 3, 11 },		// 93 bits per transform
			{ 11, 4, 10 },		// 93 bits per transform
			{ 11, 5, 9 },		// 93 bits per transform
			{ 11, 6, 8 },		// 93 bits per transform
			{ 11, 7, 7 },		// 93 bits per transform
			{ 11, 8, 6 },		// 93 bits per transform
			{ 11, 9, 5 },		// 93 bits per transform
			{ 11, 10, 4 },		// 93 bits per transform
			{ 11, 11, 3 },		// 93 bits per transform
			{ 11, 12, 2 },		// 93 bits per transform
			{ 11, 13, 1 },		// 93 bits per transform
			{ 11, 16, 0 },		// 93 bits per transform
			{ 12, 0, 15 },		// 93 bits per transform
			{ 12, 1, 12 },		// 93 bits per transform
			{ 12, 2, 11 },		// 93 bits per transform
			{ 12, 3, 10 },		// 93 bits per transform
			{ 12, 4, 9 },		// 93 bits per transform
			{ 12, 5, 8 },		// 93 bits per transform
			{ 12, 6, 7 },		// 93 bits per transform
			{ 12, 7, 6 },		// 93 bits per transform
			{ 12, 8, 5 },		// 93 bits per transform
			{ 12, 9, 4 },		// 93 bits per transform
			{ 12, 10, 3 },		// 93 bits per transform
			{ 12, 11, 2 },		// 93 bits per transform
			{ 12, 12, 1 },		// 93 bits per transform
			{ 12, 15, 0 },		// 93 bits per transform
			{ 13, 0, 14 },		// 93 bits per transform
			{ 13, 1, 11 },		// 93 bits per transform
			{ 13, 2, 10 },		// 93 bits per transform
			{ 13, 3, 9 },		// 93 bits per transform
			{ 13, 4, 8 },		// 93 bits per transform
			{ 13, 5, 7 },		// 93 bits per transform
			{ 13, 6, 6 },		// 93 bits per transform
			{ 13, 7, 5 },		// 93 bits per transform
			{ 13, 8, 4 },		// 93 bits per transform
			{ 13, 9, 3 },		// 93 bits per transform
			{ 13, 10, 2 },		// 93 bits per transform
			{ 13, 11, 1 },		// 93 bits per transform
			{ 13, 14, 0 },		// 93 bits per transform
			{ 14, 0, 13 },		// 93 bits per transform
			{ 14, 1, 10 },		// 93 bits per transform
			{ 14, 2, 9 },		// 93 bits per transform
			{ 14, 3, 8 },		// 93 bits per transform
			{ 14, 4, 7 },		// 93 bits per transform
			{ 14, 5, 6 },		// 93 bits per transform
			{ 14, 6, 5 },		// 93 bits per transform
			{ 14, 7, 4 },		// 93 bits per transform
			{ 14, 8, 3 },		// 93 bits per transform
			{ 14, 9, 2 },		// 93 bits per transform
			{ 14, 10, 1 },		// 93 bits per transform
			{ 14, 13, 0 },		// 93 bits per transform
			{ 15, 0, 12 },		// 93 bits per transform
			{ 15, 1, 9 },		// 93 bits per transform
			{ 15, 2, 8 },		// 93 bits per transform
			{ 15, 3, 7 },		// 93 bits per transform
			{ 15, 4, 6 },		// 93 bits per transform
			{ 15, 5, 5 },		// 93 bits per transform
			{ 15, 6, 4 },		// 93 bits per transform
			{ 15, 7, 3 },		// 93 bits per transform
			{ 15, 8, 2 },		// 93 bits per transform
			{ 15, 9, 1 },		// 93 bits per transform
			{ 15, 12, 0 },		// 93 bits per transform
			{ 16, 0, 11 },		// 93 bits per transform
			{ 16, 1, 8 },		// 93 bits per transform
			{ 16, 2, 7 },		// 93 bits per transform
			{ 16, 3, 6 },		// 93 bits per transform
			{ 16, 4, 5 },		// 93 bits per transform
			{ 16, 5, 4 },		// 93 bits per transform
			{ 16, 6, 3 },		// 93 bits per transform
			{ 16, 7, 2 },		// 93 bits per transform
			{ 16, 8, 1 },		// 93 bits per transform
			{ 16, 11, 0 },		// 93 bits per transform
			{ 17, 0, 10 },		// 93 bits per transform
			{ 17, 1, 7 },		// 93 bits per transform
			{ 17, 2, 6 },		// 93 bits per transform
			{ 17, 3, 5 },		// 93 bits per transform
			{ 17, 4, 4 },		// 93 bits per transform
			{ 17, 5, 3 },		// 93 bits per transform
			{ 17, 6, 2 },		// 93 bits per transform
			{ 17, 7, 1 },		// 93 bits per transform
			{ 17, 10, 0 },		// 93 bits per transform
			{ 0, 0, 18 },		// 96 bits per transform
			{ 0, 11, 17 },		// 96 bits per transform
			{ 0, 12, 16 },		// 96 bits per transform
			{ 0, 13, 15 },		// 96 bits per transform
			{ 0, 14, 14 },		// 96 bits per transform
			{ 0, 15, 13 },		// 96 bits per transform
			{ 0, 16, 12 },		// 96 bits per transform
			{ 0, 17, 11 },		// 96 bits per transform
			{ 0, 18, 0 },		// 96 bits per transform
			{ 1, 8, 17 },		// 96 bits per transform
			{ 1, 9, 16 },		// 96 bits per transform
			{ 1, 10, 15 },		// 96 bits per transform
			{ 1, 11, 14 },		// 96 bits per transform
			{ 1, 12, 13 },		// 96 bits per transform
			{ 1, 13, 12 },		// 96 bits per transform
			{ 1, 14, 11 },		// 96 bits per transform
			{ 1, 15, 10 },		// 96 bits per transform
			{ 1, 16, 9 },		// 96 bits per transform
			{ 1, 17, 8 },		// 96 bits per transform
			{ 2, 7, 17 },		// 96 bits per transform
			{ 2, 8, 16 },		// 96 bits per transform
			{ 2, 9, 15 },		// 96 bits per transform
			{ 2, 10, 14 },		// 96 bits per transform
			{ 2, 11, 13 },		// 96 bits per transform
			{ 2, 12, 12 },		// 96 bits per transform
			{ 2, 13, 11 },		// 96 bits per transform
			{ 2, 14, 10 },		// 96 bits per transform
			{ 2, 15, 9 },		// 96 bits per transform
			{ 2, 16, 8 },		// 96 bits per transform
			{ 2, 17, 7 },		// 96 bits per transform
			{ 3, 6, 17 },		// 96 bits per transform
			{ 3, 7, 16 },		// 96 bits per transform
			{ 3, 8, 15 },		// 96 bits per transform
			{ 3, 9, 14 },		// 96 bits per transform
			{ 3, 10, 13 },		// 96 bits per transform
			{ 3, 11, 12 },		// 96 bits per transform
			{ 3, 12, 11 },		// 96 bits per transform
			{ 3, 13, 10 },		// 96 bits per transform
			{ 3, 14, 9 },		// 96 bits per transform
			{ 3, 15, 8 },		// 96 bits per transform
			{ 3, 16, 7 },		// 96 bits per transform
			{ 3, 17, 6 },		// 96 bits per transform
			{ 4, 5, 17 },		// 96 bits per transform
			{ 4, 6, 16 },		// 96 bits per transform
			{ 4, 7, 15 },		// 96 bits per transform
			{ 4, 8, 14 },		// 96 bits per transform
			{ 4, 9, 13 },		// 96 bits per transform
			{ 4, 10, 12 },		// 96 bits per transform
			{ 4, 11, 11 },		// 96 bits per transform
			{ 4, 12, 10 },		// 96 bits per transform
			{ 4, 13, 9 },		// 96 bits per transform
			{ 4, 14, 8 },		// 96 bits per transform
			{ 4, 15, 7 },		// 96 bits per transform
			{ 4, 16, 6 },		// 96 bits per transform
			{ 4, 17, 5 },		// 96 bits per transform
			{ 5, 4, 17 },		// 96 bits per transform
			{ 5, 5, 16 },		// 96 bits per transform
			{ 5, 6, 15 },		// 96 bits per transform
			{ 5, 7, 14 },		// 96 bits per transform
			{ 5, 8, 13 },		// 96 bits per transform
			{ 5, 9, 12 },		// 96 bits per transform
			{ 5, 10, 11 },		// 96 bits per transform
			{ 5, 11, 10 },		// 96 bits per transform
			{ 5, 12, 9 },		// 96 bits per transform
			{ 5, 13, 8 },		// 96 bits per transform
			{ 5, 14, 7 },		// 96 bits per transform
			{ 5, 15, 6 },		// 96 bits per transform
			{ 5, 16, 5 },		// 96 bits per transform
			{ 5, 17, 4 },		// 96 bits per transform
			{ 6, 3, 17 },		// 96 bits per transform
			{ 6, 4, 16 },		// 96 bits per transform
			{ 6, 5, 15 },		// 96 bits per transform
			{ 6, 6, 14 },		// 96 bits per transform
			{ 6, 7, 13 },		// 96 bits per transform
			{ 6, 8, 12 },		// 96 bits per transform
			{ 6, 9, 11 },		// 96 bits per transform
			{ 6, 10, 10 },		// 96 bits per transform
			{ 6, 11, 9 },		// 96 bits per transform
			{ 6, 12, 8 },		// 96 bits per transform
			{ 6, 13, 7 },		// 96 bits per transform
			{ 6, 14, 6 },		// 96 bits per transform
			{ 6, 15, 5 },		// 96 bits per transform
			{ 6, 16, 4 },		// 96 bits per transform
			{ 6, 17, 3 },		// 96 bits per transform
			{ 7, 2, 17 },		// 96 bits per transform
			{ 7, 3, 16 },		// 96 bits per transform
			{ 7, 4, 15 },		// 96 bits per transform
			{ 7, 5, 14 },		// 96 bits per transform
			{ 7, 6, 13 },		// 96 bits per transform
			{ 7, 7, 12 },		// 96 bits per transform
			{ 7, 8, 11 },		// 96 bits per transform
			{ 7, 9, 10 },		// 96 bits per transform
			{ 7, 10, 9 },		// 96 bits per transform
			{ 7, 11, 8 },		// 96 bits per transform
			{ 7, 12, 7 },		// 96 bits per transform
			{ 7, 13, 6 },		// 96 bits per transform
			{ 7, 14, 5 },		// 96 bits per transform
			{ 7, 15, 4 },		// 96 bits per transform
			{ 7, 16, 3 },		// 96 bits per transform
			{ 7, 17, 2 },		// 96 bits per transform
			{ 8, 1, 17 },		// 96 bits per transform
			{ 8, 2, 16 },		// 96 bits per transform
			{ 8, 3, 15 },		// 96 bits per transform
			{ 8, 4, 14 },		// 96 bits per transform
			{ 8, 5, 13 },		// 96 bits per transform
			{ 8, 6, 12 },		// 96 bits per transform
			{ 8, 7, 11 },		// 96 bits per transform
			{ 8, 8, 10 },		// 96 bits per transform
			{ 8, 9, 9 },		// 96 bits per transform
			{ 8, 10, 8 },		// 96 bits per transform
			{ 8, 11, 7 },		// 96 bits per transform
			{ 8, 12, 6 },		// 96 bits per transform
			{ 8, 13, 5 },		// 96 bits per transform
			{ 8, 14, 4 },		// 96 bits per transform
			{ 8, 15, 3 },		// 96 bits per transform
			{ 8, 16, 2 },		// 96 bits per transform
			{ 8, 17, 1 },		// 96 bits per transform
			{ 9, 1, 16 },		// 96 bits per transform
			{ 9, 2, 15 },		// 96 bits per transform
			{ 9, 3, 14 },		// 96 bits per transform
			{ 9, 4, 13 },		// 96 bits per transform
			{ 9, 5, 12 },		// 96 bits per transform
			{ 9, 6, 11 },		// 96 bits per transform
			{ 9, 7, 10 },		// 96 bits per transform
			{ 9, 8, 9 },		// 96 bits per transform
			{ 9, 9, 8 },		// 96 bits per transform
			{ 9, 10, 7 },		// 96 bits per transform
			{ 9, 11, 6 },		// 96 bits per transform
			{ 9, 12, 5 },		// 96 bits per transform
			{ 9, 13, 4 },		// 96 bits per transform
			{ 9, 14, 3 },		// 96 bits per transform
			{ 9, 15, 2 },		// 96 bits per transform
			{ 9, 16, 1 },		// 96 bits per transform
			{ 10, 1, 15 },		// 96 bits per transform
			{ 10, 2, 14 },		// 96 bits per transform
			{ 10, 3, 13 },		// 96 bits per transform
			{ 10, 4, 12 },		// 96 bits per transform
			{ 10, 5, 11 },		// 96 bits per transform
			{ 10, 6, 10 },		// 96 bits per transform
			{ 10, 7, 9 },		// 96 bits per transform
			{ 10, 8, 8 },		// 96 bits per transform
			{ 10, 9, 7 },		// 96 bits per transform
			{ 10, 10, 6 },		// 96 bits per transform
			{ 10, 11, 5 },		// 96 bits per transform
			{ 10, 12, 4 },		// 96 bits per transform
			{ 10, 13, 3 },		// 96 bits per transform
			{ 10, 14, 2 },		// 96 bits per transform
			{ 10, 15, 1 },		// 96 bits per transform
			{ 11, 0, 17 },		// 96 bits per transform
			{ 11, 1, 14 },		// 96 bits per transform
			{ 11, 2, 13 },		// 96 bits per transform
			{ 11, 3, 12 },		// 96 bits per transform
			{ 11, 4, 11 },		// 96 bits per transform
			{ 11, 5, 10 },		// 96 bits per transform
			{ 11, 6, 9 },		// 96 bits per transform
			{ 11, 7, 8 },		// 96 bits per transform
			{ 11, 8, 7 },		// 96 bits per transform
			{ 11, 9, 6 },		// 96 bits per transform
			{ 11, 10, 5 },		// 96 bits per transform
			{ 11, 11, 4 },		// 96 bits per transform
			{ 11, 12, 3 },		// 96 bits per transform
			{ 11, 13, 2 },		// 96 bits per transform
			{ 11, 14, 1 },		// 96 bits per transform
			{ 11, 17, 0 },		// 96 bits per transform
			{ 12, 0, 16 },		// 96 bits per transform
			{ 12, 1, 13 },		// 96 bits per transform
			{ 12, 2, 12 },		// 96 bits per transform
			{ 12, 3, 11 },		// 96 bits per transform
			{ 12, 4, 10 },		// 96 bits per transform
			{ 12, 5, 9 },		// 96 bits per transform
			{ 12, 6, 8 },		// 96 bits per transform
			{ 12, 7, 7 },		// 96 bits per transform
			{ 12, 8, 6 },		// 96 bits per transform
			{ 12, 9, 5 },		// 96 bits per transform
			{ 12, 10, 4 },		// 96 bits per transform
			{ 12, 11, 3 },		// 96 bits per transform
			{ 12, 12, 2 },		// 96 bits per transform
			{ 12, 13, 1 },		// 96 bits per transform
			{ 12, 16, 0 },		// 96 bits per transform
			{ 13, 0, 15 },		// 96 bits per transform
			{ 13, 1, 12 },		// 96 bits per transform
			{ 13, 2, 11 },		// 96 bits per transform
			{ 13, 3, 10 },		// 96 bits per transform
			{ 13, 4, 9 },		// 96 bits per transform
			{ 13, 5, 8 },		// 96 bits per transform
			{ 13, 6, 7 },		// 96 bits per transform
			{ 13, 7, 6 },		// 96 bits per transform
			{ 13, 8, 5 },		// 96 bits per transform
			{ 13, 9, 4 },		// 96 bits per transform
			{ 13, 10, 3 },		// 96 bits per transform
			{ 13, 11, 2 },		// 96 bits per transform
			{ 13, 12, 1 },		// 96 bits per transform
			{ 13, 15, 0 },		// 96 bits per transform
			{ 14, 0, 14 },		// 96 bits per transform
			{ 14, 1, 11 },		// 96 bits per transform
			{ 14, 2, 10 },		// 96 bits per transform
			{ 14, 3, 9 },		// 96 bits per transform
			{ 14, 4, 8 },		// 96 bits per transform
			{ 14, 5, 7 },		// 96 bits per transform
			{ 14, 6, 6 },		// 96 bits per transform
			{ 14, 7, 5 },		// 96 bits per transform
			{ 14, 8, 4 },		// 96 bits per transform
			{ 14, 9, 3 },		// 96 bits per transform
			{ 14, 10, 2 },		// 96 bits per transform
			{ 14, 11, 1 },		// 96 bits per transform
			{ 14, 14, 0 },		// 96 bits per transform
			{ 15, 0, 13 },		// 96 bits per transform
			{ 15, 1, 10 },		// 96 bits per transform
			{ 15, 2, 9 },		// 96 bits per transform
			{ 15, 3, 8 },		// 96 bits per transform
			{ 15, 4, 7 },		// 96 bits per transform
			{ 15, 5, 6 },		// 96 bits per transform
			{ 15, 6, 5 },		// 96 bits per transform
			{ 15, 7, 4 },		// 96 bits per transform
			{ 15, 8, 3 },		// 96 bits per transform
			{ 15, 9, 2 },		// 96 bits per transform
			{ 15, 10, 1 },		// 96 bits per transform
			{ 15, 13, 0 },		// 96 bits per transform
			{ 16, 0, 12 },		// 96 bits per transform
			{ 16, 1, 9 },		// 96 bits per transform
			{ 16, 2, 8 },		// 96 bits per transform
			{ 16, 3, 7 },		// 96 bits per transform
			{ 16, 4, 6 },		// 96 bits per transform
			{ 16, 5, 5 },		// 96 bits per transform
			{ 16, 6, 4 },		// 96 bits per transform
			{ 16, 7, 3 },		// 96 bits per transform
			{ 16, 8, 2 },		// 96 bits per transform
			{ 16, 9, 1 },		// 96 bits per transform
			{ 16, 12, 0 },		// 96 bits per transform
			{ 17, 0, 11 },		// 96 bits per transform
			{ 17, 1, 8 },		// 96 bits per transform
			{ 17, 2, 7 },		// 96 bits per transform
			{ 17, 3, 6 },		// 96 bits per transform
			{ 17, 4, 5 },		// 96 bits per transform
			{ 17, 5, 4 },		// 96 bits per transform
			{ 17, 6, 3 },		// 96 bits per transform
			{ 17, 7, 2 },		// 96 bits per transform
			{ 17, 8, 1 },		// 96 bits per transform
			{ 17, 11, 0 },		// 96 bits per transform
			{ 18, 0, 0 },		// 96 bits per transform
			{ 0, 12, 17 },		// 99 bits per transform
			{ 0, 13, 16 },		// 99 bits per transform
			{ 0, 14, 15 },		// 99 bits per transform
			{ 0, 15, 14 },		// 99 bits per transform
			{ 0, 16, 13 },		// 99 bits per transform
			{ 0, 17, 12 },		// 99 bits per transform
			{ 1, 9, 17 },		// 99 bits per transform
			{ 1, 10, 16 },		// 99 bits per transform
			{ 1, 11, 15 },		// 99 bits per transform
			{ 1, 12, 14 },		// 99 bits per transform
			{ 1, 13, 13 },		// 99 bits per transform
			{ 1, 14, 12 },		// 99 bits per transform
			{ 1, 15, 11 },		// 99 bits per transform
			{ 1, 16, 10 },		// 99 bits per transform
			{ 1, 17, 9 },		// 99 bits per transform
			{ 2, 8, 17 },		// 99 bits per transform
			{ 2, 9, 16 },		// 99 bits per transform
			{ 2, 10, 15 },		// 99 bits per transform
			{ 2, 11, 14 },		// 99 bits per transform
			{ 2, 12, 13 },		// 99 bits per transform
			{ 2, 13, 12 },		// 99 bits per transform
			{ 2, 14, 11 },		// 99 bits per transform
			{ 2, 15, 10 },		// 99 bits per transform
			{ 2, 16, 9 },		// 99 bits per transform
			{ 2, 17, 8 },		// 99 bits per transform
			{ 3, 7, 17 },		// 99 bits per transform
			{ 3, 8, 16 },		// 99 bits per transform
			{ 3, 9, 15 },		// 99 bits per transform
			{ 3, 10, 14 },		// 99 bits per transform
			{ 3, 11, 13 },		// 99 bits per transform
			{ 3, 12, 12 },		// 99 bits per transform
			{ 3, 13, 11 },		// 99 bits per transform
			{ 3, 14, 10 },		// 99 bits per transform
			{ 3, 15, 9 },		// 99 bits per transform
			{ 3, 16, 8 },		// 99 bits per transform
			{ 3, 17, 7 },		// 99 bits per transform
			{ 4, 6, 17 },		// 99 bits per transform
			{ 4, 7, 16 },		// 99 bits per transform
			{ 4, 8, 15 },		// 99 bits per transform
			{ 4, 9, 14 },		// 99 bits per transform
			{ 4, 10, 13 },		// 99 bits per transform
			{ 4, 11, 12 },		// 99 bits per transform
			{ 4, 12, 11 },		// 99 bits per transform
			{ 4, 13, 10 },		// 99 bits per transform
			{ 4, 14, 9 },		// 99 bits per transform
			{ 4, 15, 8 },		// 99 bits per transform
			{ 4, 16, 7 },		// 99 bits per transform
			{ 4, 17, 6 },		// 99 bits per transform
			{ 5, 5, 17 },		// 99 bits per transform
			{ 5, 6, 16 },		// 99 bits per transform
			{ 5, 7, 15 },		// 99 bits per transform
			{ 5, 8, 14 },		// 99 bits per transform
			{ 5, 9, 13 },		// 99 bits per transform
			{ 5, 10, 12 },		// 99 bits per transform
			{ 5, 11, 11 },		// 99 bits per transform
			{ 5, 12, 10 },		// 99 bits per transform
			{ 5, 13, 9 },		// 99 bits per transform
			{ 5, 14, 8 },		// 99 bits per transform
			{ 5, 15, 7 },		// 99 bits per transform
			{ 5, 16, 6 },		// 99 bits per transform
			{ 5, 17, 5 },		// 99 bits per transform
			{ 6, 4, 17 },		// 99 bits per transform
			{ 6, 5, 16 },		// 99 bits per transform
			{ 6, 6, 15 },		// 99 bits per transform
			{ 6, 7, 14 },		// 99 bits per transform
			{ 6, 8, 13 },		// 99 bits per transform
			{ 6, 9, 12 },		// 99 bits per transform
			{ 6, 10, 11 },		// 99 bits per transform
			{ 6, 11, 10 },		// 99 bits per transform
			{ 6, 12, 9 },		// 99 bits per transform
			{ 6, 13, 8 },		// 99 bits per transform
			{ 6, 14, 7 },		// 99 bits per transform
			{ 6, 15, 6 },		// 99 bits per transform
			{ 6, 16, 5 },		// 99 bits per transform
			{ 6, 17, 4 },		// 99 bits per transform
			{ 7, 3, 17 },		// 99 bits per transform
			{ 7, 4, 16 },		// 99 bits per transform
			{ 7, 5, 15 },		// 99 bits per transform
			{ 7, 6, 14 },		// 99 bits per transform
			{ 7, 7, 13 },		// 99 bits per transform
			{ 7, 8, 12 },		// 99 bits per transform
			{ 7, 9, 11 },		// 99 bits per transform
			{ 7, 10, 10 },		// 99 bits per transform
			{ 7, 11, 9 },		// 99 bits per transform
			{ 7, 12, 8 },		// 99 bits per transform
			{ 7, 13, 7 },		// 99 bits per transform
			{ 7, 14, 6 },		// 99 bits per transform
			{ 7, 15, 5 },		// 99 bits per transform
			{ 7, 16, 4 },		// 99 bits per transform
			{ 7, 17, 3 },		// 99 bits per transform
			{ 8, 2, 17 },		// 99 bits per transform
			{ 8, 3, 16 },		// 99 bits per transform
			{ 8, 4, 15 },		// 99 bits per transform
			{ 8, 5, 14 },		// 99 bits per transform
			{ 8, 6, 13 },		// 99 bits per transform
			{ 8, 7, 12 },		// 99 bits per transform
			{ 8, 8, 11 },		// 99 bits per transform
			{ 8, 9, 10 },		// 99 bits per transform
			{ 8, 10, 9 },		// 99 bits per transform
			{ 8, 11, 8 },		// 99 bits per transform
			{ 8, 12, 7 },		// 99 bits per transform
			{ 8, 13, 6 },		// 99 bits per transform
			{ 8, 14, 5 },		// 99 bits per transform
			{ 8, 15, 4 },		// 99 bits per transform
			{ 8, 16, 3 },		// 99 bits per transform
			{ 8, 17, 2 },		// 99 bits per transform
			{ 9, 1, 17 },		// 99 bits per transform
			{ 9, 2, 16 },		// 99 bits per transform
			{ 9, 3, 15 },		// 99 bits per transform
			{ 9, 4, 14 },		// 99 bits per transform
			{ 9, 5, 13 },		// 99 bits per transform
			{ 9, 6, 12 },		// 99 bits per transform
			{ 9, 7, 11 },		// 99 bits per transform
			{ 9, 8, 10 },		// 99 bits per transform
			{ 9, 9, 9 },		// 99 bits per transform
			{ 9, 10, 8 },		// 99 bits per transform
			{ 9, 11, 7 },		// 99 bits per transform
			{ 9, 12, 6 },		// 99 bits per transform
			{ 9, 13, 5 },		// 99 bits per transform
			{ 9, 14, 4 },		// 99 bits per transform
			{ 9, 15, 3 },		// 99 bits per transform
			{ 9, 16, 2 },		// 99 bits per transform
			{ 9, 17, 1 },		// 99 bits per transform
			{ 10, 1, 16 },		// 99 bits per transform
			{ 10, 2, 15 },		// 99 bits per transform
			{ 10, 3, 14 },		// 99 bits per transform
			{ 10, 4, 13 },		// 99 bits per transform
			{ 10, 5, 12 },		// 99 bits per transform
			{ 10, 6, 11 },		// 99 bits per transform
			{ 10, 7, 10 },		// 99 bits per transform
			{ 10, 8, 9 },		// 99 bits per transform
			{ 10, 9, 8 },		// 99 bits per transform
			{ 10, 10, 7 },		// 99 bits per transform
			{ 10, 11, 6 },		// 99 bits per transform
			{ 10, 12, 5 },		// 99 bits per transform
			{ 10, 13, 4 },		// 99 bits per transform
			{ 10, 14, 3 },		// 99 bits per transform
			{ 10, 15, 2 },		// 99 bits per transform
			{ 10, 16, 1 },		// 99 bits per transform
			{ 11, 1, 15 },		// 99 bits per transform
			{ 11, 2, 14 },		// 99 bits per transform
			{ 11, 3, 13 },		// 99 bits per transform
			{ 11, 4, 12 },		// 99 bits per transform
			{ 11, 5, 11 },		// 99 bits per transform
			{ 11, 6, 10 },		// 99 bits per transform
			{ 11, 7, 9 },		// 99 bits per transform
			{ 11, 8, 8 },		// 99 bits per transform
			{ 11, 9, 7 },		// 99 bits per transform
			{ 11, 10, 6 },		// 99 bits per transform
			{ 11, 11, 5 },		// 99 bits per transform
			{ 11, 12, 4 },		// 99 bits per transform
			{ 11, 13, 3 },		// 99 bits per transform
			{ 11, 14, 2 },		// 99 bits per transform
			{ 11, 15, 1 },		// 99 bits per transform
			{ 12, 0, 17 },		// 99 bits per transform
			{ 12, 1, 14 },		// 99 bits per transform
			{ 12, 2, 13 },		// 99 bits per transform
			{ 12, 3, 12 },		// 99 bits per transform
			{ 12, 4, 11 },		// 99 bits per transform
			{ 12, 5, 10 },		// 99 bits per transform
			{ 12, 6, 9 },		// 99 bits per transform
			{ 12, 7, 8 },		// 99 bits per transform
			{ 12, 8, 7 },		// 99 bits per transform
			{ 12, 9, 6 },		// 99 bits per transform
			{ 12, 10, 5 },		// 99 bits per transform
			{ 12, 11, 4 },		// 99 bits per transform
			{ 12, 12, 3 },		// 99 bits per transform
			{ 12, 13, 2 },		// 99 bits per transform
			{ 12, 14, 1 },		// 99 bits per transform
			{ 12, 17, 0 },		// 99 bits per transform
			{ 13, 0, 16 },		// 99 bits per transform
			{ 13, 1, 13 },		// 99 bits per transform
			{ 13, 2, 12 },		// 99 bits per transform
			{ 13, 3, 11 },		// 99 bits per transform
			{ 13, 4, 10 },		// 99 bits per transform
			{ 13, 5, 9 },		// 99 bits per transform
			{ 13, 6, 8 },		// 99 bits per transform
			{ 13, 7, 7 },		// 99 bits per transform
			{ 13, 8, 6 },		// 99 bits per transform
			{ 13, 9, 5 },		// 99 bits per transform
			{ 13, 10, 4 },		// 99 bits per transform
			{ 13, 11, 3 },		// 99 bits per transform
			{ 13, 12, 2 },		// 99 bits per transform
			{ 13, 13, 1 },		// 99 bits per transform
			{ 13, 16, 0 },		// 99 bits per transform
			{ 14, 0, 15 },		// 99 bits per transform
			{ 14, 1, 12 },		// 99 bits per transform
			{ 14, 2, 11 },		// 99 bits per transform
			{ 14, 3, 10 },		// 99 bits per transform
			{ 14, 4, 9 },		// 99 bits per transform
			{ 14, 5, 8 },		// 99 bits per transform
			{ 14, 6, 7 },		// 99 bits per transform
			{ 14, 7, 6 },		// 99 bits per transform
			{ 14, 8, 5 },		// 99 bits per transform
			{ 14, 9, 4 },		// 99 bits per transform
			{ 14, 10, 3 },		// 99 bits per transform
			{ 14, 11, 2 },		// 99 bits per transform
			{ 14, 12, 1 },		// 99 bits per transform
			{ 14, 15, 0 },		// 99 bits per transform
			{ 15, 0, 14 },		// 99 bits per transform
			{ 15, 1, 11 },		// 99 bits per transform
			{ 15, 2, 10 },		// 99 bits per transform
			{ 15, 3, 9 },		// 99 bits per transform
			{ 15, 4, 8 },		// 99 bits per transform
			{ 15, 5, 7 },		// 99 bits per transform
			{ 15, 6, 6 },		// 99 bits per transform
			{ 15, 7, 5 },		// 99 bits per transform
			{ 15, 8, 4 },		// 99 bits per transform
			{ 15, 9, 3 },		// 99 bits per transform
			{ 15, 10, 2 },		// 99 bits per transform
			{ 15, 11, 1 },		// 99 bits per transform
			{ 15, 14, 0 },		// 99 bits per transform
			{ 16, 0, 13 },		// 99 bits per transform
			{ 16, 1, 10 },		// 99 bits per transform
			{ 16, 2, 9 },		// 99 bits per transform
			{ 16, 3, 8 },		// 99 bits per transform
			{ 16, 4, 7 },		// 99 bits per transform
			{ 16, 5, 6 },		// 99 bits per transform
			{ 16, 6, 5 },		// 99 bits per transform
			{ 16, 7, 4 },		// 99 bits per transform
			{ 16, 8, 3 },		// 99 bits per transform
			{ 16, 9, 2 },		// 99 bits per transform
			{ 16, 10, 1 },		// 99 bits per transform
			{ 16, 13, 0 },		// 99 bits per transform
			{ 17, 0, 12 },		// 99 bits per transform
			{ 17, 1, 9 },		// 99 bits per transform
			{ 17, 2, 8 },		// 99 bits per transform
			{ 17, 3, 7 },		// 99 bits per transform
			{ 17, 4, 6 },		// 99 bits per transform
			{ 17, 5, 5 },		// 99 bits per transform
			{ 17, 6, 4 },		// 99 bits per transform
			{ 17, 7, 3 },		// 99 bits per transform
			{ 17, 8, 2 },		// 99 bits per transform
			{ 17, 9, 1 },		// 99 bits per transform
			{ 17, 12, 0 },		// 99 bits per transform
			{ 0, 13, 17 },		// 102 bits per transform
			{ 0, 14, 16 },		// 102 bits per transform
			{ 0, 15, 15 },		// 102 bits per transform
			{ 0, 16, 14 },		// 102 bits per transform
			{ 0, 17, 13 },		// 102 bits per transform
			{ 1, 10, 17 },		// 102 bits per transform
			{ 1, 11, 16 },		// 102 bits per transform
			{ 1, 12, 15 },		// 102 bits per transform
			{ 1, 13, 14 },		// 102 bits per transform
			{ 1, 14, 13 },		// 102 bits per transform
			{ 1, 15, 12 },		// 102 bits per transform
			{ 1, 16, 11 },		// 102 bits per transform
			{ 1, 17, 10 },		// 102 bits per transform
			{ 2, 9, 17 },		// 102 bits per transform
			{ 2, 10, 16 },		// 102 bits per transform
			{ 2, 11, 15 },		// 102 bits per transform
			{ 2, 12, 14 },		// 102 bits per transform
			{ 2, 13, 13 },		// 102 bits per transform
			{ 2, 14, 12 },		// 102 bits per transform
			{ 2, 15, 11 },		// 102 bits per transform
			{ 2, 16, 10 },		// 102 bits per transform
			{ 2, 17, 9 },		// 102 bits per transform
			{ 3, 8, 17 },		// 102 bits per transform
			{ 3, 9, 16 },		// 102 bits per transform
			{ 3, 10, 15 },		// 102 bits per transform
			{ 3, 11, 14 },		// 102 bits per transform
			{ 3, 12, 13 },		// 102 bits per transform
			{ 3, 13, 12 },		// 102 bits per transform
			{ 3, 14, 11 },		// 102 bits per transform
			{ 3, 15, 10 },		// 102 bits per transform
			{ 3, 16, 9 },		// 102 bits per transform
			{ 3, 17, 8 },		// 102 bits per transform
			{ 4, 7, 17 },		// 102 bits per transform
			{ 4, 8, 16 },		// 102 bits per transform
			{ 4, 9, 15 },		// 102 bits per transform
			{ 4, 10, 14 },		// 102 bits per transform
			{ 4, 11, 13 },		// 102 bits per transform
			{ 4, 12, 12 },		// 102 bits per transform
			{ 4, 13, 11 },		// 102 bits per transform
			{ 4, 14, 10 },		// 102 bits per transform
			{ 4, 15, 9 },		// 102 bits per transform
			{ 4, 16, 8 },		// 102 bits per transform
			{ 4, 17, 7 },		// 102 bits per transform
			{ 5, 6, 17 },		// 102 bits per transform
			{ 5, 7, 16 },		// 102 bits per transform
			{ 5, 8, 15 },		// 102 bits per transform
			{ 5, 9, 14 },		// 102 bits per transform
			{ 5, 10, 13 },		// 102 bits per transform
			{ 5, 11, 12 },		// 102 bits per transform
			{ 5, 12, 11 },		// 102 bits per transform
			{ 5, 13, 10 },		// 102 bits per transform
			{ 5, 14, 9 },		// 102 bits per transform
			{ 5, 15, 8 },		// 102 bits per transform
			{ 5, 16, 7 },		// 102 bits per transform
			{ 5, 17, 6 },		// 102 bits per transform
			{ 6, 5, 17 },		// 102 bits per transform
			{ 6, 6, 16 },		// 102 bits per transform
			{ 6, 7, 15 },		// 102 bits per transform
			{ 6, 8, 14 },		// 102 bits per transform
			{ 6, 9, 13 },		// 102 bits per transform
			{ 6, 10, 12 },		// 102 bits per transform
			{ 6, 11, 11 },		// 102 bits per transform
			{ 6, 12, 10 },		// 102 bits per transform
			{ 6, 13, 9 },		// 102 bits per transform
			{ 6, 14, 8 },		// 102 bits per transform
			{ 6, 15, 7 },		// 102 bits per transform
			{ 6, 16, 6 },		// 102 bits per transform
			{ 6, 17, 5 },		// 102 bits per transform
			{ 7, 4, 17 },		// 102 bits per transform
			{ 7, 5, 16 },		// 102 bits per transform
			{ 7, 6, 15 },		// 102 bits per transform
			{ 7, 7, 14 },		// 102 bits per transform
			{ 7, 8, 13 },		// 102 bits per transform
			{ 7, 9, 12 },		// 102 bits per transform
			{ 7, 10, 11 },		// 102 bits per transform
			{ 7, 11, 10 },		// 102 bits per transform
			{ 7, 12, 9 },		// 102 bits per transform
			{ 7, 13, 8 },		// 102 bits per transform
			{ 7, 14, 7 },		// 102 bits per transform
			{ 7, 15, 6 },		// 102 bits per transform
			{ 7, 16, 5 },		// 102 bits per transform
			{ 7, 17, 4 },		// 102 bits per transform
			{ 8, 3, 17 },		// 102 bits per transform
			{ 8, 4, 16 },		// 102 bits per transform
			{ 8, 5, 15 },		// 102 bits per transform
			{ 8, 6, 14 },		// 102 bits per transform
			{ 8, 7, 13 },		// 102 bits per transform
			{ 8, 8, 12 },		// 102 bits per transform
			{ 8, 9, 11 },		// 102 bits per transform
			{ 8, 10, 10 },		// 102 bits per transform
			{ 8, 11, 9 },		// 102 bits per transform
			{ 8, 12, 8 },		// 102 bits per transform
			{ 8, 13, 7 },		// 102 bits per transform
			{ 8, 14, 6 },		// 102 bits per transform
			{ 8, 15, 5 },		// 102 bits per transform
			{ 8, 16, 4 },		// 102 bits per transform
			{ 8, 17, 3 },		// 102 bits per transform
			{ 9, 2, 17 },		// 102 bits per transform
			{ 9, 3, 16 },		// 102 bits per transform
			{ 9, 4, 15 },		// 102 bits per transform
			{ 9, 5, 14 },		// 102 bits per transform
			{ 9, 6, 13 },		// 102 bits per transform
			{ 9, 7, 12 },		// 102 bits per transform
			{ 9, 8, 11 },		// 102 bits per transform
			{ 9, 9, 10 },		// 102 bits per transform
			{ 9, 10, 9 },		// 102 bits per transform
			{ 9, 11, 8 },		// 102 bits per transform
			{ 9, 12, 7 },		// 102 bits per transform
			{ 9, 13, 6 },		// 102 bits per transform
			{ 9, 14, 5 },		// 102 bits per transform
			{ 9, 15, 4 },		// 102 bits per transform
			{ 9, 16, 3 },		// 102 bits per transform
			{ 9, 17, 2 },		// 102 bits per transform
			{ 10, 1, 17 },		// 102 bits per transform
			{ 10, 2, 16 },		// 102 bits per transform
			{ 10, 3, 15 },		// 102 bits per transform
			{ 10, 4, 14 },		// 102 bits per transform
			{ 10, 5, 13 },		// 102 bits per transform
			{ 10, 6, 12 },		// 102 bits per transform
			{ 10, 7, 11 },		// 102 bits per transform
			{ 10, 8, 10 },		// 102 bits per transform
			{ 10, 9, 9 },		// 102 bits per transform
			{ 10, 10, 8 },		// 102 bits per transform
			{ 10, 11, 7 },		// 102 bits per transform
			{ 10, 12, 6 },		// 102 bits per transform
			{ 10, 13, 5 },		// 102 bits per transform
			{ 10, 14, 4 },		// 102 bits per transform
			{ 10, 15, 3 },		// 102 bits per transform
			{ 10, 16, 2 },		// 102 bits per transform
			{ 10, 17, 1 },		// 102 bits per transform
			{ 11, 1, 16 },		// 102 bits per transform
			{ 11, 2, 15 },		// 102 bits per transform
			{ 11, 3, 14 },		// 102 bits per transform
			{ 11, 4, 13 },		// 102 bits per transform
			{ 11, 5, 12 },		// 102 bits per transform
			{ 11, 6, 11 },		// 102 bits per transform
			{ 11, 7, 10 },		// 102 bits per transform
			{ 11, 8, 9 },		// 102 bits per transform
			{ 11, 9, 8 },		// 102 bits per transform
			{ 11, 10, 7 },		// 102 bits per transform
			{ 11, 11, 6 },		// 102 bits per transform
			{ 11, 12, 5 },		// 102 bits per transform
			{ 11, 13, 4 },		// 102 bits per transform
			{ 11, 14, 3 },		// 102 bits per transform
			{ 11, 15, 2 },		// 102 bits per transform
			{ 11, 16, 1 },		// 102 bits per transform
			{ 12, 1, 15 },		// 102 bits per transform
			{ 12, 2, 14 },		// 102 bits per transform
			{ 12, 3, 13 },		// 102 bits per transform
			{ 12, 4, 12 },		// 102 bits per transform
			{ 12, 5, 11 },		// 102 bits per transform
			{ 12, 6, 10 },		// 102 bits per transform
			{ 12, 7, 9 },		// 102 bits per transform
			{ 12, 8, 8 },		// 102 bits per transform
			{ 12, 9, 7 },		// 102 bits per transform
			{ 12, 10, 6 },		// 102 bits per transform
			{ 12, 11, 5 },		// 102 bits per transform
			{ 12, 12, 4 },		// 102 bits per transform
			{ 12, 13, 3 },		// 102 bits per transform
			{ 12, 14, 2 },		// 102 bits per transform
			{ 12, 15, 1 },		// 102 bits per transform
			{ 13, 0, 17 },		// 102 bits per transform
			{ 13, 1, 14 },		// 102 bits per transform
			{ 13, 2, 13 },		// 102 bits per transform
			{ 13, 3, 12 },		// 102 bits per transform
			{ 13, 4, 11 },		// 102 bits per transform
			{ 13, 5, 10 },		// 102 bits per transform
			{ 13, 6, 9 },		// 102 bits per transform
			{ 13, 7, 8 },		// 102 bits per transform
			{ 13, 8, 7 },		// 102 bits per transform
			{ 13, 9, 6 },		// 102 bits per transform
			{ 13, 10, 5 },		// 102 bits per transform
			{ 13, 11, 4 },		// 102 bits per transform
			{ 13, 12, 3 },		// 102 bits per transform
			{ 13, 13, 2 },		// 102 bits per transform
			{ 13, 14, 1 },		// 102 bits per transform
			{ 13, 17, 0 },		// 102 bits per transform
			{ 14, 0, 16 },		// 102 bits per transform
			{ 14, 1, 13 },		// 102 bits per transform
			{ 14, 2, 12 },		// 102 bits per transform
			{ 14, 3, 11 },		// 102 bits per transform
			{ 14, 4, 10 },		// 102 bits per transform
			{ 14, 5, 9 },		// 102 bits per transform
			{ 14, 6, 8 },		// 102 bits per transform
			{ 14, 7, 7 },		// 102 bits per transform
			{ 14, 8, 6 },		// 102 bits per transform
			{ 14, 9, 5 },		// 102 bits per transform
			{ 14, 10, 4 },		// 102 bits per transform
			{ 14, 11, 3 },		// 102 bits per transform
			{ 14, 12, 2 },		// 102 bits per transform
			{ 14, 13, 1 },		// 102 bits per transform
			{ 14, 16, 0 },		// 102 bits per transform
			{ 15, 0, 15 },		// 102 bits per transform
			{ 15, 1, 12 },		// 102 bits per transform
			{ 15, 2, 11 },		// 102 bits per transform
			{ 15, 3, 10 },		// 102 bits per transform
			{ 15, 4, 9 },		// 102 bits per transform
			{ 15, 5, 8 },		// 102 bits per transform
			{ 15, 6, 7 },		// 102 bits per transform
			{ 15, 7, 6 },		// 102 bits per transform
			{ 15, 8, 5 },		// 102 bits per transform
			{ 15, 9, 4 },		// 102 bits per transform
			{ 15, 10, 3 },		// 102 bits per transform
			{ 15, 11, 2 },		// 102 bits per transform
			{ 15, 12, 1 },		// 102 bits per transform
			{ 15, 15, 0 },		// 102 bits per transform
			{ 16, 0, 14 },		// 102 bits per transform
			{ 16, 1, 11 },		// 102 bits per transform
			{ 16, 2, 10 },		// 102 bits per transform
			{ 16, 3, 9 },		// 102 bits per transform
			{ 16, 4, 8 },		// 102 bits per transform
			{ 16, 5, 7 },		// 102 bits per transform
			{ 16, 6, 6 },		// 102 bits per transform
			{ 16, 7, 5 },		// 102 bits per transform
			{ 16, 8, 4 },		// 102 bits per transform
			{ 16, 9, 3 },		// 102 bits per transform
			{ 16, 10, 2 },		// 102 bits per transform
			{ 16, 11, 1 },		// 102 bits per transform
			{ 16, 14, 0 },		// 102 bits per transform
			{ 17, 0, 13 },		// 102 bits per transform
			{ 17, 1, 10 },		// 102 bits per transform
			{ 17, 2, 9 },		// 102 bits per transform
			{ 17, 3, 8 },		// 102 bits per transform
			{ 17, 4, 7 },		// 102 bits per transform
			{ 17, 5, 6 },		// 102 bits per transform
			{ 17, 6, 5 },		// 102 bits per transform
			{ 17, 7, 4 },		// 102 bits per transform
			{ 17, 8, 3 },		// 102 bits per transform
			{ 17, 9, 2 },		// 102 bits per transform
			{ 17, 10, 1 },		// 102 bits per transform
			{ 17, 13, 0 },		// 102 bits per transform
			{ 0, 1, 18 },		// 105 bits per transform
			{ 0, 14, 17 },		// 105 bits per transform
			{ 0, 15, 16 },		// 105 bits per transform
			{ 0, 16, 15 },		// 105 bits per transform
			{ 0, 17, 14 },		// 105 bits per transform
			{ 0, 18, 1 },		// 105 bits per transform
			{ 1, 0, 18 },		// 105 bits per transform
			{ 1, 11, 17 },		// 105 bits per transform
			{ 1, 12, 16 },		// 105 bits per transform
			{ 1, 13, 15 },		// 105 bits per transform
			{ 1, 14, 14 },		// 105 bits per transform
			{ 1, 15, 13 },		// 105 bits per transform
			{ 1, 16, 12 },		// 105 bits per transform
			{ 1, 17, 11 },		// 105 bits per transform
			{ 1, 18, 0 },		// 105 bits per transform
			{ 2, 10, 17 },		// 105 bits per transform
			{ 2, 11, 16 },		// 105 bits per transform
			{ 2, 12, 15 },		// 105 bits per transform
			{ 2, 13, 14 },		// 105 bits per transform
			{ 2, 14, 13 },		// 105 bits per transform
			{ 2, 15, 12 },		// 105 bits per transform
			{ 2, 16, 11 },		// 105 bits per transform
			{ 2, 17, 10 },		// 105 bits per transform
			{ 3, 9, 17 },		// 105 bits per transform
			{ 3, 10, 16 },		// 105 bits per transform
			{ 3, 11, 15 },		// 105 bits per transform
			{ 3, 12, 14 },		// 105 bits per transform
			{ 3, 13, 13 },		// 105 bits per transform
			{ 3, 14, 12 },		// 105 bits per transform
			{ 3, 15, 11 },		// 105 bits per transform
			{ 3, 16, 10 },		// 105 bits per transform
			{ 3, 17, 9 },		// 105 bits per transform
			{ 4, 8, 17 },		// 105 bits per transform
			{ 4, 9, 16 },		// 105 bits per transform
			{ 4, 10, 15 },		// 105 bits per transform
			{ 4, 11, 14 },		// 105 bits per transform
			{ 4, 12, 13 },		// 105 bits per transform
			{ 4, 13, 12 },		// 105 bits per transform
			{ 4, 14, 11 },		// 105 bits per transform
			{ 4, 15, 10 },		// 105 bits per transform
			{ 4, 16, 9 },		// 105 bits per transform
			{ 4, 17, 8 },		// 105 bits per transform
			{ 5, 7, 17 },		// 105 bits per transform
			{ 5, 8, 16 },		// 105 bits per transform
			{ 5, 9, 15 },		// 105 bits per transform
			{ 5, 10, 14 },		// 105 bits per transform
			{ 5, 11, 13 },		// 105 bits per transform
			{ 5, 12, 12 },		// 105 bits per transform
			{ 5, 13, 11 },		// 105 bits per transform
			{ 5, 14, 10 },		// 105 bits per transform
			{ 5, 15, 9 },		// 105 bits per transform
			{ 5, 16, 8 },		// 105 bits per transform
			{ 5, 17, 7 },		// 105 bits per transform
			{ 6, 6, 17 },		// 105 bits per transform
			{ 6, 7, 16 },		// 105 bits per transform
			{ 6, 8, 15 },		// 105 bits per transform
			{ 6, 9, 14 },		// 105 bits per transform
			{ 6, 10, 13 },		// 105 bits per transform
			{ 6, 11, 12 },		// 105 bits per transform
			{ 6, 12, 11 },		// 105 bits per transform
			{ 6, 13, 10 },		// 105 bits per transform
			{ 6, 14, 9 },		// 105 bits per transform
			{ 6, 15, 8 },		// 105 bits per transform
			{ 6, 16, 7 },		// 105 bits per transform
			{ 6, 17, 6 },		// 105 bits per transform
			{ 7, 5, 17 },		// 105 bits per transform
			{ 7, 6, 16 },		// 105 bits per transform
			{ 7, 7, 15 },		// 105 bits per transform
			{ 7, 8, 14 },		// 105 bits per transform
			{ 7, 9, 13 },		// 105 bits per transform
			{ 7, 10, 12 },		// 105 bits per transform
			{ 7, 11, 11 },		// 105 bits per transform
			{ 7, 12, 10 },		// 105 bits per transform
			{ 7, 13, 9 },		// 105 bits per transform
			{ 7, 14, 8 },		// 105 bits per transform
			{ 7, 15, 7 },		// 105 bits per transform
			{ 7, 16, 6 },		// 105 bits per transform
			{ 7, 17, 5 },		// 105 bits per transform
			{ 8, 4, 17 },		// 105 bits per transform
			{ 8, 5, 16 },		// 105 bits per transform
			{ 8, 6, 15 },		// 105 bits per transform
			{ 8, 7, 14 },		// 105 bits per transform
			{ 8, 8, 13 },		// 105 bits per transform
			{ 8, 9, 12 },		// 105 bits per transform
			{ 8, 10, 11 },		// 105 bits per transform
			{ 8, 11, 10 },		// 105 bits per transform
			{ 8, 12, 9 },		// 105 bits per transform
			{ 8, 13, 8 },		// 105 bits per transform
			{ 8, 14, 7 },		// 105 bits per transform
			{ 8, 15, 6 },		// 105 bits per transform
			{ 8, 16, 5 },		// 105 bits per transform
			{ 8, 17, 4 },		// 105 bits per transform
			{ 9, 3, 17 },		// 105 bits per transform
			{ 9, 4, 16 },		// 105 bits per transform
			{ 9, 5, 15 },		// 105 bits per transform
			{ 9, 6, 14 },		// 105 bits per transform
			{ 9, 7, 13 },		// 105 bits per transform
			{ 9, 8, 12 },		// 105 bits per transform
			{ 9, 9, 11 },		// 105 bits per transform
			{ 9, 10, 10 },		// 105 bits per transform
			{ 9, 11, 9 },		// 105 bits per transform
			{ 9, 12, 8 },		// 105 bits per transform
			{ 9, 13, 7 },		// 105 bits per transform
			{ 9, 14, 6 },		// 105 bits per transform
			{ 9, 15, 5 },		// 105 bits per transform
			{ 9, 16, 4 },		// 105 bits per transform
			{ 9, 17, 3 },		// 105 bits per transform
			{ 10, 2, 17 },		// 105 bits per transform
			{ 10, 3, 16 },		// 105 bits per transform
			{ 10, 4, 15 },		// 105 bits per transform
			{ 10, 5, 14 },		// 105 bits per transform
			{ 10, 6, 13 },		// 105 bits per transform
			{ 10, 7, 12 },		// 105 bits per transform
			{ 10, 8, 11 },		// 105 bits per transform
			{ 10, 9, 10 },		// 105 bits per transform
			{ 10, 10, 9 },		// 105 bits per transform
			{ 10, 11, 8 },		// 105 bits per transform
			{ 10, 12, 7 },		// 105 bits per transform
			{ 10, 13, 6 },		// 105 bits per transform
			{ 10, 14, 5 },		// 105 bits per transform
			{ 10, 15, 4 },		// 105 bits per transform
			{ 10, 16, 3 },		// 105 bits per transform
			{ 10, 17, 2 },		// 105 bits per transform
			{ 11, 1, 17 },		// 105 bits per transform
			{ 11, 2, 16 },		// 105 bits per transform
			{ 11, 3, 15 },		// 105 bits per transform
			{ 11, 4, 14 },		// 105 bits per transform
			{ 11, 5, 13 },		// 105 bits per transform
			{ 11, 6, 12 },		// 105 bits per transform
			{ 11, 7, 11 },		// 105 bits per transform
			{ 11, 8, 10 },		// 105 bits per transform
			{ 11, 9, 9 },		// 105 bits per transform
			{ 11, 10, 8 },		// 105 bits per transform
			{ 11, 11, 7 },		// 105 bits per transform
			{ 11, 12, 6 },		// 105 bits per transform
			{ 11, 13, 5 },		// 105 bits per transform
			{ 11, 14, 4 },		// 105 bits per transform
			{ 11, 15, 3 },		// 105 bits per transform
			{ 11, 16, 2 },		// 105 bits per transform
			{ 11, 17, 1 },		// 105 bits per transform
			{ 12, 1, 16 },		// 105 bits per transform
			{ 12, 2, 15 },		// 105 bits per transform
			{ 12, 3, 14 },		// 105 bits per transform
			{ 12, 4, 13 },		// 105 bits per transform
			{ 12, 5, 12 },		// 105 bits per transform
			{ 12, 6, 11 },		// 105 bits per transform
			{ 12, 7, 10 },		// 105 bits per transform
			{ 12, 8, 9 },		// 105 bits per transform
			{ 12, 9, 8 },		// 105 bits per transform
			{ 12, 10, 7 },		// 105 bits per transform
			{ 12, 11, 6 },		// 105 bits per transform
			{ 12, 12, 5 },		// 105 bits per transform
			{ 12, 13, 4 },		// 105 bits per transform
			{ 12, 14, 3 },		// 105 bits per transform
			{ 12, 15, 2 },		// 105 bits per transform
			{ 12, 16, 1 },		// 105 bits per transform
			{ 13, 1, 15 },		// 105 bits per transform
			{ 13, 2, 14 },		// 105 bits per transform
			{ 13, 3, 13 },		// 105 bits per transform
			{ 13, 4, 12 },		// 105 bits per transform
			{ 13, 5, 11 },		// 105 bits per transform
			{ 13, 6, 10 },		// 105 bits per transform
			{ 13, 7, 9 },		// 105 bits per transform
			{ 13, 8, 8 },		// 105 bits per transform
			{ 13, 9, 7 },		// 105 bits per transform
			{ 13, 10, 6 },		// 105 bits per transform
			{ 13, 11, 5 },		// 105 bits per transform
			{ 13, 12, 4 },		// 105 bits per transform
			{ 13, 13, 3 },		// 105 bits per transform
			{ 13, 14, 2 },		// 105 bits per transform
			{ 13, 15, 1 },		// 105 bits per transform
			{ 14, 0, 17 },		// 105 bits per transform
			{ 14, 1, 14 },		// 105 bits per transform
			{ 14, 2, 13 },		// 105 bits per transform
			{ 14, 3, 12 },		// 105 bits per transform
			{ 14, 4, 11 },		// 105 bits per transform
			{ 14, 5, 10 },		// 105 bits per transform
			{ 14, 6, 9 },		// 105 bits per transform
			{ 14, 7, 8 },		// 105 bits per transform
			{ 14, 8, 7 },		// 105 bits per transform
			{ 14, 9, 6 },		// 105 bits per transform
			{ 14, 10, 5 },		// 105 bits per transform
			{ 14, 11, 4 },		// 105 bits per transform
			{ 14, 12, 3 },		// 105 bits per transform
			{ 14, 13, 2 },		// 105 bits per transform
			{ 14, 14, 1 },		// 105 bits per transform
			{ 14, 17, 0 },		// 105 bits per transform
			{ 15, 0, 16 },		// 105 bits per transform
			{ 15, 1, 13 },		// 105 bits per transform
			{ 15, 2, 12 },		// 105 bits per transform
			{ 15, 3, 11 },		// 105 bits per transform
			{ 15, 4, 10 },		// 105 bits per transform
			{ 15, 5, 9 },		// 105 bits per transform
			{ 15, 6, 8 },		// 105 bits per transform
			{ 15, 7, 7 },		// 105 bits per transform
			{ 15, 8, 6 },		// 105 bits per transform
			{ 15, 9, 5 },		// 105 bits per transform
			{ 15, 10, 4 },		// 105 bits per transform
			{ 15, 11, 3 },		// 105 bits per transform
			{ 15, 12, 2 },		// 105 bits per transform
			{ 15, 13, 1 },		// 105 bits per transform
			{ 15, 16, 0 },		// 105 bits per transform
			{ 16, 0, 15 },		// 105 bits per transform
			{ 16, 1, 12 },		// 105 bits per transform
			{ 16, 2, 11 },		// 105 bits per transform
			{ 16, 3, 10 },		// 105 bits per transform
			{ 16, 4, 9 },		// 105 bits per transform
			{ 16, 5, 8 },		// 105 bits per transform
			{ 16, 6, 7 },		// 105 bits per transform
			{ 16, 7, 6 },		// 105 bits per transform
			{ 16, 8, 5 },		// 105 bits per transform
			{ 16, 9, 4 },		// 105 bits per transform
			{ 16, 10, 3 },		// 105 bits per transform
			{ 16, 11, 2 },		// 105 bits per transform
			{ 16, 12, 1 },		// 105 bits per transform
			{ 16, 15, 0 },		// 105 bits per transform
			{ 17, 0, 14 },		// 105 bits per transform
			{ 17, 1, 11 },		// 105 bits per transform
			{ 17, 2, 10 },		// 105 bits per transform
			{ 17, 3, 9 },		// 105 bits per transform
			{ 17, 4, 8 },		// 105 bits per transform
			{ 17, 5, 7 },		// 105 bits per transform
			{ 17, 6, 6 },		// 105 bits per transform
			{ 17, 7, 5 },		// 105 bits per transform
			{ 17, 8, 4 },		// 105 bits per transform
			{ 17, 9, 3 },		// 105 bits per transform
			{ 17, 10, 2 },		// 105 bits per transform
			{ 17, 11, 1 },		// 105 bits per transform
			{ 17, 14, 0 },		// 105 bits per transform
			{ 18, 0, 1 },		// 105 bits per transform
			{ 18, 1, 0 },		// 105 bits per transform
			{ 0, 2, 18 },		// 108 bits per transform
			{ 0, 15, 17 },		// 108 bits per transform
			{ 0, 16, 16 },		// 108 bits per transform
			{ 0, 17, 15 },		// 108 bits per transform
			{ 0, 18, 2 },		// 108 bits per transform
			{ 1, 12, 17 },		// 108 bits per transform
			{ 1, 13, 16 },		// 108 bits per transform
			{ 1, 14, 15 },		// 108 bits per transform
			{ 1, 15, 14 },		// 108 bits per transform
			{ 1, 16, 13 },		// 108 bits per transform
			{ 1, 17, 12 },		// 108 bits per transform
			{ 2, 0, 18 },		// 108 bits per transform
			{ 2, 11, 17 },		// 108 bits per transform
			{ 2, 12, 16 },		// 108 bits per transform
			{ 2, 13, 15 },		// 108 bits per transform
			{ 2, 14, 14 },		// 108 bits per transform
			{ 2, 15, 13 },		// 108 bits per transform
			{ 2, 16, 12 },		// 108 bits per transform
			{ 2, 17, 11 },		// 108 bits per transform
			{ 2, 18, 0 },		// 108 bits per transform
			{ 3, 10, 17 },		// 108 bits per transform
			{ 3, 11, 16 },		// 108 bits per transform
			{ 3, 12, 15 },		// 108 bits per transform
			{ 3, 13, 14 },		// 108 bits per transform
			{ 3, 14, 13 },		// 108 bits per transform
			{ 3, 15, 12 },		// 108 bits per transform
			{ 3, 16, 11 },		// 108 bits per transform
			{ 3, 17, 10 },		// 108 bits per transform
			{ 4, 9, 17 },		// 108 bits per transform
			{ 4, 10, 16 },		// 108 bits per transform
			{ 4, 11, 15 },		// 108 bits per transform
			{ 4, 12, 14 },		// 108 bits per transform
			{ 4, 13, 13 },		// 108 bits per transform
			{ 4, 14, 12 },		// 108 bits per transform
			{ 4, 15, 11 },		// 108 bits per transform
			{ 4, 16, 10 },		// 108 bits per transform
			{ 4, 17, 9 },		// 108 bits per transform
			{ 5, 8, 17 },		// 108 bits per transform
			{ 5, 9, 16 },		// 108 bits per transform
			{ 5, 10, 15 },		// 108 bits per transform
			{ 5, 11, 14 },		// 108 bits per transform
			{ 5, 12, 13 },		// 108 bits per transform
			{ 5, 13, 12 },		// 108 bits per transform
			{ 5, 14, 11 },		// 108 bits per transform
			{ 5, 15, 10 },		// 108 bits per transform
			{ 5, 16, 9 },		// 108 bits per transform
			{ 5, 17, 8 },		// 108 bits per transform
			{ 6, 7, 17 },		// 108 bits per transform
			{ 6, 8, 16 },		// 108 bits per transform
			{ 6, 9, 15 },		// 108 bits per transform
			{ 6, 10, 14 },		// 108 bits per transform
			{ 6, 11, 13 },		// 108 bits per transform
			{ 6, 12, 12 },		// 108 bits per transform
			{ 6, 13, 11 },		// 108 bits per transform
			{ 6, 14, 10 },		// 108 bits per transform
			{ 6, 15, 9 },		// 108 bits per transform
			{ 6, 16, 8 },		// 108 bits per transform
			{ 6, 17, 7 },		// 108 bits per transform
			{ 7, 6, 17 },		// 108 bits per transform
			{ 7, 7, 16 },		// 108 bits per transform
			{ 7, 8, 15 },		// 108 bits per transform
			{ 7, 9, 14 },		// 108 bits per transform
			{ 7, 10, 13 },		// 108 bits per transform
			{ 7, 11, 12 },		// 108 bits per transform
			{ 7, 12, 11 },		// 108 bits per transform
			{ 7, 13, 10 },		// 108 bits per transform
			{ 7, 14, 9 },		// 108 bits per transform
			{ 7, 15, 8 },		// 108 bits per transform
			{ 7, 16, 7 },		// 108 bits per transform
			{ 7, 17, 6 },		// 108 bits per transform
			{ 8, 5, 17 },		// 108 bits per transform
			{ 8, 6, 16 },		// 108 bits per transform
			{ 8, 7, 15 },		// 108 bits per transform
			{ 8, 8, 14 },		// 108 bits per transform
			{ 8, 9, 13 },		// 108 bits per transform
			{ 8, 10, 12 },		// 108 bits per transform
			{ 8, 11, 11 },		// 108 bits per transform
			{ 8, 12, 10 },		// 108 bits per transform
			{ 8, 13, 9 },		// 108 bits per transform
			{ 8, 14, 8 },		// 108 bits per transform
			{ 8, 15, 7 },		// 108 bits per transform
			{ 8, 16, 6 },		// 108 bits per transform
			{ 8, 17, 5 },		// 108 bits per transform
			{ 9, 4, 17 },		// 108 bits per transform
			{ 9, 5, 16 },		// 108 bits per transform
			{ 9, 6, 15 },		// 108 bits per transform
			{ 9, 7, 14 },		// 108 bits per transform
			{ 9, 8, 13 },		// 108 bits per transform
			{ 9, 9, 12 },		// 108 bits per transform
			{ 9, 10, 11 },		// 108 bits per transform
			{ 9, 11, 10 },		// 108 bits per transform
			{ 9, 12, 9 },		// 108 bits per transform
			{ 9, 13, 8 },		// 108 bits per transform
			{ 9, 14, 7 },		// 108 bits per transform
			{ 9, 15, 6 },		// 108 bits per transform
			{ 9, 16, 5 },		// 108 bits per transform
			{ 9, 17, 4 },		// 108 bits per transform
			{ 10, 3, 17 },		// 108 bits per transform
			{ 10, 4, 16 },		// 108 bits per transform
			{ 10, 5, 15 },		// 108 bits per transform
			{ 10, 6, 14 },		// 108 bits per transform
			{ 10, 7, 13 },		// 108 bits per transform
			{ 10, 8, 12 },		// 108 bits per transform
			{ 10, 9, 11 },		// 108 bits per transform
			{ 10, 10, 10 },		// 108 bits per transform
			{ 10, 11, 9 },		// 108 bits per transform
			{ 10, 12, 8 },		// 108 bits per transform
			{ 10, 13, 7 },		// 108 bits per transform
			{ 10, 14, 6 },		// 108 bits per transform
			{ 10, 15, 5 },		// 108 bits per transform
			{ 10, 16, 4 },		// 108 bits per transform
			{ 10, 17, 3 },		// 108 bits per transform
			{ 11, 2, 17 },		// 108 bits per transform
			{ 11, 3, 16 },		// 108 bits per transform
			{ 11, 4, 15 },		// 108 bits per transform
			{ 11, 5, 14 },		// 108 bits per transform
			{ 11, 6, 13 },		// 108 bits per transform
			{ 11, 7, 12 },		// 108 bits per transform
			{ 11, 8, 11 },		// 108 bits per transform
			{ 11, 9, 10 },		// 108 bits per transform
			{ 11, 10, 9 },		// 108 bits per transform
			{ 11, 11, 8 },		// 108 bits per transform
			{ 11, 12, 7 },		// 108 bits per transform
			{ 11, 13, 6 },		// 108 bits per transform
			{ 11, 14, 5 },		// 108 bits per transform
			{ 11, 15, 4 },		// 108 bits per transform
			{ 11, 16, 3 },		// 108 bits per transform
			{ 11, 17, 2 },		// 108 bits per transform
			{ 12, 1, 17 },		// 108 bits per transform
			{ 12, 2, 16 },		// 108 bits per transform
			{ 12, 3, 15 },		// 108 bits per transform
			{ 12, 4, 14 },		// 108 bits per transform
			{ 12, 5, 13 },		// 108 bits per transform
			{ 12, 6, 12 },		// 108 bits per transform
			{ 12, 7, 11 },		// 108 bits per transform
			{ 12, 8, 10 },		// 108 bits per transform
			{ 12, 9, 9 },		// 108 bits per transform
			{ 12, 10, 8 },		// 108 bits per transform
			{ 12, 11, 7 },		// 108 bits per transform
			{ 12, 12, 6 },		// 108 bits per transform
			{ 12, 13, 5 },		// 108 bits per transform
			{ 12, 14, 4 },		// 108 bits per transform
			{ 12, 15, 3 },		// 108 bits per transform
			{ 12, 16, 2 },		// 108 bits per transform
			{ 12, 17, 1 },		// 108 bits per transform
			{ 13, 1, 16 },		// 108 bits per transform
			{ 13, 2, 15 },		// 108 bits per transform
			{ 13, 3, 14 },		// 108 bits per transform
			{ 13, 4, 13 },		// 108 bits per transform
			{ 13, 5, 12 },		// 108 bits per transform
			{ 13, 6, 11 },		// 108 bits per transform
			{ 13, 7, 10 },		// 108 bits per transform
			{ 13, 8, 9 },		// 108 bits per transform
			{ 13, 9, 8 },		// 108 bits per transform
			{ 13, 10, 7 },		// 108 bits per transform
			{ 13, 11, 6 },		// 108 bits per transform
			{ 13, 12, 5 },		// 108 bits per transform
			{ 13, 13, 4 },		// 108 bits per transform
			{ 13, 14, 3 },		// 108 bits per transform
			{ 13, 15, 2 },		// 108 bits per transform
			{ 13, 16, 1 },		// 108 bits per transform
			{ 14, 1, 15 },		// 108 bits per transform
			{ 14, 2, 14 },		// 108 bits per transform
			{ 14, 3, 13 },		// 108 bits per transform
			{ 14, 4, 12 },		// 108 bits per transform
			{ 14, 5, 11 },		// 108 bits per transform
			{ 14, 6, 10 },		// 108 bits per transform
			{ 14, 7, 9 },		// 108 bits per transform
			{ 14, 8, 8 },		// 108 bits per transform
			{ 14, 9, 7 },		// 108 bits per transform
			{ 14, 10, 6 },		// 108 bits per transform
			{ 14, 11, 5 },		// 108 bits per transform
			{ 14, 12, 4 },		// 108 bits per transform
			{ 14, 13, 3 },		// 108 bits per transform
			{ 14, 14, 2 },		// 108 bits per transform
			{ 14, 15, 1 },		// 108 bits per transform
			{ 15, 0, 17 },		// 108 bits per transform
			{ 15, 1, 14 },		// 108 bits per transform
			{ 15, 2, 13 },		// 108 bits per transform
			{ 15, 3, 12 },		// 108 bits per transform
			{ 15, 4, 11 },		// 108 bits per transform
			{ 15, 5, 10 },		// 108 bits per transform
			{ 15, 6, 9 },		// 108 bits per transform
			{ 15, 7, 8 },		// 108 bits per transform
			{ 15, 8, 7 },		// 108 bits per transform
			{ 15, 9, 6 },		// 108 bits per transform
			{ 15, 10, 5 },		// 108 bits per transform
			{ 15, 11, 4 },		// 108 bits per transform
			{ 15, 12, 3 },		// 108 bits per transform
			{ 15, 13, 2 },		// 108 bits per transform
			{ 15, 14, 1 },		// 108 bits per transform
			{ 15, 17, 0 },		// 108 bits per transform
			{ 16, 0, 16 },		// 108 bits per transform
			{ 16, 1, 13 },		// 108 bits per transform
			{ 16, 2, 12 },		// 108 bits per transform
			{ 16, 3, 11 },		// 108 bits per transform
			{ 16, 4, 10 },		// 108 bits per transform
			{ 16, 5, 9 },		// 108 bits per transform
			{ 16, 6, 8 },		// 108 bits per transform
			{ 16, 7, 7 },		// 108 bits per transform
			{ 16, 8, 6 },		// 108 bits per transform
			{ 16, 9, 5 },		// 108 bits per transform
			{ 16, 10, 4 },		// 108 bits per transform
			{ 16, 11, 3 },		// 108 bits per transform
			{ 16, 12, 2 },		// 108 bits per transform
			{ 16, 13, 1 },		// 108 bits per transform
			{ 16, 16, 0 },		// 108 bits per transform
			{ 17, 0, 15 },		// 108 bits per transform
			{ 17, 1, 12 },		// 108 bits per transform
			{ 17, 2, 11 },		// 108 bits per transform
			{ 17, 3, 10 },		// 108 bits per transform
			{ 17, 4, 9 },		// 108 bits per transform
			{ 17, 5, 8 },		// 108 bits per transform
			{ 17, 6, 7 },		// 108 bits per transform
			{ 17, 7, 6 },		// 108 bits per transform
			{ 17, 8, 5 },		// 108 bits per transform
			{ 17, 9, 4 },		// 108 bits per transform
			{ 17, 10, 3 },		// 108 bits per transform
			{ 17, 11, 2 },		// 108 bits per transform
			{ 17, 12, 1 },		// 108 bits per transform
			{ 17, 15, 0 },		// 108 bits per transform
			{ 18, 0, 2 },		// 108 bits per transform
			{ 18, 2, 0 },		// 108 bits per transform
			{ 0, 3, 18 },		// 111 bits per transform
			{ 0, 16, 17 },		// 111 bits per transform
			{ 0, 17, 16 },		// 111 bits per transform
			{ 0, 18, 3 },		// 111 bits per transform
			{ 1, 13, 17 },		// 111 bits per transform
			{ 1, 14, 16 },		// 111 bits per transform
			{ 1, 15, 15 },		// 111 bits per transform
			{ 1, 16, 14 },		// 111 bits per transform
			{ 1, 17, 13 },		// 111 bits per transform
			{ 2, 12, 17 },		// 111 bits per transform
			{ 2, 13, 16 },		// 111 bits per transform
			{ 2, 14, 15 },		// 111 bits per transform
			{ 2, 15, 14 },		// 111 bits per transform
			{ 2, 16, 13 },		// 111 bits per transform
			{ 2, 17, 12 },		// 111 bits per transform
			{ 3, 0, 18 },		// 111 bits per transform
			{ 3, 11, 17 },		// 111 bits per transform
			{ 3, 12, 16 },		// 111 bits per transform
			{ 3, 13, 15 },		// 111 bits per transform
			{ 3, 14, 14 },		// 111 bits per transform
			{ 3, 15, 13 },		// 111 bits per transform
			{ 3, 16, 12 },		// 111 bits per transform
			{ 3, 17, 11 },		// 111 bits per transform
			{ 3, 18, 0 },		// 111 bits per transform
			{ 4, 10, 17 },		// 111 bits per transform
			{ 4, 11, 16 },		// 111 bits per transform
			{ 4, 12, 15 },		// 111 bits per transform
			{ 4, 13, 14 },		// 111 bits per transform
			{ 4, 14, 13 },		// 111 bits per transform
			{ 4, 15, 12 },		// 111 bits per transform
			{ 4, 16, 11 },		// 111 bits per transform
			{ 4, 17, 10 },		// 111 bits per transform
			{ 5, 9, 17 },		// 111 bits per transform
			{ 5, 10, 16 },		// 111 bits per transform
			{ 5, 11, 15 },		// 111 bits per transform
			{ 5, 12, 14 },		// 111 bits per transform
			{ 5, 13, 13 },		// 111 bits per transform
			{ 5, 14, 12 },		// 111 bits per transform
			{ 5, 15, 11 },		// 111 bits per transform
			{ 5, 16, 10 },		// 111 bits per transform
			{ 5, 17, 9 },		// 111 bits per transform
			{ 6, 8, 17 },		// 111 bits per transform
			{ 6, 9, 16 },		// 111 bits per transform
			{ 6, 10, 15 },		// 111 bits per transform
			{ 6, 11, 14 },		// 111 bits per transform
			{ 6, 12, 13 },		// 111 bits per transform
			{ 6, 13, 12 },		// 111 bits per transform
			{ 6, 14, 11 },		// 111 bits per transform
			{ 6, 15, 10 },		// 111 bits per transform
			{ 6, 16, 9 },		// 111 bits per transform
			{ 6, 17, 8 },		// 111 bits per transform
			{ 7, 7, 17 },		// 111 bits per transform
			{ 7, 8, 16 },		// 111 bits per transform
			{ 7, 9, 15 },		// 111 bits per transform
			{ 7, 10, 14 },		// 111 bits per transform
			{ 7, 11, 13 },		// 111 bits per transform
			{ 7, 12, 12 },		// 111 bits per transform
			{ 7, 13, 11 },		// 111 bits per transform
			{ 7, 14, 10 },		// 111 bits per transform
			{ 7, 15, 9 },		// 111 bits per transform
			{ 7, 16, 8 },		// 111 bits per transform
			{ 7, 17, 7 },		// 111 bits per transform
			{ 8, 6, 17 },		// 111 bits per transform
			{ 8, 7, 16 },		// 111 bits per transform
			{ 8, 8, 15 },		// 111 bits per transform
			{ 8, 9, 14 },		// 111 bits per transform
			{ 8, 10, 13 },		// 111 bits per transform
			{ 8, 11, 12 },		// 111 bits per transform
			{ 8, 12, 11 },		// 111 bits per transform
			{ 8, 13, 10 },		// 111 bits per transform
			{ 8, 14, 9 },		// 111 bits per transform
			{ 8, 15, 8 },		// 111 bits per transform
			{ 8, 16, 7 },		// 111 bits per transform
			{ 8, 17, 6 },		// 111 bits per transform
			{ 9, 5, 17 },		// 111 bits per transform
			{ 9, 6, 16 },		// 111 bits per transform
			{ 9, 7, 15 },		// 111 bits per transform
			{ 9, 8, 14 },		// 111 bits per transform
			{ 9, 9, 13 },		// 111 bits per transform
			{ 9, 10, 12 },		// 111 bits per transform
			{ 9, 11, 11 },		// 111 bits per transform
			{ 9, 12, 10 },		// 111 bits per transform
			{ 9, 13, 9 },		// 111 bits per transform
			{ 9, 14, 8 },		// 111 bits per transform
			{ 9, 15, 7 },		// 111 bits per transform
			{ 9, 16, 6 },		// 111 bits per transform
			{ 9, 17, 5 },		// 111 bits per transform
			{ 10, 4, 17 },		// 111 bits per transform
			{ 10, 5, 16 },		// 111 bits per transform
			{ 10, 6, 15 },		// 111 bits per transform
			{ 10, 7, 14 },		// 111 bits per transform
			{ 10, 8, 13 },		// 111 bits per transform
			{ 10, 9, 12 },		// 111 bits per transform
			{ 10, 10, 11 },		// 111 bits per transform
			{ 10, 11, 10 },		// 111 bits per transform
			{ 10, 12, 9 },		// 111 bits per transform
			{ 10, 13, 8 },		// 111 bits per transform
			{ 10, 14, 7 },		// 111 bits per transform
			{ 10, 15, 6 },		// 111 bits per transform
			{ 10, 16, 5 },		// 111 bits per transform
			{ 10, 17, 4 },		// 111 bits per transform
			{ 11, 3, 17 },		// 111 bits per transform
			{ 11, 4, 16 },		// 111 bits per transform
			{ 11, 5, 15 },		// 111 bits per transform
			{ 11, 6, 14 },		// 111 bits per transform
			{ 11, 7, 13 },		// 111 bits per transform
			{ 11, 8, 12 },		// 111 bits per transform
			{ 11, 9, 11 },		// 111 bits per transform
			{ 11, 10, 10 },		// 111 bits per transform
			{ 11, 11, 9 },		// 111 bits per transform
			{ 11, 12, 8 },		// 111 bits per transform
			{ 11, 13, 7 },		// 111 bits per transform
			{ 11, 14, 6 },		// 111 bits per transform
			{ 11, 15, 5 },		// 111 bits per transform
			{ 11, 16, 4 },		// 111 bits per transform
			{ 11, 17, 3 },		// 111 bits per transform
			{ 12, 2, 17 },		// 111 bits per transform
			{ 12, 3, 16 },		// 111 bits per transform
			{ 12, 4, 15 },		// 111 bits per transform
			{ 12, 5, 14 },		// 111 bits per transform
			{ 12, 6, 13 },		// 111 bits per transform
			{ 12, 7, 12 },		// 111 bits per transform
			{ 12, 8, 11 },		// 111 bits per transform
			{ 12, 9, 10 },		// 111 bits per transform
			{ 12, 10, 9 },		// 111 bits per transform
			{ 12, 11, 8 },		// 111 bits per transform
			{ 12, 12, 7 },		// 111 bits per transform
			{ 12, 13, 6 },		// 111 bits per transform
			{ 12, 14, 5 },		// 111 bits per transform
			{ 12, 15, 4 },		// 111 bits per transform
			{ 12, 16, 3 },		// 111 bits per transform
			{ 12, 17, 2 },		// 111 bits per transform
			{ 13, 1, 17 },		// 111 bits per transform
			{ 13, 2, 16 },		// 111 bits per transform
			{ 13, 3, 15 },		// 111 bits per transform
			{ 13, 4, 14 },		// 111 bits per transform
			{ 13, 5, 13 },		// 111 bits per transform
			{ 13, 6, 12 },		// 111 bits per transform
			{ 13, 7, 11 },		// 111 bits per transform
			{ 13, 8, 10 },		// 111 bits per transform
			{ 13, 9, 9 },		// 111 bits per transform
			{ 13, 10, 8 },		// 111 bits per transform
			{ 13, 11, 7 },		// 111 bits per transform
			{ 13, 12, 6 },		// 111 bits per transform
			{ 13, 13, 5 },		// 111 bits per transform
			{ 13, 14, 4 },		// 111 bits per transform
			{ 13, 15, 3 },		// 111 bits per transform
			{ 13, 16, 2 },		// 111 bits per transform
			{ 13, 17, 1 },		// 111 bits per transform
			{ 14, 1, 16 },		// 111 bits per transform
			{ 14, 2, 15 },		// 111 bits per transform
			{ 14, 3, 14 },		// 111 bits per transform
			{ 14, 4, 13 },		// 111 bits per transform
			{ 14, 5, 12 },		// 111 bits per transform
			{ 14, 6, 11 },		// 111 bits per transform
			{ 14, 7, 10 },		// 111 bits per transform
			{ 14, 8, 9 },		// 111 bits per transform
			{ 14, 9, 8 },		// 111 bits per transform
			{ 14, 10, 7 },		// 111 bits per transform
			{ 14, 11, 6 },		// 111 bits per transform
			{ 14, 12, 5 },		// 111 bits per transform
			{ 14, 13, 4 },		// 111 bits per transform
			{ 14, 14, 3 },		// 111 bits per transform
			{ 14, 15, 2 },		// 111 bits per transform
			{ 14, 16, 1 },		// 111 bits per transform
			{ 15, 1, 15 },		// 111 bits per transform
			{ 15, 2, 14 },		// 111 bits per transform
			{ 15, 3, 13 },		// 111 bits per transform
			{ 15, 4, 12 },		// 111 bits per transform
			{ 15, 5, 11 },		// 111 bits per transform
			{ 15, 6, 10 },		// 111 bits per transform
			{ 15, 7, 9 },		// 111 bits per transform
			{ 15, 8, 8 },		// 111 bits per transform
			{ 15, 9, 7 },		// 111 bits per transform
			{ 15, 10, 6 },		// 111 bits per transform
			{ 15, 11, 5 },		// 111 bits per transform
			{ 15, 12, 4 },		// 111 bits per transform
			{ 15, 13, 3 },		// 111 bits per transform
			{ 15, 14, 2 },		// 111 bits per transform
			{ 15, 15, 1 },		// 111 bits per transform
			{ 16, 0, 17 },		// 111 bits per transform
			{ 16, 1, 14 },		// 111 bits per transform
			{ 16, 2, 13 },		// 111 bits per transform
			{ 16, 3, 12 },		// 111 bits per transform
			{ 16, 4, 11 },		// 111 bits per transform
			{ 16, 5, 10 },		// 111 bits per transform
			{ 16, 6, 9 },		// 111 bits per transform
			{ 16, 7, 8 },		// 111 bits per transform
			{ 16, 8, 7 },		// 111 bits per transform
			{ 16, 9, 6 },		// 111 bits per transform
			{ 16, 10, 5 },		// 111 bits per transform
			{ 16, 11, 4 },		// 111 bits per transform
			{ 16, 12, 3 },		// 111 bits per transform
			{ 16, 13, 2 },		// 111 bits per transform
			{ 16, 14, 1 },		// 111 bits per transform
			{ 16, 17, 0 },		// 111 bits per transform
			{ 17, 0, 16 },		// 111 bits per transform
			{ 17, 1, 13 },		// 111 bits per transform
			{ 17, 2, 12 },		// 111 bits per transform
			{ 17, 3, 11 },		// 111 bits per transform
			{ 17, 4, 10 },		// 111 bits per transform
			{ 17, 5, 9 },		// 111 bits per transform
			{ 17, 6, 8 },		// 111 bits per transform
			{ 17, 7, 7 },		// 111 bits per transform
			{ 17, 8, 6 },		// 111 bits per transform
			{ 17, 9, 5 },		// 111 bits per transform
			{ 17, 10, 4 },		// 111 bits per transform
			{ 17, 11, 3 },		// 111 bits per transform
			{ 17, 12, 2 },		// 111 bits per transform
			{ 17, 13, 1 },		// 111 bits per transform
			{ 17, 16, 0 },		// 111 bits per transform
			{ 18, 0, 3 },		// 111 bits per transform
			{ 18, 3, 0 },		// 111 bits per transform
			{ 0, 4, 18 },		// 114 bits per transform
			{ 0, 17, 17 },		// 114 bits per transform
			{ 0, 18, 4 },		// 114 bits per transform
			{ 1, 1, 18 },		// 114 bits per transform
			{ 1, 14, 17 },		// 114 bits per transform
			{ 1, 15, 16 },		// 114 bits per transform
			{ 1, 16, 15 },		// 114 bits per transform
			{ 1, 17, 14 },		// 114 bits per transform
			{ 1, 18, 1 },		// 114 bits per transform
			{ 2, 13, 17 },		// 114 bits per transform
			{ 2, 14, 16 },		// 114 bits per transform
			{ 2, 15, 15 },		// 114 bits per transform
			{ 2, 16, 14 },		// 114 bits per transform
			{ 2, 17, 13 },		// 114 bits per transform
			{ 3, 12, 17 },		// 114 bits per transform
			{ 3, 13, 16 },		// 114 bits per transform
			{ 3, 14, 15 },		// 114 bits per transform
			{ 3, 15, 14 },		// 114 bits per transform
			{ 3, 16, 13 },		// 114 bits per transform
			{ 3, 17, 12 },		// 114 bits per transform
			{ 4, 0, 18 },		// 114 bits per transform
			{ 4, 11, 17 },		// 114 bits per transform
			{ 4, 12, 16 },		// 114 bits per transform
			{ 4, 13, 15 },		// 114 bits per transform
			{ 4, 14, 14 },		// 114 bits per transform
			{ 4, 15, 13 },		// 114 bits per transform
			{ 4, 16, 12 },		// 114 bits per transform
			{ 4, 17, 11 },		// 114 bits per transform
			{ 4, 18, 0 },		// 114 bits per transform
			{ 5, 10, 17 },		// 114 bits per transform
			{ 5, 11, 16 },		// 114 bits per transform
			{ 5, 12, 15 },		// 114 bits per transform
			{ 5, 13, 14 },		// 114 bits per transform
			{ 5, 14, 13 },		// 114 bits per transform
			{ 5, 15, 12 },		// 114 bits per transform
			{ 5, 16, 11 },		// 114 bits per transform
			{ 5, 17, 10 },		// 114 bits per transform
			{ 6, 9, 17 },		// 114 bits per transform
			{ 6, 10, 16 },		// 114 bits per transform
			{ 6, 11, 15 },		// 114 bits per transform
			{ 6, 12, 14 },		// 114 bits per transform
			{ 6, 13, 13 },		// 114 bits per transform
			{ 6, 14, 12 },		// 114 bits per transform
			{ 6, 15, 11 },		// 114 bits per transform
			{ 6, 16, 10 },		// 114 bits per transform
			{ 6, 17, 9 },		// 114 bits per transform
			{ 7, 8, 17 },		// 114 bits per transform
			{ 7, 9, 16 },		// 114 bits per transform
			{ 7, 10, 15 },		// 114 bits per transform
			{ 7, 11, 14 },		// 114 bits per transform
			{ 7, 12, 13 },		// 114 bits per transform
			{ 7, 13, 12 },		// 114 bits per transform
			{ 7, 14, 11 },		// 114 bits per transform
			{ 7, 15, 10 },		// 114 bits per transform
			{ 7, 16, 9 },		// 114 bits per transform
			{ 7, 17, 8 },		// 114 bits per transform
			{ 8, 7, 17 },		// 114 bits per transform
			{ 8, 8, 16 },		// 114 bits per transform
			{ 8, 9, 15 },		// 114 bits per transform
			{ 8, 10, 14 },		// 114 bits per transform
			{ 8, 11, 13 },		// 114 bits per transform
			{ 8, 12, 12 },		// 114 bits per transform
			{ 8, 13, 11 },		// 114 bits per transform
			{ 8, 14, 10 },		// 114 bits per transform
			{ 8, 15, 9 },		// 114 bits per transform
			{ 8, 16, 8 },		// 114 bits per transform
			{ 8, 17, 7 },		// 114 bits per transform
			{ 9, 6, 17 },		// 114 bits per transform
			{ 9, 7, 16 },		// 114 bits per transform
			{ 9, 8, 15 },		// 114 bits per transform
			{ 9, 9, 14 },		// 114 bits per transform
			{ 9, 10, 13 },		// 114 bits per transform
			{ 9, 11, 12 },		// 114 bits per transform
			{ 9, 12, 11 },		// 114 bits per transform
			{ 9, 13, 10 },		// 114 bits per transform
			{ 9, 14, 9 },		// 114 bits per transform
			{ 9, 15, 8 },		// 114 bits per transform
			{ 9, 16, 7 },		// 114 bits per transform
			{ 9, 17, 6 },		// 114 bits per transform
			{ 10, 5, 17 },		// 114 bits per transform
			{ 10, 6, 16 },		// 114 bits per transform
			{ 10, 7, 15 },		// 114 bits per transform
			{ 10, 8, 14 },		// 114 bits per transform
			{ 10, 9, 13 },		// 114 bits per transform
			{ 10, 10, 12 },		// 114 bits per transform
			{ 10, 11, 11 },		// 114 bits per transform
			{ 10, 12, 10 },		// 114 bits per transform
			{ 10, 13, 9 },		// 114 bits per transform
			{ 10, 14, 8 },		// 114 bits per transform
			{ 10, 15, 7 },		// 114 bits per transform
			{ 10, 16, 6 },		// 114 bits per transform
			{ 10, 17, 5 },		// 114 bits per transform
			{ 11, 4, 17 },		// 114 bits per transform
			{ 11, 5, 16 },		// 114 bits per transform
			{ 11, 6, 15 },		// 114 bits per transform
			{ 11, 7, 14 },		// 114 bits per transform
			{ 11, 8, 13 },		// 114 bits per transform
			{ 11, 9, 12 },		// 114 bits per transform
			{ 11, 10, 11 },		// 114 bits per transform
			{ 11, 11, 10 },		// 114 bits per transform
			{ 11, 12, 9 },		// 114 bits per transform
			{ 11, 13, 8 },		// 114 bits per transform
			{ 11, 14, 7 },		// 114 bits per transform
			{ 11, 15, 6 },		// 114 bits per transform
			{ 11, 16, 5 },		// 114 bits per transform
			{ 11, 17, 4 },		// 114 bits per transform
			{ 12, 3, 17 },		// 114 bits per transform
			{ 12, 4, 16 },		// 114 bits per transform
			{ 12, 5, 15 },		// 114 bits per transform
			{ 12, 6, 14 },		// 114 bits per transform
			{ 12, 7, 13 },		// 114 bits per transform
			{ 12, 8, 12 },		// 114 bits per transform
			{ 12, 9, 11 },		// 114 bits per transform
			{ 12, 10, 10 },		// 114 bits per transform
			{ 12, 11, 9 },		// 114 bits per transform
			{ 12, 12, 8 },		// 114 bits per transform
			{ 12, 13, 7 },		// 114 bits per transform
			{ 12, 14, 6 },		// 114 bits per transform
			{ 12, 15, 5 },		// 114 bits per transform
			{ 12, 16, 4 },		// 114 bits per transform
			{ 12, 17, 3 },		// 114 bits per transform
			{ 13, 2, 17 },		// 114 bits per transform
			{ 13, 3, 16 },		// 114 bits per transform
			{ 13, 4, 15 },		// 114 bits per transform
			{ 13, 5, 14 },		// 114 bits per transform
			{ 13, 6, 13 },		// 114 bits per transform
			{ 13, 7, 12 },		// 114 bits per transform
			{ 13, 8, 11 },		// 114 bits per transform
			{ 13, 9, 10 },		// 114 bits per transform
			{ 13, 10, 9 },		// 114 bits per transform
			{ 13, 11, 8 },		// 114 bits per transform
			{ 13, 12, 7 },		// 114 bits per transform
			{ 13, 13, 6 },		// 114 bits per transform
			{ 13, 14, 5 },		// 114 bits per transform
			{ 13, 15, 4 },		// 114 bits per transform
			{ 13, 16, 3 },		// 114 bits per transform
			{ 13, 17, 2 },		// 114 bits per transform
			{ 14, 1, 17 },		// 114 bits per transform
			{ 14, 2, 16 },		// 114 bits per transform
			{ 14, 3, 15 },		// 114 bits per transform
			{ 14, 4, 14 },		// 114 bits per transform
			{ 14, 5, 13 },		// 114 bits per transform
			{ 14, 6, 12 },		// 114 bits per transform
			{ 14, 7, 11 },		// 114 bits per transform
			{ 14, 8, 10 },		// 114 bits per transform
			{ 14, 9, 9 },		// 114 bits per transform
			{ 14, 10, 8 },		// 114 bits per transform
			{ 14, 11, 7 },		// 114 bits per transform
			{ 14, 12, 6 },		// 114 bits per transform
			{ 14, 13, 5 },		// 114 bits per transform
			{ 14, 14, 4 },		// 114 bits per transform
			{ 14, 15, 3 },		// 114 bits per transform
			{ 14, 16, 2 },		// 114 bits per transform
			{ 14, 17, 1 },		// 114 bits per transform
			{ 15, 1, 16 },		// 114 bits per transform
			{ 15, 2, 15 },		// 114 bits per transform
			{ 15, 3, 14 },		// 114 bits per transform
			{ 15, 4, 13 },		// 114 bits per transform
			{ 15, 5, 12 },		// 114 bits per transform
			{ 15, 6, 11 },		// 114 bits per transform
			{ 15, 7, 10 },		// 114 bits per transform
			{ 15, 8, 9 },		// 114 bits per transform
			{ 15, 9, 8 },		// 114 bits per transform
			{ 15, 10, 7 },		// 114 bits per transform
			{ 15, 11, 6 },		// 114 bits per transform
			{ 15, 12, 5 },		// 114 bits per transform
			{ 15, 13, 4 },		// 114 bits per transform
			{ 15, 14, 3 },		// 114 bits per transform
			{ 15, 15, 2 },		// 114 bits per transform
			{ 15, 16, 1 },		// 114 bits per transform
			{ 16, 1, 15 },		// 114 bits per transform
			{ 16, 2, 14 },		// 114 bits per transform
			{ 16, 3, 13 },		// 114 bits per transform
			{ 16, 4, 12 },		// 114 bits per transform
			{ 16, 5, 11 },		// 114 bits per transform
			{ 16, 6, 10 },		// 114 bits per transform
			{ 16, 7, 9 },		// 114 bits per transform
			{ 16, 8, 8 },		// 114 bits per transform
			{ 16, 9, 7 },		// 114 bits per transform
			{ 16, 10, 6 },		// 114 bits per transform
			{ 16, 11, 5 },		// 114 bits per transform
			{ 16, 12, 4 },		// 114 bits per transform
			{ 16, 13, 3 },		// 114 bits per transform
			{ 16, 14, 2 },		// 114 bits per transform
			{ 16, 15, 1 },		// 114 bits per transform
			{ 17, 0, 17 },		// 114 bits per transform
			{ 17, 1, 14 },		// 114 bits per transform
			{ 17, 2, 13 },		// 114 bits per transform
			{ 17, 3, 12 },		// 114 bits per transform
			{ 17, 4, 11 },		// 114 bits per transform
			{ 17, 5, 10 },		// 114 bits per transform
			{ 17, 6, 9 },		// 114 bits per transform
			{ 17, 7, 8 },		// 114 bits per transform
			{ 17, 8, 7 },		// 114 bits per transform
			{ 17, 9, 6 },		// 114 bits per transform
			{ 17, 10, 5 },		// 114 bits per transform
			{ 17, 11, 4 },		// 114 bits per transform
			{ 17, 12, 3 },		// 114 bits per transform
			{ 17, 13, 2 },		// 114 bits per transform
			{ 17, 14, 1 },		// 114 bits per transform
			{ 17, 17, 0 },		// 114 bits per transform
			{ 18, 0, 4 },		// 114 bits per transform
			{ 18, 1, 1 },		// 114 bits per transform
			{ 18, 4, 0 },		// 114 bits per transform
			{ 0, 5, 18 },		// 117 bits per transform
			{ 0, 18, 5 },		// 117 bits per transform
			{ 1, 2, 18 },		// 117 bits per transform
			{ 1, 15, 17 },		// 117 bits per transform
			{ 1, 16, 16 },		// 117 bits per transform
			{ 1, 17, 15 },		// 117 bits per transform
			{ 1, 18, 2 },		// 117 bits per transform
			{ 2, 1, 18 },		// 117 bits per transform
			{ 2, 14, 17 },		// 117 bits per transform
			{ 2, 15, 16 },		// 117 bits per transform
			{ 2, 16, 15 },		// 117 bits per transform
			{ 2, 17, 14 },		// 117 bits per transform
			{ 2, 18, 1 },		// 117 bits per transform
			{ 3, 13, 17 },		// 117 bits per transform
			{ 3, 14, 16 },		// 117 bits per transform
			{ 3, 15, 15 },		// 117 bits per transform
			{ 3, 16, 14 },		// 117 bits per transform
			{ 3, 17, 13 },		// 117 bits per transform
			{ 4, 12, 17 },		// 117 bits per transform
			{ 4, 13, 16 },		// 117 bits per transform
			{ 4, 14, 15 },		// 117 bits per transform
			{ 4, 15, 14 },		// 117 bits per transform
			{ 4, 16, 13 },		// 117 bits per transform
			{ 4, 17, 12 },		// 117 bits per transform
			{ 5, 0, 18 },		// 117 bits per transform
			{ 5, 11, 17 },		// 117 bits per transform
			{ 5, 12, 16 },		// 117 bits per transform
			{ 5, 13, 15 },		// 117 bits per transform
			{ 5, 14, 14 },		// 117 bits per transform
			{ 5, 15, 13 },		// 117 bits per transform
			{ 5, 16, 12 },		// 117 bits per transform
			{ 5, 17, 11 },		// 117 bits per transform
			{ 5, 18, 0 },		// 117 bits per transform
			{ 6, 10, 17 },		// 117 bits per transform
			{ 6, 11, 16 },		// 117 bits per transform
			{ 6, 12, 15 },		// 117 bits per transform
			{ 6, 13, 14 },		// 117 bits per transform
			{ 6, 14, 13 },		// 117 bits per transform
			{ 6, 15, 12 },		// 117 bits per transform
			{ 6, 16, 11 },		// 117 bits per transform
			{ 6, 17, 10 },		// 117 bits per transform
			{ 7, 9, 17 },		// 117 bits per transform
			{ 7, 10, 16 },		// 117 bits per transform
			{ 7, 11, 15 },		// 117 bits per transform
			{ 7, 12, 14 },		// 117 bits per transform
			{ 7, 13, 13 },		// 117 bits per transform
			{ 7, 14, 12 },		// 117 bits per transform
			{ 7, 15, 11 },		// 117 bits per transform
			{ 7, 16, 10 },		// 117 bits per transform
			{ 7, 17, 9 },		// 117 bits per transform
			{ 8, 8, 17 },		// 117 bits per transform
			{ 8, 9, 16 },		// 117 bits per transform
			{ 8, 10, 15 },		// 117 bits per transform
			{ 8, 11, 14 },		// 117 bits per transform
			{ 8, 12, 13 },		// 117 bits per transform
			{ 8, 13, 12 },		// 117 bits per transform
			{ 8, 14, 11 },		// 117 bits per transform
			{ 8, 15, 10 },		// 117 bits per transform
			{ 8, 16, 9 },		// 117 bits per transform
			{ 8, 17, 8 },		// 117 bits per transform
			{ 9, 7, 17 },		// 117 bits per transform
			{ 9, 8, 16 },		// 117 bits per transform
			{ 9, 9, 15 },		// 117 bits per transform
			{ 9, 10, 14 },		// 117 bits per transform
			{ 9, 11, 13 },		// 117 bits per transform
			{ 9, 12, 12 },		// 117 bits per transform
			{ 9, 13, 11 },		// 117 bits per transform
			{ 9, 14, 10 },		// 117 bits per transform
			{ 9, 15, 9 },		// 117 bits per transform
			{ 9, 16, 8 },		// 117 bits per transform
			{ 9, 17, 7 },		// 117 bits per transform
			{ 10, 6, 17 },		// 117 bits per transform
			{ 10, 7, 16 },		// 117 bits per transform
			{ 10, 8, 15 },		// 117 bits per transform
			{ 10, 9, 14 },		// 117 bits per transform
			{ 10, 10, 13 },		// 117 bits per transform
			{ 10, 11, 12 },		// 117 bits per transform
			{ 10, 12, 11 },		// 117 bits per transform
			{ 10, 13, 10 },		// 117 bits per transform
			{ 10, 14, 9 },		// 117 bits per transform
			{ 10, 15, 8 },		// 117 bits per transform
			{ 10, 16, 7 },		// 117 bits per transform
			{ 10, 17, 6 },		// 117 bits per transform
			{ 11, 5, 17 },		// 117 bits per transform
			{ 11, 6, 16 },		// 117 bits per transform
			{ 11, 7, 15 },		// 117 bits per transform
			{ 11, 8, 14 },		// 117 bits per transform
			{ 11, 9, 13 },		// 117 bits per transform
			{ 11, 10, 12 },		// 117 bits per transform
			{ 11, 11, 11 },		// 117 bits per transform
			{ 11, 12, 10 },		// 117 bits per transform
			{ 11, 13, 9 },		// 117 bits per transform
			{ 11, 14, 8 },		// 117 bits per transform
			{ 11, 15, 7 },		// 117 bits per transform
			{ 11, 16, 6 },		// 117 bits per transform
			{ 11, 17, 5 },		// 117 bits per transform
			{ 12, 4, 17 },		// 117 bits per transform
			{ 12, 5, 16 },		// 117 bits per transform
			{ 12, 6, 15 },		// 117 bits per transform
			{ 12, 7, 14 },		// 117 bits per transform
			{ 12, 8, 13 },		// 117 bits per transform
			{ 12, 9, 12 },		// 117 bits per transform
			{ 12, 10, 11 },		// 117 bits per transform
			{ 12, 11, 10 },		// 117 bits per transform
			{ 12, 12, 9 },		// 117 bits per transform
			{ 12, 13, 8 },		// 117 bits per transform
			{ 12, 14, 7 },		// 117 bits per transform
			{ 12, 15, 6 },		// 117 bits per transform
			{ 12, 16, 5 },		// 117 bits per transform
			{ 12, 17, 4 },		// 117 bits per transform
			{ 13, 3, 17 },		// 117 bits per transform
			{ 13, 4, 16 },		// 117 bits per transform
			{ 13, 5, 15 },		// 117 bits per transform
			{ 13, 6, 14 },		// 117 bits per transform
			{ 13, 7, 13 },		// 117 bits per transform
			{ 13, 8, 12 },		// 117 bits per transform
			{ 13, 9, 11 },		// 117 bits per transform
			{ 13, 10, 10 },		// 117 bits per transform
			{ 13, 11, 9 },		// 117 bits per transform
			{ 13, 12, 8 },		// 117 bits per transform
			{ 13, 13, 7 },		// 117 bits per transform
			{ 13, 14, 6 },		// 117 bits per transform
			{ 13, 15, 5 },		// 117 bits per transform
			{ 13, 16, 4 },		// 117 bits per transform
			{ 13, 17, 3 },		// 117 bits per transform
			{ 14, 2, 17 },		// 117 bits per transform
			{ 14, 3, 16 },		// 117 bits per transform
			{ 14, 4, 15 },		// 117 bits per transform
			{ 14, 5, 14 },		// 117 bits per transform
			{ 14, 6, 13 },		// 117 bits per transform
			{ 14, 7, 12 },		// 117 bits per transform
			{ 14, 8, 11 },		// 117 bits per transform
			{ 14, 9, 10 },		// 117 bits per transform
			{ 14, 10, 9 },		// 117 bits per transform
			{ 14, 11, 8 },		// 117 bits per transform
			{ 14, 12, 7 },		// 117 bits per transform
			{ 14, 13, 6 },		// 117 bits per transform
			{ 14, 14, 5 },		// 117 bits per transform
			{ 14, 15, 4 },		// 117 bits per transform
			{ 14, 16, 3 },		// 117 bits per transform
			{ 14, 17, 2 },		// 117 bits per transform
			{ 15, 1, 17 },		// 117 bits per transform
			{ 15, 2, 16 },		// 117 bits per transform
			{ 15, 3, 15 },		// 117 bits per transform
			{ 15, 4, 14 },		// 117 bits per transform
			{ 15, 5, 13 },		// 117 bits per transform
			{ 15, 6, 12 },		// 117 bits per transform
			{ 15, 7, 11 },		// 117 bits per transform
			{ 15, 8, 10 },		// 117 bits per transform
			{ 15, 9, 9 },		// 117 bits per transform
			{ 15, 10, 8 },		// 117 bits per transform
			{ 15, 11, 7 },		// 117 bits per transform
			{ 15, 12, 6 },		// 117 bits per transform
			{ 15, 13, 5 },		// 117 bits per transform
			{ 15, 14, 4 },		// 117 bits per transform
			{ 15, 15, 3 },		// 117 bits per transform
			{ 15, 16, 2 },		// 117 bits per transform
			{ 15, 17, 1 },		// 117 bits per transform
			{ 16, 1, 16 },		// 117 bits per transform
			{ 16, 2, 15 },		// 117 bits per transform
			{ 16, 3, 14 },		// 117 bits per transform
			{ 16, 4, 13 },		// 117 bits per transform
			{ 16, 5, 12 },		// 117 bits per transform
			{ 16, 6, 11 },		// 117 bits per transform
			{ 16, 7, 10 },		// 117 bits per transform
			{ 16, 8, 9 },		// 117 bits per transform
			{ 16, 9, 8 },		// 117 bits per transform
			{ 16, 10, 7 },		// 117 bits per transform
			{ 16, 11, 6 },		// 117 bits per transform
			{ 16, 12, 5 },		// 117 bits per transform
			{ 16, 13, 4 },		// 117 bits per transform
			{ 16, 14, 3 },		// 117 bits per transform
			{ 16, 15, 2 },		// 117 bits per transform
			{ 16, 16, 1 },		// 117 bits per transform
			{ 17, 1, 15 },		// 117 bits per transform
			{ 17, 2, 14 },		// 117 bits per transform
			{ 17, 3, 13 },		// 117 bits per transform
			{ 17, 4, 12 },		// 117 bits per transform
			{ 17, 5, 11 },		// 117 bits per transform
			{ 17, 6, 10 },		// 117 bits per transform
			{ 17, 7, 9 },		// 117 bits per transform
			{ 17, 8, 8 },		// 117 bits per transform
			{ 17, 9, 7 },		// 117 bits per transform
			{ 17, 10, 6 },		// 117 bits per transform
			{ 17, 11, 5 },		// 117 bits per transform
			{ 17, 12, 4 },		// 117 bits per transform
			{ 17, 13, 3 },		// 117 bits per transform
			{ 17, 14, 2 },		// 117 bits per transform
			{ 17, 15, 1 },		// 117 bits per transform
			{ 18, 0, 5 },		// 117 bits per transform
			{ 18, 1, 2 },		// 117 bits per transform
			{ 18, 2, 1 },		// 117 bits per transform
			{ 18, 5, 0 },		// 117 bits per transform
			{ 0, 6, 18 },		// 120 bits per transform
			{ 0, 18, 6 },		// 120 bits per transform
			{ 1, 3, 18 },		// 120 bits per transform
			{ 1, 16, 17 },		// 120 bits per transform
			{ 1, 17, 16 },		// 120 bits per transform
			{ 1, 18, 3 },		// 120 bits per transform
			{ 2, 2, 18 },		// 120 bits per transform
			{ 2, 15, 17 },		// 120 bits per transform
			{ 2, 16, 16 },		// 120 bits per transform
			{ 2, 17, 15 },		// 120 bits per transform
			{ 2, 18, 2 },		// 120 bits per transform
			{ 3, 1, 18 },		// 120 bits per transform
			{ 3, 14, 17 },		// 120 bits per transform
			{ 3, 15, 16 },		// 120 bits per transform
			{ 3, 16, 15 },		// 120 bits per transform
			{ 3, 17, 14 },		// 120 bits per transform
			{ 3, 18, 1 },		// 120 bits per transform
			{ 4, 13, 17 },		// 120 bits per transform
			{ 4, 14, 16 },		// 120 bits per transform
			{ 4, 15, 15 },		// 120 bits per transform
			{ 4, 16, 14 },		// 120 bits per transform
			{ 4, 17, 13 },		// 120 bits per transform
			{ 5, 12, 17 },		// 120 bits per transform
			{ 5, 13, 16 },		// 120 bits per transform
			{ 5, 14, 15 },		// 120 bits per transform
			{ 5, 15, 14 },		// 120 bits per transform
			{ 5, 16, 13 },		// 120 bits per transform
			{ 5, 17, 12 },		// 120 bits per transform
			{ 6, 0, 18 },		// 120 bits per transform
			{ 6, 11, 17 },		// 120 bits per transform
			{ 6, 12, 16 },		// 120 bits per transform
			{ 6, 13, 15 },		// 120 bits per transform
			{ 6, 14, 14 },		// 120 bits per transform
			{ 6, 15, 13 },		// 120 bits per transform
			{ 6, 16, 12 },		// 120 bits per transform
			{ 6, 17, 11 },		// 120 bits per transform
			{ 6, 18, 0 },		// 120 bits per transform
			{ 7, 10, 17 },		// 120 bits per transform
			{ 7, 11, 16 },		// 120 bits per transform
			{ 7, 12, 15 },		// 120 bits per transform
			{ 7, 13, 14 },		// 120 bits per transform
			{ 7, 14, 13 },		// 120 bits per transform
			{ 7, 15, 12 },		// 120 bits per transform
			{ 7, 16, 11 },		// 120 bits per transform
			{ 7, 17, 10 },		// 120 bits per transform
			{ 8, 9, 17 },		// 120 bits per transform
			{ 8, 10, 16 },		// 120 bits per transform
			{ 8, 11, 15 },		// 120 bits per transform
			{ 8, 12, 14 },		// 120 bits per transform
			{ 8, 13, 13 },		// 120 bits per transform
			{ 8, 14, 12 },		// 120 bits per transform
			{ 8, 15, 11 },		// 120 bits per transform
			{ 8, 16, 10 },		// 120 bits per transform
			{ 8, 17, 9 },		// 120 bits per transform
			{ 9, 8, 17 },		// 120 bits per transform
			{ 9, 9, 16 },		// 120 bits per transform
			{ 9, 10, 15 },		// 120 bits per transform
			{ 9, 11, 14 },		// 120 bits per transform
			{ 9, 12, 13 },		// 120 bits per transform
			{ 9, 13, 12 },		// 120 bits per transform
			{ 9, 14, 11 },		// 120 bits per transform
			{ 9, 15, 10 },		// 120 bits per transform
			{ 9, 16, 9 },		// 120 bits per transform
			{ 9, 17, 8 },		// 120 bits per transform
			{ 10, 7, 17 },		// 120 bits per transform
			{ 10, 8, 16 },		// 120 bits per transform
			{ 10, 9, 15 },		// 120 bits per transform
			{ 10, 10, 14 },		// 120 bits per transform
			{ 10, 11, 13 },		// 120 bits per transform
			{ 10, 12, 12 },		// 120 bits per transform
			{ 10, 13, 11 },		// 120 bits per transform
			{ 10, 14, 10 },		// 120 bits per transform
			{ 10, 15, 9 },		// 120 bits per transform
			{ 10, 16, 8 },		// 120 bits per transform
			{ 10, 17, 7 },		// 120 bits per transform
			{ 11, 6, 17 },		// 120 bits per transform
			{ 11, 7, 16 },		// 120 bits per transform
			{ 11, 8, 15 },		// 120 bits per transform
			{ 11, 9, 14 },		// 120 bits per transform
			{ 11, 10, 13 },		// 120 bits per transform
			{ 11, 11, 12 },		// 120 bits per transform
			{ 11, 12, 11 },		// 120 bits per transform
			{ 11, 13, 10 },		// 120 bits per transform
			{ 11, 14, 9 },		// 120 bits per transform
			{ 11, 15, 8 },		// 120 bits per transform
			{ 11, 16, 7 },		// 120 bits per transform
			{ 11, 17, 6 },		// 120 bits per transform
			{ 12, 5, 17 },		// 120 bits per transform
			{ 12, 6, 16 },		// 120 bits per transform
			{ 12, 7, 15 },		// 120 bits per transform
			{ 12, 8, 14 },		// 120 bits per transform
			{ 12, 9, 13 },		// 120 bits per transform
			{ 12, 10, 12 },		// 120 bits per transform
			{ 12, 11, 11 },		// 120 bits per transform
			{ 12, 12, 10 },		// 120 bits per transform
			{ 12, 13, 9 },		// 120 bits per transform
			{ 12, 14, 8 },		// 120 bits per transform
			{ 12, 15, 7 },		// 120 bits per transform
			{ 12, 16, 6 },		// 120 bits per transform
			{ 12, 17, 5 },		// 120 bits per transform
			{ 13, 4, 17 },		// 120 bits per transform
			{ 13, 5, 16 },		// 120 bits per transform
			{ 13, 6, 15 },		// 120 bits per transform
			{ 13, 7, 14 },		// 120 bits per transform
			{ 13, 8, 13 },		// 120 bits per transform
			{ 13, 9, 12 },		// 120 bits per transform
			{ 13, 10, 11 },		// 120 bits per transform
			{ 13, 11, 10 },		// 120 bits per transform
			{ 13, 12, 9 },		// 120 bits per transform
			{ 13, 13, 8 },		// 120 bits per transform
			{ 13, 14, 7 },		// 120 bits per transform
			{ 13, 15, 6 },		// 120 bits per transform
			{ 13, 16, 5 },		// 120 bits per transform
			{ 13, 17, 4 },		// 120 bits per transform
			{ 14, 3, 17 },		// 120 bits per transform
			{ 14, 4, 16 },		// 120 bits per transform
			{ 14, 5, 15 },		// 120 bits per transform
			{ 14, 6, 14 },		// 120 bits per transform
			{ 14, 7, 13 },		// 120 bits per transform
			{ 14, 8, 12 },		// 120 bits per transform
			{ 14, 9, 11 },		// 120 bits per transform
			{ 14, 10, 10 },		// 120 bits per transform
			{ 14, 11, 9 },		// 120 bits per transform
			{ 14, 12, 8 },		// 120 bits per transform
			{ 14, 13, 7 },		// 120 bits per transform
			{ 14, 14, 6 },		// 120 bits per transform
			{ 14, 15, 5 },		// 120 bits per transform
			{ 14, 16, 4 },		// 120 bits per transform
			{ 14, 17, 3 },		// 120 bits per transform
			{ 15, 2, 17 },		// 120 bits per transform
			{ 15, 3, 16 },		// 120 bits per transform
			{ 15, 4, 15 },		// 120 bits per transform
			{ 15, 5, 14 },		// 120 bits per transform
			{ 15, 6, 13 },		// 120 bits per transform
			{ 15, 7, 12 },		// 120 bits per transform
			{ 15, 8, 11 },		// 120 bits per transform
			{ 15, 9, 10 },		// 120 bits per transform
			{ 15, 10, 9 },		// 120 bits per transform
			{ 15, 11, 8 },		// 120 bits per transform
			{ 15, 12, 7 },		// 120 bits per transform
			{ 15, 13, 6 },		// 120 bits per transform
			{ 15, 14, 5 },		// 120 bits per transform
			{ 15, 15, 4 },		// 120 bits per transform
			{ 15, 16, 3 },		// 120 bits per transform
			{ 15, 17, 2 },		// 120 bits per transform
			{ 16, 1, 17 },		// 120 bits per transform
			{ 16, 2, 16 },		// 120 bits per transform
			{ 16, 3, 15 },		// 120 bits per transform
			{ 16, 4, 14 },		// 120 bits per transform
			{ 16, 5, 13 },		// 120 bits per transform
			{ 16, 6, 12 },		// 120 bits per transform
			{ 16, 7, 11 },		// 120 bits per transform
			{ 16, 8, 10 },		// 120 bits per transform
			{ 16, 9, 9 },		// 120 bits per transform
			{ 16, 10, 8 },		// 120 bits per transform
			{ 16, 11, 7 },		// 120 bits per transform
			{ 16, 12, 6 },		// 120 bits per transform
			{ 16, 13, 5 },		// 120 bits per transform
			{ 16, 14, 4 },		// 120 bits per transform
			{ 16, 15, 3 },		// 120 bits per transform
			{ 16, 16, 2 },		// 120 bits per transform
			{ 16, 17, 1 },		// 120 bits per transform
			{ 17, 1, 16 },		// 120 bits per transform
			{ 17, 2, 15 },		// 120 bits per transform
			{ 17, 3, 14 },		// 120 bits per transform
			{ 17, 4, 13 },		// 120 bits per transform
			{ 17, 5, 12 },		// 120 bits per transform
			{ 17, 6, 11 },		// 120 bits per transform
			{ 17, 7, 10 },		// 120 bits per transform
			{ 17, 8, 9 },		// 120 bits per transform
			{ 17, 9, 8 },		// 120 bits per transform
			{ 17, 10, 7 },		// 120 bits per transform
			{ 17, 11, 6 },		// 120 bits per transform
			{ 17, 12, 5 },		// 120 bits per transform
			{ 17, 13, 4 },		// 120 bits per transform
			{ 17, 14, 3 },		// 120 bits per transform
			{ 17, 15, 2 },		// 120 bits per transform
			{ 17, 16, 1 },		// 120 bits per transform
			{ 18, 0, 6 },		// 120 bits per transform
			{ 18, 1, 3 },		// 120 bits per transform
			{ 18, 2, 2 },		// 120 bits per transform
			{ 18, 3, 1 },		// 120 bits per transform
			{ 18, 6, 0 },		// 120 bits per transform
			{ 0, 7, 18 },		// 123 bits per transform
			{ 0, 18, 7 },		// 123 bits per transform
			{ 1, 4, 18 },		// 123 bits per transform
			{ 1, 17, 17 },		// 123 bits per transform
			{ 1, 18, 4 },		// 123 bits per transform
			{ 2, 3, 18 },		// 123 bits per transform
			{ 2, 16, 17 },		// 123 bits per transform
			{ 2, 17, 16 },		// 123 bits per transform
			{ 2, 18, 3 },		// 123 bits per transform
			{ 3, 2, 18 },		// 123 bits per transform
			{ 3, 15, 17 },		// 123 bits per transform
			{ 3, 16, 16 },		// 123 bits per transform
			{ 3, 17, 15 },		// 123 bits per transform
			{ 3, 18, 2 },		// 123 bits per transform
			{ 4, 1, 18 },		// 123 bits per transform
			{ 4, 14, 17 },		// 123 bits per transform
			{ 4, 15, 16 },		// 123 bits per transform
			{ 4, 16, 15 },		// 123 bits per transform
			{ 4, 17, 14 },		// 123 bits per transform
			{ 4, 18, 1 },		// 123 bits per transform
			{ 5, 13, 17 },		// 123 bits per transform
			{ 5, 14, 16 },		// 123 bits per transform
			{ 5, 15, 15 },		// 123 bits per transform
			{ 5, 16, 14 },		// 123 bits per transform
			{ 5, 17, 13 },		// 123 bits per transform
			{ 6, 12, 17 },		// 123 bits per transform
			{ 6, 13, 16 },		// 123 bits per transform
			{ 6, 14, 15 },		// 123 bits per transform
			{ 6, 15, 14 },		// 123 bits per transform
			{ 6, 16, 13 },		// 123 bits per transform
			{ 6, 17, 12 },		// 123 bits per transform
			{ 7, 0, 18 },		// 123 bits per transform
			{ 7, 11, 17 },		// 123 bits per transform
			{ 7, 12, 16 },		// 123 bits per transform
			{ 7, 13, 15 },		// 123 bits per transform
			{ 7, 14, 14 },		// 123 bits per transform
			{ 7, 15, 13 },		// 123 bits per transform
			{ 7, 16, 12 },		// 123 bits per transform
			{ 7, 17, 11 },		// 123 bits per transform
			{ 7, 18, 0 },		// 123 bits per transform
			{ 8, 10, 17 },		// 123 bits per transform
			{ 8, 11, 16 },		// 123 bits per transform
			{ 8, 12, 15 },		// 123 bits per transform
			{ 8, 13, 14 },		// 123 bits per transform
			{ 8, 14, 13 },		// 123 bits per transform
			{ 8, 15, 12 },		// 123 bits per transform
			{ 8, 16, 11 },		// 123 bits per transform
			{ 8, 17, 10 },		// 123 bits per transform
			{ 9, 9, 17 },		// 123 bits per transform
			{ 9, 10, 16 },		// 123 bits per transform
			{ 9, 11, 15 },		// 123 bits per transform
			{ 9, 12, 14 },		// 123 bits per transform
			{ 9, 13, 13 },		// 123 bits per transform
			{ 9, 14, 12 },		// 123 bits per transform
			{ 9, 15, 11 },		// 123 bits per transform
			{ 9, 16, 10 },		// 123 bits per transform
			{ 9, 17, 9 },		// 123 bits per transform
			{ 10, 8, 17 },		// 123 bits per transform
			{ 10, 9, 16 },		// 123 bits per transform
			{ 10, 10, 15 },		// 123 bits per transform
			{ 10, 11, 14 },		// 123 bits per transform
			{ 10, 12, 13 },		// 123 bits per transform
			{ 10, 13, 12 },		// 123 bits per transform
			{ 10, 14, 11 },		// 123 bits per transform
			{ 10, 15, 10 },		// 123 bits per transform
			{ 10, 16, 9 },		// 123 bits per transform
			{ 10, 17, 8 },		// 123 bits per transform
			{ 11, 7, 17 },		// 123 bits per transform
			{ 11, 8, 16 },		// 123 bits per transform
			{ 11, 9, 15 },		// 123 bits per transform
			{ 11, 10, 14 },		// 123 bits per transform
			{ 11, 11, 13 },		// 123 bits per transform
			{ 11, 12, 12 },		// 123 bits per transform
			{ 11, 13, 11 },		// 123 bits per transform
			{ 11, 14, 10 },		// 123 bits per transform
			{ 11, 15, 9 },		// 123 bits per transform
			{ 11, 16, 8 },		// 123 bits per transform
			{ 11, 17, 7 },		// 123 bits per transform
			{ 12, 6, 17 },		// 123 bits per transform
			{ 12, 7, 16 },		// 123 bits per transform
			{ 12, 8, 15 },		// 123 bits per transform
			{ 12, 9, 14 },		// 123 bits per transform
			{ 12, 10, 13 },		// 123 bits per transform
			{ 12, 11, 12 },		// 123 bits per transform
			{ 12, 12, 11 },		// 123 bits per transform
			{ 12, 13, 10 },		// 123 bits per transform
			{ 12, 14, 9 },		// 123 bits per transform
			{ 12, 15, 8 },		// 123 bits per transform
			{ 12, 16, 7 },		// 123 bits per transform
			{ 12, 17, 6 },		// 123 bits per transform
			{ 13, 5, 17 },		// 123 bits per transform
			{ 13, 6, 16 },		// 123 bits per transform
			{ 13, 7, 15 },		// 123 bits per transform
			{ 13, 8, 14 },		// 123 bits per transform
			{ 13, 9, 13 },		// 123 bits per transform
			{ 13, 10, 12 },		// 123 bits per transform
			{ 13, 11, 11 },		// 123 bits per transform
			{ 13, 12, 10 },		// 123 bits per transform
			{ 13, 13, 9 },		// 123 bits per transform
			{ 13, 14, 8 },		// 123 bits per transform
			{ 13, 15, 7 },		// 123 bits per transform
			{ 13, 16, 6 },		// 123 bits per transform
			{ 13, 17, 5 },		// 123 bits per transform
			{ 14, 4, 17 },		// 123 bits per transform
			{ 14, 5, 16 },		// 123 bits per transform
			{ 14, 6, 15 },		// 123 bits per transform
			{ 14, 7, 14 },		// 123 bits per transform
			{ 14, 8, 13 },		// 123 bits per transform
			{ 14, 9, 12 },		// 123 bits per transform
			{ 14, 10, 11 },		// 123 bits per transform
			{ 14, 11, 10 },		// 123 bits per transform
			{ 14, 12, 9 },		// 123 bits per transform
			{ 14, 13, 8 },		// 123 bits per transform
			{ 14, 14, 7 },		// 123 bits per transform
			{ 14, 15, 6 },		// 123 bits per transform
			{ 14, 16, 5 },		// 123 bits per transform
			{ 14, 17, 4 },		// 123 bits per transform
			{ 15, 3, 17 },		// 123 bits per transform
			{ 15, 4, 16 },		// 123 bits per transform
			{ 15, 5, 15 },		// 123 bits per transform
			{ 15, 6, 14 },		// 123 bits per transform
			{ 15, 7, 13 },		// 123 bits per transform
			{ 15, 8, 12 },		// 123 bits per transform
			{ 15, 9, 11 },		// 123 bits per transform
			{ 15, 10, 10 },		// 123 bits per transform
			{ 15, 11, 9 },		// 123 bits per transform
			{ 15, 12, 8 },		// 123 bits per transform
			{ 15, 13, 7 },		// 123 bits per transform
			{ 15, 14, 6 },		// 123 bits per transform
			{ 15, 15, 5 },		// 123 bits per transform
			{ 15, 16, 4 },		// 123 bits per transform
			{ 15, 17, 3 },		// 123 bits per transform
			{ 16, 2, 17 },		// 123 bits per transform
			{ 16, 3, 16 },		// 123 bits per transform
			{ 16, 4, 15 },		// 123 bits per transform
			{ 16, 5, 14 },		// 123 bits per transform
			{ 16, 6, 13 },		// 123 bits per transform
			{ 16, 7, 12 },		// 123 bits per transform
			{ 16, 8, 11 },		// 123 bits per transform
			{ 16, 9, 10 },		// 123 bits per transform
			{ 16, 10, 9 },		// 123 bits per transform
			{ 16, 11, 8 },		// 123 bits per transform
			{ 16, 12, 7 },		// 123 bits per transform
			{ 16, 13, 6 },		// 123 bits per transform
			{ 16, 14, 5 },		// 123 bits per transform
			{ 16, 15, 4 },		// 123 bits per transform
			{ 16, 16, 3 },		// 123 bits per transform
			{ 16, 17, 2 },		// 123 bits per transform
			{ 17, 1, 17 },		// 123 bits per transform
			{ 17, 2, 16 },		// 123 bits per transform
			{ 17, 3, 15 },		// 123 bits per transform
			{ 17, 4, 14 },		// 123 bits per transform
			{ 17, 5, 13 },		// 123 bits per transform
			{ 17, 6, 12 },		// 123 bits per transform
			{ 17, 7, 11 },		// 123 bits per transform
			{ 17, 8, 10 },		// 123 bits per transform
			{ 17, 9, 9 },		// 123 bits per transform
			{ 17, 10, 8 },		// 123 bits per transform
			{ 17, 11, 7 },		// 123 bits per transform
			{ 17, 12, 6 },		// 123 bits per transform
			{ 17, 13, 5 },		// 123 bits per transform
			{ 17, 14, 4 },		// 123 bits per transform
			{ 17, 15, 3 },		// 123 bits per transform
			{ 17, 16, 2 },		// 123 bits per transform
			{ 17, 17, 1 },		// 123 bits per transform
			{ 18, 0, 7 },		// 123 bits per transform
			{ 18, 1, 4 },		// 123 bits per transform
			{ 18, 2, 3 },		// 123 bits per transform
			{ 18, 3, 2 },		// 123 bits per transform
			{ 18, 4, 1 },		// 123 bits per transform
			{ 18, 7, 0 },		// 123 bits per transform
			{ 0, 8, 18 },		// 126 bits per transform
			{ 0, 18, 8 },		// 126 bits per transform
			{ 1, 5, 18 },		// 126 bits per transform
			{ 1, 18, 5 },		// 126 bits per transform
			{ 2, 4, 18 },		// 126 bits per transform
			{ 2, 17, 17 },		// 126 bits per transform
			{ 2, 18, 4 },		// 126 bits per transform
			{ 3, 3, 18 },		// 126 bits per transform
			{ 3, 16, 17 },		// 126 bits per transform
			{ 3, 17, 16 },		// 126 bits per transform
			{ 3, 18, 3 },		// 126 bits per transform
			{ 4, 2, 18 },		// 126 bits per transform
			{ 4, 15, 17 },		// 126 bits per transform
			{ 4, 16, 16 },		// 126 bits per transform
			{ 4, 17, 15 },		// 126 bits per transform
			{ 4, 18, 2 },		// 126 bits per transform
			{ 5, 1, 18 },		// 126 bits per transform
			{ 5, 14, 17 },		// 126 bits per transform
			{ 5, 15, 16 },		// 126 bits per transform
			{ 5, 16, 15 },		// 126 bits per transform
			{ 5, 17, 14 },		// 126 bits per transform
			{ 5, 18, 1 },		// 126 bits per transform
			{ 6, 13, 17 },		// 126 bits per transform
			{ 6, 14, 16 },		// 126 bits per transform
			{ 6, 15, 15 },		// 126 bits per transform
			{ 6, 16, 14 },		// 126 bits per transform
			{ 6, 17, 13 },		// 126 bits per transform
			{ 7, 12, 17 },		// 126 bits per transform
			{ 7, 13, 16 },		// 126 bits per transform
			{ 7, 14, 15 },		// 126 bits per transform
			{ 7, 15, 14 },		// 126 bits per transform
			{ 7, 16, 13 },		// 126 bits per transform
			{ 7, 17, 12 },		// 126 bits per transform
			{ 8, 0, 18 },		// 126 bits per transform
			{ 8, 11, 17 },		// 126 bits per transform
			{ 8, 12, 16 },		// 126 bits per transform
			{ 8, 13, 15 },		// 126 bits per transform
			{ 8, 14, 14 },		// 126 bits per transform
			{ 8, 15, 13 },		// 126 bits per transform
			{ 8, 16, 12 },		// 126 bits per transform
			{ 8, 17, 11 },		// 126 bits per transform
			{ 8, 18, 0 },		// 126 bits per transform
			{ 9, 10, 17 },		// 126 bits per transform
			{ 9, 11, 16 },		// 126 bits per transform
			{ 9, 12, 15 },		// 126 bits per transform
			{ 9, 13, 14 },		// 126 bits per transform
			{ 9, 14, 13 },		// 126 bits per transform
			{ 9, 15, 12 },		// 126 bits per transform
			{ 9, 16, 11 },		// 126 bits per transform
			{ 9, 17, 10 },		// 126 bits per transform
			{ 10, 9, 17 },		// 126 bits per transform
			{ 10, 10, 16 },		// 126 bits per transform
			{ 10, 11, 15 },		// 126 bits per transform
			{ 10, 12, 14 },		// 126 bits per transform
			{ 10, 13, 13 },		// 126 bits per transform
			{ 10, 14, 12 },		// 126 bits per transform
			{ 10, 15, 11 },		// 126 bits per transform
			{ 10, 16, 10 },		// 126 bits per transform
			{ 10, 17, 9 },		// 126 bits per transform
			{ 11, 8, 17 },		// 126 bits per transform
			{ 11, 9, 16 },		// 126 bits per transform
			{ 11, 10, 15 },		// 126 bits per transform
			{ 11, 11, 14 },		// 126 bits per transform
			{ 11, 12, 13 },		// 126 bits per transform
			{ 11, 13, 12 },		// 126 bits per transform
			{ 11, 14, 11 },		// 126 bits per transform
			{ 11, 15, 10 },		// 126 bits per transform
			{ 11, 16, 9 },		// 126 bits per transform
			{ 11, 17, 8 },		// 126 bits per transform
			{ 12, 7, 17 },		// 126 bits per transform
			{ 12, 8, 16 },		// 126 bits per transform
			{ 12, 9, 15 },		// 126 bits per transform
			{ 12, 10, 14 },		// 126 bits per transform
			{ 12, 11, 13 },		// 126 bits per transform
			{ 12, 12, 12 },		// 126 bits per transform
			{ 12, 13, 11 },		// 126 bits per transform
			{ 12, 14, 10 },		// 126 bits per transform
			{ 12, 15, 9 },		// 126 bits per transform
			{ 12, 16, 8 },		// 126 bits per transform
			{ 12, 17, 7 },		// 126 bits per transform
			{ 13, 6, 17 },		// 126 bits per transform
			{ 13, 7, 16 },		// 126 bits per transform
			{ 13, 8, 15 },		// 126 bits per transform
			{ 13, 9, 14 },		// 126 bits per transform
			{ 13, 10, 13 },		// 126 bits per transform
			{ 13, 11, 12 },		// 126 bits per transform
			{ 13, 12, 11 },		// 126 bits per transform
			{ 13, 13, 10 },		// 126 bits per transform
			{ 13, 14, 9 },		// 126 bits per transform
			{ 13, 15, 8 },		// 126 bits per transform
			{ 13, 16, 7 },		// 126 bits per transform
			{ 13, 17, 6 },		// 126 bits per transform
			{ 14, 5, 17 },		// 126 bits per transform
			{ 14, 6, 16 },		// 126 bits per transform
			{ 14, 7, 15 },		// 126 bits per transform
			{ 14, 8, 14 },		// 126 bits per transform
			{ 14, 9, 13 },		// 126 bits per transform
			{ 14, 10, 12 },		// 126 bits per transform
			{ 14, 11, 11 },		// 126 bits per transform
			{ 14, 12, 10 },		// 126 bits per transform
			{ 14, 13, 9 },		// 126 bits per transform
			{ 14, 14, 8 },		// 126 bits per transform
			{ 14, 15, 7 },		// 126 bits per transform
			{ 14, 16, 6 },		// 126 bits per transform
			{ 14, 17, 5 },		// 126 bits per transform
			{ 15, 4, 17 },		// 126 bits per transform
			{ 15, 5, 16 },		// 126 bits per transform
			{ 15, 6, 15 },		// 126 bits per transform
			{ 15, 7, 14 },		// 126 bits per transform
			{ 15, 8, 13 },		// 126 bits per transform
			{ 15, 9, 12 },		// 126 bits per transform
			{ 15, 10, 11 },		// 126 bits per transform
			{ 15, 11, 10 },		// 126 bits per transform
			{ 15, 12, 9 },		// 126 bits per transform
			{ 15, 13, 8 },		// 126 bits per transform
			{ 15, 14, 7 },		// 126 bits per transform
			{ 15, 15, 6 },		// 126 bits per transform
			{ 15, 16, 5 },		// 126 bits per transform
			{ 15, 17, 4 },		// 126 bits per transform
			{ 16, 3, 17 },		// 126 bits per transform
			{ 16, 4, 16 },		// 126 bits per transform
			{ 16, 5, 15 },		// 126 bits per transform
			{ 16, 6, 14 },		// 126 bits per transform
			{ 16, 7, 13 },		// 126 bits per transform
			{ 16, 8, 12 },		// 126 bits per transform
			{ 16, 9, 11 },		// 126 bits per transform
			{ 16, 10, 10 },		// 126 bits per transform
			{ 16, 11, 9 },		// 126 bits per transform
			{ 16, 12, 8 },		// 126 bits per transform
			{ 16, 13, 7 },		// 126 bits per transform
			{ 16, 14, 6 },		// 126 bits per transform
			{ 16, 15, 5 },		// 126 bits per transform
			{ 16, 16, 4 },		// 126 bits per transform
			{ 16, 17, 3 },		// 126 bits per transform
			{ 17, 2, 17 },		// 126 bits per transform
			{ 17, 3, 16 },		// 126 bits per transform
			{ 17, 4, 15 },		// 126 bits per transform
			{ 17, 5, 14 },		// 126 bits per transform
			{ 17, 6, 13 },		// 126 bits per transform
			{ 17, 7, 12 },		// 126 bits per transform
			{ 17, 8, 11 },		// 126 bits per transform
			{ 17, 9, 10 },		// 126 bits per transform
			{ 17, 10, 9 },		// 126 bits per transform
			{ 17, 11, 8 },		// 126 bits per transform
			{ 17, 12, 7 },		// 126 bits per transform
			{ 17, 13, 6 },		// 126 bits per transform
			{ 17, 14, 5 },		// 126 bits per transform
			{ 17, 15, 4 },		// 126 bits per transform
			{ 17, 16, 3 },		// 126 bits per transform
			{ 17, 17, 2 },		// 126 bits per transform
			{ 18, 0, 8 },		// 126 bits per transform
			{ 18, 1, 5 },		// 126 bits per transform
			{ 18, 2, 4 },		// 126 bits per transform
			{ 18, 3, 3 },		// 126 bits per transform
			{ 18, 4, 2 },		// 126 bits per transform
			{ 18, 5, 1 },		// 126 bits per transform
			{ 18, 8, 0 },		// 126 bits per transform
			{ 0, 9, 18 },		// 129 bits per transform
			{ 0, 18, 9 },		// 129 bits per transform
			{ 1, 6, 18 },		// 129 bits per transform
			{ 1, 18, 6 },		// 129 bits per transform
			{ 2, 5, 18 },		// 129 bits per transform
			{ 2, 18, 5 },		// 129 bits per transform
			{ 3, 4, 18 },		// 129 bits per transform
			{ 3, 17, 17 },		// 129 bits per transform
			{ 3, 18, 4 },		// 129 bits per transform
			{ 4, 3, 18 },		// 129 bits per transform
			{ 4, 16, 17 },		// 129 bits per transform
			{ 4, 17, 16 },		// 129 bits per transform
			{ 4, 18, 3 },		// 129 bits per transform
			{ 5, 2, 18 },		// 129 bits per transform
			{ 5, 15, 17 },		// 129 bits per transform
			{ 5, 16, 16 },		// 129 bits per transform
			{ 5, 17, 15 },		// 129 bits per transform
			{ 5, 18, 2 },		// 129 bits per transform
			{ 6, 1, 18 },		// 129 bits per transform
			{ 6, 14, 17 },		// 129 bits per transform
			{ 6, 15, 16 },		// 129 bits per transform
			{ 6, 16, 15 },		// 129 bits per transform
			{ 6, 17, 14 },		// 129 bits per transform
			{ 6, 18, 1 },		// 129 bits per transform
			{ 7, 13, 17 },		// 129 bits per transform
			{ 7, 14, 16 },		// 129 bits per transform
			{ 7, 15, 15 },		// 129 bits per transform
			{ 7, 16, 14 },		// 129 bits per transform
			{ 7, 17, 13 },		// 129 bits per transform
			{ 8, 12, 17 },		// 129 bits per transform
			{ 8, 13, 16 },		// 129 bits per transform
			{ 8, 14, 15 },		// 129 bits per transform
			{ 8, 15, 14 },		// 129 bits per transform
			{ 8, 16, 13 },		// 129 bits per transform
			{ 8, 17, 12 },		// 129 bits per transform
			{ 9, 0, 18 },		// 129 bits per transform
			{ 9, 11, 17 },		// 129 bits per transform
			{ 9, 12, 16 },		// 129 bits per transform
			{ 9, 13, 15 },		// 129 bits per transform
			{ 9, 14, 14 },		// 129 bits per transform
			{ 9, 15, 13 },		// 129 bits per transform
			{ 9, 16, 12 },		// 129 bits per transform
			{ 9, 17, 11 },		// 129 bits per transform
			{ 9, 18, 0 },		// 129 bits per transform
			{ 10, 10, 17 },		// 129 bits per transform
			{ 10, 11, 16 },		// 129 bits per transform
			{ 10, 12, 15 },		// 129 bits per transform
			{ 10, 13, 14 },		// 129 bits per transform
			{ 10, 14, 13 },		// 129 bits per transform
			{ 10, 15, 12 },		// 129 bits per transform
			{ 10, 16, 11 },		// 129 bits per transform
			{ 10, 17, 10 },		// 129 bits per transform
			{ 11, 9, 17 },		// 129 bits per transform
			{ 11, 10, 16 },		// 129 bits per transform
			{ 11, 11, 15 },		// 129 bits per transform
			{ 11, 12, 14 },		// 129 bits per transform
			{ 11, 13, 13 },		// 129 bits per transform
			{ 11, 14, 12 },		// 129 bits per transform
			{ 11, 15, 11 },		// 129 bits per transform
			{ 11, 16, 10 },		// 129 bits per transform
			{ 11, 17, 9 },		// 129 bits per transform
			{ 12, 8, 17 },		// 129 bits per transform
			{ 12, 9, 16 },		// 129 bits per transform
			{ 12, 10, 15 },		// 129 bits per transform
			{ 12, 11, 14 },		// 129 bits per transform
			{ 12, 12, 13 },		// 129 bits per transform
			{ 12, 13, 12 },		// 129 bits per transform
			{ 12, 14, 11 },		// 129 bits per transform
			{ 12, 15, 10 },		// 129 bits per transform
			{ 12, 16, 9 },		// 129 bits per transform
			{ 12, 17, 8 },		// 129 bits per transform
			{ 13, 7, 17 },		// 129 bits per transform
			{ 13, 8, 16 },		// 129 bits per transform
			{ 13, 9, 15 },		// 129 bits per transform
			{ 13, 10, 14 },		// 129 bits per transform
			{ 13, 11, 13 },		// 129 bits per transform
			{ 13, 12, 12 },		// 129 bits per transform
			{ 13, 13, 11 },		// 129 bits per transform
			{ 13, 14, 10 },		// 129 bits per transform
			{ 13, 15, 9 },		// 129 bits per transform
			{ 13, 16, 8 },		// 129 bits per transform
			{ 13, 17, 7 },		// 129 bits per transform
			{ 14, 6, 17 },		// 129 bits per transform
			{ 14, 7, 16 },		// 129 bits per transform
			{ 14, 8, 15 },		// 129 bits per transform
			{ 14, 9, 14 },		// 129 bits per transform
			{ 14, 10, 13 },		// 129 bits per transform
			{ 14, 11, 12 },		// 129 bits per transform
			{ 14, 12, 11 },		// 129 bits per transform
			{ 14, 13, 10 },		// 129 bits per transform
			{ 14, 14, 9 },		// 129 bits per transform
			{ 14, 15, 8 },		// 129 bits per transform
			{ 14, 16, 7 },		// 129 bits per transform
			{ 14, 17, 6 },		// 129 bits per transform
			{ 15, 5, 17 },		// 129 bits per transform
			{ 15, 6, 16 },		// 129 bits per transform
			{ 15, 7, 15 },		// 129 bits per transform
			{ 15, 8, 14 },		// 129 bits per transform
			{ 15, 9, 13 },		// 129 bits per transform
			{ 15, 10, 12 },		// 129 bits per transform
			{ 15, 11, 11 },		// 129 bits per transform
			{ 15, 12, 10 },		// 129 bits per transform
			{ 15, 13, 9 },		// 129 bits per transform
			{ 15, 14, 8 },		// 129 bits per transform
			{ 15, 15, 7 },		// 129 bits per transform
			{ 15, 16, 6 },		// 129 bits per transform
			{ 15, 17, 5 },		// 129 bits per transform
			{ 16, 4, 17 },		// 129 bits per transform
			{ 16, 5, 16 },		// 129 bits per transform
			{ 16, 6, 15 },		// 129 bits per transform
			{ 16, 7, 14 },		// 129 bits per transform
			{ 16, 8, 13 },		// 129 bits per transform
			{ 16, 9, 12 },		// 129 bits per transform
			{ 16, 10, 11 },		// 129 bits per transform
			{ 16, 11, 10 },		// 129 bits per transform
			{ 16, 12, 9 },		// 129 bits per transform
			{ 16, 13, 8 },		// 129 bits per transform
			{ 16, 14, 7 },		// 129 bits per transform
			{ 16, 15, 6 },		// 129 bits per transform
			{ 16, 16, 5 },		// 129 bits per transform
			{ 16, 17, 4 },		// 129 bits per transform
			{ 17, 3, 17 },		// 129 bits per transform
			{ 17, 4, 16 },		// 129 bits per transform
			{ 17, 5, 15 },		// 129 bits per transform
			{ 17, 6, 14 },		// 129 bits per transform
			{ 17, 7, 13 },		// 129 bits per transform
			{ 17, 8, 12 },		// 129 bits per transform
			{ 17, 9, 11 },		// 129 bits per transform
			{ 17, 10, 10 },		// 129 bits per transform
			{ 17, 11, 9 },		// 129 bits per transform
			{ 17, 12, 8 },		// 129 bits per transform
			{ 17, 13, 7 },		// 129 bits per transform
			{ 17, 14, 6 },		// 129 bits per transform
			{ 17, 15, 5 },		// 129 bits per transform
			{ 17, 16, 4 },		// 129 bits per transform
			{ 17, 17, 3 },		// 129 bits per transform
			{ 18, 0, 9 },		// 129 bits per transform
			{ 18, 1, 6 },		// 129 bits per transform
			{ 18, 2, 5 },		// 129 bits per transform
			{ 18, 3, 4 },		// 129 bits per transform
			{ 18, 4, 3 },		// 129 bits per transform
			{ 18, 5, 2 },		// 129 bits per transform
			{ 18, 6, 1 },		// 129 bits per transform
			{ 18, 9, 0 },		// 129 bits per transform
			{ 0, 10, 18 },		// 132 bits per transform
			{ 0, 18, 10 },		// 132 bits per transform
			{ 1, 7, 18 },		// 132 bits per transform
			{ 1, 18, 7 },		// 132 bits per transform
			{ 2, 6, 18 },		// 132 bits per transform
			{ 2, 18, 6 },		// 132 bits per transform
			{ 3, 5, 18 },		// 132 bits per transform
			{ 3, 18, 5 },		// 132 bits per transform
			{ 4, 4, 18 },		// 132 bits per transform
			{ 4, 17, 17 },		// 132 bits per transform
			{ 4, 18, 4 },		// 132 bits per transform
			{ 5, 3, 18 },		// 132 bits per transform
			{ 5, 16, 17 },		// 132 bits per transform
			{ 5, 17, 16 },		// 132 bits per transform
			{ 5, 18, 3 },		// 132 bits per transform
			{ 6, 2, 18 },		// 132 bits per transform
			{ 6, 15, 17 },		// 132 bits per transform
			{ 6, 16, 16 },		// 132 bits per transform
			{ 6, 17, 15 },		// 132 bits per transform
			{ 6, 18, 2 },		// 132 bits per transform
			{ 7, 1, 18 },		// 132 bits per transform
			{ 7, 14, 17 },		// 132 bits per transform
			{ 7, 15, 16 },		// 132 bits per transform
			{ 7, 16, 15 },		// 132 bits per transform
			{ 7, 17, 14 },		// 132 bits per transform
			{ 7, 18, 1 },		// 132 bits per transform
			{ 8, 13, 17 },		// 132 bits per transform
			{ 8, 14, 16 },		// 132 bits per transform
			{ 8, 15, 15 },		// 132 bits per transform
			{ 8, 16, 14 },		// 132 bits per transform
			{ 8, 17, 13 },		// 132 bits per transform
			{ 9, 12, 17 },		// 132 bits per transform
			{ 9, 13, 16 },		// 132 bits per transform
			{ 9, 14, 15 },		// 132 bits per transform
			{ 9, 15, 14 },		// 132 bits per transform
			{ 9, 16, 13 },		// 132 bits per transform
			{ 9, 17, 12 },		// 132 bits per transform
			{ 10, 0, 18 },		// 132 bits per transform
			{ 10, 11, 17 },		// 132 bits per transform
			{ 10, 12, 16 },		// 132 bits per transform
			{ 10, 13, 15 },		// 132 bits per transform
			{ 10, 14, 14 },		// 132 bits per transform
			{ 10, 15, 13 },		// 132 bits per transform
			{ 10, 16, 12 },		// 132 bits per transform
			{ 10, 17, 11 },		// 132 bits per transform
			{ 10, 18, 0 },		// 132 bits per transform
			{ 11, 10, 17 },		// 132 bits per transform
			{ 11, 11, 16 },		// 132 bits per transform
			{ 11, 12, 15 },		// 132 bits per transform
			{ 11, 13, 14 },		// 132 bits per transform
			{ 11, 14, 13 },		// 132 bits per transform
			{ 11, 15, 12 },		// 132 bits per transform
			{ 11, 16, 11 },		// 132 bits per transform
			{ 11, 17, 10 },		// 132 bits per transform
			{ 12, 9, 17 },		// 132 bits per transform
			{ 12, 10, 16 },		// 132 bits per transform
			{ 12, 11, 15 },		// 132 bits per transform
			{ 12, 12, 14 },		// 132 bits per transform
			{ 12, 13, 13 },		// 132 bits per transform
			{ 12, 14, 12 },		// 132 bits per transform
			{ 12, 15, 11 },		// 132 bits per transform
			{ 12, 16, 10 },		// 132 bits per transform
			{ 12, 17, 9 },		// 132 bits per transform
			{ 13, 8, 17 },		// 132 bits per transform
			{ 13, 9, 16 },		// 132 bits per transform
			{ 13, 10, 15 },		// 132 bits per transform
			{ 13, 11, 14 },		// 132 bits per transform
			{ 13, 12, 13 },		// 132 bits per transform
			{ 13, 13, 12 },		// 132 bits per transform
			{ 13, 14, 11 },		// 132 bits per transform
			{ 13, 15, 10 },		// 132 bits per transform
			{ 13, 16, 9 },		// 132 bits per transform
			{ 13, 17, 8 },		// 132 bits per transform
			{ 14, 7, 17 },		// 132 bits per transform
			{ 14, 8, 16 },		// 132 bits per transform
			{ 14, 9, 15 },		// 132 bits per transform
			{ 14, 10, 14 },		// 132 bits per transform
			{ 14, 11, 13 },		// 132 bits per transform
			{ 14, 12, 12 },		// 132 bits per transform
			{ 14, 13, 11 },		// 132 bits per transform
			{ 14, 14, 10 },		// 132 bits per transform
			{ 14, 15, 9 },		// 132 bits per transform
			{ 14, 16, 8 },		// 132 bits per transform
			{ 14, 17, 7 },		// 132 bits per transform
			{ 15, 6, 17 },		// 132 bits per transform
			{ 15, 7, 16 },		// 132 bits per transform
			{ 15, 8, 15 },		// 132 bits per transform
			{ 15, 9, 14 },		// 132 bits per transform
			{ 15, 10, 13 },		// 132 bits per transform
			{ 15, 11, 12 },		// 132 bits per transform
			{ 15, 12, 11 },		// 132 bits per transform
			{ 15, 13, 10 },		// 132 bits per transform
			{ 15, 14, 9 },		// 132 bits per transform
			{ 15, 15, 8 },		// 132 bits per transform
			{ 15, 16, 7 },		// 132 bits per transform
			{ 15, 17, 6 },		// 132 bits per transform
			{ 16, 5, 17 },		// 132 bits per transform
			{ 16, 6, 16 },		// 132 bits per transform
			{ 16, 7, 15 },		// 132 bits per transform
			{ 16, 8, 14 },		// 132 bits per transform
			{ 16, 9, 13 },		// 132 bits per transform
			{ 16, 10, 12 },		// 132 bits per transform
			{ 16, 11, 11 },		// 132 bits per transform
			{ 16, 12, 10 },		// 132 bits per transform
			{ 16, 13, 9 },		// 132 bits per transform
			{ 16, 14, 8 },		// 132 bits per transform
			{ 16, 15, 7 },		// 132 bits per transform
			{ 16, 16, 6 },		// 132 bits per transform
			{ 16, 17, 5 },		// 132 bits per transform
			{ 17, 4, 17 },		// 132 bits per transform
			{ 17, 5, 16 },		// 132 bits per transform
			{ 17, 6, 15 },		// 132 bits per transform
			{ 17, 7, 14 },		// 132 bits per transform
			{ 17, 8, 13 },		// 132 bits per transform
			{ 17, 9, 12 },		// 132 bits per transform
			{ 17, 10, 11 },		// 132 bits per transform
			{ 17, 11, 10 },		// 132 bits per transform
			{ 17, 12, 9 },		// 132 bits per transform
			{ 17, 13, 8 },		// 132 bits per transform
			{ 17, 14, 7 },		// 132 bits per transform
			{ 17, 15, 6 },		// 132 bits per transform
			{ 17, 16, 5 },		// 132 bits per transform
			{ 17, 17, 4 },		// 132 bits per transform
			{ 18, 0, 10 },		// 132 bits per transform
			{ 18, 1, 7 },		// 132 bits per transform
			{ 18, 2, 6 },		// 132 bits per transform
			{ 18, 3, 5 },		// 132 bits per transform
			{ 18, 4, 4 },		// 132 bits per transform
			{ 18, 5, 3 },		// 132 bits per transform
			{ 18, 6, 2 },		// 132 bits per transform
			{ 18, 7, 1 },		// 132 bits per transform
			{ 18, 10, 0 },		// 132 bits per transform
			{ 0, 11, 18 },		// 135 bits per transform
			{ 0, 18, 11 },		// 135 bits per transform
			{ 1, 8, 18 },		// 135 bits per transform
			{ 1, 18, 8 },		// 135 bits per transform
			{ 2, 7, 18 },		// 135 bits per transform
			{ 2, 18, 7 },		// 135 bits per transform
			{ 3, 6, 18 },		// 135 bits per transform
			{ 3, 18, 6 },		// 135 bits per transform
			{ 4, 5, 18 },		// 135 bits per transform
			{ 4, 18, 5 },		// 135 bits per transform
			{ 5, 4, 18 },		// 135 bits per transform
			{ 5, 17, 17 },		// 135 bits per transform
			{ 5, 18, 4 },		// 135 bits per transform
			{ 6, 3, 18 },		// 135 bits per transform
			{ 6, 16, 17 },		// 135 bits per transform
			{ 6, 17, 16 },		// 135 bits per transform
			{ 6, 18, 3 },		// 135 bits per transform
			{ 7, 2, 18 },		// 135 bits per transform
			{ 7, 15, 17 },		// 135 bits per transform
			{ 7, 16, 16 },		// 135 bits per transform
			{ 7, 17, 15 },		// 135 bits per transform
			{ 7, 18, 2 },		// 135 bits per transform
			{ 8, 1, 18 },		// 135 bits per transform
			{ 8, 14, 17 },		// 135 bits per transform
			{ 8, 15, 16 },		// 135 bits per transform
			{ 8, 16, 15 },		// 135 bits per transform
			{ 8, 17, 14 },		// 135 bits per transform
			{ 8, 18, 1 },		// 135 bits per transform
			{ 9, 13, 17 },		// 135 bits per transform
			{ 9, 14, 16 },		// 135 bits per transform
			{ 9, 15, 15 },		// 135 bits per transform
			{ 9, 16, 14 },		// 135 bits per transform
			{ 9, 17, 13 },		// 135 bits per transform
			{ 10, 12, 17 },		// 135 bits per transform
			{ 10, 13, 16 },		// 135 bits per transform
			{ 10, 14, 15 },		// 135 bits per transform
			{ 10, 15, 14 },		// 135 bits per transform
			{ 10, 16, 13 },		// 135 bits per transform
			{ 10, 17, 12 },		// 135 bits per transform
			{ 11, 0, 18 },		// 135 bits per transform
			{ 11, 11, 17 },		// 135 bits per transform
			{ 11, 12, 16 },		// 135 bits per transform
			{ 11, 13, 15 },		// 135 bits per transform
			{ 11, 14, 14 },		// 135 bits per transform
			{ 11, 15, 13 },		// 135 bits per transform
			{ 11, 16, 12 },		// 135 bits per transform
			{ 11, 17, 11 },		// 135 bits per transform
			{ 11, 18, 0 },		// 135 bits per transform
			{ 12, 10, 17 },		// 135 bits per transform
			{ 12, 11, 16 },		// 135 bits per transform
			{ 12, 12, 15 },		// 135 bits per transform
			{ 12, 13, 14 },		// 135 bits per transform
			{ 12, 14, 13 },		// 135 bits per transform
			{ 12, 15, 12 },		// 135 bits per transform
			{ 12, 16, 11 },		// 135 bits per transform
			{ 12, 17, 10 },		// 135 bits per transform
			{ 13, 9, 17 },		// 135 bits per transform
			{ 13, 10, 16 },		// 135 bits per transform
			{ 13, 11, 15 },		// 135 bits per transform
			{ 13, 12, 14 },		// 135 bits per transform
			{ 13, 13, 13 },		// 135 bits per transform
			{ 13, 14, 12 },		// 135 bits per transform
			{ 13, 15, 11 },		// 135 bits per transform
			{ 13, 16, 10 },		// 135 bits per transform
			{ 13, 17, 9 },		// 135 bits per transform
			{ 14, 8, 17 },		// 135 bits per transform
			{ 14, 9, 16 },		// 135 bits per transform
			{ 14, 10, 15 },		// 135 bits per transform
			{ 14, 11, 14 },		// 135 bits per transform
			{ 14, 12, 13 },		// 135 bits per transform
			{ 14, 13, 12 },		// 135 bits per transform
			{ 14, 14, 11 },		// 135 bits per transform
			{ 14, 15, 10 },		// 135 bits per transform
			{ 14, 16, 9 },		// 135 bits per transform
			{ 14, 17, 8 },		// 135 bits per transform
			{ 15, 7, 17 },		// 135 bits per transform
			{ 15, 8, 16 },		// 135 bits per transform
			{ 15, 9, 15 },		// 135 bits per transform
			{ 15, 10, 14 },		// 135 bits per transform
			{ 15, 11, 13 },		// 135 bits per transform
			{ 15, 12, 12 },		// 135 bits per transform
			{ 15, 13, 11 },		// 135 bits per transform
			{ 15, 14, 10 },		// 135 bits per transform
			{ 15, 15, 9 },		// 135 bits per transform
			{ 15, 16, 8 },		// 135 bits per transform
			{ 15, 17, 7 },		// 135 bits per transform
			{ 16, 6, 17 },		// 135 bits per transform
			{ 16, 7, 16 },		// 135 bits per transform
			{ 16, 8, 15 },		// 135 bits per transform
			{ 16, 9, 14 },		// 135 bits per transform
			{ 16, 10, 13 },		// 135 bits per transform
			{ 16, 11, 12 },		// 135 bits per transform
			{ 16, 12, 11 },		// 135 bits per transform
			{ 16, 13, 10 },		// 135 bits per transform
			{ 16, 14, 9 },		// 135 bits per transform
			{ 16, 15, 8 },		// 135 bits per transform
			{ 16, 16, 7 },		// 135 bits per transform
			{ 16, 17, 6 },		// 135 bits per transform
			{ 17, 5, 17 },		// 135 bits per transform
			{ 17, 6, 16 },		// 135 bits per transform
			{ 17, 7, 15 },		// 135 bits per transform
			{ 17, 8, 14 },		// 135 bits per transform
			{ 17, 9, 13 },		// 135 bits per transform
			{ 17, 10, 12 },		// 135 bits per transform
			{ 17, 11, 11 },		// 135 bits per transform
			{ 17, 12, 10 },		// 135 bits per transform
			{ 17, 13, 9 },		// 135 bits per transform
			{ 17, 14, 8 },		// 135 bits per transform
			{ 17, 15, 7 },		// 135 bits per transform
			{ 17, 16, 6 },		// 135 bits per transform
			{ 17, 17, 5 },		// 135 bits per transform
			{ 18, 0, 11 },		// 135 bits per transform
			{ 18, 1, 8 },		// 135 bits per transform
			{ 18, 2, 7 },		// 135 bits per transform
			{ 18, 3, 6 },		// 135 bits per transform
			{ 18, 4, 5 },		// 135 bits per transform
			{ 18, 5, 4 },		// 135 bits per transform
			{ 18, 6, 3 },		// 135 bits per transform
			{ 18, 7, 2 },		// 135 bits per transform
			{ 18, 8, 1 },		// 135 bits per transform
			{ 18, 11, 0 },		// 135 bits per transform
			{ 0, 12, 18 },		// 138 bits per transform
			{ 0, 18, 12 },		// 138 bits per transform
			{ 1, 9, 18 },		// 138 bits per transform
			{ 1, 18, 9 },		// 138 bits per transform
			{ 2, 8, 18 },		// 138 bits per transform
			{ 2, 18, 8 },		// 138 bits per transform
			{ 3, 7, 18 },		// 138 bits per transform
			{ 3, 18, 7 },		// 138 bits per transform
			{ 4, 6, 18 },		// 138 bits per transform
			{ 4, 18, 6 },		// 138 bits per transform
			{ 5, 5, 18 },		// 138 bits per transform
			{ 5, 18, 5 },		// 138 bits per transform
			{ 6, 4, 18 },		// 138 bits per transform
			{ 6, 17, 17 },		// 138 bits per transform
			{ 6, 18, 4 },		// 138 bits per transform
			{ 7, 3, 18 },		// 138 bits per transform
			{ 7, 16, 17 },		// 138 bits per transform
			{ 7, 17, 16 },		// 138 bits per transform
			{ 7, 18, 3 },		// 138 bits per transform
			{ 8, 2, 18 },		// 138 bits per transform
			{ 8, 15, 17 },		// 138 bits per transform
			{ 8, 16, 16 },		// 138 bits per transform
			{ 8, 17, 15 },		// 138 bits per transform
			{ 8, 18, 2 },		// 138 bits per transform
			{ 9, 1, 18 },		// 138 bits per transform
			{ 9, 14, 17 },		// 138 bits per transform
			{ 9, 15, 16 },		// 138 bits per transform
			{ 9, 16, 15 },		// 138 bits per transform
			{ 9, 17, 14 },		// 138 bits per transform
			{ 9, 18, 1 },		// 138 bits per transform
			{ 10, 13, 17 },		// 138 bits per transform
			{ 10, 14, 16 },		// 138 bits per transform
			{ 10, 15, 15 },		// 138 bits per transform
			{ 10, 16, 14 },		// 138 bits per transform
			{ 10, 17, 13 },		// 138 bits per transform
			{ 11, 12, 17 },		// 138 bits per transform
			{ 11, 13, 16 },		// 138 bits per transform
			{ 11, 14, 15 },		// 138 bits per transform
			{ 11, 15, 14 },		// 138 bits per transform
			{ 11, 16, 13 },		// 138 bits per transform
			{ 11, 17, 12 },		// 138 bits per transform
			{ 12, 0, 18 },		// 138 bits per transform
			{ 12, 11, 17 },		// 138 bits per transform
			{ 12, 12, 16 },		// 138 bits per transform
			{ 12, 13, 15 },		// 138 bits per transform
			{ 12, 14, 14 },		// 138 bits per transform
			{ 12, 15, 13 },		// 138 bits per transform
			{ 12, 16, 12 },		// 138 bits per transform
			{ 12, 17, 11 },		// 138 bits per transform
			{ 12, 18, 0 },		// 138 bits per transform
			{ 13, 10, 17 },		// 138 bits per transform
			{ 13, 11, 16 },		// 138 bits per transform
			{ 13, 12, 15 },		// 138 bits per transform
			{ 13, 13, 14 },		// 138 bits per transform
			{ 13, 14, 13 },		// 138 bits per transform
			{ 13, 15, 12 },		// 138 bits per transform
			{ 13, 16, 11 },		// 138 bits per transform
			{ 13, 17, 10 },		// 138 bits per transform
			{ 14, 9, 17 },		// 138 bits per transform
			{ 14, 10, 16 },		// 138 bits per transform
			{ 14, 11, 15 },		// 138 bits per transform
			{ 14, 12, 14 },		// 138 bits per transform
			{ 14, 13, 13 },		// 138 bits per transform
			{ 14, 14, 12 },		// 138 bits per transform
			{ 14, 15, 11 },		// 138 bits per transform
			{ 14, 16, 10 },		// 138 bits per transform
			{ 14, 17, 9 },		// 138 bits per transform
			{ 15, 8, 17 },		// 138 bits per transform
			{ 15, 9, 16 },		// 138 bits per transform
			{ 15, 10, 15 },		// 138 bits per transform
			{ 15, 11, 14 },		// 138 bits per transform
			{ 15, 12, 13 },		// 138 bits per transform
			{ 15, 13, 12 },		// 138 bits per transform
			{ 15, 14, 11 },		// 138 bits per transform
			{ 15, 15, 10 },		// 138 bits per transform
			{ 15, 16, 9 },		// 138 bits per transform
			{ 15, 17, 8 },		// 138 bits per transform
			{ 16, 7, 17 },		// 138 bits per transform
			{ 16, 8, 16 },		// 138 bits per transform
			{ 16, 9, 15 },		// 138 bits per transform
			{ 16, 10, 14 },		// 138 bits per transform
			{ 16, 11, 13 },		// 138 bits per transform
			{ 16, 12, 12 },		// 138 bits per transform
			{ 16, 13, 11 },		// 138 bits per transform
			{ 16, 14, 10 },		// 138 bits per transform
			{ 16, 15, 9 },		// 138 bits per transform
			{ 16, 16, 8 },		// 138 bits per transform
			{ 16, 17, 7 },		// 138 bits per transform
			{ 17, 6, 17 },		// 138 bits per transform
			{ 17, 7, 16 },		// 138 bits per transform
			{ 17, 8, 15 },		// 138 bits per transform
			{ 17, 9, 14 },		// 138 bits per transform
			{ 17, 10, 13 },		// 138 bits per transform
			{ 17, 11, 12 },		// 138 bits per transform
			{ 17, 12, 11 },		// 138 bits per transform
			{ 17, 13, 10 },		// 138 bits per transform
			{ 17, 14, 9 },		// 138 bits per transform
			{ 17, 15, 8 },		// 138 bits per transform
			{ 17, 16, 7 },		// 138 bits per transform
			{ 17, 17, 6 },		// 138 bits per transform
			{ 18, 0, 12 },		// 138 bits per transform
			{ 18, 1, 9 },		// 138 bits per transform
			{ 18, 2, 8 },		// 138 bits per transform
			{ 18, 3, 7 },		// 138 bits per transform
			{ 18, 4, 6 },		// 138 bits per transform
			{ 18, 5, 5 },		// 138 bits per transform
			{ 18, 6, 4 },		// 138 bits per transform
			{ 18, 7, 3 },		// 138 bits per transform
			{ 18, 8, 2 },		// 138 bits per transform
			{ 18, 9, 1 },		// 138 bits per transform
			{ 18, 12, 0 },		// 138 bits per transform
			{ 0, 13, 18 },		// 141 bits per transform
			{ 0, 18, 13 },		// 141 bits per transform
			{ 1, 10, 18 },		// 141 bits per transform
			{ 1, 18, 10 },		// 141 bits per transform
			{ 2, 9, 18 },		// 141 bits per transform
			{ 2, 18, 9 },		// 141 bits per transform
			{ 3, 8, 18 },		// 141 bits per transform
			{ 3, 18, 8 },		// 141 bits per transform
			{ 4, 7, 18 },		// 141 bits per transform
			{ 4, 18, 7 },		// 141 bits per transform
			{ 5, 6, 18 },		// 141 bits per transform
			{ 5, 18, 6 },		// 141 bits per transform
			{ 6, 5, 18 },		// 141 bits per transform
			{ 6, 18, 5 },		// 141 bits per transform
			{ 7, 4, 18 },		// 141 bits per transform
			{ 7, 17, 17 },		// 141 bits per transform
			{ 7, 18, 4 },		// 141 bits per transform
			{ 8, 3, 18 },		// 141 bits per transform
			{ 8, 16, 17 },		// 141 bits per transform
			{ 8, 17, 16 },		// 141 bits per transform
			{ 8, 18, 3 },		// 141 bits per transform
			{ 9, 2, 18 },		// 141 bits per transform
			{ 9, 15, 17 },		// 141 bits per transform
			{ 9, 16, 16 },		// 141 bits per transform
			{ 9, 17, 15 },		// 141 bits per transform
			{ 9, 18, 2 },		// 141 bits per transform
			{ 10, 1, 18 },		// 141 bits per transform
			{ 10, 14, 17 },		// 141 bits per transform
			{ 10, 15, 16 },		// 141 bits per transform
			{ 10, 16, 15 },		// 141 bits per transform
			{ 10, 17, 14 },		// 141 bits per transform
			{ 10, 18, 1 },		// 141 bits per transform
			{ 11, 13, 17 },		// 141 bits per transform
			{ 11, 14, 16 },		// 141 bits per transform
			{ 11, 15, 15 },		// 141 bits per transform
			{ 11, 16, 14 },		// 141 bits per transform
			{ 11, 17, 13 },		// 141 bits per transform
			{ 12, 12, 17 },		// 141 bits per transform
			{ 12, 13, 16 },		// 141 bits per transform
			{ 12, 14, 15 },		// 141 bits per transform
			{ 12, 15, 14 },		// 141 bits per transform
			{ 12, 16, 13 },		// 141 bits per transform
			{ 12, 17, 12 },		// 141 bits per transform
			{ 13, 0, 18 },		// 141 bits per transform
			{ 13, 11, 17 },		// 141 bits per transform
			{ 13, 12, 16 },		// 141 bits per transform
			{ 13, 13, 15 },		// 141 bits per transform
			{ 13, 14, 14 },		// 141 bits per transform
			{ 13, 15, 13 },		// 141 bits per transform
			{ 13, 16, 12 },		// 141 bits per transform
			{ 13, 17, 11 },		// 141 bits per transform
			{ 13, 18, 0 },		// 141 bits per transform
			{ 14, 10, 17 },		// 141 bits per transform
			{ 14, 11, 16 },		// 141 bits per transform
			{ 14, 12, 15 },		// 141 bits per transform
			{ 14, 13, 14 },		// 141 bits per transform
			{ 14, 14, 13 },		// 141 bits per transform
			{ 14, 15, 12 },		// 141 bits per transform
			{ 14, 16, 11 },		// 141 bits per transform
			{ 14, 17, 10 },		// 141 bits per transform
			{ 15, 9, 17 },		// 141 bits per transform
			{ 15, 10, 16 },		// 141 bits per transform
			{ 15, 11, 15 },		// 141 bits per transform
			{ 15, 12, 14 },		// 141 bits per transform
			{ 15, 13, 13 },		// 141 bits per transform
			{ 15, 14, 12 },		// 141 bits per transform
			{ 15, 15, 11 },		// 141 bits per transform
			{ 15, 16, 10 },		// 141 bits per transform
			{ 15, 17, 9 },		// 141 bits per transform
			{ 16, 8, 17 },		// 141 bits per transform
			{ 16, 9, 16 },		// 141 bits per transform
			{ 16, 10, 15 },		// 141 bits per transform
			{ 16, 11, 14 },		// 141 bits per transform
			{ 16, 12, 13 },		// 141 bits per transform
			{ 16, 13, 12 },		// 141 bits per transform
			{ 16, 14, 11 },		// 141 bits per transform
			{ 16, 15, 10 },		// 141 bits per transform
			{ 16, 16, 9 },		// 141 bits per transform
			{ 16, 17, 8 },		// 141 bits per transform
			{ 17, 7, 17 },		// 141 bits per transform
			{ 17, 8, 16 },		// 141 bits per transform
			{ 17, 9, 15 },		// 141 bits per transform
			{ 17, 10, 14 },		// 141 bits per transform
			{ 17, 11, 13 },		// 141 bits per transform
			{ 17, 12, 12 },		// 141 bits per transform
			{ 17, 13, 11 },		// 141 bits per transform
			{ 17, 14, 10 },		// 141 bits per transform
			{ 17, 15, 9 },		// 141 bits per transform
			{ 17, 16, 8 },		// 141 bits per transform
			{ 17, 17, 7 },		// 141 bits per transform
			{ 18, 0, 13 },		// 141 bits per transform
			{ 18, 1, 10 },		// 141 bits per transform
			{ 18, 2, 9 },		// 141 bits per transform
			{ 18, 3, 8 },		// 141 bits per transform
			{ 18, 4, 7 },		// 141 bits per transform
			{ 18, 5, 6 },		// 141 bits per transform
			{ 18, 6, 5 },		// 141 bits per transform
			{ 18, 7, 4 },		// 141 bits per transform
			{ 18, 8, 3 },		// 141 bits per transform
			{ 18, 9, 2 },		// 141 bits per transform
			{ 18, 10, 1 },		// 141 bits per transform
			{ 18, 13, 0 },		// 141 bits per transform
			{ 0, 14, 18 },		// 144 bits per transform
			{ 0, 18, 14 },		// 144 bits per transform
			{ 1, 11, 18 },		// 144 bits per transform
			{ 1, 18, 11 },		// 144 bits per transform
			{ 2, 10, 18 },		// 144 bits per transform
			{ 2, 18, 10 },		// 144 bits per transform
			{ 3, 9, 18 },		// 144 bits per transform
			{ 3, 18, 9 },		// 144 bits per transform
			{ 4, 8, 18 },		// 144 bits per transform
			{ 4, 18, 8 },		// 144 bits per transform
			{ 5, 7, 18 },		// 144 bits per transform
			{ 5, 18, 7 },		// 144 bits per transform
			{ 6, 6, 18 },		// 144 bits per transform
			{ 6, 18, 6 },		// 144 bits per transform
			{ 7, 5, 18 },		// 144 bits per transform
			{ 7, 18, 5 },		// 144 bits per transform
			{ 8, 4, 18 },		// 144 bits per transform
			{ 8, 17, 17 },		// 144 bits per transform
			{ 8, 18, 4 },		// 144 bits per transform
			{ 9, 3, 18 },		// 144 bits per transform
			{ 9, 16, 17 },		// 144 bits per transform
			{ 9, 17, 16 },		// 144 bits per transform
			{ 9, 18, 3 },		// 144 bits per transform
			{ 10, 2, 18 },		// 144 bits per transform
			{ 10, 15, 17 },		// 144 bits per transform
			{ 10, 16, 16 },		// 144 bits per transform
			{ 10, 17, 15 },		// 144 bits per transform
			{ 10, 18, 2 },		// 144 bits per transform
			{ 11, 1, 18 },		// 144 bits per transform
			{ 11, 14, 17 },		// 144 bits per transform
			{ 11, 15, 16 },		// 144 bits per transform
			{ 11, 16, 15 },		// 144 bits per transform
			{ 11, 17, 14 },		// 144 bits per transform
			{ 11, 18, 1 },		// 144 bits per transform
			{ 12, 13, 17 },		// 144 bits per transform
			{ 12, 14, 16 },		// 144 bits per transform
			{ 12, 15, 15 },		// 144 bits per transform
			{ 12, 16, 14 },		// 144 bits per transform
			{ 12, 17, 13 },		// 144 bits per transform
			{ 13, 12, 17 },		// 144 bits per transform
			{ 13, 13, 16 },		// 144 bits per transform
			{ 13, 14, 15 },		// 144 bits per transform
			{ 13, 15, 14 },		// 144 bits per transform
			{ 13, 16, 13 },		// 144 bits per transform
			{ 13, 17, 12 },		// 144 bits per transform
			{ 14, 0, 18 },		// 144 bits per transform
			{ 14, 11, 17 },		// 144 bits per transform
			{ 14, 12, 16 },		// 144 bits per transform
			{ 14, 13, 15 },		// 144 bits per transform
			{ 14, 14, 14 },		// 144 bits per transform
			{ 14, 15, 13 },		// 144 bits per transform
			{ 14, 16, 12 },		// 144 bits per transform
			{ 14, 17, 11 },		// 144 bits per transform
			{ 14, 18, 0 },		// 144 bits per transform
			{ 15, 10, 17 },		// 144 bits per transform
			{ 15, 11, 16 },		// 144 bits per transform
			{ 15, 12, 15 },		// 144 bits per transform
			{ 15, 13, 14 },		// 144 bits per transform
			{ 15, 14, 13 },		// 144 bits per transform
			{ 15, 15, 12 },		// 144 bits per transform
			{ 15, 16, 11 },		// 144 bits per transform
			{ 15, 17, 10 },		// 144 bits per transform
			{ 16, 9, 17 },		// 144 bits per transform
			{ 16, 10, 16 },		// 144 bits per transform
			{ 16, 11, 15 },		// 144 bits per transform
			{ 16, 12, 14 },		// 144 bits per transform
			{ 16, 13, 13 },		// 144 bits per transform
			{ 16, 14, 12 },		// 144 bits per transform
			{ 16, 15, 11 },		// 144 bits per transform
			{ 16, 16, 10 },		// 144 bits per transform
			{ 16, 17, 9 },		// 144 bits per transform
			{ 17, 8, 17 },		// 144 bits per transform
			{ 17, 9, 16 },		// 144 bits per transform
			{ 17, 10, 15 },		// 144 bits per transform
			{ 17, 11, 14 },		// 144 bits per transform
			{ 17, 12, 13 },		// 144 bits per transform
			{ 17, 13, 12 },		// 144 bits per transform
			{ 17, 14, 11 },		// 144 bits per transform
			{ 17, 15, 10 },		// 144 bits per transform
			{ 17, 16, 9 },		// 144 bits per transform
			{ 17, 17, 8 },		// 144 bits per transform
			{ 18, 0, 14 },		// 144 bits per transform
			{ 18, 1, 11 },		// 144 bits per transform
			{ 18, 2, 10 },		// 144 bits per transform
			{ 18, 3, 9 },		// 144 bits per transform
			{ 18, 4, 8 },		// 144 bits per transform
			{ 18, 5, 7 },		// 144 bits per transform
			{ 18, 6, 6 },		// 144 bits per transform
			{ 18, 7, 5 },		// 144 bits per transform
			{ 18, 8, 4 },		// 144 bits per transform
			{ 18, 9, 3 },		// 144 bits per transform
			{ 18, 10, 2 },		// 144 bits per transform
			{ 18, 11, 1 },		// 144 bits per transform
			{ 18, 14, 0 },		// 144 bits per transform
			{ 0, 15, 18 },		// 147 bits per transform
			{ 0, 18, 15 },		// 147 bits per transform
			{ 1, 12, 18 },		// 147 bits per transform
			{ 1, 18, 12 },		// 147 bits per transform
			{ 2, 11, 18 },		// 147 bits per transform
			{ 2, 18, 11 },		// 147 bits per transform
			{ 3, 10, 18 },		// 147 bits per transform
			{ 3, 18, 10 },		// 147 bits per transform
			{ 4, 9, 18 },		// 147 bits per transform
			{ 4, 18, 9 },		// 147 bits per transform
			{ 5, 8, 18 },		// 147 bits per transform
			{ 5, 18, 8 },		// 147 bits per transform
			{ 6, 7, 18 },		// 147 bits per transform
			{ 6, 18, 7 },		// 147 bits per transform
			{ 7, 6, 18 },		// 147 bits per transform
			{ 7, 18, 6 },		// 147 bits per transform
			{ 8, 5, 18 },		// 147 bits per transform
			{ 8, 18, 5 },		// 147 bits per transform
			{ 9, 4, 18 },		// 147 bits per transform
			{ 9, 17, 17 },		// 147 bits per transform
			{ 9, 18, 4 },		// 147 bits per transform
			{ 10, 3, 18 },		// 147 bits per transform
			{ 10, 16, 17 },		// 147 bits per transform
			{ 10, 17, 16 },		// 147 bits per transform
			{ 10, 18, 3 },		// 147 bits per transform
			{ 11, 2, 18 },		// 147 bits per transform
			{ 11, 15, 17 },		// 147 bits per transform
			{ 11, 16, 16 },		// 147 bits per transform
			{ 11, 17, 15 },		// 147 bits per transform
			{ 11, 18, 2 },		// 147 bits per transform
			{ 12, 1, 18 },		// 147 bits per transform
			{ 12, 14, 17 },		// 147 bits per transform
			{ 12, 15, 16 },		// 147 bits per transform
			{ 12, 16, 15 },		// 147 bits per transform
			{ 12, 17, 14 },		// 147 bits per transform
			{ 12, 18, 1 },		// 147 bits per transform
			{ 13, 13, 17 },		// 147 bits per transform
			{ 13, 14, 16 },		// 147 bits per transform
			{ 13, 15, 15 },		// 147 bits per transform
			{ 13, 16, 14 },		// 147 bits per transform
			{ 13, 17, 13 },		// 147 bits per transform
			{ 14, 12, 17 },		// 147 bits per transform
			{ 14, 13, 16 },		// 147 bits per transform
			{ 14, 14, 15 },		// 147 bits per transform
			{ 14, 15, 14 },		// 147 bits per transform
			{ 14, 16, 13 },		// 147 bits per transform
			{ 14, 17, 12 },		// 147 bits per transform
			{ 15, 0, 18 },		// 147 bits per transform
			{ 15, 11, 17 },		// 147 bits per transform
			{ 15, 12, 16 },		// 147 bits per transform
			{ 15, 13, 15 },		// 147 bits per transform
			{ 15, 14, 14 },		// 147 bits per transform
			{ 15, 15, 13 },		// 147 bits per transform
			{ 15, 16, 12 },		// 147 bits per transform
			{ 15, 17, 11 },		// 147 bits per transform
			{ 15, 18, 0 },		// 147 bits per transform
			{ 16, 10, 17 },		// 147 bits per transform
			{ 16, 11, 16 },		// 147 bits per transform
			{ 16, 12, 15 },		// 147 bits per transform
			{ 16, 13, 14 },		// 147 bits per transform
			{ 16, 14, 13 },		// 147 bits per transform
			{ 16, 15, 12 },		// 147 bits per transform
			{ 16, 16, 11 },		// 147 bits per transform
			{ 16, 17, 10 },		// 147 bits per transform
			{ 17, 9, 17 },		// 147 bits per transform
			{ 17, 10, 16 },		// 147 bits per transform
			{ 17, 11, 15 },		// 147 bits per transform
			{ 17, 12, 14 },		// 147 bits per transform
			{ 17, 13, 13 },		// 147 bits per transform
			{ 17, 14, 12 },		// 147 bits per transform
			{ 17, 15, 11 },		// 147 bits per transform
			{ 17, 16, 10 },		// 147 bits per transform
			{ 17, 17, 9 },		// 147 bits per transform
			{ 18, 0, 15 },		// 147 bits per transform
			{ 18, 1, 12 },		// 147 bits per transform
			{ 18, 2, 11 },		// 147 bits per transform
			{ 18, 3, 10 },		// 147 bits per transform
			{ 18, 4, 9 },		// 147 bits per transform
			{ 18, 5, 8 },		// 147 bits per transform
			{ 18, 6, 7 },		// 147 bits per transform
			{ 18, 7, 6 },		// 147 bits per transform
			{ 18, 8, 5 },		// 147 bits per transform
			{ 18, 9, 4 },		// 147 bits per transform
			{ 18, 10, 3 },		// 147 bits per transform
			{ 18, 11, 2 },		// 147 bits per transform
			{ 18, 12, 1 },		// 147 bits per transform
			{ 18, 15, 0 },		// 147 bits per transform
			{ 0, 16, 18 },		// 150 bits per transform
			{ 0, 18, 16 },		// 150 bits per transform
			{ 1, 13, 18 },		// 150 bits per transform
			{ 1, 18, 13 },		// 150 bits per transform
			{ 2, 12, 18 },		// 150 bits per transform
			{ 2, 18, 12 },		// 150 bits per transform
			{ 3, 11, 18 },		// 150 bits per transform
			{ 3, 18, 11 },		// 150 bits per transform
			{ 4, 10, 18 },		// 150 bits per transform
			{ 4, 18, 10 },		// 150 bits per transform
			{ 5, 9, 18 },		// 150 bits per transform
			{ 5, 18, 9 },		// 150 bits per transform
			{ 6, 8, 18 },		// 150 bits per transform
			{ 6, 18, 8 },		// 150 bits per transform
			{ 7, 7, 18 },		// 150 bits per transform
			{ 7, 18, 7 },		// 150 bits per transform
			{ 8, 6, 18 },		// 150 bits per transform
			{ 8, 18, 6 },		// 150 bits per transform
			{ 9, 5, 18 },		// 150 bits per transform
			{ 9, 18, 5 },		// 150 bits per transform
			{ 10, 4, 18 },		// 150 bits per transform
			{ 10, 17, 17 },		// 150 bits per transform
			{ 10, 18, 4 },		// 150 bits per transform
			{ 11, 3, 18 },		// 150 bits per transform
			{ 11, 16, 17 },		// 150 bits per transform
			{ 11, 17, 16 },		// 150 bits per transform
			{ 11, 18, 3 },		// 150 bits per transform
			{ 12, 2, 18 },		// 150 bits per transform
			{ 12, 15, 17 },		// 150 bits per transform
			{ 12, 16, 16 },		// 150 bits per transform
			{ 12, 17, 15 },		// 150 bits per transform
			{ 12, 18, 2 },		// 150 bits per transform
			{ 13, 1, 18 },		// 150 bits per transform
			{ 13, 14, 17 },		// 150 bits per transform
			{ 13, 15, 16 },		// 150 bits per transform
			{ 13, 16, 15 },		// 150 bits per transform
			{ 13, 17, 14 },		// 150 bits per transform
			{ 13, 18, 1 },		// 150 bits per transform
			{ 14, 13, 17 },		// 150 bits per transform
			{ 14, 14, 16 },		// 150 bits per transform
			{ 14, 15, 15 },		// 150 bits per transform
			{ 14, 16, 14 },		// 150 bits per transform
			{ 14, 17, 13 },		// 150 bits per transform
			{ 15, 12, 17 },		// 150 bits per transform
			{ 15, 13, 16 },		// 150 bits per transform
			{ 15, 14, 15 },		// 150 bits per transform
			{ 15, 15, 14 },		// 150 bits per transform
			{ 15, 16, 13 },		// 150 bits per transform
			{ 15, 17, 12 },		// 150 bits per transform
			{ 16, 0, 18 },		// 150 bits per transform
			{ 16, 11, 17 },		// 150 bits per transform
			{ 16, 12, 16 },		// 150 bits per transform
			{ 16, 13, 15 },		// 150 bits per transform
			{ 16, 14, 14 },		// 150 bits per transform
			{ 16, 15, 13 },		// 150 bits per transform
			{ 16, 16, 12 },		// 150 bits per transform
			{ 16, 17, 11 },		// 150 bits per transform
			{ 16, 18, 0 },		// 150 bits per transform
			{ 17, 10, 17 },		// 150 bits per transform
			{ 17, 11, 16 },		// 150 bits per transform
			{ 17, 12, 15 },		// 150 bits per transform
			{ 17, 13, 14 },		// 150 bits per transform
			{ 17, 14, 13 },		// 150 bits per transform
			{ 17, 15, 12 },		// 150 bits per transform
			{ 17, 16, 11 },		// 150 bits per transform
			{ 17, 17, 10 },		// 150 bits per transform
			{ 18, 0, 16 },		// 150 bits per transform
			{ 18, 1, 13 },		// 150 bits per transform
			{ 18, 2, 12 },		// 150 bits per transform
			{ 18, 3, 11 },		// 150 bits per transform
			{ 18, 4, 10 },		// 150 bits per transform
			{ 18, 5, 9 },		// 150 bits per transform
			{ 18, 6, 8 },		// 150 bits per transform
			{ 18, 7, 7 },		// 150 bits per transform
			{ 18, 8, 6 },		// 150 bits per transform
			{ 18, 9, 5 },		// 150 bits per transform
			{ 18, 10, 4 },		// 150 bits per transform
			{ 18, 11, 3 },		// 150 bits per transform
			{ 18, 12, 2 },		// 150 bits per transform
			{ 18, 13, 1 },		// 150 bits per transform
			{ 18, 16, 0 },		// 150 bits per transform
			{ 0, 17, 18 },		// 153 bits per transform
			{ 0, 18, 17 },		// 153 bits per transform
			{ 1, 14, 18 },		// 153 bits per transform
			{ 1, 18, 14 },		// 153 bits per transform
			{ 2, 13, 18 },		// 153 bits per transform
			{ 2, 18, 13 },		// 153 bits per transform
			{ 3, 12, 18 },		// 153 bits per transform
			{ 3, 18, 12 },		// 153 bits per transform
			{ 4, 11, 18 },		// 153 bits per transform
			{ 4, 18, 11 },		// 153 bits per transform
			{ 5, 10, 18 },		// 153 bits per transform
			{ 5, 18, 10 },		// 153 bits per transform
			{ 6, 9, 18 },		// 153 bits per transform
			{ 6, 18, 9 },		// 153 bits per transform
			{ 7, 8, 18 },		// 153 bits per transform
			{ 7, 18, 8 },		// 153 bits per transform
			{ 8, 7, 18 },		// 153 bits per transform
			{ 8, 18, 7 },		// 153 bits per transform
			{ 9, 6, 18 },		// 153 bits per transform
			{ 9, 18, 6 },		// 153 bits per transform
			{ 10, 5, 18 },		// 153 bits per transform
			{ 10, 18, 5 },		// 153 bits per transform
			{ 11, 4, 18 },		// 153 bits per transform
			{ 11, 17, 17 },		// 153 bits per transform
			{ 11, 18, 4 },		// 153 bits per transform
			{ 12, 3, 18 },		// 153 bits per transform
			{ 12, 16, 17 },		// 153 bits per transform
			{ 12, 17, 16 },		// 153 bits per transform
			{ 12, 18, 3 },		// 153 bits per transform
			{ 13, 2, 18 },		// 153 bits per transform
			{ 13, 15, 17 },		// 153 bits per transform
			{ 13, 16, 16 },		// 153 bits per transform
			{ 13, 17, 15 },		// 153 bits per transform
			{ 13, 18, 2 },		// 153 bits per transform
			{ 14, 1, 18 },		// 153 bits per transform
			{ 14, 14, 17 },		// 153 bits per transform
			{ 14, 15, 16 },		// 153 bits per transform
			{ 14, 16, 15 },		// 153 bits per transform
			{ 14, 17, 14 },		// 153 bits per transform
			{ 14, 18, 1 },		// 153 bits per transform
			{ 15, 13, 17 },		// 153 bits per transform
			{ 15, 14, 16 },		// 153 bits per transform
			{ 15, 15, 15 },		// 153 bits per transform
			{ 15, 16, 14 },		// 153 bits per transform
			{ 15, 17, 13 },		// 153 bits per transform
			{ 16, 12, 17 },		// 153 bits per transform
			{ 16, 13, 16 },		// 153 bits per transform
			{ 16, 14, 15 },		// 153 bits per transform
			{ 16, 15, 14 },		// 153 bits per transform
			{ 16, 16, 13 },		// 153 bits per transform
			{ 16, 17, 12 },		// 153 bits per transform
			{ 17, 0, 18 },		// 153 bits per transform
			{ 17, 11, 17 },		// 153 bits per transform
			{ 17, 12, 16 },		// 153 bits per transform
			{ 17, 13, 15 },		// 153 bits per transform
			{ 17, 14, 14 },		// 153 bits per transform
			{ 17, 15, 13 },		// 153 bits per transform
			{ 17, 16, 12 },		// 153 bits per transform
			{ 17, 17, 11 },		// 153 bits per transform
			{ 17, 18, 0 },		// 153 bits per transform
			{ 18, 0, 17 },		// 153 bits per transform
			{ 18, 1, 14 },		// 153 bits per transform
			{ 18, 2, 13 },		// 153 bits per transform
			{ 18, 3, 12 },		// 153 bits per transform
			{ 18, 4, 11 },		// 153 bits per transform
			{ 18, 5, 10 },		// 153 bits per transform
			{ 18, 6, 9 },		// 153 bits per transform
			{ 18, 7, 8 },		// 153 bits per transform
			{ 18, 8, 7 },		// 153 bits per transform
			{ 18, 9, 6 },		// 153 bits per transform
			{ 18, 10, 5 },		// 153 bits per transform
			{ 18, 11, 4 },		// 153 bits per transform
			{ 18, 12, 3 },		// 153 bits per transform
			{ 18, 13, 2 },		// 153 bits per transform
			{ 18, 14, 1 },		// 153 bits per transform
			{ 18, 17, 0 },		// 153 bits per transform
			{ 1, 15, 18 },		// 156 bits per transform
			{ 1, 18, 15 },		// 156 bits per transform
			{ 2, 14, 18 },		// 156 bits per transform
			{ 2, 18, 14 },		// 156 bits per transform
			{ 3, 13, 18 },		// 156 bits per transform
			{ 3, 18, 13 },		// 156 bits per transform
			{ 4, 12, 18 },		// 156 bits per transform
			{ 4, 18, 12 },		// 156 bits per transform
			{ 5, 11, 18 },		// 156 bits per transform
			{ 5, 18, 11 },		// 156 bits per transform
			{ 6, 10, 18 },		// 156 bits per transform
			{ 6, 18, 10 },		// 156 bits per transform
			{ 7, 9, 18 },		// 156 bits per transform
			{ 7, 18, 9 },		// 156 bits per transform
			{ 8, 8, 18 },		// 156 bits per transform
			{ 8, 18, 8 },		// 156 bits per transform
			{ 9, 7, 18 },		// 156 bits per transform
			{ 9, 18, 7 },		// 156 bits per transform
			{ 10, 6, 18 },		// 156 bits per transform
			{ 10, 18, 6 },		// 156 bits per transform
			{ 11, 5, 18 },		// 156 bits per transform
			{ 11, 18, 5 },		// 156 bits per transform
			{ 12, 4, 18 },		// 156 bits per transform
			{ 12, 17, 17 },		// 156 bits per transform
			{ 12, 18, 4 },		// 156 bits per transform
			{ 13, 3, 18 },		// 156 bits per transform
			{ 13, 16, 17 },		// 156 bits per transform
			{ 13, 17, 16 },		// 156 bits per transform
			{ 13, 18, 3 },		// 156 bits per transform
			{ 14, 2, 18 },		// 156 bits per transform
			{ 14, 15, 17 },		// 156 bits per transform
			{ 14, 16, 16 },		// 156 bits per transform
			{ 14, 17, 15 },		// 156 bits per transform
			{ 14, 18, 2 },		// 156 bits per transform
			{ 15, 1, 18 },		// 156 bits per transform
			{ 15, 14, 17 },		// 156 bits per transform
			{ 15, 15, 16 },		// 156 bits per transform
			{ 15, 16, 15 },		// 156 bits per transform
			{ 15, 17, 14 },		// 156 bits per transform
			{ 15, 18, 1 },		// 156 bits per transform
			{ 16, 13, 17 },		// 156 bits per transform
			{ 16, 14, 16 },		// 156 bits per transform
			{ 16, 15, 15 },		// 156 bits per transform
			{ 16, 16, 14 },		// 156 bits per transform
			{ 16, 17, 13 },		// 156 bits per transform
			{ 17, 12, 17 },		// 156 bits per transform
			{ 17, 13, 16 },		// 156 bits per transform
			{ 17, 14, 15 },		// 156 bits per transform
			{ 17, 15, 14 },		// 156 bits per transform
			{ 17, 16, 13 },		// 156 bits per transform
			{ 17, 17, 12 },		// 156 bits per transform
			{ 18, 1, 15 },		// 156 bits per transform
			{ 18, 2, 14 },		// 156 bits per transform
			{ 18, 3, 13 },		// 156 bits per transform
			{ 18, 4, 12 },		// 156 bits per transform
			{ 18, 5, 11 },		// 156 bits per transform
			{ 18, 6, 10 },		// 156 bits per transform
			{ 18, 7, 9 },		// 156 bits per transform
			{ 18, 8, 8 },		// 156 bits per transform
			{ 18, 9, 7 },		// 156 bits per transform
			{ 18, 10, 6 },		// 156 bits per transform
			{ 18, 11, 5 },		// 156 bits per transform
			{ 18, 12, 4 },		// 156 bits per transform
			{ 18, 13, 3 },		// 156 bits per transform
			{ 18, 14, 2 },		// 156 bits per transform
			{ 18, 15, 1 },		// 156 bits per transform
			{ 1, 16, 18 },		// 159 bits per transform
			{ 1, 18, 16 },		// 159 bits per transform
			{ 2, 15, 18 },		// 159 bits per transform
			{ 2, 18, 15 },		// 159 bits per transform
			{ 3, 14, 18 },		// 159 bits per transform
			{ 3, 18, 14 },		// 159 bits per transform
			{ 4, 13, 18 },		// 159 bits per transform
			{ 4, 18, 13 },		// 159 bits per transform
			{ 5, 12, 18 },		// 159 bits per transform
			{ 5, 18, 12 },		// 159 bits per transform
			{ 6, 11, 18 },		// 159 bits per transform
			{ 6, 18, 11 },		// 159 bits per transform
			{ 7, 10, 18 },		// 159 bits per transform
			{ 7, 18, 10 },		// 159 bits per transform
			{ 8, 9, 18 },		// 159 bits per transform
			{ 8, 18, 9 },		// 159 bits per transform
			{ 9, 8, 18 },		// 159 bits per transform
			{ 9, 18, 8 },		// 159 bits per transform
			{ 10, 7, 18 },		// 159 bits per transform
			{ 10, 18, 7 },		// 159 bits per transform
			{ 11, 6, 18 },		// 159 bits per transform
			{ 11, 18, 6 },		// 159 bits per transform
			{ 12, 5, 18 },		// 159 bits per transform
			{ 12, 18, 5 },		// 159 bits per transform
			{ 13, 4, 18 },		// 159 bits per transform
			{ 13, 17, 17 },		// 159 bits per transform
			{ 13, 18, 4 },		// 159 bits per transform
			{ 14, 3, 18 },		// 159 bits per transform
			{ 14, 16, 17 },		// 159 bits per transform
			{ 14, 17, 16 },		// 159 bits per transform
			{ 14, 18, 3 },		// 159 bits per transform
			{ 15, 2, 18 },		// 159 bits per transform
			{ 15, 15, 17 },		// 159 bits per transform
			{ 15, 16, 16 },		// 159 bits per transform
			{ 15, 17, 15 },		// 159 bits per transform
			{ 15, 18, 2 },		// 159 bits per transform
			{ 16, 1, 18 },		// 159 bits per transform
			{ 16, 14, 17 },		// 159 bits per transform
			{ 16, 15, 16 },		// 159 bits per transform
			{ 16, 16, 15 },		// 159 bits per transform
			{ 16, 17, 14 },		// 159 bits per transform
			{ 16, 18, 1 },		// 159 bits per transform
			{ 17, 13, 17 },		// 159 bits per transform
			{ 17, 14, 16 },		// 159 bits per transform
			{ 17, 15, 15 },		// 159 bits per transform
			{ 17, 16, 14 },		// 159 bits per transform
			{ 17, 17, 13 },		// 159 bits per transform
			{ 18, 1, 16 },		// 159 bits per transform
			{ 18, 2, 15 },		// 159 bits per transform
			{ 18, 3, 14 },		// 159 bits per transform
			{ 18, 4, 13 },		// 159 bits per transform
			{ 18, 5, 12 },		// 159 bits per transform
			{ 18, 6, 11 },		// 159 bits per transform
			{ 18, 7, 10 },		// 159 bits per transform
			{ 18, 8, 9 },		// 159 bits per transform
			{ 18, 9, 8 },		// 159 bits per transform
			{ 18, 10, 7 },		// 159 bits per transform
			{ 18, 11, 6 },		// 159 bits per transform
			{ 18, 12, 5 },		// 159 bits per transform
			{ 18, 13, 4 },		// 159 bits per transform
			{ 18, 14, 3 },		// 159 bits per transform
			{ 18, 15, 2 },		// 159 bits per transform
			{ 18, 16, 1 },		// 159 bits per transform
			{ 1, 17, 18 },		// 162 bits per transform
			{ 1, 18, 17 },		// 162 bits per transform
			{ 2, 16, 18 },		// 162 bits per transform
			{ 2, 18, 16 },		// 162 bits per transform
			{ 3, 15, 18 },		// 162 bits per transform
			{ 3, 18, 15 },		// 162 bits per transform
			{ 4, 14, 18 },		// 162 bits per transform
			{ 4, 18, 14 },		// 162 bits per transform
			{ 5, 13, 18 },		// 162 bits per transform
			{ 5, 18, 13 },		// 162 bits per transform
			{ 6, 12, 18 },		// 162 bits per transform
			{ 6, 18, 12 },		// 162 bits per transform
			{ 7, 11, 18 },		// 162 bits per transform
			{ 7, 18, 11 },		// 162 bits per transform
			{ 8, 10, 18 },		// 162 bits per transform
			{ 8, 18, 10 },		// 162 bits per transform
			{ 9, 9, 18 },		// 162 bits per transform
			{ 9, 18, 9 },		// 162 bits per transform
			{ 10, 8, 18 },		// 162 bits per transform
			{ 10, 18, 8 },		// 162 bits per transform
			{ 11, 7, 18 },		// 162 bits per transform
			{ 11, 18, 7 },		// 162 bits per transform
			{ 12, 6, 18 },		// 162 bits per transform
			{ 12, 18, 6 },		// 162 bits per transform
			{ 13, 5, 18 },		// 162 bits per transform
			{ 13, 18, 5 },		// 162 bits per transform
			{ 14, 4, 18 },		// 162 bits per transform
			{ 14, 17, 17 },		// 162 bits per transform
			{ 14, 18, 4 },		// 162 bits per transform
			{ 15, 3, 18 },		// 162 bits per transform
			{ 15, 16, 17 },		// 162 bits per transform
			{ 15, 17, 16 },		// 162 bits per transform
			{ 15, 18, 3 },		// 162 bits per transform
			{ 16, 2, 18 },		// 162 bits per transform
			{ 16, 15, 17 },		// 162 bits per transform
			{ 16, 16, 16 },		// 162 bits per transform
			{ 16, 17, 15 },		// 162 bits per transform
			{ 16, 18, 2 },		// 162 bits per transform
			{ 17, 1, 18 },		// 162 bits per transform
			{ 17, 14, 17 },		// 162 bits per transform
			{ 17, 15, 16 },		// 162 bits per transform
			{ 17, 16, 15 },		// 162 bits per transform
			{ 17, 17, 14 },		// 162 bits per transform
			{ 17, 18, 1 },		// 162 bits per transform
			{ 18, 1, 17 },		// 162 bits per transform
			{ 18, 2, 16 },		// 162 bits per transform
			{ 18, 3, 15 },		// 162 bits per transform
			{ 18, 4, 14 },		// 162 bits per transform
			{ 18, 5, 13 },		// 162 bits per transform
			{ 18, 6, 12 },		// 162 bits per transform
			{ 18, 7, 11 },		// 162 bits per transform
			{ 18, 8, 10 },		// 162 bits per transform
			{ 18, 9, 9 },		// 162 bits per transform
			{ 18, 10, 8 },		// 162 bits per transform
			{ 18, 11, 7 },		// 162 bits per transform
			{ 18, 12, 6 },		// 162 bits per transform
			{ 18, 13, 5 },		// 162 bits per transform
			{ 18, 14, 4 },		// 162 bits per transform
			{ 18, 15, 3 },		// 162 bits per transform
			{ 18, 16, 2 },		// 162 bits per transform
			{ 18, 17, 1 },		// 162 bits per transform
			{ 2, 17, 18 },		// 165 bits per transform
			{ 2, 18, 17 },		// 165 bits per transform
			{ 3, 16, 18 },		// 165 bits per transform
			{ 3, 18, 16 },		// 165 bits per transform
			{ 4, 15, 18 },		// 165 bits per transform
			{ 4, 18, 15 },		// 165 bits per transform
			{ 5, 14, 18 },		// 165 bits per transform
			{ 5, 18, 14 },		// 165 bits per transform
			{ 6, 13, 18 },		// 165 bits per transform
			{ 6, 18, 13 },		// 165 bits per transform
			{ 7, 12, 18 },		// 165 bits per transform
			{ 7, 18, 12 },		// 165 bits per transform
			{ 8, 11, 18 },		// 165 bits per transform
			{ 8, 18, 11 },		// 165 bits per transform
			{ 9, 10, 18 },		// 165 bits per transform
			{ 9, 18, 10 },		// 165 bits per transform
			{ 10, 9, 18 },		// 165 bits per transform
			{ 10, 18, 9 },		// 165 bits per transform
			{ 11, 8, 18 },		// 165 bits per transform
			{ 11, 18, 8 },		// 165 bits per transform
			{ 12, 7, 18 },		// 165 bits per transform
			{ 12, 18, 7 },		// 165 bits per transform
			{ 13, 6, 18 },		// 165 bits per transform
			{ 13, 18, 6 },		// 165 bits per transform
			{ 14, 5, 18 },		// 165 bits per transform
			{ 14, 18, 5 },		// 165 bits per transform
			{ 15, 4, 18 },		// 165 bits per transform
			{ 15, 17, 17 },		// 165 bits per transform
			{ 15, 18, 4 },		// 165 bits per transform
			{ 16, 3, 18 },		// 165 bits per transform
			{ 16, 16, 17 },		// 165 bits per transform
			{ 16, 17, 16 },		// 165 bits per transform
			{ 16, 18, 3 },		// 165 bits per transform
			{ 17, 2, 18 },		// 165 bits per transform
			{ 17, 15, 17 },		// 165 bits per transform
			{ 17, 16, 16 },		// 165 bits per transform
			{ 17, 17, 15 },		// 165 bits per transform
			{ 17, 18, 2 },		// 165 bits per transform
			{ 18, 2, 17 },		// 165 bits per transform
			{ 18, 3, 16 },		// 165 bits per transform
			{ 18, 4, 15 },		// 165 bits per transform
			{ 18, 5, 14 },		// 165 bits per transform
			{ 18, 6, 13 },		// 165 bits per transform
			{ 18, 7, 12 },		// 165 bits per transform
			{ 18, 8, 11 },		// 165 bits per transform
			{ 18, 9, 10 },		// 165 bits per transform
			{ 18, 10, 9 },		// 165 bits per transform
			{ 18, 11, 8 },		// 165 bits per transform
			{ 18, 12, 7 },		// 165 bits per transform
			{ 18, 13, 6 },		// 165 bits per transform
			{ 18, 14, 5 },		// 165 bits per transform
			{ 18, 15, 4 },		// 165 bits per transform
			{ 18, 16, 3 },		// 165 bits per transform
			{ 18, 17, 2 },		// 165 bits per transform
			{ 3, 17, 18 },		// 168 bits per transform
			{ 3, 18, 17 },		// 168 bits per transform
			{ 4, 16, 18 },		// 168 bits per transform
			{ 4, 18, 16 },		// 168 bits per transform
			{ 5, 15, 18 },		// 168 bits per transform
			{ 5, 18, 15 },		// 168 bits per transform
			{ 6, 14, 18 },		// 168 bits per transform
			{ 6, 18, 14 },		// 168 bits per transform
			{ 7, 13, 18 },		// 168 bits per transform
			{ 7, 18, 13 },		// 168 bits per transform
			{ 8, 12, 18 },		// 168 bits per transform
			{ 8, 18, 12 },		// 168 bits per transform
			{ 9, 11, 18 },		// 168 bits per transform
			{ 9, 18, 11 },		// 168 bits per transform
			{ 10, 10, 18 },		// 168 bits per transform
			{ 10, 18, 10 },		// 168 bits per transform
			{ 11, 9, 18 },		// 168 bits per transform
			{ 11, 18, 9 },		// 168 bits per transform
			{ 12, 8, 18 },		// 168 bits per transform
			{ 12, 18, 8 },		// 168 bits per transform
			{ 13, 7, 18 },		// 168 bits per transform
			{ 13, 18, 7 },		// 168 bits per transform
			{ 14, 6, 18 },		// 168 bits per transform
			{ 14, 18, 6 },		// 168 bits per transform
			{ 15, 5, 18 },		// 168 bits per transform
			{ 15, 18, 5 },		// 168 bits per transform
			{ 16, 4, 18 },		// 168 bits per transform
			{ 16, 17, 17 },		// 168 bits per transform
			{ 16, 18, 4 },		// 168 bits per transform
			{ 17, 3, 18 },		// 168 bits per transform
			{ 17, 16, 17 },		// 168 bits per transform
			{ 17, 17, 16 },		// 168 bits per transform
			{ 17, 18, 3 },		// 168 bits per transform
			{ 18, 3, 17 },		// 168 bits per transform
			{ 18, 4, 16 },		// 168 bits per transform
			{ 18, 5, 15 },		// 168 bits per transform
			{ 18, 6, 14 },		// 168 bits per transform
			{ 18, 7, 13 },		// 168 bits per transform
			{ 18, 8, 12 },		// 168 bits per transform
			{ 18, 9, 11 },		// 168 bits per transform
			{ 18, 10, 10 },		// 168 bits per transform
			{ 18, 11, 9 },		// 168 bits per transform
			{ 18, 12, 8 },		// 168 bits per transform
			{ 18, 13, 7 },		// 168 bits per transform
			{ 18, 14, 6 },		// 168 bits per transform
			{ 18, 15, 5 },		// 168 bits per transform
			{ 18, 16, 4 },		// 168 bits per transform
			{ 18, 17, 3 },		// 168 bits per transform
			{ 4, 17, 18 },		// 171 bits per transform
			{ 4, 18, 17 },		// 171 bits per transform
			{ 5, 16, 18 },		// 171 bits per transform
			{ 5, 18, 16 },		// 171 bits per transform
			{ 6, 15, 18 },		// 171 bits per transform
			{ 6, 18, 15 },		// 171 bits per transform
			{ 7, 14, 18 },		// 171 bits per transform
			{ 7, 18, 14 },		// 171 bits per transform
			{ 8, 13, 18 },		// 171 bits per transform
			{ 8, 18, 13 },		// 171 bits per transform
			{ 9, 12, 18 },		// 171 bits per transform
			{ 9, 18, 12 },		// 171 bits per transform
			{ 10, 11, 18 },		// 171 bits per transform
			{ 10, 18, 11 },		// 171 bits per transform
			{ 11, 10, 18 },		// 171 bits per transform
			{ 11, 18, 10 },		// 171 bits per transform
			{ 12, 9, 18 },		// 171 bits per transform
			{ 12, 18, 9 },		// 171 bits per transform
			{ 13, 8, 18 },		// 171 bits per transform
			{ 13, 18, 8 },		// 171 bits per transform
			{ 14, 7, 18 },		// 171 bits per transform
			{ 14, 18, 7 },		// 171 bits per transform
			{ 15, 6, 18 },		// 171 bits per transform
			{ 15, 18, 6 },		// 171 bits per transform
			{ 16, 5, 18 },		// 171 bits per transform
			{ 16, 18, 5 },		// 171 bits per transform
			{ 17, 4, 18 },		// 171 bits per transform
			{ 17, 17, 17 },		// 171 bits per transform
			{ 17, 18, 4 },		// 171 bits per transform
			{ 18, 4, 17 },		// 171 bits per transform
			{ 18, 5, 16 },		// 171 bits per transform
			{ 18, 6, 15 },		// 171 bits per transform
			{ 18, 7, 14 },		// 171 bits per transform
			{ 18, 8, 13 },		// 171 bits per transform
			{ 18, 9, 12 },		// 171 bits per transform
			{ 18, 10, 11 },		// 171 bits per transform
			{ 18, 11, 10 },		// 171 bits per transform
			{ 18, 12, 9 },		// 171 bits per transform
			{ 18, 13, 8 },		// 171 bits per transform
			{ 18, 14, 7 },		// 171 bits per transform
			{ 18, 15, 6 },		// 171 bits per transform
			{ 18, 16, 5 },		// 171 bits per transform
			{ 18, 17, 4 },		// 171 bits per transform
			{ 5, 17, 18 },		// 174 bits per transform
			{ 5, 18, 17 },		// 174 bits per transform
			{ 6, 16, 18 },		// 174 bits per transform
			{ 6, 18, 16 },		// 174 bits per transform
			{ 7, 15, 18 },		// 174 bits per transform
			{ 7, 18, 15 },		// 174 bits per transform
			{ 8, 14, 18 },		// 174 bits per transform
			{ 8, 18, 14 },		// 174 bits per transform
			{ 9, 13, 18 },		// 174 bits per transform
			{ 9, 18, 13 },		// 174 bits per transform
			{ 10, 12, 18 },		// 174 bits per transform
			{ 10, 18, 12 },		// 174 bits per transform
			{ 11, 11, 18 },		// 174 bits per transform
			{ 11, 18, 11 },		// 174 bits per transform
			{ 12, 10, 18 },		// 174 bits per transform
			{ 12, 18, 10 },		// 174 bits per transform
			{ 13, 9, 18 },		// 174 bits per transform
			{ 13, 18, 9 },		// 174 bits per transform
			{ 14, 8, 18 },		// 174 bits per transform
			{ 14, 18, 8 },		// 174 bits per transform
			{ 15, 7, 18 },		// 174 bits per transform
			{ 15, 18, 7 },		// 174 bits per transform
			{ 16, 6, 18 },		// 174 bits per transform
			{ 16, 18, 6 },		// 174 bits per transform
			{ 17, 5, 18 },		// 174 bits per transform
			{ 17, 18, 5 },		// 174 bits per transform
			{ 18, 5, 17 },		// 174 bits per transform
			{ 18, 6, 16 },		// 174 bits per transform
			{ 18, 7, 15 },		// 174 bits per transform
			{ 18, 8, 14 },		// 174 bits per transform
			{ 18, 9, 13 },		// 174 bits per transform
			{ 18, 10, 12 },		// 174 bits per transform
			{ 18, 11, 11 },		// 174 bits per transform
			{ 18, 12, 10 },		// 174 bits per transform
			{ 18, 13, 9 },		// 174 bits per transform
			{ 18, 14, 8 },		// 174 bits per transform
			{ 18, 15, 7 },		// 174 bits per transform
			{ 18, 16, 6 },		// 174 bits per transform
			{ 18, 17, 5 },		// 174 bits per transform
			{ 6, 17, 18 },		// 177 bits per transform
			{ 6, 18, 17 },		// 177 bits per transform
			{ 7, 16, 18 },		// 177 bits per transform
			{ 7, 18, 16 },		// 177 bits per transform
			{ 8, 15, 18 },		// 177 bits per transform
			{ 8, 18, 15 },		// 177 bits per transform
			{ 9, 14, 18 },		// 177 bits per transform
			{ 9, 18, 14 },		// 177 bits per transform
			{ 10, 13, 18 },		// 177 bits per transform
			{ 10, 18, 13 },		// 177 bits per transform
			{ 11, 12, 18 },		// 177 bits per transform
			{ 11, 18, 12 },		// 177 bits per transform
			{ 12, 11, 18 },		// 177 bits per transform
			{ 12, 18, 11 },		// 177 bits per transform
			{ 13, 10, 18 },		// 177 bits per transform
			{ 13, 18, 10 },		// 177 bits per transform
			{ 14, 9, 18 },		// 177 bits per transform
			{ 14, 18, 9 },		// 177 bits per transform
			{ 15, 8, 18 },		// 177 bits per transform
			{ 15, 18, 8 },		// 177 bits per transform
			{ 16, 7, 18 },		// 177 bits per transform
			{ 16, 18, 7 },		// 177 bits per transform
			{ 17, 6, 18 },		// 177 bits per transform
			{ 17, 18, 6 },		// 177 bits per transform
			{ 18, 6, 17 },		// 177 bits per transform
			{ 18, 7, 16 },		// 177 bits per transform
			{ 18, 8, 15 },		// 177 bits per transform
			{ 18, 9, 14 },		// 177 bits per transform
			{ 18, 10, 13 },		// 177 bits per transform
			{ 18, 11, 12 },		// 177 bits per transform
			{ 18, 12, 11 },		// 177 bits per transform
			{ 18, 13, 10 },		// 177 bits per transform
			{ 18, 14, 9 },		// 177 bits per transform
			{ 18, 15, 8 },		// 177 bits per transform
			{ 18, 16, 7 },		// 177 bits per transform
			{ 18, 17, 6 },		// 177 bits per transform
			{ 7, 17, 18 },		// 180 bits per transform
			{ 7, 18, 17 },		// 180 bits per transform
			{ 8, 16, 18 },		// 180 bits per transform
			{ 8, 18, 16 },		// 180 bits per transform
			{ 9, 15, 18 },		// 180 bits per transform
			{ 9, 18, 15 },		// 180 bits per transform
			{ 10, 14, 18 },		// 180 bits per transform
			{ 10, 18, 14 },		// 180 bits per transform
			{ 11, 13, 18 },		// 180 bits per transform
			{ 11, 18, 13 },		// 180 bits per transform
			{ 12, 12, 18 },		// 180 bits per transform
			{ 12, 18, 12 },		// 180 bits per transform
			{ 13, 11, 18 },		// 180 bits per transform
			{ 13, 18, 11 },		// 180 bits per transform
			{ 14, 10, 18 },		// 180 bits per transform
			{ 14, 18, 10 },		// 180 bits per transform
			{ 15, 9, 18 },		// 180 bits per transform
			{ 15, 18, 9 },		// 180 bits per transform
			{ 16, 8, 18 },		// 180 bits per transform
			{ 16, 18, 8 },		// 180 bits per transform
			{ 17, 7, 18 },		// 180 bits per transform
			{ 17, 18, 7 },		// 180 bits per transform
			{ 18, 7, 17 },		// 180 bits per transform
			{ 18, 8, 16 },		// 180 bits per transform
			{ 18, 9, 15 },		// 180 bits per transform
			{ 18, 10, 14 },		// 180 bits per transform
			{ 18, 11, 13 },		// 180 bits per transform
			{ 18, 12, 12 },		// 180 bits per transform
			{ 18, 13, 11 },		// 180 bits per transform
			{ 18, 14, 10 },		// 180 bits per transform
			{ 18, 15, 9 },		// 180 bits per transform
			{ 18, 16, 8 },		// 180 bits per transform
			{ 18, 17, 7 },		// 180 bits per transform
			{ 8, 17, 18 },		// 183 bits per transform
			{ 8, 18, 17 },		// 183 bits per transform
			{ 9, 16, 18 },		// 183 bits per transform
			{ 9, 18, 16 },		// 183 bits per transform
			{ 10, 15, 18 },		// 183 bits per transform
			{ 10, 18, 15 },		// 183 bits per transform
			{ 11, 14, 18 },		// 183 bits per transform
			{ 11, 18, 14 },		// 183 bits per transform
			{ 12, 13, 18 },		// 183 bits per transform
			{ 12, 18, 13 },		// 183 bits per transform
			{ 13, 12, 18 },		// 183 bits per transform
			{ 13, 18, 12 },		// 183 bits per transform
			{ 14, 11, 18 },		// 183 bits per transform
			{ 14, 18, 11 },		// 183 bits per transform
			{ 15, 10, 18 },		// 183 bits per transform
			{ 15, 18, 10 },		// 183 bits per transform
			{ 16, 9, 18 },		// 183 bits per transform
			{ 16, 18, 9 },		// 183 bits per transform
			{ 17, 8, 18 },		// 183 bits per transform
			{ 17, 18, 8 },		// 183 bits per transform
			{ 18, 8, 17 },		// 183 bits per transform
			{ 18, 9, 16 },		// 183 bits per transform
			{ 18, 10, 15 },		// 183 bits per transform
			{ 18, 11, 14 },		// 183 bits per transform
			{ 18, 12, 13 },		// 183 bits per transform
			{ 18, 13, 12 },		// 183 bits per transform
			{ 18, 14, 11 },		// 183 bits per transform
			{ 18, 15, 10 },		// 183 bits per transform
			{ 18, 16, 9 },		// 183 bits per transform
			{ 18, 17, 8 },		// 183 bits per transform
			{ 9, 17, 18 },		// 186 bits per transform
			{ 9, 18, 17 },		// 186 bits per transform
			{ 10, 16, 18 },		// 186 bits per transform
			{ 10, 18, 16 },		// 186 bits per transform
			{ 11, 15, 18 },		// 186 bits per transform
			{ 11, 18, 15 },		// 186 bits per transform
			{ 12, 14, 18 },		// 186 bits per transform
			{ 12, 18, 14 },		// 186 bits per transform
			{ 13, 13, 18 },		// 186 bits per transform
			{ 13, 18, 13 },		// 186 bits per transform
			{ 14, 12, 18 },		// 186 bits per transform
			{ 14, 18, 12 },		// 186 bits per transform
			{ 15, 11, 18 },		// 186 bits per transform
			{ 15, 18, 11 },		// 186 bits per transform
			{ 16, 10, 18 },		// 186 bits per transform
			{ 16, 18, 10 },		// 186 bits per transform
			{ 17, 9, 18 },		// 186 bits per transform
			{ 17, 18, 9 },		// 186 bits per transform
			{ 18, 9, 17 },		// 186 bits per transform
			{ 18, 10, 16 },		// 186 bits per transform
			{ 18, 11, 15 },		// 186 bits per transform
			{ 18, 12, 14 },		// 186 bits per transform
			{ 18, 13, 13 },		// 186 bits per transform
			{ 18, 14, 12 },		// 186 bits per transform
			{ 18, 15, 11 },		// 186 bits per transform
			{ 18, 16, 10 },		// 186 bits per transform
			{ 18, 17, 9 },		// 186 bits per transform
			{ 10, 17, 18 },		// 189 bits per transform
			{ 10, 18, 17 },		// 189 bits per transform
			{ 11, 16, 18 },		// 189 bits per transform
			{ 11, 18, 16 },		// 189 bits per transform
			{ 12, 15, 18 },		// 189 bits per transform
			{ 12, 18, 15 },		// 189 bits per transform
			{ 13, 14, 18 },		// 189 bits per transform
			{ 13, 18, 14 },		// 189 bits per transform
			{ 14, 13, 18 },		// 189 bits per transform
			{ 14, 18, 13 },		// 189 bits per transform
			{ 15, 12, 18 },		// 189 bits per transform
			{ 15, 18, 12 },		// 189 bits per transform
			{ 16, 11, 18 },		// 189 bits per transform
			{ 16, 18, 11 },		// 189 bits per transform
			{ 17, 10, 18 },		// 189 bits per transform
			{ 17, 18, 10 },		// 189 bits per transform
			{ 18, 10, 17 },		// 189 bits per transform
			{ 18, 11, 16 },		// 189 bits per transform
			{ 18, 12, 15 },		// 189 bits per transform
			{ 18, 13, 14 },		// 189 bits per transform
			{ 18, 14, 13 },		// 189 bits per transform
			{ 18, 15, 12 },		// 189 bits per transform
			{ 18, 16, 11 },		// 189 bits per transform
			{ 18, 17, 10 },		// 189 bits per transform
			{ 0, 18, 18 },		// 192 bits per transform
			{ 11, 17, 18 },		// 192 bits per transform
			{ 11, 18, 17 },		// 192 bits per transform
			{ 12, 16, 18 },		// 192 bits per transform
			{ 12, 18, 16 },		// 192 bits per transform
			{ 13, 15, 18 },		// 192 bits per transform
			{ 13, 18, 15 },		// 192 bits per transform
			{ 14, 14, 18 },		// 192 bits per transform
			{ 14, 18, 14 },		// 192 bits per transform
			{ 15, 13, 18 },		// 192 bits per transform
			{ 15, 18, 13 },		// 192 bits per transform
			{ 16, 12, 18 },		// 192 bits per transform
			{ 16, 18, 12 },		// 192 bits per transform
			{ 17, 11, 18 },		// 192 bits per transform
			{ 17, 18, 11 },		// 192 bits per transform
			{ 18, 0, 18 },		// 192 bits per transform
			{ 18, 11, 17 },		// 192 bits per transform
			{ 18, 12, 16 },		// 192 bits per transform
			{ 18, 13, 15 },		// 192 bits per transform
			{ 18, 14, 14 },		// 192 bits per transform
			{ 18, 15, 13 },		// 192 bits per transform
			{ 18, 16, 12 },		// 192 bits per transform
			{ 18, 17, 11 },		// 192 bits per transform
			{ 18, 18, 0 },		// 192 bits per transform
			{ 12, 17, 18 },		// 195 bits per transform
			{ 12, 18, 17 },		// 195 bits per transform
			{ 13, 16, 18 },		// 195 bits per transform
			{ 13, 18, 16 },		// 195 bits per transform
			{ 14, 15, 18 },		// 195 bits per transform
			{ 14, 18, 15 },		// 195 bits per transform
			{ 15, 14, 18 },		// 195 bits per transform
			{ 15, 18, 14 },		// 195 bits per transform
			{ 16, 13, 18 },		// 195 bits per transform
			{ 16, 18, 13 },		// 195 bits per transform
			{ 17, 12, 18 },		// 195 bits per transform
			{ 17, 18, 12 },		// 195 bits per transform
			{ 18, 12, 17 },		// 195 bits per transform
			{ 18, 13, 16 },		// 195 bits per transform
			{ 18, 14, 15 },		// 195 bits per transform
			{ 18, 15, 14 },		// 195 bits per transform
			{ 18, 16, 13 },		// 195 bits per transform
			{ 18, 17, 12 },		// 195 bits per transform
			{ 13, 17, 18 },		// 198 bits per transform
			{ 13, 18, 17 },		// 198 bits per transform
			{ 14, 16, 18 },		// 198 bits per transform
			{ 14, 18, 16 },		// 198 bits per transform
			{ 15, 15, 18 },		// 198 bits per transform
			{ 15, 18, 15 },		// 198 bits per transform
			{ 16, 14, 18 },		// 198 bits per transform
			{ 16, 18, 14 },		// 198 bits per transform
			{ 17, 13, 18 },		// 198 bits per transform
			{ 17, 18, 13 },		// 198 bits per transform
			{ 18, 13, 17 },		// 198 bits per transform
			{ 18, 14, 16 },		// 198 bits per transform
			{ 18, 15, 15 },		// 198 bits per transform
			{ 18, 16, 14 },		// 198 bits per transform
			{ 18, 17, 13 },		// 198 bits per transform
			{ 1, 18, 18 },		// 201 bits per transform
			{ 14, 17, 18 },		// 201 bits per transform
			{ 14, 18, 17 },		// 201 bits per transform
			{ 15, 16, 18 },		// 201 bits per transform
			{ 15, 18, 16 },		// 201 bits per transform
			{ 16, 15, 18 },		// 201 bits per transform
			{ 16, 18, 15 },		// 201 bits per transform
			{ 17, 14, 18 },		// 201 bits per transform
			{ 17, 18, 14 },		// 201 bits per transform
			{ 18, 1, 18 },		// 201 bits per transform
			{ 18, 14, 17 },		// 201 bits per transform
			{ 18, 15, 16 },		// 201 bits per transform
			{ 18, 16, 15 },		// 201 bits per transform
			{ 18, 17, 14 },		// 201 bits per transform
			{ 18, 18, 1 },		// 201 bits per transform
			{ 2, 18, 18 },		// 204 bits per transform
			{ 15, 17, 18 },		// 204 bits per transform
			{ 15, 18, 17 },		// 204 bits per transform
			{ 16, 16, 18 },		// 204 bits per transform
			{ 16, 18, 16 },		// 204 bits per transform
			{ 17, 15, 18 },		// 204 bits per transform
			{ 17, 18, 15 },		// 204 bits per transform
			{ 18, 2, 18 },		// 204 bits per transform
			{ 18, 15, 17 },		// 204 bits per transform
			{ 18, 16, 16 },		// 204 bits per transform
			{ 18, 17, 15 },		// 204 bits per transform
			{ 18, 18, 2 },		// 204 bits per transform
			{ 3, 18, 18 },		// 207 bits per transform
			{ 16, 17, 18 },		// 207 bits per transform
			{ 16, 18, 17 },		// 207 bits per transform
			{ 17, 16, 18 },		// 207 bits per transform
			{ 17, 18, 16 },		// 207 bits per transform
			{ 18, 3, 18 },		// 207 bits per transform
			{ 18, 16, 17 },		// 207 bits per transform
			{ 18, 17, 16 },		// 207 bits per transform
			{ 18, 18, 3 },		// 207 bits per transform
			{ 4, 18, 18 },		// 210 bits per transform
			{ 17, 17, 18 },		// 210 bits per transform
			{ 17, 18, 17 },		// 210 bits per transform
			{ 18, 4, 18 },		// 210 bits per transform
			{ 18, 17, 17 },		// 210 bits per transform
			{ 18, 18, 4 },		// 210 bits per transform
			{ 5, 18, 18 },		// 213 bits per transform
			{ 18, 5, 18 },		// 213 bits per transform
			{ 18, 18, 5 },		// 213 bits per transform
			{ 6, 18, 18 },		// 216 bits per transform
			{ 18, 6, 18 },		// 216 bits per transform
			{ 18, 18, 6 },		// 216 bits per transform
			{ 7, 18, 18 },		// 219 bits per transform
			{ 18, 7, 18 },		// 219 bits per transform
			{ 18, 18, 7 },		// 219 bits per transform
			{ 8, 18, 18 },		// 222 bits per transform
			{ 18, 8, 18 },		// 222 bits per transform
			{ 18, 18, 8 },		// 222 bits per transform
			{ 9, 18, 18 },		// 225 bits per transform
			{ 18, 9, 18 },		// 225 bits per transform
			{ 18, 18, 9 },		// 225 bits per transform
			{ 10, 18, 18 },		// 228 bits per transform
			{ 18, 10, 18 },		// 228 bits per transform
			{ 18, 18, 10 },		// 228 bits per transform
			{ 11, 18, 18 },		// 231 bits per transform
			{ 18, 11, 18 },		// 231 bits per transform
			{ 18, 18, 11 },		// 231 bits per transform
			{ 12, 18, 18 },		// 234 bits per transform
			{ 18, 12, 18 },		// 234 bits per transform
			{ 18, 18, 12 },		// 234 bits per transform
			{ 13, 18, 18 },		// 237 bits per transform
			{ 18, 13, 18 },		// 237 bits per transform
			{ 18, 18, 13 },		// 237 bits per transform
			{ 14, 18, 18 },		// 240 bits per transform
			{ 18, 14, 18 },		// 240 bits per transform
			{ 18, 18, 14 },		// 240 bits per transform
			{ 15, 18, 18 },		// 243 bits per transform
			{ 18, 15, 18 },		// 243 bits per transform
			{ 18, 18, 15 },		// 243 bits per transform
			{ 16, 18, 18 },		// 246 bits per transform
			{ 18, 16, 18 },		// 246 bits per transform
			{ 18, 18, 16 },		// 246 bits per transform
			{ 17, 18, 18 },		// 249 bits per transform
			{ 18, 17, 18 },		// 249 bits per transform
			{ 18, 18, 17 },		// 249 bits per transform
			{ 18, 18, 18 },		// 288 bits per transform
		};
	}

	ACL_IMPL_VERSION_NAMESPACE_END
}

ACL_IMPL_FILE_PRAGMA_POP
